Package: SingleCellExperiment
Version: 1.18.1
Date: 2022-08-29
Title: S4 Classes for Single Cell Data
Authors@R: c(
        person("Aaron", "Lun", role=c("aut", "cph"), email="infinite.monkeys.with.keyboards@gmail.com"),
        person("Davide","Risso", role=c("aut","cre", "cph"), email="risso.davide@gmail.com"),
        person("Keegan", "Korthauer", role="ctb"),
        person("Kevin", "Rue-Albrecht", role="ctb"))
Depends: SummarizedExperiment
Imports: methods, utils, stats, S4Vectors, BiocGenerics, GenomicRanges,
        DelayedArray
Suggests: testthat, BiocStyle, knitr, rmarkdown, Matrix, scRNAseq (>=
        2.9.1), Rtsne
biocViews: ImmunoOncology, DataRepresentation, DataImport,
        Infrastructure, SingleCell
Description: Defines a S4 class for storing data from single-cell
        experiments. This includes specialized methods to store and
        retrieve spike-in information, dimensionality reduction
        coordinates and size factors for each cell, along with the
        usual metadata for genes and libraries.
License: GPL-3
VignetteBuilder: knitr
RoxygenNote: 7.2.1
git_url: https://git.bioconductor.org/packages/SingleCellExperiment
git_branch: RELEASE_3_15
git_last_commit: db7768a
git_last_commit_date: 2022-09-30
Date/Publication: 2022-10-02
NeedsCompilation: no
Packaged: 2022-10-02 22:08:29 UTC; biocbuild
Author: Aaron Lun [aut, cph],
  Davide Risso [aut, cre, cph],
  Keegan Korthauer [ctb],
  Kevin Rue-Albrecht [ctb]
Maintainer: Davide Risso <risso.davide@gmail.com>

Package: SingleCellExperiment
Version: 1.28.1
Date: 2024-11-08
Title: S4 Classes for Single Cell Data
Authors@R: c(
        person("Aaron", "Lun", role=c("aut", "cph"), email="infinite.monkeys.with.keyboards@gmail.com"),
        person("Davide","Risso", role=c("aut","cre", "cph"), email="risso.davide@gmail.com"),
        person("Keegan", "Korthauer", role="ctb"),
        person("Kevin", "Rue-Albrecht", role="ctb"),
        person("Luke", "Zappia", role = "ctb", comment = c(ORCID = "0000-0001-7744-8565", github = "lazappi")))
Depends: SummarizedExperiment
Imports: methods, utils, stats, S4Vectors, BiocGenerics, GenomicRanges,
        DelayedArray
Suggests: testthat, BiocStyle, knitr, rmarkdown, Matrix, scRNAseq (>=
        2.9.1), Rtsne
biocViews: ImmunoOncology, DataRepresentation, DataImport,
        Infrastructure, SingleCell
Description: Defines a S4 class for storing data from single-cell
        experiments. This includes specialized methods to store and
        retrieve spike-in information, dimensionality reduction
        coordinates and size factors for each cell, along with the
        usual metadata for genes and libraries.
License: GPL-3
VignetteBuilder: knitr
RoxygenNote: 7.3.1
git_url: https://git.bioconductor.org/packages/SingleCellExperiment
git_branch: RELEASE_3_20
git_last_commit: f3e30fb
git_last_commit_date: 2024-11-08
Repository: Bioconductor 3.20
Date/Publication: 2024-11-10
NeedsCompilation: no
Packaged: 2024-11-11 01:33:59 UTC; biocbuild
Author: Aaron Lun [aut, cph],
  Davide Risso [aut, cre, cph],
  Keegan Korthauer [ctb],
  Kevin Rue-Albrecht [ctb],
  Luke Zappia [ctb] (<https://orcid.org/0000-0001-7744-8565>, lazappi)
Maintainer: Davide Risso <risso.davide@gmail.com>

# SingleCellExperiment Bioconductor Package

This is a clone of the Bioconductor repository for the SingleCellExperiment package.

## Package Status

|                |               |
| -------------- | ------------- |
| Project Status | [![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active) |
| Travis CI      | [![Build Status](https://travis-ci.org/drisso/SingleCellExperiment.svg?branch=master)](https://travis-ci.org/drisso/SingleCellExperiment) |
| Test coverage  | [![Coverage](https://codecov.io/gh/drisso/SingleCellExperiment/branch/master/graph/badge.svg)](https://codecov.io/gh/drisso/SingleCellExperiment) |


## Installation and Usage

Please, see the [SingleCellExperiment](https://bioconductor.org/packages/SingleCellExperiment) Bioconductor page for details on how to install and use the package.

#' The reduced.dim.matrix class
#'
#' A matrix class that retains its attributes upon being subsetted or combined.
#' This is useful for storing metadata about a dimensionality reduction result alongside the matrix,
#' and for ensuring that the metadata persists when the matrix is stored inside \code{\link{reducedDims}}.
#'
#' @section Constructor:
#' \code{reduced.dim.matrix(x, ...)} will return a reduced.dim.matrix object, given a matrix input \code{x}.
#' Arguments in \code{...} should be named and are stored as custom attributes in the output.
#' Any arguments named \code{dim} or \code{dimnames} are ignored.
#'
#' @section Subsetting:
#' \code{x[i, j, ..., drop=FALSE]} will subset a reduced.dim.matrix \code{x} in the same manner as a base matrix.
#' The only difference is that a reduced.dim.matrix will be returned, retaining any custom attributes in \code{x}.
#' Note that no custom attributes are retained if the return value is a vector with \code{drop=TRUE}.
#'
#' @section Combining:
#' \code{rbind(...)} will combine multiple reduced.dim.matrix inputs in \code{...} by row, 
#' while \code{cbind(...)} will combine those inputs by column.
#' 
#' If the custom attributes are the same across all objects \code{...},
#' a reduced.dim.matrix is returned containing all combined rows/columns as well as the custom attributes.
#'
#' If the custom attributes are different, a warning is issued.
#' A matrix is returned containing all combined rows/columns; no custom attributes are retained.
#' 
#' @author Aaron Lun
#'
#' @examples
#' # Typical PC result, with metadata stored in the attributes:
#' pc <- matrix(runif(500), ncol=5)
#' attr(pc, "sdev") <- 1:100
#' attr(pc, "rotation") <- matrix(rnorm(20), ncol=5)
#'
#' # Disappears upon subsetting and combining!
#' attributes(pc[1:10,])
#' attributes(rbind(pc, pc))
#'
#' # Transformed into a reduced.dim.matrix:
#' rd.pc <- reduced.dim.matrix(pc)
#'
#' attributes(rd.pc[1:10,])
#' attributes(rbind(rd.pc, rd.pc))
#'
#' @seealso
#' \code{\link{reducedDims}}, to store these objects in a \linkS4class{SingleCellExperiment}.
#'
#' @aliases
#' reduced.dim.matrix
#' reduced.dim.matrix-class
#' [.reduced.dim.matrix
#' cbind.reduced.dim.matrix
#' rbind.reduced.dim.matrix
#'
#' @name reduced.dim.matrix
NULL

#' @export
reduced.dim.matrix <- function(x, ...) {
    class(x) <- c("reduced.dim.matrix", "matrix")
    mostattributes(x) <- c(attributes(x), list(...))
    x
}

#' @rawNamespace exportClasses(reduced.dim.matrix)
setOldClass(c("reduced.dim.matrix", "matrix"))

#' @export
`[.reduced.dim.matrix` <- function(x, i, j, ..., drop=FALSE) {
    at <- attributes(x)
    out <- NextMethod()
    if (!is.null(dim(out))) {
        at <- at[setdiff(names(at), c("dim", "dimnames"))]
        mostattributes(out) <- c(attributes(out), at)
    }
    out
}

.check_reddim_attributes <- function(available) {
    all.attr <- lapply(available, attributes)

    # Ignore dim and dimnames.
    for (i in seq_along(all.attr)) {
        current <- all.attr[[i]] 
        all.attr[[i]] <- current[setdiff(names(current), c("dim", "dimnames"))]
    }

    u.attr <- unique(all.attr)
    if (length(u.attr) > 1) {
        warning("mismatched custom attributes when combining 'reduced.dim.matrix' objects")
        NULL
    } else {
        u.attr[[1]]
    }
}

#' @export
#' @method rbind reduced.dim.matrix
rbind.reduced.dim.matrix <- function(..., deparse.level=1) {
    available <- list(...)
    u.attr <- .check_reddim_attributes(available)

    available <- lapply(available, unclass)
    out <- do.call(rbind, available)

    mostattributes(out) <- c(attributes(out), u.attr)
    out
}

#' @export
#' @method cbind reduced.dim.matrix
cbind.reduced.dim.matrix <- function(..., deparse.level=1) {
    available <- list(...)
    u.attr <- .check_reddim_attributes(available)

    available <- lapply(available, unclass)
    out <- do.call(cbind, available)

    mostattributes(out) <- c(attributes(out), u.attr)
    out
}

# This tests the reduced.dim.matrix class
# library(testthat); library(SingleCellExperiment); source("setup.R"); source("test-reduced.dim.matrix.R")

pc <- matrix(runif(500), ncol=5)
rot <- matrix(rnorm(20), ncol=5)
rd.pc <- reduced.dim.matrix(pc, sdev=1:100, rotation=rot)

test_that("reduced.dim.matrix construction works as expected", {
    expect_identical(attr(rd.pc, "sdev"), 1:100)
    expect_identical(attr(rd.pc, "rotation"), rot)
    expect_identical(dim(rd.pc), dim(pc))

    stuff <- paste0("GENE_", seq_len(nrow(pc)))
    rownames(rd.pc) <- stuff
    expect_identical(rownames(rd.pc), stuff)

    expect_true(is.matrix(rd.pc))
    expect_true(is(rd.pc, "matrix"))
})

test_that("reduced.dim.matrix subsetting retains attributes", {
    sub.pc <- rd.pc[1:10,]
    expect_identical(attr(sub.pc, "sdev"), 1:100)
    expect_identical(attr(sub.pc, "rotation"), rot)
    attributes(sub.pc) <- attributes(sub.pc)[c('dim', 'dimnames')]
    expect_identical(sub.pc, pc[1:10,])

    sub.pc <- rd.pc[,1:2]
    expect_identical(attr(rd.pc, "sdev"), 1:100)
    expect_identical(attr(rd.pc, "rotation"), rot)
    attributes(sub.pc) <- attributes(sub.pc)[c('dim', 'dimnames')]
    expect_identical(sub.pc, pc[,1:2])

    sub.pc <- rd.pc[,1]
    expect_null(attr(sub.pc, "sdev"))
    expect_null(attr(sub.pc, "rotation"))
})

test_that("reduced.dim.matrix combining retains attributes", {
    com.pc <- rbind(rd.pc, rd.pc[1:10,])
    expect_identical(attr(com.pc, "sdev"), 1:100)
    expect_identical(attr(com.pc, "rotation"), rot)
    attributes(com.pc) <- attributes(com.pc)[c('dim', 'dimnames')]
    expect_identical(com.pc, rbind(pc, pc[1:10,]))

    com.pc <- cbind(rd.pc, rd.pc[,1:2])
    expect_identical(attr(com.pc, "sdev"), 1:100)
    expect_identical(attr(com.pc, "rotation"), rot)
    attributes(com.pc) <- attributes(com.pc)[c('dim', 'dimnames')]
    expect_identical(com.pc, cbind(pc, pc[,1:2]))

    # What happens with differences in attributes?
    expect_warning(com.pc <- rbind(rd.pc, pc[1:10,]), "mismatched") 
    expect_identical(com.pc, rbind(pc, pc[1:10,]))

    expect_warning(com.pc <- cbind(rd.pc, pc[,1:2]), "mismatched") 
    expect_identical(com.pc, cbind(pc, pc[,1:2]))
})

test_that("reduced.dim.matrix works in its intended environment", {
    sce <- loaded
    reducedDim(sce, "PCA") <- reduced.dim.matrix(reducedDim(sce, "PCA"), sdev=1:100)

    subsce <- sce[1:10,]
    expect_identical(attr(reducedDim(subsce, "PCA"), "sdev"), 1:100)

    comsce <- cbind(sce, sce)
    expect_identical(attr(reducedDim(comsce, "PCA"), "sdev"), 1:100)
})

#' @title
#' Named assay getters and setters
#'
#' @description
#' These are methods for getting or setting \code{assay(sce, i=X, ...)} 
#' where \code{sce} is a \linkS4class{SingleCellExperiment} object and \code{X} is the name of the method.
#' For example, \code{counts} will get or set \code{X="counts"}.
#' This provides some convenience for users as well as encouraging standardization of assay names across packages.
#'
#' @section Available methods:
#' In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment} object,
#' \code{value} is a matrix-like object with the same dimensions as \code{x},
#' and \code{...} are further arguments passed to \code{\link{assay}} (for the getter) or \code{\link{assay<-}} (for the setter).
#' \describe{
#' \item{\code{counts(x, ...)}, \code{counts(x, ...) <- value}:}{
#' Get or set a matrix of raw count data, e.g., number of reads or transcripts.
#' }
#' \item{\code{normcounts(x, ...)}, \code{normcounts(x, ...) <- value}:}{
#' Get or set a matrix of normalized values on the same scale as the original counts.
#' For example, counts divided by cell-specific size factors that are centred at unity.
#' }
#' \item{\code{logcounts(x, ...)}, \code{logcounts(x, ...) <- value}:}{
#' Get or set a matrix of log-transformed counts or count-like values.
#' In most cases, this will be defined as log-transformed \code{normcounts}, e.g., using log base 2 and a pseudo-count of 1.
#' }
#' \item{\code{cpm(x, ...)}, \code{cpm(x, ...) <- value}:}{
#' Get or set a matrix of counts-per-million values.
#' This is the read count for each gene in each cell, divided by the library size of each cell in millions.
#' }
#' \item{\code{tpm(x, ...)}, \code{tpm(x, ...) <- value}:}{
#' Get or set a matrix of transcripts-per-million values.
#' This is the number of transcripts for each gene in each cell, divided by the total number of transcripts in that cell (in millions).
#' }
#' \item{\code{weights(x, ...)}, \code{weights(x, ...) <- value}:}{
#' Get or set a matrix of weights, e.g., observational weights to be used in differential expression analysis.
#' }
#' }
#' 
#' @author
#' Aaron Lun
#' 
#' @seealso
#' \code{\link{assay}} and \code{\link{assay<-}}, for the wrapped methods.
#' 
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#' counts(sce) <- matrix(rnorm(nrow(sce)*ncol(sce)), ncol=ncol(sce))
#' dim(counts(sce))
#' 
#' # One possible way of computing normalized "counts"
#' sf <- 2^rnorm(ncol(sce))
#' sf <- sf/mean(sf)
#' normcounts(sce) <- t(t(counts(sce))/sf)
#' dim(normcounts(sce))
#' 
#' # One possible way of computing log-counts
#' logcounts(sce) <- log2(normcounts(sce)+1)
#' dim(normcounts(sce))
#' 
#' @name SCE-assays
#' @rdname assays
#' @docType methods
#' @aliases
#' counts
#' counts<-
#' counts,SingleCellExperiment-method
#' counts<-,SingleCellExperiment-method
#' normcounts
#' normcounts<-
#' normcounts,SingleCellExperiment-method
#' normcounts<-,SingleCellExperiment-method
#' logcounts
#' logcounts<-
#' logcounts,SingleCellExperiment-method
#' logcounts<-,SingleCellExperiment-method
#' cpm
#' cpm<-
#' cpm,SingleCellExperiment-method
#' cpm<-,SingleCellExperiment-method
#' tpm
#' tpm<-
#' tpm,SingleCellExperiment-method
#' tpm<-,SingleCellExperiment-method
#' weights
#' weights<-
#' weights,SingleCellExperiment-method
#' weights<-,SingleCellExperiment-method
NULL

GET_FUN <- function(exprs_values, ...) {
    (exprs_values) # To ensure evaluation
    function(object, ...) {
        assay(object, i=exprs_values, ...)
    }
}

SET_FUN <- function(exprs_values, ...) {
    (exprs_values) # To ensure evaluation
    function(object, ..., value) {
        assay(object, i=exprs_values, ...) <- value
        object
    }
}

#' @export
#' @importFrom BiocGenerics counts
setMethod("counts", "SingleCellExperiment", GET_FUN("counts"))

#' @export
#' @importFrom BiocGenerics "counts<-"
setReplaceMethod("counts", c("SingleCellExperiment", "ANY"), SET_FUN("counts"))

#' @export
setMethod("logcounts", "SingleCellExperiment", GET_FUN("logcounts"))

#' @export
setReplaceMethod("logcounts", c("SingleCellExperiment", "ANY"), SET_FUN("logcounts"))

#' @export
setMethod("normcounts", "SingleCellExperiment", GET_FUN("normcounts"))

#' @export
setReplaceMethod("normcounts", c("SingleCellExperiment", "ANY"), SET_FUN("normcounts"))

#' @export
setMethod("cpm", "SingleCellExperiment", GET_FUN("cpm"))

#' @export
setReplaceMethod("cpm", c("SingleCellExperiment", "ANY"), SET_FUN("cpm"))

#' @export
setMethod("tpm", "SingleCellExperiment", GET_FUN("tpm"))

#' @export
setReplaceMethod("tpm", c("SingleCellExperiment", "ANY"), SET_FUN("tpm"))

#' @export
#' @importFrom BiocGenerics weights
setMethod("weights", "SingleCellExperiment", GET_FUN("weights"))

#' @export
setReplaceMethod("weights", c("SingleCellExperiment", "ANY"), SET_FUN("weights"))

#' Reduced dimensions methods
#'
#' Methods to get or set dimensionality reduction results in a \linkS4class{SingleCellExperiment} object.
#' These are typically used to store and retrieve low-dimensional representations of single-cell datasets.
#' Each row of a reduced dimension result is expected to correspond to a column of the SingleCellExperiment object.
#'
#' @section Getters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{reducedDim(x, type, withDimnames=TRUE)}:}{
#' Retrieves a matrix (or matrix-like object) containing reduced dimension coordinates for cells (rows) and dimensions (columns).
#' \code{type} is either a string specifying the name of the dimensionality reduction result in \code{x} to retrieve,
#' or a numeric scalar specifying the index of the desired result, defaulting to the first entry if missing.
#'
#' If \code{withDimnames=TRUE}, row names of the output matrix are replaced with the column names of \code{x}.
#' }
#' \item{\code{reducedDimNames(x)}:}{
#' Returns a character vector containing the names of all dimensionality reduction results in \code{x}.
#' This is guaranteed to be of the same length as the number of results, though the names may not be unique.
#' }
#' \item{\code{reducedDims(x, withDimnames=TRUE)}:}{
#' Returns a named \linkS4class{List} of matrices containing one or more dimensionality reduction results.
#' Each result is a matrix (or matrix-like object) with the same number of rows as \code{ncol(x)}.
#'
#' If \code{withDimnames=TRUE}, row names of each matrix are replaced with the column names of \code{x}.
#' }
#' }
#'
#' @section Single-result setter:
#' \code{reducedDim(x, type, withDimnames=TRUE) <- value} will add or replace a dimensionality reduction result
#' in a \linkS4class{SingleCellExperiment} object \code{x}.
#' The value of \code{type} determines how the result is added or replaced:
#' \itemize{
#' \item If \code{type} is missing, \code{value} is assigned to the first result.
#' If the result already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
#' \item If \code{type} is a numeric scalar, it must be within the range of existing results, and \code{value} will be assigned to the result at that index.
#' \item If \code{type} is a string and a result exists with this name, \code{value} is assigned to to that result.
#' Otherwise a new result with this name is append to the existing list of results.
#' }
#'
#' \code{value} is expected to be a matrix or matrix-like object with number of rows equal to \code{ncol(x)}.
#' Alternatively, if \code{value} is \code{NULL}, the result corresponding to \code{type} is removed from the object.
#'
#' If \code{withDimnames=TRUE}, any non-\code{NULL} \code{rownames(value)} is checked against \code{colnames(x)} and a warning is emitted if they are not the same.
#' Otherwise, any differences in the row names are ignored. 
#' This is inspired by the argument of the same name in \code{\link{assay<-}} but is more relaxed for practicality's sake - 
#' it raises a warning rather than an error and allows \code{NULL} rownames to pass through without complaints.
#'
#' @section Other setters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{reducedDims(x, withDimnames=TRUE) <- value}:}{
#' Replaces all dimensionality reduction results in \code{x} with those in \code{value}.
#' The latter should be a list-like object containing any number of matrices or matrix-like objects
#' with number of rows equal to \code{ncol(x)}.
#'
#' If \code{value} is named, those names will be used to name the dimensionality reduction results in \code{x}.
#' Otherwise, unnamed results are assigned default names prefixed with \code{"unnamed"}.
#'
#' If \code{value} is \code{NULL}, all dimensionality reduction results in \code{x} are removed.
#'
#' If \code{value} is a \linkS4class{Annotated} object, any \code{\link{metadata}} will be retained in \code{reducedDims(x)}.
#' If \code{value} is a \linkS4class{Vector} object, any \code{\link{mcols}} will also be retained.
#'
#' If \code{withDimnames=TRUE}, any non-\code{NULL} row names in each entry of \code{value} is checked against \code{colnames(x)} and a warning is emitted if they are not the same.
#' Otherwise, any differences in the row names are ignored. 
#' }
#' \item{\code{reducedDimNames(x) <- value}:}{
#' Replaces all names for dimensionality reduction results in \code{x} with a character vector \code{value}.
#' This should be of length equal to the number of results currently in \code{x}.
#' }
#' }
#'
#' @section Storing dimensionality reduction metadata:
#' When performing dimensionality reduction, we frequently generate metadata associated with a particular method.
#' The typical example is the percentage of variance explained and the rotation matrix from PCA;
#' model-based methods may also report some model information that can be used later to project points onto the embedding.
#' Ideally, we would want to store this information alongside the coordinates themselves.
#'
#' Our recommended approach is to store this metadata as attributes of the coordinate matrix.
#' This is simple to do, easy to extract, and avoids problems with synchronization (when the coordinates are separated from the metadata).
#' The biggest problem with this approach is that attributes are not retained when the matrix is subsetted or combined.
#' To persist these attributes, we suggest wrapping the coordinates and metadata in a \link{reduced.dim.matrix}.
#' More complex matrix-like objects like the \code{\link{LinearEmbeddingMatrix}} can also be used 
#' but may not be immediately compatible with downstream functions that expect an ordinary matrix.
#'
#' The path less taken is to store the metadata in the \code{\link{mcols}} of the \code{\link{reducedDims}} List.
#' This approach avoids the subsetting problem with the attributes but is less ideal as it separates the metadata from the coordinates.
#' Such separation makes the metadata harder to find and remember to keep in sync with the coordinates when the latter changes.
#' The structure of \code{\link{mcols}} is best suited to situations where there are some commonalities in the metadata across entries,
#' but this rarely occurs for different dimensionality reduction strategies.
#'
#' @author Aaron Lun and Kevin Rue-Albrecht
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE)
#' reducedDim(sce, "PCA")
#' reducedDim(sce, "tSNE")
#' reducedDims(sce)
#'
#' reducedDim(sce, "PCA") <- NULL
#' reducedDims(sce)
#'
#' reducedDims(sce) <- SimpleList()
#' reducedDims(sce)
#'
#' @name reducedDims
#' @docType methods
#' @aliases
#' reducedDim reducedDims reducedDimNames
#' reducedDim,SingleCellExperiment,missing-method
#' reducedDim,SingleCellExperiment,numeric-method
#' reducedDim,SingleCellExperiment,character-method
#' reducedDims,SingleCellExperiment-method
#' reducedDimNames,SingleCellExperiment-method
#' reducedDim<- reducedDims<- reducedDimNames<-
#' reducedDim<-,SingleCellExperiment,missing-method
#' reducedDim<-,SingleCellExperiment,numeric-method
#' reducedDim<-,SingleCellExperiment,character-method
#' reducedDims<-,SingleCellExperiment-method
#' reducedDimNames<-,SingleCellExperiment,character-method
NULL

.red_key <- "reducedDims"

#' @export
setMethod("reducedDims", "SingleCellExperiment", function(x, withDimnames=TRUE) {
    value <- .get_internal_all(x, 
        getfun=int_colData, 
        key=.red_key)

    if (withDimnames) {
        for (i in seq_along(value)) {
            rownames(value[[i]]) <- colnames(x)
        }
    }
    value
})

#' @export
setReplaceMethod("reducedDims", "SingleCellExperiment", function(x, withDimnames=TRUE, ..., value) {
    if (withDimnames) {
        for (v in seq_along(value)) {
            .check_reddim_names(x, value[[v]], withDimnames=TRUE, 
                vname=sprintf("value[[%s]]", v), fun='reducedDims')
        }
    }

    .set_internal_all(x, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.red_key,
        convertfun=NULL,
        xdimfun=ncol,
        vdimfun=nrow,
        funstr="reducedDims",
        xdimstr="ncol",
        vdimstr="rows")
})

#' @export
setMethod("reducedDimNames", "SingleCellExperiment", function(x) {
    .get_internal_names(x, 
        getfun=int_colData, 
        key=.red_key)
})

#' @export
setReplaceMethod("reducedDimNames", c("SingleCellExperiment", "character"), function(x, value) {
    .set_internal_names(x, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.red_key)
})

#' @export
setMethod("reducedDim", c("SingleCellExperiment", "missing"), function(x, type, withDimnames=TRUE) {
    .get_internal_missing(x, 
        basefun=reducedDim, 
        namefun=reducedDimNames, 
        funstr="reducedDim",
        withDimnames=withDimnames)
})

#' @export
setMethod("reducedDim", c("SingleCellExperiment", "numeric"), function(x, type, withDimnames=TRUE) {
    out <- .get_internal_integer(x, type,
        getfun=int_colData,
        key=.red_key,
        funstr="reducedDim",
        substr="type")

    if (withDimnames) {
        rownames(out) <- colnames(x)
    }

    out
})

#' @export
setMethod("reducedDim", c("SingleCellExperiment", "character"), function(x, type, withDimnames=TRUE) {
    out <- .get_internal_character(x, type,
        getfun=int_colData,
        key=.red_key,
        funstr="reducedDim",
        substr="type",
        namestr="reducedDimNames")

    if (withDimnames) {
        rownames(out) <- colnames(x)
    }

    out
})

.check_reddim_names <- function(reference, incoming, withDimnames, fun='reducedDim', vname='value') {
    if (!is.null(incoming)) {
        rni <- rownames(incoming)
        cnr <- colnames(reference)
        if (withDimnames && !is.null(rni)) {
            if (!identical(cnr, rni)) {
                msg <- paste0("non-NULL 'rownames(", vname, ")' should be the same as 'colnames(x)' for '", 
                    fun, "<-'. This will be an error in the next release of Bioconductor.")
                warning(paste(strwrap(msg), collapse="\n"))
            }
        }
    }
    incoming
}

#' @export
setReplaceMethod("reducedDim", c("SingleCellExperiment", "missing"), function(x, type, withDimnames=TRUE, ..., value) {
    .set_internal_missing(x, value,
        withDimnames=withDimnames,
        basefun=`reducedDim<-`,
        namefun=reducedDimNames
    )
})

#' @export
setReplaceMethod("reducedDim", c("SingleCellExperiment", "numeric"), function(x, type, withDimnames=TRUE, ..., value) {
    .check_reddim_names(x, value, withDimnames)

    .set_internal_numeric(x, type, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.red_key,
        convertfun=NULL,
        xdimfun=ncol,
        vdimfun=nrow,
        funstr="reducedDim",
        xdimstr="ncol",
        vdimstr="rows",
        substr="type")
})

#' @export
setReplaceMethod("reducedDim", c("SingleCellExperiment", "character"), function(x, type, withDimnames=TRUE, ..., value) {
    .check_reddim_names(x, value, withDimnames)

    .set_internal_character(x, type, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.red_key,
        convertfun=NULL,
        xdimfun=ncol, 
        vdimfun=nrow,
        funstr="reducedDim", 
        xdimstr="ncol",
        vdimstr="rows", 
        substr="type") 
})

#' The SingleCellExperiment class
#'
#' The SingleCellExperiment class is designed to represent single-cell sequencing data.
#' It inherits from the \linkS4class{RangedSummarizedExperiment} class and is used in the same manner.
#' In addition, the class supports storage of dimensionality reduction results (e.g., PCA, t-SNE) via \code{\link{reducedDims}},
#' and storage of alternative feature types (e.g., spike-ins) via \code{\link{altExps}}.
#' 
#' @param ... Arguments passed to the \code{\link{SummarizedExperiment}} constructor to fill the slots of the base class.
#' @param reducedDims A list of any number of matrix-like objects containing dimensionality reduction results,
#' each of which should have the same number of rows as the output SingleCellExperiment object.
#' @param altExps A list of any number of \linkS4class{SummarizedExperiment} objects containing alternative Experiments,
#' each of which should have the same number of columns as the output SingleCellExperiment object.
#' @param rowPairs A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of rows.
#' Each entry should have number of nodes equal to the number of rows of the output SingleCellExperiment object.
#' Alternatively, entries may be square sparse matrices of order equal to the number of rows of the output object.
#' @param colPairs A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of columns.
#' Each entry should have number of nodes equal to the number of columns of the output SingleCellExperiment object.
#' Alternatively, entries may be square sparse matrices of order equal to the number of columns of the output object.
#' @param mainExpName String containing the name of the main Experiment.
#' This is comparable to the names assigned to each of the \code{altExps}.
#'
#' @details
#' In this class, rows should represent genomic features (e.g., genes) while columns represent samples generated from single cells.
#' As with any \linkS4class{SummarizedExperiment} derivative,
#' different quantifications (e.g., counts, CPMs, log-expression) can be stored simultaneously in the \code{\link{assays}} slot,
#' and row and column metadata can be attached using \code{\link{rowData}} and \code{\link{colData}}, respectively.
#'
#' The extra arguments in the constructor (e.g., \code{\link{reducedDims}} \code{\link{altExps}})
#' represent the main extensions implemented in the SingleCellExperiment class.
#' This enables a consistent, formalized representation of data structures 
#' that are commonly encountered during single-cell data analysis.
#' Readers are referred to the specific documentation pages for more details.
#' 
#' A SingleCellExperiment can also be created by coercing from a \linkS4class{SummarizedExperiment}
#' or \linkS4class{RangedSummarizedExperiment} instance.
#'
#' @return A SingleCellExperiment object.
#'
#' @author
#' Aaron Lun and Davide Risso
#' 
#' @seealso
#' \code{\link{reducedDims}}, for representation of dimensionality reduction results.
#'
#' \code{\link{altExps}}, for representation of data for alternative feature sets.
#'
#' \code{\link{colPairs}} and \code{\link{rowPairs}}, to hold pairing information for rows and columns.
#' 
#' \code{\link{sizeFactors}}, to store size factors for normalization.
#'
#' \code{\link{colLabels}}, to store cell-level labels.
#'
#' \code{\link{rowSubset}}, to store a subset of rows.
#'
#' \code{?"\link{SCE-combine}"}, to combine or subset a SingleCellExperiment object.
#'
#' \code{?"\link{SCE-internals}"}, for developer use.
#' @examples
#' ncells <- 100
#' u <- matrix(rpois(20000, 5), ncol=ncells)
#' v <- log2(u + 1)
#' 
#' pca <- matrix(runif(ncells*5), ncells)
#' tsne <- matrix(rnorm(ncells*2), ncells)
#' 
#' sce <- SingleCellExperiment(assays=list(counts=u, logcounts=v),
#'     reducedDims=SimpleList(PCA=pca, tSNE=tsne))
#' sce
#' 
#' ## coercion from SummarizedExperiment
#' se <- SummarizedExperiment(assays=list(counts=u, logcounts=v))
#' as(se, "SingleCellExperiment")
#' 
#' @docType class
#' @aliases
#' coerce,SummarizedExperiment,SingleCellExperiment-method
#' coerce,RangedSummarizedExperiment,SingleCellExperiment-method
#' @export
#' @importFrom S4Vectors SimpleList 
#' @importFrom methods is as
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment
SingleCellExperiment <- function(..., reducedDims=list(), altExps=list(), rowPairs=list(), colPairs=list(), mainExpName=NULL) {
    se <- SummarizedExperiment(...)
    if(!is(se, "RangedSummarizedExperiment")) {
        se <- as(se, "RangedSummarizedExperiment")
    }
    .rse_to_sce(se, reducedDims=reducedDims, altExps=altExps, rowPairs=rowPairs, colPairs=colPairs, mainExpName=mainExpName)
}

#' @importFrom S4Vectors DataFrame SimpleList
#' @importClassesFrom S4Vectors DataFrame
#' @importFrom methods new
#' @importFrom BiocGenerics nrow ncol
.rse_to_sce <- function(rse, reducedDims=list(), altExps=list(), rowPairs=list(), colPairs=list(), mainExpName=NULL) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    
    out <- new("SingleCellExperiment", rse, 
        int_elementMetadata=new("DFrame", nrows=nrow(rse)),
        int_colData=new("DFrame", nrows=ncol(rse)))

    reducedDims(out) <- reducedDims
    altExps(out) <- altExps
    rowPairs(out) <- rowPairs
    colPairs(out) <- colPairs
    mainExpName(out) <- mainExpName

    out
}

#' @exportMethod coerce
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment
setAs("RangedSummarizedExperiment", "SingleCellExperiment", function(from) {
    .rse_to_sce(from)
})

#' @exportMethod coerce
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment SummarizedExperiment
setAs("SummarizedExperiment", "SingleCellExperiment", function(from) {
    .rse_to_sce(as(from, "RangedSummarizedExperiment"))
})

# Checks that LEM can be used inside a SCE object.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-with-lem.R")

factors <- matrix(rnorm(1000), ncol=10)
loadings <- matrix(runif(10000), ncol=10)
lem <- LinearEmbeddingMatrix(factors, loadings)

sce <- loaded
reducedDim(sce) <- lem

test_that("SCE construction works correctly with LEM", {

    sce1 <- SingleCellExperiment(assay=SimpleList(counts=u, exprs=v),
                                 reducedDims = SimpleList(rd1 = lem))
    sce2 <- SingleCellExperiment(assay=SimpleList(counts=u, exprs=v),
                                 reducedDims = SimpleList(rd1 = lem, rd2 = factors))


    expect_identical(reducedDim(sce1, "rd1"), reducedDim(sce2, "rd1"))

    expect_identical(reducedDim(sce1, "rd1"), lem)
})

test_that("reduced dimension getters/setters are functioning", {

    sce <- SingleCellExperiment(assay=SimpleList(counts=u, exprs=v))
    class(lem) <- as.character(class(lem))
    reducedDim(sce, "PCA") <- lem
    expect_identical(reducedDim(sce, "PCA"), lem)
    expect_identical(reducedDims(sce), SimpleList(PCA=lem))
    expect_identical(reducedDimNames(sce), "PCA")

})


test_that("subsetting by row works correctly", {

    colData(sce)$indicator <- seq_len(ncells)

    for (j in 1:3) {
        if (j==1L) {
            by.col <- sample(ncells, 20)
            sub.sce <- sce[,by.col]
            expect_identical(colData(sub.sce)$indicator, by.col)
        } else if (j==2L) {
            by.col <- rbinom(ncells, 1, 0.2)==1
            sub.sce <- sce[,by.col]
            expect_identical(colData(sub.sce)$indicator, which(by.col))
        } else if (j==3L) {
            by.col <- colnames(sce)[sample(ncells, 50)]
            sub.sce <- sce[,by.col]
            expect_identical(colData(sub.sce)$indicator, match(by.col, colnames(sce)))
        }
        ind <- colData(sub.sce)$indicator

        expect_identical(reducedDim(sub.sce, "PCA"), lem[ind,,drop=FALSE])

    }

})


test_that("cbind works correctly", {
    shuffled <- sample(ncells)
    sce.alt <- sce[,shuffled]

    sce2 <- cbind(sce, sce.alt)
    expect_identical(reducedDim(sce2, "PCA"), rbind(reducedDim(sce, "PCA"), reducedDim(sce.alt, "PCA")))

    sce.err <- sce
    reducedDim(sce.err, "PCA") <- NULL
    expect_error(cbind(sce.err, sce), "'int_colData'")

    sce.err <- sce
    reducedDim(sce.err, "PCA") <- sampleFactors(reducedDim(sce.err, "PCA"))
    # trying to make this robust to line breaks in the error message
    text <- "no method for coercing this S4 class to a vector"
    regexp <- gsub(" ", "[ \n]*", text, fixed=TRUE)
    expect_error(cbind(sce.err, sce), regexp)
    expect_error(cbind(sce, sce.err), regexp)

})

# Checks for proper construction and get/setting of the slots of a SingleCellExperiment.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-class.R")
context("SingleCellExperiment class")

set.seed(1000)
ncells <- 100
v <- matrix(rnorm(20000), ncol=ncells)
u <- matrix(rpois(20000, 5), ncol=ncells)
w <- matrix(runif(20000), ncol=ncells)
rd <- DataFrame(stuff=runif(nrow(v)))
cd <- DataFrame(whee=runif(ncells))

test_that("construction of the SCE works correctly", {
    sce <- SingleCellExperiment(assay=v)
    expect_equivalent(assay(sce), v)

    sce <- SingleCellExperiment(assay=list(counts=u, exprs=v))
    expect_equivalent(assay(sce, "counts"), u)
    expect_equivalent(assay(sce, "exprs"), v)

    assay(sce, "exprs") <- w
    expect_equivalent(assay(sce, "exprs"), w)
})

test_that("coercion from other classes works correctly", {
    # Coercion from SummarizedExperiment
    se <- SummarizedExperiment(u, rowData = rd, colData = cd)
    sce2 <- as(se, "SingleCellExperiment")
    expect_equal(sce2, SingleCellExperiment(u, rowData=rd, colData=cd)) # equality not identity due to environment in 'assays'.
    expect_true(validObject(sce2))

    # Coercion from RangedSummarizedExperiment
    ranges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                      IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                      strand=sample(c("+", "-"), 200, TRUE))
    mcols(ranges) <- rd

    rse <- SummarizedExperiment(u, colData = cd, rowRanges = ranges)
    sce3 <- as(rse, "SingleCellExperiment")
    expect_equal(sce3, SingleCellExperiment(u, colData=cd, rowRanges=ranges))
    expect_true(validObject(sce3))
})

test_that("coercion to other classes works correctly", {
    # Coercion to RangedSummarizedExperiment
    ranges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                      IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                      strand=sample(c("+", "-"), 200, TRUE))
    mcols(ranges) <- rd
    names(ranges) <- sprintf("GENE_%i", seq_along(ranges))

    sce <- SingleCellExperiment(assay=list(counts=u, exprs=v), 
                                rowRanges=ranges, 
                                colData=cd, 
                                metadata=list(foo="bar"))
    expect_identical(rownames(sce), names(ranges))

    rse <- as(sce, "RangedSummarizedExperiment")
    expected <- SummarizedExperiment(assay=list(counts=u, exprs=v), rowRanges=ranges, colData=cd, metadata=list(foo="bar"))
    expect_identical(rse, expected)
    expect_identical(rownames(rse), names(ranges))

    # Coercion to SummarizedExperiment doesn't work because of our
    # old nemesis https://github.com/Bioconductor/SummarizedExperiment/issues/29.
})

test_that("manipulation of SE metadata is correct", {
    sce <- SingleCellExperiment(u, rowData=rd, colData=cd)

    # Checking colData and rowData
    expect_equal(rd, rowData(sce))
    expect_equal(cd, colData(sce))

    # Adding extra metadata fields.
    cextra <- rnorm(ncells)
    sce$blah <- cextra
    expect_equal(cextra, colData(sce)$blah)
    rextra <- rnorm(nrow(v))
    rowData(sce)$blah <- rextra
    expect_equal(rextra, rowData(sce)$blah)

    # Adding metadata fields.
    sce <- SingleCellExperiment(u, metadata=list(yay=1))
    expect_equal(metadata(sce)$yay, 1)
    metadata(sce)$yay <- "stuff"
    expect_identical(metadata(sce)$yay, "stuff")
})

test_that("internal functions work correctly", {
    sce <- SingleCellExperiment(assay=u)
    expect_identical(nrow(int_elementMetadata(sce)), nrow(sce))
    expect_identical(nrow(int_colData(sce)), ncol(sce))
    expect_identical(length(int_metadata(sce)), 1L)

    rextra <- rnorm(nrow(v))
    int_elementMetadata(sce)$whee <- rextra
    expect_equal(rextra, int_elementMetadata(sce)$whee)
    int_elementMetadata(sce) <- int_elementMetadata(sce)[1:5,]
    expect_error(validObject(sce), "'nrow' of 'int_elementMetadata' not equal to 'nrow(object)'", fixed=TRUE)

    cextra <- rnorm(ncells)
    int_colData(sce)$stuff <- cextra
    expect_equal(cextra, int_colData(sce)$stuff)
    int_colData(sce) <- DataFrame(1:5)
    expect_error(validObject(sce), "'nrow' of 'int_colData' not equal to 'ncol(object)'", fixed=TRUE)

    int_metadata(sce)$urg <- "I was here"
    expect_identical(int_metadata(sce)$urg, "I was here")
})

test_that(".sce_show works", {
    expect_null(show(loaded))
})

# Checks for proper construction and get/setting of the slots of a SingleCellExperiment.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-class.R")
context("SingleCellExperiment class")

set.seed(1000)
ncells <- 100
v <- matrix(rnorm(20000), ncol=ncells)
u <- matrix(rpois(20000, 5), ncol=ncells)
w <- matrix(runif(20000), ncol=ncells)
rd <- DataFrame(stuff=runif(nrow(v)))
cd <- DataFrame(whee=runif(ncells))

test_that("construction of the SCE works correctly", {
    sce <- SingleCellExperiment(assay=v)
    expect_equivalent(assay(sce), v)

    sce <- SingleCellExperiment(assay=list(counts=u, exprs=v))
    expect_equivalent(assay(sce, "counts"), u)
    expect_equivalent(assay(sce, "exprs"), v)

    assay(sce, "exprs") <- w
    expect_equivalent(assay(sce, "exprs"), w)
})

test_that("coercion from other classes works correctly", {
    # Coercion from SummarizedExperiment
    se <- SummarizedExperiment(u, rowData = rd, colData = cd)
    sce2 <- as(se, "SingleCellExperiment")
    expect_equal(sce2, SingleCellExperiment(u, rowData=rd, colData=cd)) # equality not identity due to environment in 'assays'.
    expect_true(validObject(sce2))

    # Coercion from RangedSummarizedExperiment
    ranges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                      IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                      strand=sample(c("+", "-"), 200, TRUE))
    mcols(ranges) <- rd

    rse <- SummarizedExperiment(u, colData = cd, rowRanges = ranges)
    sce3 <- as(rse, "SingleCellExperiment")
    expect_equal(sce3, SingleCellExperiment(u, colData=cd, rowRanges=ranges))
    expect_true(validObject(sce3))
})

test_that("manipulation of SE metadata is correct", {
    sce <- SingleCellExperiment(u, rowData=rd, colData=cd)

    # Checking colData and rowData
    expect_equal(rd, rowData(sce))
    expect_equal(cd, colData(sce))

    # Adding extra metadata fields.
    cextra <- rnorm(ncells)
    sce$blah <- cextra
    expect_equal(cextra, colData(sce)$blah)
    rextra <- rnorm(nrow(v))
    rowData(sce)$blah <- rextra
    expect_equal(rextra, rowData(sce)$blah)

    # Adding metadata fields.
    sce <- SingleCellExperiment(u, metadata=list(yay=1))
    expect_equal(metadata(sce)$yay, 1)
    metadata(sce)$yay <- "stuff"
    expect_identical(metadata(sce)$yay, "stuff")
})

test_that("internal functions work correctly", {
    sce <- SingleCellExperiment(assay=u)
    expect_identical(nrow(int_elementMetadata(sce)), nrow(sce))
    expect_identical(nrow(int_colData(sce)), ncol(sce))
    expect_identical(length(int_metadata(sce)), 1L)

    rextra <- rnorm(nrow(v))
    int_elementMetadata(sce)$whee <- rextra
    expect_equal(rextra, int_elementMetadata(sce)$whee)
    int_elementMetadata(sce) <- int_elementMetadata(sce)[1:5,]
    expect_error(validObject(sce), "'nrow' of 'int_elementMetadata' not equal to 'nrow(object)'", fixed=TRUE)

    cextra <- rnorm(ncells)
    int_colData(sce)$stuff <- cextra
    expect_equal(cextra, int_colData(sce)$stuff)
    int_colData(sce) <- DataFrame(1:5)
    expect_error(validObject(sce), "'nrow' of 'int_colData' not equal to 'ncol(object)'", fixed=TRUE)

    int_metadata(sce)$urg <- "I was here"
    expect_identical(int_metadata(sce)$urg, "I was here")
})

test_that(".sce_show works", {
    expect_null(show(loaded))
})

# Tests the unsplitAltExps function.
# library(testthat); library(SingleCellExperiment); source("test-unsplit-altexp.R")

#########################
#########################

# Assembling an appropriately stripped down dummy object.

set.seed(1000)
ncells <- 100
u <- matrix(rpois(20000, 5), ncol=ncells)
sce <- SingleCellExperiment(list(counts=u))
rownames(sce) <- sprintf("GENE_%i", seq_len(nrow(sce)))
sce$Cell_Cycle <- sample(LETTERS, ncol(sce), replace=TRUE)

se1 <- SingleCellExperiment(list(counts=matrix(rpois(2000, 5), ncol=ncells)))
rowData(se1)$stuff <- sample(LETTERS, nrow(se1), replace=TRUE)
rownames(se1) <- sprintf("SPIKE_%i", seq_len(nrow(se1)))
altExp(sce, "Spike") <- se1

se2 <- SummarizedExperiment(list(counts=matrix(rpois(800, 5), ncol=ncells)))
rowData(se2)$blah <- sample(letters, nrow(se2), replace=TRUE)
rownames(se2) <- sprintf("TAG_%i", seq_len(nrow(se2)))
se2$something <- sample(letters, ncol(sce), replace=TRUE)
altExp(sce, "Protein") <- se2

#########################
#########################

is.first <- seq_len(nrow(sce))
is.spike <- nrow(sce) + seq_len(nrow(altExp(sce)))
is.stuff <- nrow(sce) + nrow(altExp(sce)) + + seq_len(nrow(altExp(sce, 2)))

expected_names <- c(
    rownames(sce), 
    paste0("Spike.", rownames(altExp(sce))),
    paste0("Protein.", rownames(altExp(sce, 2)))
)

test_that("unsplitAltExps works as expected for assays", {
    output <- unsplitAltExps(sce, prefix.row=FALSE)
    expect_identical(as.matrix(assay(output)), rbind(assay(sce), assay(altExp(sce)), assay(altExp(sce, 2))))

    output <- unsplitAltExps(sce)
    expect_identical(expected_names, rownames(output))

    # A trickier situation with an assay only available in one of the matrices.
    alt <- sce
    logcounts(alt) <- log2(counts(sce) + 1)
    output <- unsplitAltExps(alt)
    expect_identical(as.matrix(logcounts(alt)), as.matrix(logcounts(output)[is.first,]))
    expect_true(all(is.na(logcounts(output)[is.spike,])))
    expect_true(all(is.na(logcounts(output)[is.stuff,])))

    alt <- sce
    logcounts(altExp(alt)) <- log2(counts(altExp(alt)) + 1)
    output <- unsplitAltExps(alt, prefix.rows=FALSE)
    expect_true(all(is.na(logcounts(output)[is.first,])))
    expect_identical(as.matrix(assay(altExp(alt), "logcounts")), as.matrix(logcounts(output)[is.spike,]))
    expect_true(all(is.na(logcounts(output)[is.stuff,])))

    # Counterpart is present in all assays.
    alt <- sce
    logcounts(alt) <- log2(counts(alt) + 1)
    logcounts(altExp(alt)) <- log2(counts(altExp(alt)) + 1)
    assay(altExp(alt, 2), "logcounts") <- log2(assay(altExp(alt, 2), "counts") + 1)
    output <- unsplitAltExps(alt, prefix.row=FALSE)
    expect_identical(as.matrix(logcounts(output)), rbind(logcounts(alt), assay(altExp(alt), "logcounts"), assay(altExp(alt, 2), "logcounts")))
})

test_that("rowRanges merges work as expected", {
    replacement <- rep(List(GRanges("chrA:1-100")), nrow(sce))
    names(replacement) <- rownames(sce)
    rowRanges(sce) <- replacement
    output <- unsplitAltExps(sce)

    len <- lengths(rowRanges(output))
    expect_identical(expected_names, names(len))
    expect_identical(unname(len), c(rep(1L, nrow(sce)), integer(nrow(altExp(sce))), integer(nrow(altExp(sce, 2)))))

    # What happens if one of them is a GRangesList, and another is a GRanges?
    replacement <- GRanges(rep("chrB:1-100", nrow(altExp(sce))))
    names(replacement) <- rownames(altExp(sce))
    rowRanges(altExp(sce)) <- replacement
    suppressWarnings(output <- unsplitAltExps(sce))

    expect_s4_class(rowRanges(output), "GRangesList")
    is.A <- any(seqnames(rowRanges(output))=="chrA")
    expect_true(all(is.A[is.first]))
    expect_true(!any(is.A[-is.first]))
    is.B <- any(seqnames(rowRanges(output))=="chrB")
    expect_true(all(is.B[is.spike]))
    expect_true(!any(is.B[-is.spike]))
    expect_true(all(lengths(rowRanges(output))[is.stuff]==0))

    # What happens if all of them are GRanges?
    replacement <- GRanges(rep("chrA:1-100", nrow(sce)))
    names(replacement) <- rownames(sce)
    rowRanges(sce) <- replacement

    suppressWarnings(output <- unsplitAltExps(sce))
    expect_s4_class(rowRanges(output), "GRanges")
    expect_identical(as.character(seqnames(output)), 
        rep(c("chrA", "chrB", "unknown"), c(nrow(sce), nrow(altExp(sce)), nrow(altExp(sce, 2)))))

    # How are metadata fields handled?
    rowData(sce)$thingy <- 1
    rowData(altExp(sce))$blah <- "A"
    rowData(altExp(sce, 2))$whee <- TRUE

    suppressWarnings(output <- unsplitAltExps(sce))
    expect_type(rowData(output)$thingy, "double")
    expect_type(rowData(output)$blah, "character")
    expect_type(rowData(output)$whee, "logical")
})

test_that("colData merges work as expected", {
    output <- unsplitAltExps(sce)
    expect_identical(output$Cell_Cycle, sce$Cell_Cycle)
    expect_identical(output$Protein.something, altExp(sce, 2)$something)

    output <- unsplitAltExps(sce, prefix.cols=FALSE)
    expect_identical(output$something, altExp(sce, 2)$something)
})

test_that("reducedDim merges work as expected", {
    reducedDim(sce, "PCA") <- matrix(rnorm(ncol(sce)*2), ncol=2)
    output <- unsplitAltExps(sce)
    expect_identical(reducedDims(sce), reducedDims(output))

    reducedDim(altExp(sce), "PCA") <- matrix(rnorm(ncol(sce)*2), ncol=2)
    output <- unsplitAltExps(sce)
    expect_identical(reducedDimNames(output), c("PCA", "Spike.PCA"))
    expect_identical(reducedDim(output, "Spike.PCA"), reducedDim(altExp(sce)))

    output <- unsplitAltExps(sce, prefix.cols=FALSE)
    expect_identical(reducedDimNames(output), c("PCA", "PCA"))
    expect_identical(reducedDim(output, 2), reducedDim(altExp(sce)))
})

test_that("the effect of splitAltExps is reversed", {
    alt <- sce
    altExps(alt) <- NULL
    ref <- rbind(alt, altExp(sce))
    int_metadata(ref) <- int_metadata(alt)

    alt <- sce
    altExps(alt) <- altExps(alt)[1]
    out <- unsplitAltExps(alt, delayed=FALSE, prefix.cols=NA, prefix.rows=FALSE)
    expect_identical(ref, out)
})

#' The SingleCellExperiment class
#'
#' The SingleCellExperiment class is designed to represent single-cell sequencing data.
#' It inherits from the \linkS4class{RangedSummarizedExperiment} class and is used in the same manner.
#' In addition, the class supports storage of dimensionality reduction results (e.g., PCA, t-SNE) via \code{\link{reducedDims}},
#' and storage of alternative feature types (e.g., spike-ins) via \code{\link{altExps}}.
#' 
#' @param ... Arguments passed to the \code{\link{SummarizedExperiment}} constructor to fill the slots of the base class.
#' @param reducedDims A list of any number of matrix-like objects containing dimensionality reduction results,
#' each of which should have the same number of rows as the output SingleCellExperiment object.
#' @param altExps A list of any number of \linkS4class{SummarizedExperiment} objects containing alternative Experiments,
#' each of which should have the same number of columns as the output SingleCellExperiment object.
#' @param rowPairs A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of rows.
#' Each entry should have number of nodes equal to the number of rows of the output SingleCellExperiment object.
#' Alternatively, entries may be square sparse matrices of order equal to the number of rows of the output object.
#' @param colPairs A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of columns.
#' Each entry should have number of nodes equal to the number of columns of the output SingleCellExperiment object.
#' Alternatively, entries may be square sparse matrices of order equal to the number of columns of the output object.
#' @param mainExpName String containing the name of the main Experiment.
#' This is comparable to the names assigned to each of the \code{altExps}.
#'
#' @details
#' In this class, rows should represent genomic features (e.g., genes) while columns represent samples generated from single cells.
#' As with any \linkS4class{SummarizedExperiment} derivative,
#' different quantifications (e.g., counts, CPMs, log-expression) can be stored simultaneously in the \code{\link{assays}} slot,
#' and row and column metadata can be attached using \code{\link{rowData}} and \code{\link{colData}}, respectively.
#'
#' The extra arguments in the constructor (e.g., \code{\link{reducedDims}} \code{\link{altExps}})
#' represent the main extensions implemented in the SingleCellExperiment class.
#' This enables a consistent, formalized representation of data structures 
#' that are commonly encountered during single-cell data analysis.
#' Readers are referred to the specific documentation pages for more details.
#' 
#' A SingleCellExperiment can also be created by coercing from a \linkS4class{SummarizedExperiment}
#' or \linkS4class{RangedSummarizedExperiment} instance.
#'
#' @return A SingleCellExperiment object.
#'
#' @author
#' Aaron Lun and Davide Risso
#' 
#' @seealso
#' \code{\link{reducedDims}}, for representation of dimensionality reduction results.
#'
#' \code{\link{altExps}}, for representation of data for alternative feature sets.
#'
#' \code{\link{colPairs}} and \code{\link{rowPairs}}, to hold pairing information for rows and columns.
#' 
#' \code{\link{sizeFactors}}, to store size factors for normalization.
#'
#' \code{\link{colLabels}}, to store cell-level labels.
#'
#' \code{\link{rowSubset}}, to store a subset of rows.
#'
#' \code{?"\link{SCE-combine}"}, to combine or subset a SingleCellExperiment object.
#'
#' \code{?"\link{SCE-internals}"}, for developer use.
#' @examples
#' ncells <- 100
#' u <- matrix(rpois(20000, 5), ncol=ncells)
#' v <- log2(u + 1)
#' 
#' pca <- matrix(runif(ncells*5), ncells)
#' tsne <- matrix(rnorm(ncells*2), ncells)
#' 
#' sce <- SingleCellExperiment(assays=list(counts=u, logcounts=v),
#'     reducedDims=SimpleList(PCA=pca, tSNE=tsne))
#' sce
#' 
#' ## coercion from SummarizedExperiment
#' se <- SummarizedExperiment(assays=list(counts=u, logcounts=v))
#' as(se, "SingleCellExperiment")
#' 
#' ## coercion from RangedSummarizedExperiment
#' rse <- as(se, "RangedSummarizedExperiment")
#' as(rse, "SingleCellExperiment")
#' 
#' # coercion to a RangedSummarizedExperiment
#' as(sce, "RangedSummarizedExperiment")
#'
#' # coercion to a SummarizedExperiment is slightly buggy right now
#' # and requires a little workaround:
#' as(as(sce, "RangedSummarizedExperiment"), "SummarizedExperiment")
#' 
#' @docType class
#' @aliases
#' coerce,SummarizedExperiment,SingleCellExperiment-method
#' coerce,RangedSummarizedExperiment,SingleCellExperiment-method
#' @export
#' @importFrom S4Vectors SimpleList 
#' @importFrom methods is as
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment
SingleCellExperiment <- function(..., reducedDims=list(), altExps=list(), rowPairs=list(), colPairs=list(), mainExpName=NULL) {
    se <- SummarizedExperiment(...)
    if(!is(se, "RangedSummarizedExperiment")) {
        se <- as(se, "RangedSummarizedExperiment")
    }
    .rse_to_sce(se, reducedDims=reducedDims, altExps=altExps, rowPairs=rowPairs, colPairs=colPairs, mainExpName=mainExpName)
}

#' @importFrom S4Vectors DataFrame SimpleList
#' @importClassesFrom S4Vectors DataFrame
#' @importFrom methods new
#' @importFrom BiocGenerics nrow ncol
.rse_to_sce <- function(rse, reducedDims=list(), altExps=list(), rowPairs=list(), colPairs=list(), mainExpName=NULL) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    
    out <- new("SingleCellExperiment", rse, 
        int_elementMetadata=new("DFrame", nrows=nrow(rse)),
        int_colData=new("DFrame", nrows=ncol(rse)))

    reducedDims(out) <- reducedDims
    altExps(out) <- altExps
    rowPairs(out) <- rowPairs
    colPairs(out) <- colPairs
    mainExpName(out) <- mainExpName

    out
}

#' @exportMethod coerce
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment
setAs("RangedSummarizedExperiment", "SingleCellExperiment", function(from) {
    .rse_to_sce(from)
})

#' @exportMethod coerce
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment SummarizedExperiment
setAs("SummarizedExperiment", "SingleCellExperiment", function(from) {
    .rse_to_sce(as(from, "RangedSummarizedExperiment"))
})

#' Size factor methods
#' 
#' Gets or sets the size factors for all cells in a \linkS4class{SingleCellExperiment} object.
#' 
#' @param object A \linkS4class{SingleCellExperiment} object.
#' @param value A numeric vector of length equal to \code{ncol(object)}, containing size factors for all cells.
#' @param ... Additional arguments, currently ignored.
#' @param onAbsence String indicating an additional action to take when size factors are absent:
#' nothing (\code{"none"}), a warning (\code{"warn"}) or an error (\code{"error"}).
#' 
#' @details
#' A size factor is a scaling factor used to divide the raw counts of a particular cell to obtain normalized expression values,
#' thus allowing downstream comparisons between cells that are not affected by differences in library size or total RNA content.
#' The \code{sizeFactors} methods can be used to get or set size factors for all cells in a SingleCellExperiment object.
#'
#' When setting size factors, the values are stored in the \code{\link{colData}} as the \code{\link{sizeFactors}} field.
#' This name is chosen for general consistency with other packages (e.g., \pkg{DESeq2})
#' and to allow the size factors to be easily extracted from the \code{\link{colData}} for use as covariates.
#'
#' For developers, \code{onAbsence} is provided to make it easier to mandate that \code{object} has size factors.
#' This avoids silent \code{NULL} values that flow to the rest of the function and make debugging difficult.
#' 
#' @return
#' For \code{sizeFactors}, a numeric vector is returned containing size factors for all cells.
#' If no size factors are available, a \code{NULL} is returned (and/or a warning or error, depending on \code{onAbsence}).
#' 
#' For \code{sizeFactors<-}, a modified \code{object} is returned with size factors in its \code{\link{colData}}.
#' 
#' @seealso
#' \linkS4class{SingleCellExperiment}, for the underlying class definition. 
#'
#' \code{librarySizeFactors} from the \pkg{scater} package
#' or \code{computeSumFactors} from the \pkg{scran} package,
#' as examples of functions that compute the size factors.
#' 
#' @author
#' Aaron Lun
#' 
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#' sizeFactors(sce) <- runif(ncol(sce))
#' sizeFactors(sce)
#'
#' @name sizeFactors
NULL

.sf_field <- "sizeFactor"

#' @export
#' @rdname sizeFactors
#' @importFrom SummarizedExperiment colData
#' @importFrom BiocGenerics sizeFactors
setMethod("sizeFactors", "SingleCellExperiment", function(object, onAbsence="none") {
    object <- updateObject(object)
    output <- colData(object)[[.sf_field]]
    .absent_action(object, val=output, fun="sizeFactors", onAbsence=onAbsence) 
    output
})

#' @export
#' @rdname sizeFactors
#' @importFrom SummarizedExperiment colData<- colData
#' @importFrom BiocGenerics sizeFactors<-
setReplaceMethod("sizeFactors", "SingleCellExperiment", function(object, ..., value) {
    object <- updateObject(object)
    colData(object)[[.sf_field]] <- value
    object
})

.convert_subset_index <- function(subset, names) {
    if (is.character(subset)) {
        fmt <- "index out of bounds: %s"
        subset <- SummarizedExperiment:::.SummarizedExperiment.charbound(subset, names, fmt)
    }
    return(as.vector(subset))
}

.unnamed <- "unnamed"

.absent_action <- function(object, val, fun, onAbsence=c("none", "warn", "error")) {
    if (is.null(val)) {
        onAbsence <- match.arg(onAbsence)
        if (onAbsence!="none") {
            msg <- sprintf("'%s(<%s>)' returns 'NULL'", fun, class(object)[1])
            if (onAbsence=="warn") {
                warning(msg)
            } else {
                stop(msg)
            }
        }
    }
}

#' Defunct methods
#'
#' Defunct methods in the \pkg{SingleCellExperiment} package.
#'
#' @section Named size factors:
#' The class now only supports one set of size factors, accessible via \code{\link{sizeFactors}}.
#' This represents a simplification of the class and removes a difficult part of the API 
#' (that had to deal with both \code{NULL} and strings to specify the size factor set of interest).
#'
#' @section Spike-ins:
#' It is recommended to handle spike-ins and other \dQuote{alternative} features via \code{\link{altExps}}.
#'
#' @author Aaron Lun
#'
#' @docType methods 
#' @aliases isSpike isSpike<- spikeNames clearSpikes
#' sizeFactorNames clearSizeFactors
#' @name defunct
NULL

#' @title
#' Miscellaneous SingleCellExperiment methods
#'
#' @description
#' Miscellaneous methods for the \linkS4class{SingleCellExperiment} class
#' that do not fit in any other documentation category.
#' 
#' @section Available methods:
#' In the following code snippets, \code{x} and \code{object} are \linkS4class{SingleCellExperiment} objects.
#' \describe{
#' \item{\code{show(object)}:}{Print a message to screen describing the contents of \code{object}.}
#' \item{\code{objectVersion(x)}:}{Return the version of the package with which \code{x} was constructed.}
#' \item{\code{sizeFactors(object)}:}{Return a numeric vector of size factors of length equal to \code{ncol(object)}.
#' If no size factors are available in \code{object}, return \code{NULL} instead.}
#' \item{\code{sizeFactors(object) <- value}:}{Replace the size factors with \code{value},
#' usually expected to be a numeric vector or vector-like object.
#' Alternatively, \code{value} can be \code{NULL} in which case any size factors in \code{object} are removed.}
#' }
#' 
#' @author Aaron Lun
#' @seealso
#' \code{\link{updateObject}}, where \code{objectVersion} is used.
#' 
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#'
#' show(sce)
#' 
#' objectVersion(sce)
#' 
#' # Setting/getting size factors.
#' sizeFactors(sce) <- runif(ncol(sce))
#' sizeFactors(sce)
#'
#' sizeFactors(sce) <- NULL
#' sizeFactors(sce)
#'
#' @name SCE-miscellaneous
#' @rdname miscellaneous
#' @docType methods
#' @aliases
#' show,SingleCellExperiment-method
#' objectVersion
#' objectVersion,SingleCellExperiment-method
NULL

#' @export
setMethod("objectVersion", "SingleCellExperiment", function(x) {
    int_metadata(x)$version
})

#' @importFrom S4Vectors coolcat
.sce_show <- function(object) {
    callNextMethod()
    coolcat("reducedDimNames(%d): %s\n", reducedDimNames(object))

    me <- mainExpName(object)
    if (is.null(me)) me <- "NULL"
    cat(sprintf("mainExpName: %s\n", me))

    coolcat("altExpNames(%d): %s\n", altExpNames(object))
}

#' @export
setMethod("show", "SingleCellExperiment", .sce_show)

#' Update a SingleCellExperiment object
#'
#' Update \linkS4class{SingleCellExperiment} objects to the latest version of the class structure.
#' This is usually called by methods in the \pkg{SingleCellExperiment} package rather than by users or downstream packages.
#' 
#' @param object A old \linkS4class{SingleCellExperiment} object.
#' @param ... Additional arguments that are ignored.
#' @param verbose Logical scalar indicating whether a message should be emitted as the object is updated.
#' 
#' @details
#' This function updates the SingleCellExperiment to match changes in the internal class representation.
#' Changes are as follows:
#' \itemize{
#' \item Objects created before 1.7.1 are modified to include \code{\link{altExps}} and \code{\link{reducedDims}} fields in their internal column metadata.
#' Reduced dimension results previously in the \code{reducedDims} slot are transferred to the \code{reducedDims} field.
#' \item Objects created before 1.9.1 are modified so that the size factors are stored by \code{\link{sizeFactors<-}} in \code{\link{colData}} rather than \code{\link{int_colData}}.
#' }
#' 
#' @return
#' An updated version of \code{object}.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{objectVersion}}, which is used to determine if the object is up-to-date.
#' 
#' @name updateObject 
#' @export
#' @aliases updateObject updateObject,SingleCellExperiment-method
#' @importFrom BiocGenerics updateObject
#' @importFrom S4Vectors DataFrame
#' @importFrom utils packageVersion
setMethod("updateObject", "SingleCellExperiment", function(object, ..., verbose=FALSE) {
    old.ver <- objectVersion(object)
    triggered <- FALSE

    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }

    # Update possibly outdated DataFrame instances.
    if (.hasSlot(object, "int_elementMetadata"))
        object@int_elementMetadata <-
            updateObject(object@int_elementMetadata, ..., verbose=verbose)
    if (.hasSlot(object, "int_colData"))
        object@int_colData <-
            updateObject(object@int_colData, ..., verbose=verbose)

    if (old.ver < "1.7.1") {
        # Need this to avoid a circular recursion when calling reducedDims()<-.
        int_metadata(object)$version <- packageVersion("SingleCellExperiment")

        if (!.red_key %in% colnames(int_colData(object))) {
            reddims <- NULL

            # Need the try() to handle rare cases involving an as() from old
            # subclass, which does not have @reducedDims anymore. See
            # https://github.com/drisso/SingleCellExperiment/issues/37.
            try(reddims <- object@reducedDims, silent=TRUE) 
            reducedDims(object) <- reddims
        }

        if (!.alt_key %in% colnames(int_colData(object))) { 
            altExps(object) <- NULL
        }

        triggered <- TRUE
    }

    if (old.ver < "1.9.2") {
        # Need this to avoid a circular recursion when calling sizeFactors()<-.
        int_metadata(object)$version <- packageVersion("SingleCellExperiment")

        old_sf <- int_colData(object)$size_factor
        has_sf <- sizeFactors(object)
        if (!is.null(has_sf) && !identical(has_sf, old_sf)) {
            warning(sprintf("clobbering old 'sizeFactors' in 'colData(<%s>)'", class(object)[1]))
        }
        sizeFactors(object) <- old_sf

        triggered <- TRUE
    }

    if (old.ver < "1.11.3") {
        # Need this to avoid a circular recursion when calling rowPairs()<-.
        int_metadata(object)$version <- packageVersion("SingleCellExperiment")
        
        rowPairs(object) <- list()
        colPairs(object) <- list()

        triggered <- TRUE
    }

    if (verbose && triggered) {
        message("[updateObject] ", class(object)[1], " object uses ", 
            "internal representation\n", "[updateObject] from SingleCellExperiment ", 
            old.ver, ". ", "Updating it ...\n", appendLF = FALSE)
    }

    int_metadata(object)$version <- packageVersion("SingleCellExperiment")
    callNextMethod()
})

#' Update a SingleCellExperiment object
#'
#' Update \linkS4class{SingleCellExperiment} objects to the latest version of the class structure.
#' This is usually called by methods in the \pkg{SingleCellExperiment} package rather than by users or downstream packages.
#' 
#' @param object A old \linkS4class{SingleCellExperiment} object.
#' @param ... Additional arguments that are ignored.
#' @param verbose Logical scalar indicating whether a message should be emitted as the object is updated.
#' 
#' @details
#' This function updates the SingleCellExperiment to match changes in the internal class representation.
#' Changes are as follows:
#' \itemize{
#' \item Objects created before 1.7.1 are modified to include \code{\link{altExps}} and \code{\link{reducedDims}} fields in their internal column metadata.
#' Reduced dimension results previously in the \code{reducedDims} slot are transferred to the \code{reducedDims} field.
#' \item Objects created before 1.9.1 are modified so that the size factors are stored by \code{\link{sizeFactors<-}} in \code{\link{colData}} rather than \code{\link{int_colData}}.
#' }
#' 
#' @return
#' An updated version of \code{object}.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{\link{objectVersion}}, which is used to determine if the object is up-to-date.
#' 
#' @name updateObject 
#' @export
#' @aliases updateObject updateObject,SingleCellExperiment-method
#' @importFrom BiocGenerics updateObject
#' @importFrom S4Vectors DataFrame
#' @importFrom utils packageVersion
setMethod("updateObject", "SingleCellExperiment", function(object, ..., verbose=FALSE) {
    old.ver <- objectVersion(object)
    new.ver <- packageVersion("SingleCellExperiment")
    if (old.ver >= new.ver) {
        return(object)
    }

    triggered <- FALSE

    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }

    # Update possibly outdated DataFrame instances.
    if (.hasSlot(object, "int_elementMetadata")) {
        object@int_elementMetadata <- updateObject(object@int_elementMetadata, ..., verbose=verbose)
    }
    if (.hasSlot(object, "int_colData")) {
        object@int_colData <- updateObject(object@int_colData, ..., verbose=verbose)
    }

    if (old.ver < "1.7.1") {
        # Need this to avoid a circular recursion when calling reducedDims()<-.
        int_metadata(object)$version <- packageVersion("SingleCellExperiment")

        if (!.red_key %in% colnames(int_colData(object))) {
            reddims <- NULL

            # Need the try() to handle rare cases involving an as() from old
            # subclass, which does not have @reducedDims anymore. See
            # https://github.com/drisso/SingleCellExperiment/issues/37.
            try(reddims <- object@reducedDims, silent=TRUE) 
            reducedDims(object) <- reddims
        }

        if (!.alt_key %in% colnames(int_colData(object))) { 
            altExps(object) <- NULL
        }

        triggered <- TRUE
    }

    if (old.ver < "1.9.2") {
        # Need this to avoid a circular recursion when calling sizeFactors()<-.
        int_metadata(object)$version <- packageVersion("SingleCellExperiment")

        old_sf <- int_colData(object)$size_factor
        has_sf <- sizeFactors(object)
        if (!is.null(has_sf) && !identical(has_sf, old_sf)) {
            warning(sprintf("clobbering old 'sizeFactors' in 'colData(<%s>)'", class(object)[1]))
        }
        sizeFactors(object) <- old_sf

        triggered <- TRUE
    }

    if (old.ver < "1.11.3") {
        # Need this to avoid a circular recursion when calling rowPairs()<-.
        int_metadata(object)$version <- packageVersion("SingleCellExperiment")
        
        rowPairs(object) <- list()
        colPairs(object) <- list()

        triggered <- TRUE
    }

    if (verbose && triggered) {
        message("[updateObject] ", class(object)[1], " object uses ", 
            "internal representation\n", "[updateObject] from SingleCellExperiment ", 
            old.ver, ". ", "Updating it ...\n", appendLF = FALSE)
    }

    int_metadata(object)$version <- new.ver
    callNextMethod()
})

#' @export
#' @rdname SingleCellExperiment
#' @importFrom utils packageVersion
#' @importFrom S4Vectors SimpleList
#' @importFrom stats setNames
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment
#' @importClassesFrom S4Vectors DataFrame SimpleList
setClass("SingleCellExperiment",
    slots=c(int_elementMetadata = "DataFrame",
        int_colData = "DataFrame",
        int_metadata = "list"),
    contains = "RangedSummarizedExperiment",
    prototype = prototype(
        int_metadata=list(
            version=packageVersion("SingleCellExperiment"),
            mainExpName=NULL
        )
    )
)

#' @export
#' @importClassesFrom S4Vectors DataFrame Annotated character_OR_NULL
setClass("LinearEmbeddingMatrix",
         slots = c(sampleFactors = "ANY",
                   featureLoadings = "ANY",
                   NAMES = "character_OR_NULL",
                   factorData = "DataFrame"),
         contains = "Annotated")

setClass("SummarizedExperimentByColumn", slots=c(se="SummarizedExperiment"))

setClass("DualSubset", slots=c(hits="SelfHits"))

#' Row pair methods
#'
#' Methods to get or set row pairings in a \linkS4class{SingleCellExperiment} object.
#' These are typically used to store and retrieve relationships between features, 
#' e.g., in gene regulatory or co-expression networks.
#'
#' @section Getters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{rowPair(x, type, asSparse=FALSE)}:}{
#' Retrieves a \linkS4class{SelfHits} object where each entry represents a pair of rows of \code{x}
#' and has number of nodes equal to \code{nrow(x)}.
#' \code{type} is either a string specifying the name of the row pairing in \code{x} to retrieve,
#' or a numeric scalar specifying the index of the desired pairing.
#'
#' If \code{asSparse=TRUE}, a sparse matrix is returned instead, see below for details.
#' }
#' \item{\code{rowPairNames(x)}:}{
#' Returns a character vector containing the names of all row pairings in \code{x}.
#' This is guaranteed to be of the same length as the number of pairings, though the names may not be unique.
#' }
#' \item{\code{rowPairs(x, asSparse=FALSE)}:}{
#' Returns a named \linkS4class{List} of matrices containing one or more row pairings as \linkS4class{SelfHits} objects.
#' If \code{asSparse=FALSE}, each entry is instead a sparse matrix.
#' }
#' }
#'
#' When \code{asSparse=TRUE}, the return value will be a triplet-form sparse matrix 
#' where each row/column corresponds to a row of \code{x}.
#' The values in the matrix will be taken from the first metadata field of the underlying \linkS4class{SelfHits} object,
#' with an error being raised if the first metadata field is not of an acceptable type.
#' If there are duplicate pairs, only the value from the last pair is used. 
#' If no metadata is available, the matrix values are set to \code{TRUE} for all pairs.
#'
#' @section Single setter:
#' \code{rowPair(x, type) <- value} will add or replace a row pairing
#' in a \linkS4class{SingleCellExperiment} object \code{x}.
#' The value of \code{type} determines how the pairing is added or replaced:
#' \itemize{
#' \item If \code{type} is missing, \code{value} is assigned to the first pairing.
#' If the pairing already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
#' \item If \code{type} is a numeric scalar, it must be within the range of existing pairings, 
#' and \code{value} will be assigned to the pairing at that index.
#' \item If \code{type} is a string and a pairing exists with this name, \code{value} is assigned to to that pairing.
#' Otherwise a new pairing with this name is append to the existing list of pairings.
#' }
#'
#' \code{value} is expected to be a \linkS4class{SelfHits} with number of nodes equal to \code{nrow(x)}.
#' Any number of additional fields can be placed in \code{\link{mcols}(value)}.
#' Duplicate row pairs are supported and will not be collapsed into a single entry.
#' 
#' \code{value} may also be a sparse matrix with number of rows and columns equal to \code{nrow(x)}.
#' This is converted into a \linkS4class{SelfHits} object with values stored in the metadata as the \code{"x"} field.
#'
#' Alternatively, if \code{value} is \code{NULL}, the pairings corresponding to \code{type} are removed from \code{x}.
#'
#' @section Other setters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{rowPairs(x) <- value}:}{
#' Replaces all row pairings in \code{x} with those in \code{value}.
#' The latter should be a list-like object containing any number of \linkS4class{SelfHits} or sparse matrices,
#' each of which is subject to the constraints described for the single setter.
#'
#' If \code{value} is named, those names will be used to name the row pairings in \code{x}.
#' Otherwise, unnamed pairings are assigned default names prefixed with \code{"unnamed"}.
#'
#' If \code{value} is \code{NULL}, all row pairings in \code{x} are removed.
#' }
#' \item{\code{rowPairNames(x) <- value}:}{
#' Replaces all names for row pairings in \code{x} with a character vector \code{value}.
#' This should be of length equal to the number of pairings currently in \code{x}.
#' }
#' }
#'
#' @section Interaction with SingleCellExperiment operations:
#' When row-subset replacement is performed on a SingleCellExperiment object (i.e., \code{x[i,] <- y}),
#' a pair of rows in \code{rowPair(x)} is only replaced if both rows are present in \code{i}.
#' This replacement not only affects the \code{value} of the pair but also whether it even exists in \code{y}.
#' For example, if a pair exists between two rows in \code{x[i,]} but not in the corresponding rows of \code{y},
#' it is removed upon subset replacement.
#'
#' Importantly, pairs in \code{x} with only one row in \code{i} are preserved by replacement.
#' This ensures that \code{x[i,] <- x[i,]} is a no-op.
#' However, if the replacement is fundamentally altering the identity of the features in \code{x[i,]},
#' it is unlikely that the pairings involving the old identities are applicable to the replacement features in \code{y}.
#' In such cases, additional pruning may be required to remove all pairs involving \code{i} prior to replacement.
#'
#' Another interesting note is that, for some \code{i <- 1:n} where \code{n} is in \code{[1, nrow(x))},
#' \code{rbind(x[i,], x[-i,])} will not return a SingleCellExperiment equal to \code{x} with respect to \code{\link{rowPairs}}.
#' This operation will remove any pairs involving one row in \code{i} and another row outside of \code{i},
#' simply because each individual subset operation will remove pairs involving rows outside of the subset.
#'
#' @author Aaron Lun 
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE)
#'
#' # Making up some regulatory pairings:
#' hits <- SelfHits(
#'     sample(nrow(sce), 10),
#'     sample(nrow(sce), 10),
#'     nnode=nrow(sce)
#' )
#' mcols(hits)$value <- runif(10)
#'
#' rowPair(sce, "regulators") <- hits
#' rowPair(sce, "regulators")
#' 
#' as.mat <- rowPair(sce, "regulators", asSparse=TRUE)
#' class(as.mat)
#'
#' rowPair(sce, "coexpression") <- hits
#' rowPairs(sce)
#'
#' rowPair(sce, "regulators") <- NULL
#' rowPairs(sce)
#'
#' rowPairs(sce) <- SimpleList()
#' rowPairs(sce)
#'
#' @seealso
#' \code{\link{colPairs}}, for the column equivalent.
#'
#' @name rowPairs
#' @docType methods
#' @aliases
#' rowPair rowPairs rowPairNames
#' rowPair,SingleCellExperiment,missing-method
#' rowPair,SingleCellExperiment,numeric-method
#' rowPair,SingleCellExperiment,character-method
#' rowPairs,SingleCellExperiment-method
#' rowPairNames,SingleCellExperiment-method
#' rowPair<- rowPairs<- rowPairNames<-
#' rowPair<-,SingleCellExperiment,missing-method
#' rowPair<-,SingleCellExperiment,numeric-method
#' rowPair<-,SingleCellExperiment,character-method
#' rowPairs<-,SingleCellExperiment-method
#' rowPairNames<-,SingleCellExperiment,character-method
#' [,DualSubset,ANY,ANY,ANY-method
#' [<-,DualSubset,ANY,ANY,ANY-method
#' c,DualSubset-method
#' length,DualSubset-method
NULL

.rowp_key <- "rowPairs"

#' @export
#' @importFrom S4Vectors SimpleList
setMethod("rowPairs", "SingleCellExperiment", function(x, asSparse=FALSE) {
    value <- .get_internal_all(x, 
        getfun=int_elementMetadata, 
        key=.rowp_key)

    value <- lapply(value, .get_hits)
    if (asSparse) {
        for (i in seq_along(value)) {
            value[[i]] <- .hits2mat(value[[i]])
        }
    }

    SimpleList(value)
})

#' @importClassesFrom S4Vectors SelfHits
.any2dualsubset <- function(value) {
    if (!is(value, "SelfHits")) {
        value <- .mat2hits(value)
    }
    DualSubset(value)
}

#' @export
setReplaceMethod("rowPairs", "SingleCellExperiment", function(x, value) {
    .set_internal_all(x, value, 
        getfun=int_elementMetadata,
        setfun=`int_elementMetadata<-`,
        key=.rowp_key,
        convertfun=.any2dualsubset,
        xdimfun=nrow,
        vdimfun=length,
        funstr="rowPairs",
        xdimstr="nrow",
        vdimstr="nodes")
})

#' @export
setMethod("rowPairNames", "SingleCellExperiment", function(x) {
    .get_internal_names(x, 
        getfun=int_elementMetadata, 
        key=.rowp_key)
})

#' @export
setReplaceMethod("rowPairNames", c("SingleCellExperiment", "character"), function(x, value) {
    .set_internal_names(x, value,
        getfun=int_elementMetadata,
        setfun=`int_elementMetadata<-`,
        key=.rowp_key)
})

#' @export
setMethod("rowPair", c("SingleCellExperiment", "missing"), function(x, type, asSparse=FALSE) {
    .get_internal_missing(x, 
        basefun=rowPair, 
        namefun=rowPairNames, 
        funstr="rowPair",
        asSparse=asSparse)
})

#' @export
setMethod("rowPair", c("SingleCellExperiment", "numeric"), function(x, type, asSparse=FALSE) {
    out <- .get_internal_integer(x, type,
        getfun=int_elementMetadata,
        key=.rowp_key,
        funstr="rowPair",
        substr="type")

    out <- .get_hits(out)
    if (asSparse) {
        out <- .hits2mat(out)
    }

    out
})

#' @export
setMethod("rowPair", c("SingleCellExperiment", "character"), function(x, type, asSparse=FALSE) {
    out <- .get_internal_character(x, type,
        getfun=int_elementMetadata,
        key=.rowp_key,
        funstr="rowPair",
        substr="type",
        namestr="rowPairNames")

    out <- .get_hits(out)
    if (asSparse) {
        out <- .hits2mat(out)
    }

    out
})

#' @export
setReplaceMethod("rowPair", c("SingleCellExperiment", "missing"), function(x, type, ..., value) {
    .set_internal_missing(x, value,
        basefun=`rowPair<-`,
        namefun=rowPairNames
    )
})

#' @export
setReplaceMethod("rowPair", c("SingleCellExperiment", "numeric"), function(x, type, ..., value) {
    .set_internal_numeric(x, type, value,
        getfun=int_elementMetadata,
        setfun=`int_elementMetadata<-`,
        key=.rowp_key,
        convertfun=.any2dualsubset,
        xdimfun=nrow,
        vdimfun=length,
        funstr="rowPair",
        xdimstr="nrow",
        vdimstr="nodes",
        substr="type")
})

#' @export
setReplaceMethod("rowPair", c("SingleCellExperiment", "character"), function(x, type, ..., value) {
    .set_internal_character(x, type, value, 
        getfun=int_elementMetadata,
        setfun=`int_elementMetadata<-`,
        key=.rowp_key,
        convertfun=.any2dualsubset,
        xdimfun=nrow, 
        vdimfun=length,
        funstr="rowPair", 
        xdimstr="nrow",
        vdimstr="nodes", 
        substr="type") 
})

#' @title
#' Internal SingleCellExperiment functions 
#' 
#' @description
#' Methods to get or set internal fields from the SingleCellExperiment class.
#' Thse functions are intended for package developers who want to add protected fields to a SingleCellExperiment.
#' They should \emph{not} be used by ordinary users of the \pkg{SingleCellExperiment} package.
#' 
#' @section Getters:
#' In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment}.
#' \describe{
#' \item{\code{int_elementMetadata(x)}:}{Returns a \linkS4class{DataFrame} of internal row metadata,
#' with number of rows equal to \code{nrow(x)}.
#' This is analogous to the user-visible \code{\link{rowData}}.}
#' \item{\code{int_colData(x)}:}{Returns a \linkS4class{DataFrame} of internal column metadata,
#' with number of rows equal to \code{ncol(x)}.
#' This is analogous to the user-visible \code{\link{colData}}.}
#' \item{\code{int_metadata(x)}:}{Returns a list of internal metadata, analogous to the user-visible \code{\link{metadata}}.}
#' }
#'
#' It may occasionally be useful to return both the visible and the internal \code{colData} in a single DataFrame.
#' This is facilitated by the following methods:
#' \describe{
#' \item{\code{rowData(x, ..., internal=FALSE)}:}{Returns a \linkS4class{DataFrame} of the user-visible row metadata.
#' If \code{internal=TRUE}, the internal row metadata is added column-wise to the user-visible metadata.
#' A warning is emitted if the user-visible metadata column names overlap with the internal fields.
#' Any arguments in \code{...} are passed to \code{\link{rowData,SummarizedExperiment-method}}.}
#' \item{\code{colData(x, ..., internal=FALSE)}:}{Returns a \linkS4class{DataFrame} of the user-visible column metadata.
#' If \code{internal=TRUE}, the internal column metadata is added column-wise to the user-visible metadata.
#' A warning is emitted if the user-visible metadata column names overlap with the internal fields.
#' Any arguments in \code{...} are passed to \code{\link{colData,SummarizedExperiment-method}}.}
#' } 
#'
#' @section Setters:
#' In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment}.
#' \describe{
#' \item{\code{int_elementMetadata(x) <- value}:}{Replaces the internal row metadata with \code{value},
#' a \linkS4class{DataFrame} with number of rows equal to \code{nrow(x)}.
#' This is analogous to the user-visible \code{\link{rowData<-}}.}
#' \item{\code{int_colData(x) <- value}:}{Replaces the internal column metadata with \code{value},
#' a \linkS4class{DataFrame} with number of rows equal to \code{ncol(x)}.
#' This is analogous to the user-visible \code{\link{colData<-}}.}
#' \item{\code{int_metadata(x) <- value}:}{Replaces the internal metadata with \code{value}, 
#' analogous to the user-visible \code{\link{metadata<-}}.}
#' }
#'
#' @section Comments:
#' The internal metadata fields allow easy and extensible storage of additional elements
#' that are parallel to the rows or columns of a \linkS4class{SingleCellExperiment} class.
#' This avoids the need to specify new slots and adjust the subsetting/combining code for a new data element.
#' For example, \code{\link{altExps}} and \code{\link{reducedDims}} are implemented as fields in the internal column metadata.
#'
#' That these elements are internal is important as this ensures that the implementation details are abstracted away.
#' Any user interaction with these internal fields should be done via the designated getter and setter methods,
#' e.g., \code{\link{reducedDim}} and friends for retrieving or modifying reduced dimensions.
#' This provides developers with more freedom to change the internal representation without breaking user code.
#' 
#' Package developers intending to use these methods to store their own content should read the development vignette for guidance.
#' 
#' @seealso
#' \code{\link{colData}}, \code{\link{rowData}} and \code{\link{metadata}} for the user-visible equivalents.
#'
#' @author Aaron Lun
#'
#' @name SCE-internals
#' @rdname internals
#' @docType methods
#' @aliases
#' int_colData
#' int_elementMetadata
#' int_metadata
#' int_colData,SingleCellExperiment-method
#' int_elementMetadata,SingleCellExperiment-method
#' int_metadata,SingleCellExperiment-method
#' int_colData<-
#' int_elementMetadata<-
#' int_metadata<-
#' int_colData<-,SingleCellExperiment-method
#' int_elementMetadata<-,SingleCellExperiment-method
#' int_metadata<-,SingleCellExperiment-method
#' colData,SingleCellExperiment-method
#' rowData,SingleCellExperiment-method
#' parallel_slot_names,SingleCellExperiment-method
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#' int_metadata(sce)$whee <- 1
NULL

#' @export
setMethod("int_elementMetadata", "SingleCellExperiment", function(x) x@int_elementMetadata)

#' @export
setReplaceMethod("int_elementMetadata", "SingleCellExperiment", function(x, value) {
    x@int_elementMetadata <- value
    return(x)
})

#' @export
#' @importFrom S4Vectors parallel_slot_names
setMethod("parallel_slot_names", "SingleCellExperiment", function(x) {
    c("int_elementMetadata", callNextMethod())
})

#' @export
setMethod("int_colData", "SingleCellExperiment", function(x) x@int_colData)

#' @export
setReplaceMethod("int_colData", "SingleCellExperiment", function(x, value) {
    x@int_colData <- value
    return(x)
})

#' @export
setMethod("int_metadata", "SingleCellExperiment", function(x) x@int_metadata)

#' @export
setReplaceMethod("int_metadata", "SingleCellExperiment", function(x, value) {
    x@int_metadata <- value
    return(x)
})

#' @export
#' @importFrom SummarizedExperiment colData
setMethod("colData", "SingleCellExperiment", function(x, ..., internal=FALSE) {
    if(internal) {
        cn <- colnames(x@colData) # need explicit slot reference to avoid recursive colData() calling.
        conflict <- cn %in% colnames(int_colData(x))
        if (any(conflict)) {
            cn <- cn[conflict]
            if (length(cn) > 2) {
                cn <- c(cn[seq_len(2)], "...")
            }
            warning("overlapping names in internal and external colData (", paste(cn, collapse = ", "), ")")
        }
        cbind(callNextMethod(x, ...), int_colData(x))
    } else {
        callNextMethod(x, ...)
  }
})

#' @export
#' @importFrom S4Vectors mcols
#' @importFrom SummarizedExperiment rowData
setMethod("rowData", "SingleCellExperiment", function(x, ..., internal=FALSE) {
    if (internal) {
        cn <- colnames(mcols(x))
        conflict <- cn %in% colnames(int_elementMetadata(x))
        if (any(conflict)) {
            cn <- cn[conflict]
            if (length(cn) > 2) {
                cn <- c(cn[seq_len(2)], "...")
            }
            warning("overlapping names in internal and external rowData (", paste(cn, collapse = ", "), ")")
        }
        cbind(callNextMethod(x, ...), int_elementMetadata(x))
    } else {
        callNextMethod(x, ...)
    }
})

##################################################
### Defining getters/setters for the internals ###
##################################################

#' @importClassesFrom S4Vectors SimpleList
.get_internal_all <- function(x, getfun, key, convertfun) {
    x <- updateObject(x)
    as(getfun(x)[[key]], "SimpleList")
}

#' @importFrom methods as
#' @importFrom BiocGenerics lapply
#' @importFrom S4Vectors DataFrame I mcols mcols<- metadata metadata<- 
.set_internal_all <- function(x, value, getfun, setfun, key, convertfun, xdimfun, vdimfun, funstr, xdimstr, vdimstr) {
    x <- updateObject(x)

    if (length(value) == 0L) {
        collected <- getfun(x)[, 0]
    } else {
        original <- value

        if (!is.null(convertfun)) {
            value <- lapply(value, convertfun)
        }

        N <- vapply(value, vdimfun, 0L)
        if (!all(N == xdimfun(x))) {
            stop("invalid 'value' in '", funstr, "(<", class(x), ">) <- value'\n",
                "each element of 'value' should have number of ", vdimstr, " equal to '", xdimstr, "(x)'")
        }

        names(value) <- .clean_internal_names(names(value), N=length(value), msg="names(value)")
        collected <- do.call(DataFrame, c(lapply(value, I), list(row.names=NULL, check.names=FALSE)))

        if (is(original, "Annotated")) {
            metadata(collected) <- metadata(original)
        }
        if (is(original, "Vector")) {
            mcols(collected) <- mcols(original)
        }
    }

    tmp <- getfun(x)
    tmp[[key]] <- collected
    setfun(x, tmp)
}

.clean_internal_names <- function(names, N, msg) {
    if (is.null(names) && N > 0) {
        warning("'", msg, "' is NULL, replacing with 'unnamed'")
        names <- paste0(.unnamed, seq_len(N))
    } else if (any(empty <- names=="")) {
        warning("'", msg, "' contains empty strings, replacing with 'unnamed'")
        names[empty] <- paste0(.unnamed, seq_along(sum(empty)))
    }
    names
}

.get_internal_names <- function(x, getfun, key) {
    x <- updateObject(x)
    colnames(getfun(x)[[key]])
}

.set_internal_names <- function(x, value, getfun, setfun, key) {
    x <- updateObject(x)
    tmp <- getfun(x)
    value <- .clean_internal_names(value, N=ncol(tmp[[key]]), msg="value")
    colnames(tmp[[key]]) <- value
    setfun(x, tmp)
}

.get_internal_missing <- function(x, basefun, namefun, funstr, ...) {
    if (identical(length(namefun(x)), 0L)) {
        stop("no available entries for '", funstr, "(<", class(x), ">, ...)'")
    }
    basefun(x, 1L, ...)
}

.get_internal_integer <- function(x, index, getfun, key, funstr, substr) {
    x <- updateObject(x)
    internals <- getfun(x)[[key]]

    tryCatch({
        internals[, index]
    }, error=function(err) {
        stop("invalid subscript '", substr, "' in '", funstr, "(<", class(x), ">, type=\"numeric\", ...)':\n  ",
            conditionMessage(err))
    })
}

.get_internal_character <- function(x, index, getfun, key, funstr, substr, namestr) {
    x <- updateObject(x)
    internals <- getfun(x)[[key]]

    tryCatch({
        internals[, index]
    }, error=function(err) {
        stop("invalid subscript '", substr, "' in '", funstr, "(<", class(x), ">, type=\"character\", ...)':\n  ",
            "'", index, "' not in '", namestr, "(<", class(x), ">)'")
    })
}

.set_internal_missing <- function(x, value, ..., basefun, namefun) {
    if (length(namefun(x))){
        type <- 1L
    } else {
        type <- paste0(.unnamed, 1L)
    }
    basefun(x, type, ..., value=value)
}

.set_internal_numeric <- function(x, type, value, getfun, setfun, key, 
    convertfun, xdimfun, vdimfun, funstr, xdimstr, vdimstr, substr) 
{
    x <- updateObject(x)

    if (!is.null(value)) {
        if (!is.null(convertfun)) {
            value <- convertfun(value)
        }
        if (!identical(vdimfun(value), xdimfun(x))) {
            stop("invalid 'value' in '", funstr, "(<", class(x), ">, type=\"numeric\") <- value':\n  ",
                "'value' should have number of ", vdimstr, " equal to '", xdimstr, "(x)'")
        }
    }

    internals <- getfun(x)
    if (type[1] > ncol(internals[[key]])) {
        stop("'", substr, "' out of bounds in '", funstr, "(<", class(x), ">, type='numeric')")
    }

    internals[[key]][[type]] <- value
    setfun(x, internals)
}

.set_internal_character <- function(x, type, value, getfun, setfun, key, 
    convertfun, xdimfun, vdimfun, funstr, xdimstr, vdimstr, substr) 
{
    x <- updateObject(x)

    if (!is.null(value)) {
        if (!is.null(convertfun)) {
            value <- convertfun(value)
        }
        if (!identical(vdimfun(value), xdimfun(x))) {
            stop("invalid 'value' in '", funstr, "(<", class(x), ">, type=\"character\") <- value':\n  ",
                "'value' should have number of ", vdimstr, " equal to '", xdimstr, "(x)'")
        }
    }

    internals <- getfun(x)
    internals[[key]][[type]] <- value
    setfun(x, internals)
}    

#' @importFrom S4Vectors isSingleString
.sce_validity <- function(object) {
    msg <- NULL

    if (nrow(int_elementMetadata(object))!=nrow(object)) {
        msg <- c(msg, "'nrow' of 'int_elementMetadata' not equal to 'nrow(object)'")
    }
    if (nrow(int_colData(object))!=ncol(object)) {
        msg <- c(msg, "'nrow' of 'int_colData' not equal to 'ncol(object)'")
    }

    obj.ver <- objectVersion(object)
    if (length(obj.ver) != 1 || !is(obj.ver, "numeric_version")) {
        msg <- c(msg, "'objectVersion' should return a single version value")
        return(msg) # no point checking the rest if this doesn't hold.
    }

    if (obj.ver >= "1.7.1") {
        if (!.red_key %in% colnames(int_colData(object))) {
            msg <- c(msg, "no 'reducedDims' field in 'int_colData'")
        }
        if (!.alt_key %in% colnames(int_colData(object))) {
            msg <- c(msg, "no 'altExps' field in 'int_colData'")
        }
    }

    if (obj.ver >= "1.11.3") {
        if (!.rowp_key %in% colnames(int_elementMetadata(object))) {
            msg <- c(msg, "no 'rowPairs' field in 'int_elementMetadata'")
        }
        if (!.colp_key %in% colnames(int_colData(object))) {
            msg <- c(msg, "no 'colPairs' field in 'int_colData'")
        }
    }

    main.name <- int_metadata(object)$mainExpName
    if (!is.null(main.name) && !isSingleString(main.name)) {
        msg <- c(msg, "'mainExpName' should return NULL or a single non-NA string")
    }

    if (length(msg)) { return(msg) }
    return(TRUE)
}

#' @importFrom S4Vectors setValidity2
setValidity2("SingleCellExperiment", .sce_validity)

#' Unsplit the alternative experiments
#'
#' Combine the main and alternative experiments back into one \linkS4class{SingleCellExperiment} object.
#' This is effectively the reverse operation to \code{\link{splitAltExps}}.
#'
#' @param sce A \linkS4class{SingleCellExperiment} containing alternative experiments in the \code{\link{altExps}} slot.
#' @param prefix.rows Logical scalar indicating whether the (non-\code{NULL}) row names should be prefixed with the name of the alternative experiment.
#' @param prefix.cols Logical scalar indicating whether the names of column-related fields should be prefixed with the name of the alternative experiment.
#' If \code{NA}, any \code{\link{colData}} of the \code{\link{altExps}} are ignored.
#' @param delayed Logical scalar indicating whether the combining of the assays should be delayed. 
#'
#' @return A SingleCellExperiment where all features in the alternative experiments of \code{sce} are now features in the main experiment.
#' The output object has no alternative experiments of its own.
#' 
#' @author Aaron Lun
#'
#' @details
#' This function is intended for downstream applications that accept a SingleCellExperiment but are not aware of the \code{\link{altExps}} concept.
#' By consolidating all data together, applications like \pkg{iSEE} can use the same machinery to visualize any feature of interest across all modalities.
#' However, for quantitative analyses, it is usually preferable to keep different modalities separate.
#'
#' Assays with the same name are \code{\link{rbind}}ed together in the output object.
#' If a particular name is not present for any experiment, its values are filled in with the appropriately typed \code{NA} instead.
#' By default, this is done efficiently via \linkS4class{ConstantMatrix} abstractions to avoid actually creating a dense matrix of \code{NA}s.
#' If \code{delayed=FALSE}, the combining of matrices is done without any \linkS4class{DelayedArray} wrappers,
#' yielding a simpler matrix representation at the cost of increasing memory usage.
#'
#' Any \code{\link{colData}} or \code{\link{reducedDims}} in the alternative experiments are added to those of the main experiment.
#' The names of these migrated fields are prefixed by the name of the alternative experiment if \code{prefix.cols=TRUE}.
#' 
#' Setting \code{prefix.rows=FALSE}, \code{prefix.cols=NA} and \code{delayed=FALSE} will reverse the effects of \code{\link{splitAltExps}}.
#'
#' @examples
#' counts <- matrix(rpois(10000, 5), ncol=100)
#' sce <- SingleCellExperiment(assays=list(counts=counts))
#' feat.type <- sample(c("endog", "ERCC", "adt"), nrow(sce),
#'     replace=TRUE, p=c(0.8, 0.1, 0.1))
#' sce <- splitAltExps(sce, feat.type)
#'
#' # Making life a little more complicated.
#' logcounts(sce) <- log2(counts(sce) + 1)
#' sce$cluster <- sample(5, ncol(sce), replace=TRUE)
#' reducedDim(sce, "PCA") <- matrix(rnorm(ncol(sce)*2), ncol=2)
#'  
#' # Now, putting Humpty Dumpty back together again. 
#' restored <- unsplitAltExps(sce)
#' restored
#' 
#' @seealso
#' \code{\link{splitAltExps}}, which does the reverse operation of this function.
#'
#' @export
unsplitAltExps <- function(sce, prefix.rows=TRUE, prefix.cols=TRUE, delayed=TRUE) {
    all.se <- c(list(sce), as.list(altExps(sce)))

    args <- list(
        assays=.unsplit_assays(all.se, delayed=delayed),
        colData=.combine_coldata(all.se, prefix=prefix.cols),
        reducedDims=.combine_reddims(all.se, prefix=prefix.cols),
        metadata=metadata(sce)
    )

    all.rr <- .combine_rowranges(all.se, prefix=prefix.rows)
    if (is(all.rr, "DFrame")) {
        args$rowData <- all.rr
    } else {
        args$rowRanges <- all.rr
    }

    do.call(SingleCellExperiment, args)
}

#' @importFrom DelayedArray DelayedArray ConstantArray
#' @importFrom BiocGenerics rbind
#' @importFrom SummarizedExperiment assayNames assay
.unsplit_assays <- function(all.se, delayed) {
    all_assay_names <- unique(unlist(lapply(all.se, assayNames)))
    combined <- vector("list", length(all_assay_names))
    names(combined) <- all_assay_names

    for (assay_name in all_assay_names) {
        current <- vector("list", length(all.se))

        for (s in seq_along(all.se)) {
            cur.se <- all.se[[s]]
            if (assay_name %in% assayNames(cur.se)) {
                mat <- assay(cur.se, assay_name, withDimnames=FALSE)
                if (delayed) {
                    mat <- DelayedArray(mat)
                }
                current[[s]] <- mat
            } else {
                mat <- ConstantArray(dim(cur.se), value=NA)
                if (!delayed) {
                    mat <- as.matrix(mat)
                }
                current[[s]] <- mat
            }
        }
        a <- do.call(rbind, current)
        rownames(a) <- NULL
        combined[[assay_name]] <- a
    }

    combined
}

#' @importFrom S4Vectors mcols<-
#' @importFrom GenomicRanges GRanges GRangesList
#' @importFrom SummarizedExperiment rowRanges rowData
.combine_rowranges <- function(all.se, prefix) {
    final.rd <- vector("list", length(all.se))
    for (s in seq_along(all.se)) {
        cur.se <- all.se[[s]]
        if (is(cur.se, "RangedSummarizedExperiment")) {
            final.rd[[s]] <- rowRanges(cur.se)
        }
    }

    # Filling in the empties. We promote everyone to a GRL if any of the individuals are GRLs.
    has.grl <- any(vapply(final.rd, FUN=is, class2="GRangesList", FUN.VALUE=TRUE))
    for (e in which(vapply(final.rd, is.null, FUN.VALUE=TRUE))) {
        cur.se <- all.se[[e]]
        if (has.grl) {
            empty <- GRangesList(rep(list(GRanges()), nrow(cur.se)))
        } else {
            empty <- GRanges(rep("unknown:1-0", nrow(cur.se)))
        }
        mcols(empty) <- rowData(cur.se)
        names(empty) <- rownames(cur.se)
        final.rd[[e]] <- empty
    }

    output <- NULL
    tryCatch(
        output <- do.call(c, final.rd),
        error=function(e) {
            warning(conditionMessage(e))
        }
    )

    if (is.null(output)) {
        output <- lapply(all.se, function(x) rowData(x)[,0])
        output <- do.call(rbind, output)
    }

    if (prefix) {
        prefixes <- rep(c("", sprintf("%s.", names(all.se)[-1])), vapply(all.se, nrow, 0L))
        if (is(output, "DFrame")) {
            if (!is.null(rownames(output))) {
                rownames(output) <- sprintf("%s%s", prefixes, rownames(output))
            }
        } else {
            if (!is.null(names(output))) {
                names(output) <- sprintf("%s%s", prefixes, names(output))
            }
        }
    }

    output
}

#' @importFrom SummarizedExperiment colData
.combine_coldata <- function(all.se, prefix) {
    if (!is.na(prefix)) {
        final.cd <- lapply(all.se, colData)
        final.cd <- unname(final.cd)
        if (prefix) {
            for (i in seq_along(all.se)[-1]) {
                colnames(final.cd[[i]]) <- sprintf("%s.%s", names(all.se)[i], colnames(final.cd[[i]]))
            }
        }
        do.call(cbind, final.cd)
    } else {
        colData(all.se[[1]])
    }
}

.combine_reddims <- function(all.se, prefix) {
    if (!is.na(prefix)) {
        final.rd <- lapply(all.se, function(x) {
            if (is(x, "SingleCellExperiment")) {
                reducedDims(x)
            } else {
                list()
            }
        })

        if (prefix) {
            for (i in seq_along(all.se)[-1]) {
                names(final.rd[[i]]) <- sprintf("%s.%s", names(all.se)[i], names(final.rd[[i]]))
            }
        }
        do.call(c, final.rd)
    } else {
        reducedDims(all.se[[1]])
    }
}

#' Applying over parts of a SingleCellExperiment
#'
#' Apply a function over the main and alternative Experiments of a \linkS4class{SingleCellExperiment}.
#'
#' @param X A \linkS4class{SingleCellExperiment} object.
#' @param WHICH A character or integer vector containing the names or positions of alternative Experiments to loop over.
#' @param FUN A function to apply to each Experiment.
#' @param ... Further (named) arguments to pass to all calls to \code{FUN}.
#' @param MAIN.ARGS A named list of arguments to pass to \code{FUN} for the main Experiment only.
#' Alternatively \code{NULL}, in which case the function is \emph{not} applied to the main Experiment.
#' @param ALT.ARGS A named list where each entry is named after an alternative Experiment and contains named arguments to use in \code{FUN} for that Experiment.
#' @param SIMPLIFY Logical scalar indicating whether the output should be simplified to a single SingleCellExperiment.
#' 
#' @return 
#' In most cases or when \code{SIMPLIFY=FALSE}, a list is returned containing the output of \code{FUN} applied to each Experiment.
#' If \code{MAIN.ARGS} is not \code{NULL}, the first entry corresponds to the result generated from the main Experiment;
#' all other results are generated according to the entries specified in \code{WHICH} and are named accordingly.
#' 
#' If \code{SIMPLIFY=TRUE} and certain conditions are fulfilled,
#' a SingleCellExperiment is returned where the results of \code{FUN} are mapped to the relevant main or alternative Experiments.
#' This mirrors the organization of Experiments in \code{X}.
#'
#' @author Aaron Lun
#'
#' @details
#' The behavior of this function is equivalent to creating a list containing \code{X} as the first entry and \code{\link{altExps}(X)} in the subsequent entries,
#' and then \code{\link{lapply}}ing over this list with \code{FUN} and the specified arguments.
#' In this manner, users can easily apply the same function to all the Experiments (main and alternative) in a \linkS4class{SingleCellExperiment} object.
#' 
#' Arguments in \code{...} are passed to all calls to \code{FUN}.
#' Arguments in \code{MAIN.ARGS} are only used in the call to \code{FUN} on the main Experiment.
#' Arguments in \code{ALT.ARGS} are passed to the call to \code{FUN} on the alternative Experiment of the same name.
#' For the last two, any arguments therein will override arguments of the same name in \code{...}.
#'
#' By default, looping is performed over all alternative Experiments, but the order and identities can be changed by setting \code{WHICH}.
#' Values of \code{WHICH} should be unique if any simplification of the output is desired.
#' If \code{MAIN.ARGS=NULL}, the main Experiment is ignored and the function is only applied to the alternative Experiments.
#'
#' The default of \code{SIMPLIFY=TRUE} is intended as a user-level convenience when all calls to \code{FUN} return a SingleCellExperiment with the same number of columns,
#' and \code{WHICH} itself contains no more than one reference to each alternative Experiment in \code{x}.
#' Under these conditions, the results are collated into a single SingleCellExperiment for easier downstream manipulation.
#'
#' @section Developer note:
#' When using this function inside other functions, developers should set \code{SIMPLIFY=FALSE} to guarantee consistent output for arbitrary \code{WHICH}.
#' If simplification is necessary, the output of this function can be explicitly passed to \code{\link{simplifyToSCE}},
#' typically with \code{warn.level=3} to throw an appropriate error if simplification is not possible.
#'
#' @examples
#' ncells <- 10
#' u <- matrix(rpois(200, 5), ncol=ncells)
#' sce <- SingleCellExperiment(assays=list(counts=u))
#' altExp(sce, "BLAH") <- SingleCellExperiment(assays=list(counts=u*10))
#' altExp(sce, "WHEE") <- SingleCellExperiment(assays=list(counts=u/10))
#'
#' # Here, using a very simple function that just 
#' # computes the mean of the input for each cell.
#' FUN <- function(y, multiplier=1) {
#'     colMeans(assay(y)) * multiplier
#' }
#' 
#' # Applying over all of the specified parts of 'sce'.
#' applySCE(sce, FUN=FUN)
#'
#' # Adding general arguments.
#' applySCE(sce, FUN=FUN, multiplier=5)
#' 
#' # Adding custom arguments.
#' applySCE(sce, FUN=FUN, MAIN.ARGS=list(multiplier=5))
#' applySCE(sce, FUN=FUN, ALT.ARGS=list(BLAH=list(multiplier=5)))
#'
#' # Skipping Experiments.
#' applySCE(sce, FUN=FUN, MAIN.ARGS=NULL) # skipping the main
#' applySCE(sce, FUN=FUN, WHICH=NULL) # skipping the alternatives
#' 
#' @seealso
#' \code{\link{simplifyToSCE}}, which is used when \code{SIMPLIFY=TRUE}.
#'
#' \code{\link{altExps}}, to manually extract the alternative Experiments for operations.
#' @export
applySCE <- function(X, FUN, WHICH=altExpNames(X), ..., MAIN.ARGS=list(), ALT.ARGS=list(), SIMPLIFY=TRUE) {
    use.main <- !is.null(MAIN.ARGS)
    output <- vector("list", use.main + length(WHICH))
    
    if (!is.character(WHICH)) {
        WHICH <- altExpNames(X)[WHICH]
    }
    ae.names <- WHICH
    if (use.main) {
        ae.names <- c("", WHICH)
    }
    names(output) <- ae.names

    common.args <- list(...)
    if (use.main) {
        tryCatch({
            output[[1]] <- do.call(FUN, c(list(X), .dedup_args(MAIN.ARGS, common.args)))
        }, error=function(err) {
            stop("'FUN' failed on the main Experiment:\n  ", conditionMessage(err))
        })
        ae.names <- c("", ae.names)
    }

    for (i in seq_along(WHICH)) {
        current <- WHICH[i]
        all.args <- c(list(altExp(X, current)), .dedup_args(ALT.ARGS[[current]], common.args))
        tryCatch({
            output[[i+use.main]] <- do.call(FUN, all.args)
        }, error=function(err) {
            stop("'FUN' failed on alternative Experiment '", current, "':\n  ", conditionMessage(err))
        })
    }

    if (SIMPLIFY) {
        which.main <- if (use.main) 1L else NULL
        attempt <- simplifyToSCE(output, which.main=which.main, warn.level=1)
        if (!is.null(attempt)) {
            output <- attempt
        }
    }

    output
}

.dedup_args <- function(arg1, arg2) {
    args <- c(arg1, arg2)
    args[!duplicated(names(args))]
}

# This tests the applySCE function.
# library(testthat); library(SingleCellExperiment); source("setup.R"); source("test-applySCE.R")

TESTFUN <- function(x, a=1, b=2, c=3) {
    list(X=x, ARGS=list(A=a, B=b, C=c))
}

identity2 <- function(x) {
    if (is(x, "SingleCellExperiment")) removeAltExps(x) else x
}

test_that("applySCE works as expected", {
    def <- applySCE(loaded, FUN=TESTFUN)
    expect_identical(def[[1]]$X, loaded)
    expect_identical(def[[2]]$X, altExp(loaded, "Spike"))
    expect_identical(def[[3]]$X, altExp(loaded, "Protein"))
    expect_identical(unique(lapply(def, function(x) x$ARGS)), list(list(A=1, B=2, C=3)))
    expect_identical(names(def), c("", "Spike", "Protein"))

    # Trying with custom args.
    out <- applySCE(loaded, FUN=TESTFUN, MAIN.ARGS=list(a=-1),
        ALT.ARGS=list(Spike=list(b=-2, c=-10)), a=-100)

    expect_identical(out[[1]]$ARGS, list(A=-1, B=2, C=3))
    expect_identical(out[[2]]$ARGS, list(A=-100, B=-2, C=-10))
    expect_identical(out[[3]]$ARGS, list(A=-100, B=2, C=3))

    # Other choices of WHICH work.
    def <- applySCE(loaded, FUN=TESTFUN, WHICH="Spike")
    short <- applySCE(loaded, FUN=TESTFUN, WHICH=1)
    expect_identical(def, short)

    # Check that the right names are pulled by simplifyToSCE.
    def <- applySCE(loaded, FUN=identity2)
    short <- applySCE(loaded, FUN=identity2, WHICH=1:2)
    expect_identical(def, short)
})

test_that("applySCE errors out nicely", {
    expect_error(out <- applySCE(loaded, FUN=function(x) stop("YAY")), "YAY")
    expect_error(out <- applySCE(loaded, FUN=function(x) stop("YAY")), "failed on the main Experiment", fixed=TRUE)
    expect_error(out <- applySCE(loaded, MAIN.ARGS=NULL, FUN=function(x) stop("YAY")), "failed on alternative Experiment", fixed=TRUE)
})

test_that("simplification works correctly", {
    results <- applySCE(loaded, FUN=identity2)
    expect_identical(results, loaded)

    # Manual simplification works.
    raw <- applySCE(loaded, FUN=identity2, WHICH=c("Spike", "Protein"), SIMPLIFY=FALSE)
    expect_identical(raw, list(removeAltExps(loaded), Spike=altExp(loaded), Protein=altExp(loaded, 2)))
    expect_identical(results, simplifyToSCE(raw)) # inference works correctly.

    # Simplifies even when main is absent.
    raw <- applySCE(loaded, FUN=identity2, MAIN.ARGS=NULL)
    expect_identical(nrow(raw), 0L)
    expect_identical(altExps(raw), altExps(loaded)) 
})

test_that("simplification fails correctly", {
    raw <- applySCE(loaded, FUN=identity2, SIMPLIFY=FALSE, WHICH=c("Spike", "Spike"))
    expect_warning(results <- simplifyToSCE(raw), "multiple references.*Spike")
    expect_error(results <- simplifyToSCE(raw, warn.level=3), "multiple references.*Spike")
    expect_null(results)

    raw <- applySCE(loaded, FUN=identity2, SIMPLIFY=FALSE)
    expect_error(simplifyToSCE(raw, which.main=1:2), "length(which.main)", fixed=TRUE)
    expect_error(simplifyToSCE(unname(raw)), "multiple")

    raw <- applySCE(loaded, FUN=function(x) 1, SIMPLIFY=FALSE, WHICH=1)
    expect_warning(results <- simplifyToSCE(raw, warn.level=1), NA)
    expect_warning(results <- simplifyToSCE(raw), "not a SummarizedExperiment")
    expect_null(results)

    set.seed(1000)
    raw <- applySCE(loaded, FUN=function(x) { x[,sample(ncol(x), sample(ncol(x), 1))] }, SIMPLIFY=FALSE)
    expect_warning(results <- simplifyToSCE(raw, warn.level=0), NA)
    expect_warning(results <- simplifyToSCE(raw), "columns are different")
    expect_null(results)

    raw <- applySCE(loaded, FUN=function(x) { as(x, "SummarizedExperiment") }, SIMPLIFY=FALSE, WHICH=1)
    expect_warning(results <- simplifyToSCE(raw, warn.level=1), NA)
    expect_warning(results <- simplifyToSCE(raw), "not a SingleCellExperiment")
    expect_null(results)
})

#' Alternative Experiment methods
#'
#' @description
#' In some experiments, different features must be normalized differently or have different row-level metadata.
#' Typical examples would be for spike-in transcripts in plate-based experiments and antibody or CRISPR tags in CITE-seq experiments.
#' These data cannot be stored in the main \code{assays} of the \linkS4class{SingleCellExperiment} itself.
#' However, it is still desirable to store these features \emph{somewhere} in the SingleCellExperiment.
#' This simplifies book-keeping in long workflows and ensure that samples remain synchronised.
#'
#' To facilitate this, the \linkS4class{SingleCellExperiment} class allows for \dQuote{alternative Experiments}.
#' Nested \linkS4class{SummarizedExperiment}-class objects are stored inside the SingleCellExperiment object \code{x}, in a manner that guarantees that the nested objects have the same columns in the same order as those in \code{x}.
#' Methods are provided to enable convenient access to and manipulation of these alternative Experiments.
#' Each alternative Experiment should contain experimental data and row metadata for a distinct set of features.
#'
#' @section Getters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{altExp(x, e, withColData=FALSE)}:}{
#' Retrieves a \linkS4class{SummarizedExperiment} containing alternative features (rows) for all cells (columns) in \code{x}.
#' \code{e} is either a string specifying the name of the alternative Experiment in \code{x} to retrieve,
#' or a numeric scalar specifying the index of the desired Experiment.
#' If \code{withColData=TRUE}, the column metadata of the output object is set to \code{\link{colData}(x)}.
#' }
#' \item{\code{altExpNames(x)}:}{
#' Returns a character vector containing the names of all alternative Experiments in \code{x}.
#' This is guaranteed to be of the same length as the number of results, though the names may not be unique.
#' }
#' \item{\code{altExps(x, withColData=FALSE)}:}{
#' Returns a named \linkS4class{List} of matrices containing one or more \linkS4class{SummarizedExperiment} objects.
#' Each object has the same number of columns.
#' If \code{withColData=TRUE}, the column metadata of each output object is set to \code{\link{colData}(x)}.
#' }
#' }
#'
#' @section Single-object setter:
#' \code{altExp(x, e) <- value} will add or replace an alternative Experiment
#' in a \linkS4class{SingleCellExperiment} object \code{x}.
#' The value of \code{e} determines how the result is added or replaced:
#' \itemize{
#' \item If \code{e} is missing, \code{value} is assigned to the first result.
#' If the result already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
#' \item If \code{e} is a numeric scalar, it must be within the range of existing results, and \code{value} will be assigned to the result at that index.
#' \item If \code{e} is a string and a result exists with this name, \code{value} is assigned to to that result.
#' Otherwise a new result with this name is append to the existing list of results.
#' }
#'
#' \code{value} is expected to be a SummarizedExperiment object with number of columns equal to \code{ncol(x)}.
#' Alternatively, if \code{value} is \code{NULL}, the alternative Experiment at \code{e} is removed from the object.
#'
#' @section Other setters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{altExps(x) <- value}:}{
#' Replaces all alterrnative Experiments in \code{x} with those in \code{value}.
#' The latter should be a list-like object containing any number of SummarizedExperiment objects
#' with number of columns equal to \code{ncol(x)}.
#'
#' If \code{value} is named, those names will be used to name the alternative Experiments in \code{x}.
#' Otherwise, unnamed results are assigned default names prefixed with \code{"unnamed"}.
#'
#' If \code{value} is \code{NULL}, all alternative Experiments in \code{x} are removed.
#' }
#' \item{\code{altExpNames(x) <- value}:}{
#' Replaces all names for alternative Experiments in \code{x} with a character vector \code{value}.
#' This should be of length equal to the number of results currently in \code{x}.
#' }
#' }
#'
#' \code{removeAltExps(x)} will remove all alternative Experiments from \code{x}.
#' This has the same effect as \code{altExps(x) <- NULL} but may be more convenient as it directly returns a SingleCellExperiment.
#' @seealso
#' \code{\link{splitAltExps}}, for a convenient way of adding alternative Experiments from existing features.
#'
#' \code{\link{swapAltExp}}, to swap the main and alternative Experiments.
#'
#' @author Aaron Lun
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#' dim(counts(sce))
#'
#' # Mocking up some alternative Experiments.
#' se1 <- SummarizedExperiment(matrix(rpois(1000, 5), ncol=ncol(se)))
#' rowData(se1)$stuff <- sample(LETTERS, nrow(se1), replace=TRUE)
#' se2 <- SummarizedExperiment(matrix(rpois(500, 5), ncol=ncol(se)))
#' rowData(se2)$blah <- sample(letters, nrow(se2), replace=TRUE)
#'
#' # Setting the alternative Experiments.
#' altExp(sce, "spike-in") <- se1
#' altExp(sce, "CRISPR") <- se2
#'
#' # Getting alternative Experimental data.
#' altExpNames(sce)
#' altExp(sce, "spike-in")
#' altExp(sce, 2)
#'
#' # Setting alternative Experimental data.
#' altExpNames(sce) <- c("ERCC", "Ab")
#' altExp(sce, "ERCC") <- se1[1:2,]
#'
#' @name altExps
#' @docType methods
#' @aliases
#' altExp altExps altExpNames
#' altExp,SingleCellExperiment,missing-method
#' altExp,SingleCellExperiment,numeric-method
#' altExp,SingleCellExperiment,character-method
#' altExps,SingleCellExperiment-method
#' altExpNames,SingleCellExperiment-method
#' altExp<- altExps<- altExpNames<-
#' altExp<-,SingleCellExperiment,missing-method
#' altExp<-,SingleCellExperiment,numeric-method
#' altExp<-,SingleCellExperiment,character-method
#' altExps<-,SingleCellExperiment-method
#' altExpNames<-,SingleCellExperiment,character-method
#' [,SummarizedExperimentByColumn,ANY,ANY,ANY-method
#' [<-,SummarizedExperimentByColumn,ANY,ANY,ANY-method
#' c,SummarizedExperimentByColumn-method
#' length,SummarizedExperimentByColumn-method
#' names,SummarizedExperimentByColumn-method
#' names<-,SummarizedExperimentByColumn-method
#' removeAltExps
#'
#' % Dumping the SEBC methods here, so that check doesn't complain.
NULL

.alt_key <- "altExps"

#' @export
setMethod("altExpNames", "SingleCellExperiment", function(x) {
    .get_internal_names(x, 
        getfun=int_colData, 
        key=.alt_key)
})

#' @export
#' @importFrom S4Vectors endoapply
setMethod("altExps", "SingleCellExperiment", function(x, withColData=FALSE) {
    value <- .get_internal_all(x, 
        getfun=int_colData, 
        key=.alt_key)

    value <- endoapply(value, .get_se)
    if (withColData) {
        for (i in seq_along(value)) {
            colData(value[[i]]) <- colData(x)
        }
    } else {
        for (i in seq_along(value)) {
            colnames(value[[i]]) <- colnames(x)
        }
    }

    value
})

#' @export
setMethod("altExp", c("SingleCellExperiment", "missing"), function(x, e, withColData=FALSE) {
    .get_internal_missing(x, 
        basefun=altExp, 
        namefun=altExpNames, 
        funstr="altExp",
        withColData=withColData)
})

#' @export
setMethod("altExp", c("SingleCellExperiment", "numeric"), function(x, e, withColData=FALSE) {
    out <- .get_internal_integer(x, e,
        getfun=int_colData,
        key=.alt_key,
        funstr="altExp",
        substr="e")

    out <- .get_se(out)
    if (withColData) {
        colData(out) <- colData(x)
    } else {
        colnames(out) <- colnames(x)
    }

    out
})

#' @export
setMethod("altExp", c("SingleCellExperiment", "character"), function(x, e, withColData=FALSE) {
    out <- .get_internal_character(x, e,
        getfun=int_colData,
        key=.alt_key,
        funstr="altExp",
        substr="e",
        namestr="altExpNames")

    out <- .get_se(out)
    if (withColData) {
        colData(out) <- colData(x)
    } else {
        colnames(out) <- colnames(x)
    }

    out
})

#' @export
setReplaceMethod("altExpNames", c("SingleCellExperiment", "character"), function(x, value) {
    .set_internal_names(x, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key)
})

#' @export
#' @importClassesFrom S4Vectors SimpleList
setReplaceMethod("altExps", "SingleCellExperiment", function(x, value) {
    .set_internal_all(x, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key,
        convertfun=SummarizedExperimentByColumn,
        xdimfun=ncol,
        vdimfun=length,
        funstr="altExps",
        xdimstr="ncol",
        vdimstr="columns")
})

#' @export
removeAltExps <- function(x) {
    altExps(x) <- NULL
    x
}

#' @export
setReplaceMethod("altExp", c("SingleCellExperiment", "missing"), function(x, e, ..., value) {
    .set_internal_missing(x, value,
        basefun=`altExp<-`,
        namefun=altExpNames)
})

#' @export
setReplaceMethod("altExp", c("SingleCellExperiment", "numeric"), function(x, e, ..., value) {
    .set_internal_numeric(x, e, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key,
        convertfun=SummarizedExperimentByColumn,
        xdimfun=ncol,
        vdimfun=length,
        funstr="altExp",
        xdimstr="ncol",
        vdimstr="columns",
        substr="e")
})

#' @export
setReplaceMethod("altExp", c("SingleCellExperiment", "character"), function(x, e, ..., value) {
    .set_internal_character(x, e, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key,
        convertfun=SummarizedExperimentByColumn,
        xdimfun=ncol, 
        vdimfun=length,
        funstr="altExp", 
        xdimstr="ncol",
        vdimstr="columns", 
        substr="e") 
})

#############################################
# This file defines the non-get-set methods for the LinearEmbeddingMatrix class.
#############################################

#############################################
# Sets the validity checker.

.le_validity <- function(object) {
    msg <- NULL

    # Check dimensions
    sf <- sampleFactors(object, withDimnames=FALSE)
    fl <- featureLoadings(object, withDimnames=FALSE)
    fd <- factorData(object, withDimnames=FALSE)

    if(NCOL(sf) != NCOL(fl)) {
        msg <- c(msg, "'sampleFactors' and 'featureLoadings' must have the same number of columns")
    }

    if(NROW(fd) != NCOL(sf)) {
        msg <- c(msg, "'factorData' must have one row per factor")
    }

    rn <- rownames(object)
    if (!is.null(rn) && length(rn) != NROW(sf)) {
        msg <- c(msg, "'length(NAMES)' must be NULL or equal to 'nrow(object)'")
    }
    
    if (length(msg)) { return(msg) }
    return(TRUE)
}

#' @importFrom S4Vectors setValidity2
setValidity2("LinearEmbeddingMatrix", .le_validity)

#############################################
# Sets the show method.

#' @importFrom S4Vectors metadata coolcat
.le_show <- function(object) {

    cat("class:", class(object), "\n")
    cat("dim:", dim(object), "\n")

    ## metadata
    expt <- names(metadata(object))
    if (is.null(expt)) {
        expt <- character(length(metadata(object)))
    }
    coolcat("metadata(%d): %s\n", expt)

    ## rownames
    rownames <- rownames(object)
    if(is.null(rownames)) {
        cat("rownames: NULL\n")
    } else {
        coolcat("rownames(%d): %s\n", rownames(object))
    }

    ## colnames
    colnames <- colnames(object)
    if(is.null(colnames)) {
        cat("colnames: NULL\n")
    } else {
        coolcat("colnames(%d): %s\n", colnames(object))
    }

    ## factorData
    coolcat("factorData names(%d): %s\n", names(factorData(object)))
}

#' @export
setMethod("show", "LinearEmbeddingMatrix", .le_show)

#############################################
# Defines a constructor

#' @export
#' @importClassesFrom S4Vectors DataFrame
LinearEmbeddingMatrix <- function(sampleFactors = matrix(nrow = 0, ncol = 0),
                            featureLoadings = matrix(nrow = 0, ncol = 0),
                            factorData = NULL,
                            metadata = list()) {
    if (is.null(factorData)) {
        factorData <- new("DFrame", nrows = ncol(sampleFactors))
    }
    out <- new("LinearEmbeddingMatrix",
               sampleFactors = sampleFactors,
               featureLoadings = featureLoadings,
               factorData = factorData,
               metadata = as.list(metadata)
               )
    return(out)
}

#############################################
# Define subsetting methods.

#' @export
setMethod("[", c("LinearEmbeddingMatrix", "ANY", "ANY"), function(x, i, j, ..., drop=TRUE) {
    temp_sf <- sampleFactors(x, withDimnames=FALSE) 
    temp_fl <- featureLoadings(x, withDimnames=FALSE)
    temp_fd <- factorData(x)
    temp_rn <- rownames(x)

    if(!missing(i)) {
        i <- .convert_subset_index(i, rownames(x))
        temp_sf <- temp_sf[i,,drop=FALSE]
        temp_rn <- temp_rn[i]
    }

    if(!missing(j)) {
        j <- .convert_subset_index(j, colnames(x))
        temp_sf <- temp_sf[,j,drop=FALSE]
        temp_fl <- temp_fl[,j,drop=FALSE]
        temp_fd <- temp_fd[j,,drop=FALSE]
    }

    # Returning a vector, a la drop=TRUE for a full matrix.
    if (any(dim(temp_sf)==1L) && drop) {
        colnames(temp_sf) <- rownames(temp_fd)
        rownames(temp_sf) <- temp_rn
        return(drop(temp_sf))
    }

    BiocGenerics:::replaceSlots(x, sampleFactors = temp_sf,
               featureLoadings = temp_fl, 
               factorData = temp_fd, 
               NAMES = temp_rn, check=FALSE)
})

#' @export
setMethod("[<-", c("LinearEmbeddingMatrix", "ANY", "ANY", "LinearEmbeddingMatrix"), function(x, i, j, ..., value) {
    temp_sf <- sampleFactors(x, withDimnames=FALSE)
    temp_fl <- featureLoadings(x, withDimnames=FALSE)
    temp_fd <- factorData(x, withDimnames=FALSE)

    # i is samples
    # j is factors
    if (!missing(i)) {
        i <- .convert_subset_index(i, rownames(x))
    }
    if (!missing(j)) {
        j <- .convert_subset_index(j, colnames(x))
    }

    # Inserting sample factors.
    if (missing(i) && missing(j)) {
        temp_sf <- sampleFactors(value, withDimnames=FALSE)
    } else if (missing(i)) {
        temp_sf[,j] <- sampleFactors(value, withDimnames=FALSE)
    } else if (missing(j)) {
        temp_sf[i,] <- sampleFactors(value, withDimnames=FALSE)
    } else {
        temp_sf[i,j] <- sampleFactors(value, withDimnames=FALSE)
    }

    # Dealing with the factorData, featureLoadings.
    if (missing(i) && missing(j)) {
        temp_fl <- featureLoadings(value, withDimnames=FALSE)
        temp_fd[] <- factorData(value)
    } else if (!missing(j)) {
        temp_fl[,j] <- featureLoadings(value, withDimnames=FALSE)
        temp_fd[j,] <- factorData(value)
    }
   
    BiocGenerics:::replaceSlots(x, sampleFactors = temp_sf,
               featureLoadings = temp_fl, 
               factorData = temp_fd, 
               check=FALSE)
})

#############################################
# Defining the combining methods.

#' @importFrom BiocGenerics rbind
setMethod("rbind", "LinearEmbeddingMatrix", function(..., deparse.level=1) {
    args <- list(...)
    x <- args[[1]]
    all_sf <- lapply(args, sampleFactors, withDimnames=FALSE)
    all_sf <- do.call(rbind, all_sf)

    # Checking what to do with names.
    all_rn <- lapply(args, rownames)
    unnamed <- sapply(all_rn, is.null)
    if (any(unnamed)) { 
        all_rn <- NULL
    } else {
        all_rn <- unlist(all_rn)
    }

    # Replacing the relevant slots.
    BiocGenerics:::replaceSlots(x, NAMES=all_rn, sampleFactors=all_sf, check=FALSE)
})

#' @importFrom BiocGenerics cbind
setMethod("cbind", "LinearEmbeddingMatrix", function(..., deparse.level=1) {
    args <- list(...)
    x <- args[[1]]

    all_sf <- lapply(args, sampleFactors, withDimnames=FALSE)
    all_fl <- lapply(args, featureLoadings, withDimnames=FALSE)
    all_fd <- lapply(args, factorData)

    BiocGenerics:::replaceSlots(x, sampleFactors = do.call(cbind, all_sf),
               featureLoadings = do.call(cbind, all_fl),
               factorData = do.call(rbind, all_fd), check=FALSE)
})

# Checks the combining methods.
# library(SingleCellExperiment); library(testthat); source("test-lem-combine.R")
context("LEM combine")

set.seed(1000)
ncells <- 100

factors <- matrix(rnorm(1000), ncol=10)
loadings <- matrix(runif(10000), ncol=10)
fdata <- DataFrame(WHEE=sample(LETTERS, ncol(factors)))
lem <- LinearEmbeddingMatrix(factors, loadings, fdata)

test_that("rbind works correctly", {
    shuffled <- sample(nrow(lem))
    lem.alt <- lem[shuffled,]
    samish <- rbind(lem.alt)
    expect_identical(sampleFactors(lem.alt), sampleFactors(samish))
    expect_identical(featureLoadings(lem.alt), featureLoadings(samish))
    expect_identical(factorData(lem.alt), factorData(samish))

    lem2 <- rbind(lem, lem.alt)
    expect_identical(sampleFactors(lem2, withDimnames=FALSE),
                     rbind(sampleFactors(lem, withDimnames=FALSE),
                           sampleFactors(lem.alt, withDimnames=FALSE)))
    expect_identical(featureLoadings(lem2), featureLoadings(lem))
    expect_identical(factorData(lem2), factorData(lem))
    expect_identical(rownames(lem2), NULL)
    expect_identical(colnames(lem2), NULL)

    # Works correctly with names.
    unnamed <- lem
    rownames(lem) <- paste0("CELL", seq_len(nrow(lem)))
    colnames(lem) <- paste0("FACTOR", seq_len(ncol(lem)))

    lem3 <- rbind(lem, lem[shuffled,])
    expect_identical(rownames(lem3), c(rownames(lem), rownames(lem)[shuffled]))
    expect_identical(colnames(lem3), colnames(lem))
    expect_equivalent(sampleFactors(lem3), sampleFactors(lem2))

    lem4 <- rbind(lem, unnamed)
    expect_identical(rownames(lem4), NULL)
    expect_identical(colnames(lem4), colnames(lem))
    lem4 <- rbind(unnamed, lem)
    expect_identical(rownames(lem4), NULL)
    expect_identical(colnames(lem4), NULL)

    # Throws errors correctly.
    lem.alt <- lem[,1:2]
    expect_error(rbind(lem, lem.alt), "number of columns of matrices must match")
})

test_that("cbind works correctly", {
    shuffled <- sample(ncol(factors))
    lem.alt <- lem[,shuffled]
    samish <- cbind(lem.alt)
    expect_identical(sampleFactors(lem.alt), sampleFactors(samish))
    expect_identical(featureLoadings(lem.alt), featureLoadings(samish))
    expect_identical(factorData(lem.alt), factorData(samish))

    lem2 <- cbind(lem, lem.alt)
    expect_identical(sampleFactors(lem2, withDimnames=FALSE),
                     cbind(sampleFactors(lem, withDimnames=FALSE),
                           sampleFactors(lem.alt, withDimnames=FALSE)))
    expect_identical(featureLoadings(lem2), cbind(featureLoadings(lem), featureLoadings(lem.alt)))
    expect_identical(factorData(lem2), rbind(factorData(lem), factorData(lem.alt)))
    expect_identical(rownames(lem2), NULL)
    expect_identical(colnames(lem2), NULL)

    # Works correctly with names.
    unnamed <- lem
    rownames(lem) <- paste0("CELL", seq_len(nrow(lem)))
    colnames(lem) <- paste0("FACTOR", seq_len(ncol(lem)))

    lem3<- cbind(lem, lem[,shuffled])
    expect_identical(rownames(lem3), rownames(lem))
    expect_identical(colnames(lem3), c(colnames(lem), colnames(lem)[shuffled]))
    expect_equivalent(sampleFactors(lem3), sampleFactors(lem2))

    lem4 <- cbind(unnamed, lem)
    expect_identical(rownames(lem4), NULL)
    expect_identical(colnames(lem4), NULL)
    lem4 <- cbind(lem, unnamed)
    expect_identical(rownames(lem4), rownames(lem))
    expect_identical(colnames(lem4), NULL)

    # Throws errors correctly.
    lem.alt <- lem[1:5,]
    expect_error(cbind(lem, lem.alt), "number of rows")

    lem.alt <- lem
    factorData(lem.alt)$WHEE <- NULL
    expect_error(cbind(lem, lem.alt), "column names")
})

# Checks for proper construction and get/setting of the slots of a LinearEmbeddingMatrix.
# library(SingleCellExperiment); library(testthat); source("test-lem-class.R")
context("LinearEmbeddingMatrix class")
set.seed(1000)
ncells <- 100

factors <- matrix(rnorm(1000), ncol=10)
loadings <- matrix(runif(10000), ncol=10)
lem <- LinearEmbeddingMatrix(factors, loadings)

test_that("LEM construction works correctly", {
    expect_equivalent(sampleFactors(lem, withDimnames=FALSE), factors)
    expect_identical(featureLoadings(lem), loadings)
    expect_identical(nrow(factorData(lem)), ncol(lem))
    expect_identical(ncol(factorData(lem)), 0L)

    # Trying again with an initialized factorData.
    fd <- DataFrame(YAY=seq_len(ncol(factors)))
    lem2 <- LinearEmbeddingMatrix(factors, loadings, factorData=fd)
    expect_identical(factorData(lem2), fd)
    expect_identical(lem2$YAY, fd$YAY)

    # Should throw errors if it doesn't make sense.
    expect_error(LinearEmbeddingMatrix(factors, loadings[,1:2]), "must have the same number of\n *columns")
    expect_error(LinearEmbeddingMatrix(factors, loadings, DataFrame(YAY=2)), "one row per factor")

    # Add metadata.
    md <- list(a = 1, b = "two")
    lem3 <- LinearEmbeddingMatrix(factors, loadings, factorData=fd, metadata=md)
    expect_identical(md, metadata(lem3))
})

test_that("LEM setters work correctly", {
    lem2 <- lem
    sampleFactors(lem2) <- factors * 2
    expect_identical(sampleFactors(lem2, withDimnames=FALSE), factors * 2)

    lem2 <- lem
    featureLoadings(lem2) <- -loadings
    expect_identical(featureLoadings(lem2), -loadings)

    to.add <- LETTERS[seq_len(ncol(factors))]
    lem2 <- lem
    factorData(lem2)$whee <- to.add
    expect_identical(factorData(lem2)$whee, to.add)

    # Factor Data settters.
    lem2$whee <- NULL
    expect_identical(lem2$whee, NULL)
    lem2$whee <- 42
    expect_identical(lem2$whee, rep(42, ncol(lem2)))

    # Dimnames setters.
    lem2 <- lem
    colnames(lem2) <- to.add
    expect_identical(colnames(lem2), to.add)
    cell.names <- paste0("Cell", seq_len(nrow(factors)))
    rownames(lem2) <- cell.names
    expect_identical(rownames(lem2), cell.names)

    # Should throw errors if it doesn't make sense.
    expect_error(sampleFactors(lem) <- factors[,1], "matrix-like")
    expect_error(featureLoadings(lem) <- loadings[,1], "matrix-like")
    expect_error(factorData(lem) <- 2, "DataFrame")
    expect_error(factorData(lem) <- DataFrame(YAY=2), "one row per factor")
})

test_that("getting with names makes sense", {
    rn <- paste0("Cell_", seq_len(nrow(lem)))
    rownames(lem) <- rn
    cn <- paste0("Factor_", seq_len(ncol(lem)))
    colnames(lem) <- cn

    expect_identical(rn, rownames(lem))
    expect_identical(cn, colnames(lem))

    expect_identical(sampleFactors(lem, withDimnames=FALSE), factors)
    ref <- factors
    dimnames(ref) <- list(rn, cn)
    expect_identical(sampleFactors(lem), ref)

    expect_identical(featureLoadings(lem, withDimnames=FALSE), loadings)
    ref <- loadings
    colnames(ref) <- cn
    expect_identical(featureLoadings(lem), ref)

    ref <- new("DFrame", nrows=ncol(lem))
    rownames(ref) <- cn
    expect_identical(factorData(lem, withDimnames=FALSE), ref)
    expect_identical(factorData(lem), ref) # Doesn't make a difference, as this is the reference location.
})

test_that("setting with names makes sense", {
    rn <- paste0("Cell_", seq_len(nrow(lem)))
    rownames(lem) <- rn
    cn <- paste0("Factor_", seq_len(ncol(lem)))
    colnames(lem) <- cn

    lem2 <- lem
    sampleFactors(lem2) <- factors * 2
    expect_identical(rownames(sampleFactors(lem2)), rn)
    expect_identical(colnames(sampleFactors(lem2)), cn)
    expect_equal(sampleFactors(lem2), sampleFactors(lem)*2)

    lem2 <- lem
    featureLoadings(lem2) <- loadings * 2
    expect_identical(colnames(featureLoadings(lem2)), cn)
    expect_equal(featureLoadings(lem2), featureLoadings(lem)*2)

    # This will delete the column names.
    lem2 <- lem
    factorData(lem2) <- new("DFrame", nrows=ncol(lem))
    expect_equal(ncol(factorData(lem2)), 0L)
    expect_identical(rownames(factorData(lem2)), NULL)

    # Throwing errors when the names don't match up.
    factor2 <- factors
    rownames(factor2) <- paste("X", rn)
    expect_error(sampleFactors(lem) <- factor2, "must match")
    factor2 <- factors
    colnames(factor2) <- paste("X", cn)
    expect_error(sampleFactors(lem) <- factor2, "must match")

    loading2 <- loadings
    colnames(loading2) <- paste0("Y", cn)
    expect_error(featureLoadings(lem) <- loading2, "must match")

    ref <- new("DFrame", nrows=ncol(lem))
    rownames(ref) <- paste0("Y", cn)
    expect_error(factorData(lem) <- ref, "must match")
})

library(Matrix)
test_that("as.matrix works as expected", {
    factors2 <- factors
    dimnames(factors2) <- dimnames(lem)
    expect_equal(as.matrix(lem), factors2)

    alt <- rsparsematrix(nrow(lem), ncol(lem), density=0.1)
    sampleFactors(lem) <- alt
    expect_identical(sampleFactors(lem, withDimnames=FALSE), alt)
    expect_equal(as.matrix(lem), as.matrix(alt))
})

test_that("manipulation of metadata is correct", {
    metadata(lem)$yay <- 1
    expect_equal(metadata(lem)$yay, 1)
    metadata(lem)$yay <- "stuff"
    expect_identical(metadata(lem)$yay, "stuff")
})

test_that("show method works", {
    expect_output(show(LinearEmbeddingMatrix()))
})

# Checks the subsetting methods.
# library(SingleCellExperiment); library(testthat); source("test-lem-subset.R")
context("LEM subsetting")

set.seed(1000)
ncells <- 100

factors <- matrix(rnorm(1000), ncol=10)
loadings <- matrix(runif(10000), ncol=10)
fdata <- DataFrame(WHEE=sample(LETTERS, ncol(factors)))
lem <- LinearEmbeddingMatrix(factors, loadings, fdata)

test_that("subsetting works correctly for different index types", {
    keep.dimnames <- FALSE
    for (x in 1:3) {
        if (x==1) {
            by.row <- sample(nrow(factors), nrow(factors)/2)
            by.col <- sample(ncol(factors), ncol(factors)/2)
        } else if (x==2) {
            by.row <- rbinom(nrow(factors), 1, 0.5)==1
            by.col <- rbinom(ncol(factors), 1, 0.5)==1
        } else {
            colnames(lem) <- paste0("Factor_", seq_len(ncol(factors)))
            rownames(lem) <- paste0("Cell_", seq_len(nrow(factors)))
            dimnames(factors) <- dimnames(lem)
            colnames(loadings) <- rownames(fdata) <- colnames(lem)

            by.row <- sample(rownames(lem), nrow(factors)/2)
            by.col <- sample(colnames(lem), ncol(factors)/2)
            keep.dimnames <- TRUE
        }

        # By row.
        lem.alt <- lem[by.row,]
        expect_identical(sampleFactors(lem.alt, withDimnames=keep.dimnames), factors[by.row,])
        expect_identical(featureLoadings(lem.alt), loadings)
        expect_identical(factorData(lem.alt), fdata)

        # By column.
        lem.alt <- lem[,by.col]
        expect_identical(sampleFactors(lem.alt, withDimnames=keep.dimnames), factors[,by.col])
        expect_identical(featureLoadings(lem.alt), loadings[,by.col])
        expect_identical(factorData(lem.alt), fdata[by.col,,drop=FALSE])

        # By row and column.
        lem.alt <- lem[by.row, by.col]
        expect_identical(sampleFactors(lem.alt, withDimnames=keep.dimnames), factors[by.row,by.col])
        expect_identical(featureLoadings(lem.alt), loadings[,by.col])
        expect_identical(factorData(lem.alt), fdata[by.col,,drop=FALSE])
    }
})

test_that("subsetting works correctly with drop=TRUE", {
    # By row, with and without drop.
    keeper <- lem[1,]
    expect_identical(keeper, factors[1,])

    nodrop <- lem[1,,drop=FALSE]
    expect_identical(sampleFactors(nodrop, withDimnames=FALSE), factors[1,,drop=FALSE])
    expect_identical(featureLoadings(nodrop), loadings)
    expect_identical(factorData(nodrop), fdata)

    # By column, with and without drop.
    keeper <- lem[,1]
    expect_identical(keeper, factors[,1])

    nodrop <- lem[,1,drop=FALSE]
    expect_identical(sampleFactors(nodrop, withDimnames=FALSE), factors[,1,drop=FALSE])
    expect_identical(featureLoadings(nodrop), loadings[,1,drop=FALSE])
    expect_identical(factorData(nodrop), fdata[1,,drop=FALSE])

    # Handles names correctly.
    colnames(lem) <- paste0("Factor_", seq_len(ncol(factors)))
    rownames(lem) <- paste0("Cell_", seq_len(nrow(factors)))
    expect_identical(lem[,1], sampleFactors(lem)[,1])
    expect_identical(lem[2,], sampleFactors(lem)[2,])
    expect_identical(lem[1,2], sampleFactors(lem)[1,2])

    # Throws errors correctly.
    expect_error(lem[nrow(lem)+1,], "subscript out of bounds", fixed=TRUE)
    expect_error(lem["A",], "index out of bounds", fixed=TRUE)
})

test_that("subsetting assignment works correctly", {
    keep.dimnames <- FALSE
    for (x in 1:3) {
        if (x==1) {
            dest.row <- sample(nrow(factors), nrow(factors)/2)
            src.row <- sample(nrow(factors), nrow(factors)/2)
            dest.col <- sample(ncol(factors), ncol(factors)/2)
            src.col <- sample(ncol(factors), ncol(factors)/2)
        } else if (x==2) {
            dest.row <- rbinom(nrow(factors), 1, 0.5)==1
            src.row <- sample(dest.row)
            dest.col <- rbinom(ncol(factors), 1, 0.5)==1
            src.col <- sample(dest.col)
        } else {
            colnames(lem) <- paste0("Factor_", seq_len(ncol(factors)))
            rownames(lem) <- paste0("Gene_", seq_len(nrow(factors)))
            dimnames(factors) <- dimnames(lem)
            colnames(loadings) <- rownames(fdata) <- colnames(lem)

            dest.row <- sample(rownames(lem), nrow(factors)/2)
            src.row <- sample(rownames(lem), nrow(factors)/2)
            dest.col <- sample(colnames(lem), ncol(factors)/2)
            src.col <- sample(colnames(lem), ncol(factors)/2)
            keep.dimnames <- TRUE
        }

        # By row.
        lem.alt <- lem
        lem.alt[dest.row,] <- lem[src.row,]

        ref <- factors
        ref[dest.row,] <- ref[src.row,]
        expect_identical(sampleFactors(lem.alt, withDimnames=keep.dimnames), ref)
        expect_identical(featureLoadings(lem.alt), loadings)
        expect_identical(factorData(lem.alt), fdata)

        # By column.
        lem.alt <- lem
        lem.alt[,dest.col] <- lem[,src.col]

        ref_sf <- factors
        ref_sf[,dest.col] <- ref_sf[,src.col]
        expect_identical(sampleFactors(lem.alt, withDimnames=keep.dimnames), ref_sf)

        ref_fl <- loadings
        ref_fl[,dest.col] <- ref_fl[,src.col]
        expect_identical(featureLoadings(lem.alt), ref_fl)

        ref_fd <- fdata
        ref_fd[dest.col,] <- fdata[src.col,]
        expect_identical(factorData(lem.alt), ref_fd)

        # By row and column.
        lem.alt <- lem
        lem.alt[dest.row,dest.col] <- lem[src.row,src.col]

        ref_sf <- factors
        ref_sf[dest.row,dest.col] <- ref_sf[src.row,src.col]
        expect_identical(sampleFactors(lem.alt, withDimnames=keep.dimnames), ref_sf)

        ref_fl <- loadings
        ref_fl[,dest.col] <- ref_fl[,src.col]
        expect_identical(featureLoadings(lem.alt), ref_fl)

        ref_fd <- fdata
        ref_fd[dest.col,] <- fdata[src.col,]
        expect_identical(factorData(lem.alt), ref_fd)
    }
})

test_that("subsetting works correctly with names", {
    rownames(lem) <- paste0("CELL", seq_len(nrow(lem)))
    colnames(lem) <- paste0("FACTOR", seq_len(ncol(lem)))
    out <- lem[,1:5]
    expect_identical(colnames(out), colnames(lem)[1:5])
    expect_identical(rownames(out), rownames(lem))

    out <- lem[1:5,]
    expect_identical(rownames(out), rownames(lem)[1:5])
    expect_identical(colnames(out), colnames(lem))

    # Repeating with subset assignment; names should NOT change.
    lem2 <- lem
    lem2[1:5,] <- lem[5:1,]
    expect_identical(rownames(lem2), rownames(lem))
    expect_identical(colnames(lem2), colnames(lem))

    lem2 <- lem
    lem2[,1:5] <- lem[,5:1]
    expect_identical(colnames(lem2), colnames(lem))
    expect_identical(rownames(lem2), rownames(lem))

    unnamed <- lem
    rownames(unnamed) <- NULL
    lem2 <- lem
    lem2[1:5,] <- unnamed[5:1,]
    expect_identical(rownames(lem2), rownames(lem))

    unnamed[1:5,] <- lem[5:1,]
    expect_identical(rownames(unnamed), NULL)
})

#' Simplify a list to a single SingleCellExperiment
#'
#' Simplify a list of \linkS4class{SingleCellExperiment}, usually generated by \code{\link{applySCE}} on main and alternative Experiments,
#' into a single SingleCellExperiment containing some of the results in its \code{\link{altExps}}.
#'
#' @param results A named list of SummarizedExperiment or SingleCellExperiment objects.
#' @param which.main Integer scalar specifying which entry of \code{results} contains the output generated from the main Experiment.
#' If \code{NULL} or a vector of length zero, this indicates that no entry was generated from the main Experiment.
#' Defaults to the unnamed entry of \code{results}.
#' @param warn.level Integer scalar specifying the type of warnings that can be emitted.
#'
#' @return 
#' A SingleCellExperiment corresponding to the entry of \code{results} generated from the main Experiment.
#' All results generated from the alternative Experiments of \code{x} are stored in the \code{\link{altExps}} of the output.
#' 
#' If no main Experiment was used to generate \code{results}, an empty SingleCellExperiment is used as a container for the various \code{\link{altExps}}.
#'
#' If simplification could not be performed, \code{NULL} is returned with a warning (depending on \code{warn.level}.
#'
#' @author Aaron Lun
#'
#' @details
#' Each entry of \code{results} should be a \linkS4class{SummarizedExperiment} with the same number and names of the columns.
#' There should not be any duplicate entries in \code{names(results)}, as the names are used to represent the names of the alternative Experiments in the output.
#' If \code{which.main} is a scalar, the corresponding entry of \code{results} should be a \linkS4class{SingleCellExperiment}.
#' Failure to meet these conditions may result in a warning or error depending on \code{warn.level}.
#'
#' The type of warnings that are emitted can be controlled with \code{warn.level}.
#' If \code{warn.level=0}, no warnings are emitted.
#' If \code{warn.level=1}, all warnings are emitted except for those related to \code{results} not being of the appropriate class.
#' If \code{warn.level=2}, all warnings are emitted, and if \code{warn.level=3}, warnings are promoted to errors.
#'
#' @examples
#' ncells <- 100
#' u <- matrix(rpois(20000, 5), ncol=ncells)
#' sce <- SingleCellExperiment(assays=list(counts=u))
#' altExp(sce, "BLAH") <- SingleCellExperiment(assays=list(counts=u*10))
#' altExp(sce, "WHEE") <- SingleCellExperiment(assays=list(counts=u*2))
#'
#' # Setting FUN=identity just extracts each piece:
#' results <- applySCE(sce, FUN=identity, SIMPLIFY=FALSE)
#' results
#' 
#' # Simplifying to an output that mirrors the structure of 'sce'.
#' simplifyToSCE(results)
#' 
#' @seealso
#' \code{\link{applySCE}}, where this function is used when \code{SIMPLIFY=TRUE}.
#' 
#' @export
#' @importFrom S4Vectors make_zero_col_DFrame
simplifyToSCE <- function(results, which.main, warn.level=2) {
    if (warn.level==3) {
        WTFUN <- stop
    } else if (warn.level==0) {
        WTFUN <- identity
    } else {
        WTFUN <- warning
    }

    for (i in seq_along(results)) {
        curres <- results[[i]]
        if (!is(curres, "SummarizedExperiment")) {
            if (warn.level > 1) {
                WTFUN("could not simplify as result ", i, " is not a SummarizedExperiment")
            }
            return(NULL)
        } 
    }

    if (missing(which.main)) {
        which.main <- which(names(results)=="")
        if (is.null(names(results)) || length(which.main) > 1) {
            stop("multiple entries in 'results' are unnamed")
        }
    } else {
        stopifnot(length(which.main)<=1)
    }

    if (dup <- anyDuplicated(names(results))) {
        WTFUN(paste(strwrap(paste0("could not simplify results due to multiple references to the '", names(results)[dup], "' alternative Experiment in 'results'")), collapse="\n"))
        return(NULL)
    }

    u.ncols <- unique(lapply(results, ncol))
    u.colnames <- unique(lapply(results, colnames))
    if (length(u.ncols)!=1 || length(u.colnames)!=1) {
        if (warn.level > 0) {
            WTFUN("could not simplify results as the columns are different")
        }
        return(NULL)
    }

    if (length(which.main)) {
        sce <- results[[which.main]]
        if (!is(sce, "SingleCellExperiment")) {
            if (warn.level > 1) {
                WTFUN("entry of 'results' corresponding to main Experiment is not a SingleCellExperiment")
            }
            return(NULL)
        }
    } else {
        df <- make_zero_col_DFrame(nrow=u.ncols[[1]])
        rownames(df) <- u.colnames[[1]]
        sce <- SingleCellExperiment(colData=df)
    }

    for (a in setdiff(seq_along(results), which.main)) {
        altExp(sce, names(results)[a]) <- results[[a]]
    }

    sce
}

#' Swap main and alternative Experiments
#'
#' Swap the main Experiment for an alternative Experiment in a \linkS4class{SingleCellExperiment} object.
#'
#' @param x A \linkS4class{SingleCellExperiment} object.
#' @param name String or integer scalar specifying the alternative Experiment to use to replace the main Experiment.
#' @param saved String specifying the name to use to save the original \code{x} as an alternative experiment in the output.
#' If \code{NULL}, the original is not saved.
#' @param withColData Logical scalar specifying whether the column metadata of \code{x} should be preserved in the output.
#'
#' @return A SingleCellExperiment derived from \code{altExp(x, name)}.
#' This contains all alternative Experiments in \code{altExps(x)},
#' with an additional entry containing \code{x} if \code{saved} is specified.
#' If \code{withColData=TRUE}, the column metadata is set to \code{colData(x)}.
#' 
#' @details
#' During the course of an analysis, we may need to perform operations on each of the alternative Experiments in turn.
#' This would require us to repeatedly call \code{altExp(x, name)} prior to running downstream functions on those Experiments.
#' In such cases, it may be more convenient to switch the main Experiment with the desired alternative Experiments,
#' allowing a particular section of the analysis to be performed on the latter by default.
#' 
#' For example, the initial phases of the analysis might use the entire set of features.
#' At some point, we might want to focus only on a subset of features of interest,
#' but we do not want to discard the rest of the features.
#' This can be achieved by storing the subset as an alternative Experiment and swapping it with the main Experiment,
#' as shown in the Examples below.
#'
#' @author Aaron Lun
#' @seealso 
#' \code{\link{altExps}}, for a description of the alternative Experiment concept.
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # using the class example
#'
#' # Let's say we defined a subset of genes of interest.
#' # We can save the feature set as its own altExp.
#' hvgs <- 1:10
#' altExp(sce, "subset") <- sce[hvgs,] 
#'
#' # At some point, we want to do our analysis on the HVGs only,
#' # but we want to hold onto the other features for later reference.
#' sce <- swapAltExp(sce, name="subset", saved="all")
#' sce
#' 
#' # Once we're done, it is straightforward to switch back.
#' swapAltExp(sce, "all") 
#' @export
swapAltExp <- function(x, name, saved=NULL, withColData=TRUE) {
    y <- altExp(x, name, withColData=withColData)
    y <- as(y, "SingleCellExperiment")
    altExps(y) <- altExps(x, withColData=FALSE)

    if (!is.null(saved)) {
        altExp(y, saved) <- removeAltExps(x)
    }
    y
}

# Tests for proper functioning of the altExp methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-altExp.R")

sce <- loaded

test_that("altExp getters work correctly", {
    expect_identical(altExp(sce), se1)
    expect_identical(altExp(sce, 2), se2)
    expect_identical(altExp(sce, "Protein"), se2)

    expect_identical(altExps(sce, withColData=FALSE), List(Spike=se1, Protein=se2))
    expect_identical(altExpNames(sce), c("Spike", "Protein"))

    # Carries over colData.
    colData(sce)$stuff <- runif(ncol(sce))
    expect_identical(sce$stuff, altExp(sce, withColData=TRUE)$stuff)
    expect_identical(sce$stuff, altExp(sce, "Protein", withColData=TRUE)$stuff)
    expect_identical(NULL, altExp(sce, withColData=FALSE)$stuff)

    expect_identical(sce$stuff, altExps(sce, withColData=TRUE)[[1]]$stuff)
    expect_identical(NULL, altExps(sce, withColData=FALSE)[[1]]$stuff)
})

test_that("altExp setters work correctly", {
    se3 <- se2
    assay(se3) <- assay(se3) + 1
    altExp(sce) <- se3

    expect_identical(altExp(sce), se3)
    expect_identical(altExp(sce, 1), se3)
    expect_identical(altExp(sce, "Spike"), se3)

    altExp(sce, 2) <- se3
    expect_identical(altExp(sce, 2), se3)
    expect_identical(altExp(sce, "Protein"), se3)

    altExp(sce, 1) <- NULL
    expect_identical(altExpNames(sce), "Protein")
    altExp(sce, 1) <- NULL
    expect_identical(altExpNames(sce), character(0))

    altExp(sce) <- se2
    expect_identical(altExpNames(sce), "unnamed1")
    expect_identical(altExp(sce), se2)
    altExp(sce) <- se3
    expect_identical(altExpNames(sce), "unnamed1")
    expect_identical(altExp(sce), se3)

    expect_error(altExp(sce, 5) <- se3, "out of bounds")
})

test_that("altExps setters work correctly", {
    altExps(sce) <- NULL
    expect_identical(unname(altExps(sce)), List())
    altExps(sce) <- list(whee=se1, blah=se2)
    expect_identical(altExpNames(sce), c("whee", "blah"))
    expect_identical(altExp(sce,1), se1)

    # Works without names.
    altExps(sce) <- list(se1, se2)
    expect_identical(altExpNames(sce), c("unnamed1", "unnamed2"))
    expect_identical(altExp(sce,1), se1)
    expect_identical(altExp(sce,2), se2)
})

test_that("altExpNames setters work correctly", {
    altExpNames(sce) <- c("A", "B")
    expect_identical(altExpNames(sce), c("A", "B"))

    expect_error(altExpNames(empty) <- c("A", "B"), "more column names")
    expect_error(altExpNames(empty) <- NULL, "unable to find an inherited method")
    expect_error(altExpNames(sce) <- LETTERS, "more column names")
})

test_that("splitAltExps works correctly", {
    feat.type <- sample(c("endog", "ERCC", "CITE"), nrow(empty),
        replace=TRUE, p=c(0.8, 0.1, 0.1))
    out <- splitAltExps(empty, feat.type)

    expect_identical(assay(out), assay(empty[feat.type=="endog",]))
    expect_identical(altExp(out, "ERCC"), empty[feat.type=="ERCC",])
    expect_identical(altExp(out, "CITE"), empty[feat.type=="CITE",])

    # Handles alternative reference.
    out <- splitAltExps(empty, feat.type, ref="ERCC")

    expect_identical(assay(out), assay(empty[feat.type=="ERCC",]))
    expect_identical(altExp(out, "endog"), empty[feat.type=="endog",])
    expect_identical(altExp(out, "CITE"), empty[feat.type=="CITE",])

    # Clears out colData
    empty$blah <- sample(LETTERS, ncol(empty), replace=TRUE)
    out <- splitAltExps(empty, feat.type)
    expect_identical(colnames(colData(altExp(out, withColData=FALSE))), character(0))
})

test_that("swapAltExp works correctly", {
    feat.type <- sample(c("endog", "ERCC", "CITE"), nrow(empty),
        replace=TRUE, p=c(0.8, 0.1, 0.1))
    ref <- splitAltExps(empty, feat.type)
    ref$A <- seq_len(ncol(ref))

    swapped <- swapAltExp(ref, "CITE", save="all")
    expect_identical(assay(swapped), assay(altExp(ref, "CITE")))
    expect_identical(colData(swapped), colData(ref))
    expect_identical(altExpNames(swapped), c(altExpNames(ref), "all"))

    swapped2 <- swapAltExp(swapped, "all")
    expect_identical(assay(swapped2), assay(ref))
    expect_identical(colData(swapped2), colData(ref))
    expect_identical(altExps(swapped2), altExps(swapped))

    swapped3 <- swapAltExp(swapped, "CITE", withColData=FALSE)
    expect_identical(ncol(colData(swapped3)), 0L)
})

test_that("getters and setters throw appropriate errors", {
    expect_error(altExp(empty), "no available entries")
    expect_error(altExp(sce, 3), "subscript contains out-of-bounds indices")
    expect_error(altExp(sce, "dummy"), "invalid subscript")
    expect_error(altExp(sce, 3) <- se1, "out of bounds")
})

test_that(".precheck_altExp throws appropriate errors", {
    expect_error(
        altExp(sce) <- assay(sce),
        "SummarizedExperiment"
    )

    expect_error(
        altExp(sce) <- SummarizedExperiment(),
        "number of columns"
    )
})

# Tests for proper functioning of the altExp methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-altExp.R")

sce <- loaded

test_that("altExp getters work correctly", {
    expect_identical(altExp(sce), se1)
    expect_identical(altExp(sce, 2), se2)
    expect_identical(altExp(sce, "Protein"), se2)

    expect_identical(altExps(sce), List(Spike=se1, Protein=se2))
    expect_identical(altExpNames(sce), c("Spike", "Protein"))

    # Carries over column names.
    copy <- sce
    colnames(copy) <- seq_len(ncol(copy))
    expect_identical(colnames(altExp(copy)), colnames(copy))
    expect_null(colnames(altExp(copy, withDimnames=FALSE)))

    # Carries over colData.
    expect_identical(sce$sizeFactor, altExp(sce, withColData=TRUE)$sizeFactor)
    expect_identical(sce$sizeFactor, altExp(sce, "Protein", withColData=TRUE)$sizeFactor)
    expect_identical(NULL, altExp(sce, withColData=FALSE)$sizeFactor)

    expect_identical(sce$sizeFactor, altExps(sce, withColData=TRUE)[[1]]$sizeFactor)
    expect_identical(NULL, altExps(sce, withColData=FALSE)[[1]]$sizeFactor)

    # Prepends colData properly.
    copy <- sce
    u <- runif(ncol(sce))
    altExp(copy)$BLAH <- u
    expect_identical(colData(altExp(copy, withColData=TRUE)), cbind(colData(sce), colData(altExp(copy))))
    expect_identical(colData(altExp(copy)), DataFrame(BLAH=u))
})

test_that("altExp setters work correctly", {
    se3 <- se2
    assay(se3) <- assay(se3) + 1
    altExp(sce) <- se3

    expect_identical(altExp(sce), se3)
    expect_identical(altExp(sce, 1), se3)
    expect_identical(altExp(sce, "Spike"), se3)

    altExp(sce, 2) <- se3
    expect_identical(altExp(sce, 2), se3)
    expect_identical(altExp(sce, "Protein"), se3)

    altExp(sce, 1) <- NULL
    expect_identical(altExpNames(sce), "Protein")
    altExp(sce, 1) <- NULL
    expect_identical(altExpNames(sce), character(0))

    altExp(sce) <- se2
    expect_identical(altExpNames(sce), "unnamed1")
    expect_identical(altExp(sce), se2)
    altExp(sce) <- se3
    expect_identical(altExpNames(sce), "unnamed1")
    expect_identical(altExp(sce), se3)

    expect_error(altExp(sce, 5) <- se3, "out of bounds")
})

test_that("altExp setter handles name mismatches", {
    colnames(se2) <- seq_len(ncol(se2))
    expect_warning(altExp(sce, 2) <- se2, "not the same")
    expect_warning(altExp(sce, 2, withDimnames=FALSE) <- se2, NA)

    colnames(sce) <- colnames(se2) <- seq_len(ncol(se2))
    expect_warning(altExp(sce, 2) <- se2, NA)
})

test_that("altExp setter correctly removes cloned colData.", {
    copy <- altExp(sce, 2, withColData=TRUE)

    # Attempt 1:
    expect_warning(altExp(sce, 2) <- copy, NA)
    expect_false(is.null(altExp(sce, 2)$sizeFactor))

    # Attempt 2:
    expect_warning(altExp(sce, 2, withColData=TRUE) <- copy, NA)
    expect_null(altExp(sce, 2)$sizeFactor)

    # Attempt 3:
    expect_warning(altExp(sce, 2, withColData=TRUE) <- se2, "left-most")
    expect_null(altExp(sce, 2)$sizeFactor)

    # Attempt 4:
    colData(copy) <- cbind(colData(copy), X=runif(ncol(copy)))
    expect_warning(altExp(sce, 2, withColData=TRUE) <- copy, NA)
    expect_null(altExp(sce, 2)$sizeFactor)
    expect_false(is.null(altExp(sce, 2)$X))

    # Attempt 5:
    expect_warning(rownames(altExp(sce, 2, withColData=TRUE)) <- 1:5, NA)
    expect_null(altExp(sce, 2)$sizeFactor)

    # Attempt 6:
    expect_warning(altExp(sce, 2, withColData=TRUE)$stuff <- 2, NA)
    expect_null(altExp(sce, 2)$sizeFactor)
    expect_true(all(altExp(sce, 2)$stuff==2))
})

test_that("altExps setters work correctly", {
    altExps(sce) <- NULL
    expect_identical(unname(altExps(sce)), List())
    altExps(sce) <- list(whee=se1, blah=se2)
    expect_identical(altExpNames(sce), c("whee", "blah"))
    expect_identical(altExp(sce,1), se1)

    # Works without names.
    expect_warning(altExps(sce) <- list(se1, se2), "NULL")
    expect_identical(altExpNames(sce), c("unnamed1", "unnamed2"))
    expect_identical(altExp(sce,1), se1)
    expect_identical(altExp(sce,2), se2)

    expect_warning(altExps(sce) <- list(X=se1, se2), "empty")
    expect_identical(altExpNames(sce), c("X", "unnamed1"))

    # Handles non-syntactical names.
    altExps(sce) <- list(`first thing`=se1, `second thing`=se2)
    expect_identical(altExpNames(sce), c("first thing", "second thing"))
})

test_that("altExps setter responds to withDimnames=", {
    colnames(se2) <- seq_len(ncol(se2))
    expect_warning(altExps(sce) <- list(YAY=se2), "not the same")
    expect_warning(altExps(sce, withDimnames=FALSE) <- list(YAY=se2), NA)

    colnames(sce) <- colnames(se2) <- seq_len(ncol(se2))
    expect_warning(altExps(sce) <- list(YAY=se2), NA)
})

test_that("altExps setter responds to withColData=", {
    copy <- altExps(sce, withColData=TRUE)
    expect_warning(altExps(sce) <- copy, NA)
    expect_false(is.null(altExp(sce)$sizeFactor))

    expect_warning(altExps(sce, withColData=TRUE) <- copy, NA)
    expect_null(altExp(sce)$sizeFactor)

    colData(copy[[2]]) <- cbind(stuff=runif(ncol(sce)), colData(copy[[2]]))
    expect_warning(altExps(sce, withColData=TRUE) <- copy, "left-most")
    expect_false(is.null(altExp(sce, 2)$stuff))
})

test_that("altExps getters/setters preserve mcols and metadata", {
    stuff <- List(whee=se1, blah=se2)
    mcols(stuff)$A <- c("one", "two")
    metadata(stuff)$B <- "three"

    altExps(sce) <- stuff
    out <- altExps(sce)
    expect_identical(mcols(out), mcols(stuff))
    expect_identical(metadata(out), metadata(stuff))
})

test_that("altExpNames setters work correctly", {
    altExpNames(sce) <- c("A", "B")
    expect_identical(altExpNames(sce), c("A", "B"))

    expect_warning(altExpNames(sce) <- c("X", ""), "empty")
    expect_identical(altExpNames(sce), c("X", "unnamed1"))

    expect_error(altExpNames(empty) <- c("A", "B"), "more column names")
    expect_error(altExpNames(empty) <- NULL, "unable to find an inherited method")
    expect_error(altExpNames(sce) <- LETTERS, "more column names")
})

test_that("splitAltExps works correctly", {
    feat.type <- sample(c("endog", "ERCC", "CITE"), nrow(empty),
        replace=TRUE, p=c(0.8, 0.1, 0.1))
    out <- splitAltExps(empty, feat.type)

    expect_identical(assay(out), assay(empty[feat.type=="endog",]))

    test <- empty
    mainExpName(test) <- NULL
    expect_identical(altExp(out, "ERCC"), test[feat.type=="ERCC",])
    expect_identical(altExp(out, "CITE"), test[feat.type=="CITE",])

    expect_identical(mainExpName(out), "endog")
    expect_null(mainExpName(altExp(out)))

    # Handles alternative references.
    out <- splitAltExps(empty, feat.type, ref="ERCC")

    expect_identical(assay(out), assay(empty[feat.type=="ERCC",]))
    expect_identical(altExp(out, "endog"), test[feat.type=="endog",])
    expect_identical(altExp(out, "CITE"), test[feat.type=="CITE",])
    expect_identical(mainExpName(out), "ERCC")

    # Clears out colData
    empty$blah <- sample(LETTERS, ncol(empty), replace=TRUE)
    out <- splitAltExps(empty, feat.type)
    expect_identical(colnames(colData(altExp(out, withColData=FALSE))), character(0))
})

test_that("swapAltExp works correctly", {
    feat.type <- sample(c("endog", "ERCC", "CITE"), nrow(empty),
        replace=TRUE, p=c(0.8, 0.1, 0.1))
    ref <- splitAltExps(empty, feat.type)
    ref$A <- seq_len(ncol(ref))

    swapped <- swapAltExp(ref, "CITE")
    expect_identical(assay(swapped), assay(altExp(ref, "CITE")))
    expect_identical(colData(swapped), colData(ref))

    expect_identical(altExpNames(swapped), c("ERCC", "endog"))
    expect_null(mainExpName(altExp(swapped, "endog")))
    expect_identical(mainExpName(swapped), "CITE")

    # Operation is perfectly reversible.
    swapped2 <- swapAltExp(swapped, "endog")
    altExps(swapped2) <- rev(altExps(swapped2))
    expect_identical(swapped2, ref)

    # More predictable behavior with withColData=FALSE.
    swapped3 <- swapAltExp(ref, "CITE", withColData=FALSE)
    expect_identical(ncol(colData(swapped3)), 0L)
    expect_identical(colnames(colData(altExp(swapped3, "endog"))), "A")
})

test_that("getters and setters throw appropriate errors", {
    expect_error(altExp(empty), "no available entries")
    expect_error(altExp(sce, 3), "subscript contains out-of-bounds indices")
    expect_error(altExp(sce, "dummy"), "invalid subscript")
    expect_error(altExp(sce, 3) <- se1, "out of bounds")
})

test_that(".precheck_altExp throws appropriate errors", {
    expect_error(
        altExp(sce) <- assay(sce),
        "SummarizedExperiment"
    )

    expect_error(
        altExp(sce) <- SummarizedExperiment(),
        "number of columns"
    )
})

#' Get or set column labels
#'
#' Get or set column labels in an instance of a \linkS4class{SingleCellExperiment} class.
#' Labels are expected to represent information about the the biological state of each cell.
#'
#' @param x A \linkS4class{SingleCellExperiment} object.
#' @param value Any vector-like object of length equal to \code{ncol(object)}, containing labels for all cells.
#' Alternatively \code{NULL}, in which case existing label information is removed.
#' @param ... Additional arguments, currently ignored.
#' @param onAbsence String indicating an additional action to take when labels are absent:
#' nothing (\code{"none"}), a warning (\code{"warn"}) or an error (\code{"error"}).
#'
#' @details
#' A frequent task in single-cell data analyses is to label cells with some annotation,
#' e.g., cluster identities, predicted cell type classifications and so on.
#' In a \linkS4class{SummarizedExperiment}, the \code{\link{colData}} represents the ideal place for such annotations,
#' which can be easily set and retrieved with standard methods, e.g., \code{x$label <- my.labels}.
#'
#' That said, it is desirable to have some informal standardization of the name of the column used to store these annotations as this makes it easier to programmatically set sensible defaults for retrieval of the labels in downstream functions.
#' To this end, the \code{colLabels} function will get or set labels from the \code{"label"} field of the \code{\link{colData}}.
#' This considers the use case where there is a \dQuote{primary} set of labels that represents the default grouping of cells in downstream analyses.
#'
#' To illustrate, let's say we have a downstream function that accepts a SingleCellExperiment object and requires labels.
#' When defining our function, we can set \code{colLabels(x)} as the default value for our label argument.
#' This pattern is useful as it accommodates on-the-fly changes to a secondary set of labels in \code{x} without requiring the user to run \code{colLabels(x) <- second.labels}, while facilitating convenient use of the primary labels by default.
#' 
#' For developers, \code{onAbsence} is provided to make it easier to mandate that \code{x} actually has labels.
#' This avoids silent \code{NULL} values that flow to the rest of the function and make debugging difficult.
#'
#' @author Aaron Lun
#'
#' @return
#' For \code{colLabels}, a vector or equivalent is returned containing label assignments for all cells.
#' If no labels are available, a \code{NULL} is returned (and/or a warning or error, depending on \code{onAbsence}).
#' 
#' For \code{colLabels<-}, a modified \code{x} is returned with labels in its \code{\link{colData}}.
#' 
#' @seealso
#' \linkS4class{SingleCellExperiment}, for the underlying class definition. 
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#' colLabels(sce) <- sample(LETTERS, ncol(sce), replace=TRUE)
#' colLabels(sce)
#'
#' @docType methods
#' @name colLabels
#' @aliases colLabels colLabels<-
NULL

.label_field <- "label"

#' @export
#' @rdname colLabels
#' @importFrom SummarizedExperiment colData
setMethod("colLabels", "SingleCellExperiment", function(x, onAbsence="none") {
    output <- colData(x)[[.label_field]]
    .absent_action(x, val=output, fun="colLabels", onAbsence=onAbsence)
    output
})

#' @export
#' @rdname colLabels
#' @importFrom SummarizedExperiment colData<- colData
setReplaceMethod("colLabels", "SingleCellExperiment", function(x, ..., value) {
    colData(x)[[.label_field]] <- value
    x
})

#' Split off alternative features
#'
#' Split a \linkS4class{SingleCellExperiment} based on the feature type, creating alternative Experiments to hold features that are not in the majority set.
#'
#' @param x A \linkS4class{SingleCellExperiment} object.
#' @param f A character vector or factor of length equal to \code{nrow(x)}, specifying the feature type of each row.
#' @param ref String indicating which level of \code{f} should be treated as the main set.
#'
#' @return
#' A SingleCellExperiment where each row corresponds to a feature in the main set.
#' Each other feature type is stored as an alternative Experiment, accessible by \code{\link{altExp}}.
#' \code{ref} is used as the \code{\link{mainExpName}}.
#'
#' @details
#' This function provides a convenient way to create a SingleCellExperiment with alternative Experiments.
#' For example, a SingleCellExperiment with rows corresponding to all features can be quickly split into endogenous genes (main)
#' and other alternative features like spike-in transcripts and antibody tags.
#'
#' By default, the most frequent level of \code{f} is treated as the \code{ref} if the latter is not specified.
#'
#' @author
#' Aaron Lun
#'
#' @seealso
#' \code{\link{altExp}}, to access and manipulate the alternative Experiment fields.
#'
#' \code{\link{unsplitAltExps}}, to reverse the splitting.
#' @examples
#' example(SingleCellExperiment, echo=FALSE)
#' feat.type <- sample(c("endog", "ERCC", "CITE"), nrow(sce),
#'     replace=TRUE, p=c(0.8, 0.1, 0.1))
#'
#' sce2 <- splitAltExps(sce, feat.type)
#' sce2
#' @export
#' @importFrom SummarizedExperiment colData colData<-
splitAltExps <- function(x, f, ref=NULL) {
    by.feat <- split(seq_along(f), f)
    if (is.null(ref)) {
        ref <- names(by.feat)[which.max(lengths(by.feat))]
    }

    x0 <- x[by.feat[[ref]], ]
    for (other in setdiff(names(by.feat), ref)) {
        # Clearing out the colData() before adding it.
        subset <- x[by.feat[[other]],]
        colData(subset) <- colData(subset)[, 0]
        mainExpName(subset) <- NULL
        altExp(x0, other) <- subset
    }

    mainExpName(x0) <- ref
    x0
}

#' Column pair methods
#'
#' Methods to get or set column pairings in a \linkS4class{SingleCellExperiment} object.
#' These are typically used to store and retrieve relationships between cells, 
#' e.g., in nearest-neighbor graphs or for inferred cell-cell interactions.
#'
#' @section Getters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{colPair(x, type, asSparse=FALSE)}:}{
#' Retrieves a \linkS4class{SelfHits} object where each entry represents a pair of columns of \code{x}
#' and has number of nodes equal to \code{ncol(x)}.
#' \code{type} is either a string specifying the name of the column pairing in \code{x} to retrieve,
#' or a numeric scalar specifying the index of the desired result.
#'
#' If \code{asSparse=TRUE}, a sparse matrix is returned instead, see below for details.
#' }
#' \item{\code{colPairNames(x)}:}{
#' Returns a character vector containing the names of all column pairings in \code{x}.
#' This is guaranteed to be of the same length as the number of results, though the names may not be unique.
#' }
#' \item{\code{colPairs(x, asSparse=FALSE)}:}{
#' Returns a named \linkS4class{List} of matrices containing one or more column pairings as \linkS4class{SelfHits} objects.
#' If \code{asSparse=FALSE}, each entry is instead a sparse matrix.
#' }
#' }
#'
#' When \code{asSparse=TRUE}, the return value will be a triplet-form sparse matrix 
#' where each row/column corresponds to a column of \code{x}.
#' The values in the matrix will be taken from the first metadata field of the underlying \linkS4class{SelfHits} object,
#' with an error being raised if the first metadata field is not of an acceptable type.
#' If there are duplicate pairs, only the value from the last pair is used. 
#' If no metadata is available, the matrix values are set to \code{TRUE} for all pairs.
#'
#' @section Single setter:
#' \code{colPair(x, type) <- value} will add or replace a column pairing
#' in a \linkS4class{SingleCellExperiment} object \code{x}.
#' The value of \code{type} determines how the pairing is added or replaced:
#' \itemize{
#' \item If \code{type} is missing, \code{value} is assigned to the first pairing.
#' If the pairing already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
#' \item If \code{type} is a numeric scalar, it must be within the range of existing pairings, 
#' and \code{value} will be assigned to the pairing at that index.
#' \item If \code{type} is a string and a pairing exists with this name, \code{value} is assigned to to that pairing.
#' Otherwise a new pairing with this name is append to the existing list of pairings.
#' }
#'
#' \code{value} is expected to be a \linkS4class{SelfHits} with number of nodes equal to \code{ncol(x)}.
#' Any number of additional fields can be placed in \code{\link{mcols}(value)}.
#' Duplicate column pairs are supported and will not be collapsed into a single entry.
#' 
#' \code{value} may also be a sparse matrix with number of rows and columns equal to \code{ncol(x)}.
#' This is converted into a \linkS4class{SelfHits} object with values stored in the metadata as the \code{"x"} field.
#' 
#' Alternatively, if \code{value} is \code{NULL}, the pairings corresponding to \code{type} are removed from \code{x}.
#'
#' @section Other setters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{colPairs(x) <- value}:}{
#' Replaces all column pairings in \code{x} with those in \code{value}.
#' The latter should be a list-like object containing any number of \linkS4class{SelfHits} or sparse matrices,
#' each of which is subject to the constraints described for the single setter.
#'
#' If \code{value} is named, those names will be used to name the column pairings in \code{x}.
#' Otherwise, unnamed pairings are assigned default names prefixed with \code{"unnamed"}.
#'
#' If \code{value} is \code{NULL}, all column pairings in \code{x} are removed.
#' }
#' \item{\code{colPairNames(x) <- value}:}{
#' Replaces all names for column pairings in \code{x} with a character vector \code{value}.
#' This should be of length equal to the number of pairings currently in \code{x}.
#' }
#' }
#'
#' @section Interaction with SingleCellExperiment operations:
#' When column-subset replacement is performed on a SingleCellExperiment object (i.e., \code{x[,i] <- y}),
#' a pair of columns in \code{colPair(x)} is only replaced if both columns are present in \code{i}.
#' This replacement not only affects the \code{value} of the pair but also whether it even exists in \code{y}.
#' For example, if a pair exists between two columns in \code{x[,i]} but not in the corresponding columns of \code{y},
#' it is removed upon subset replacement.
#'
#' Importantly, pairs in \code{x} with only one column in \code{i} are preserved by replacement.
#' This ensures that \code{x[,i] <- x[,i]} is a no-op.
#' However, if the replacement is fundamentally altering the identity of the features in \code{x[,i]},
#' it is unlikely that the pairings involving the old identities are applicable to the replacement features in \code{y}.
#' In such cases, additional pruning may be required to remove all pairs involving \code{i} prior to replacement.
#'
#' Another interesting note is that, for some \code{i <- 1:n} where \code{n} is in \code{[1, ncol(x))},
#' \code{cbind(x[,i], x[,-i])} will not return a SingleCellExperiment equal to \code{x} with respect to \code{\link{colPairs}}.
#' This operation will remove any pairs involving one column in \code{i} and another column outside of \code{i},
#' simply because each individual subset operation will remove pairs involving columns outside of the subset.
#'
#' @author Aaron Lun 
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE)
#'
#' # Making up some regulatory pairings:
#' hits <- SelfHits(
#'     sample(ncol(sce), 10),
#'     sample(ncol(sce), 10),
#'     nnode=ncol(sce)
#' )
#' mcols(hits)$value <- runif(10)
#'
#' colPair(sce, "regulators") <- hits
#' colPair(sce, "regulators")
#' 
#' as.mat <- colPair(sce, "regulators", asSparse=TRUE)
#' class(as.mat)
#'
#' colPair(sce, "coexpression") <- hits
#' colPairs(sce)
#'
#' colPair(sce, "regulators") <- NULL
#' colPairs(sce)
#'
#' colPairs(sce) <- SimpleList()
#' colPairs(sce)
#'
#' @seealso
#' \code{\link{rowPairs}}, for the row equivalent.
#'
#' @name colPairs
#' @docType methods
#' @aliases
#' colPair colPairs colPairNames
#' colPair,SingleCellExperiment,missing-method
#' colPair,SingleCellExperiment,numeric-method
#' colPair,SingleCellExperiment,character-method
#' colPairs,SingleCellExperiment-method
#' colPairNames,SingleCellExperiment-method
#' colPair<- colPairs<- colPairNames<-
#' colPair<-,SingleCellExperiment,missing-method
#' colPair<-,SingleCellExperiment,numeric-method
#' colPair<-,SingleCellExperiment,character-method
#' colPairs<-,SingleCellExperiment-method
#' colPairNames<-,SingleCellExperiment,character-method
NULL

.colp_key <- "colPairs"

#' @export
#' @importFrom S4Vectors SimpleList
setMethod("colPairs", "SingleCellExperiment", function(x, asSparse=FALSE) {
    value <- .get_internal_all(x, 
        getfun=int_colData, 
        key=.colp_key)

    value <- lapply(value, .get_hits)
    if (asSparse) {
        for (i in seq_along(value)) {
            value[[i]] <- .hits2mat(value[[i]])
        }
    }

    SimpleList(value)
})

#' @importClassesFrom S4Vectors SelfHits
.any2dualsubset <- function(value) {
    if (!is(value, "SelfHits")) {
        value <- .mat2hits(value)
    }
    DualSubset(value)
}

#' @export
setReplaceMethod("colPairs", "SingleCellExperiment", function(x, value) {
    .set_internal_all(x, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.colp_key,
        convertfun=.any2dualsubset,
        xdimfun=ncol,
        vdimfun=length,
        funstr="colPairs",
        xdimstr="ncol",
        vdimstr="nodes")
})

#' @export
setMethod("colPairNames", "SingleCellExperiment", function(x) {
    .get_internal_names(x, 
        getfun=int_colData, 
        key=.colp_key)
})

#' @export
setReplaceMethod("colPairNames", c("SingleCellExperiment", "character"), function(x, value) {
    .set_internal_names(x, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.colp_key)
})

#' @export
setMethod("colPair", c("SingleCellExperiment", "missing"), function(x, type, asSparse=FALSE) {
    .get_internal_missing(x, 
        basefun=colPair, 
        namefun=colPairNames, 
        funstr="colPair",
        asSparse=asSparse)
})

#' @export
setMethod("colPair", c("SingleCellExperiment", "numeric"), function(x, type, asSparse=FALSE) {
    out <- .get_internal_integer(x, type,
        getfun=int_colData,
        key=.colp_key,
        funstr="colPair",
        substr="type")

    out <- .get_hits(out)
    if (asSparse) {
        out <- .hits2mat(out)
    }

    out
})

#' @export
setMethod("colPair", c("SingleCellExperiment", "character"), function(x, type, asSparse=FALSE) {
    out <- .get_internal_character(x, type,
        getfun=int_colData,
        key=.colp_key,
        funstr="colPair",
        substr="type",
        namestr="colPairNames")

    out <- .get_hits(out)
    if (asSparse) {
        out <- .hits2mat(out)
    }

    out
})

#' @export
setReplaceMethod("colPair", c("SingleCellExperiment", "missing"), function(x, type, ..., value) {
    .set_internal_missing(x, value,
        basefun=`colPair<-`,
        namefun=colPairNames
    )
})

#' @export
setReplaceMethod("colPair", c("SingleCellExperiment", "numeric"), function(x, type, ..., value) {
    .set_internal_numeric(x, type, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.colp_key,
        convertfun=.any2dualsubset,
        xdimfun=ncol,
        vdimfun=length,
        funstr="colPair",
        xdimstr="ncol",
        vdimstr="nodes",
        substr="type")
})

#' @export
setReplaceMethod("colPair", c("SingleCellExperiment", "character"), function(x, type, ..., value) {
    .set_internal_character(x, type, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.colp_key,
        convertfun=.any2dualsubset,
        xdimfun=ncol, 
        vdimfun=length,
        funstr="colPair", 
        xdimstr="ncol",
        vdimstr="nodes", 
        substr="type") 
})

# Defines methods for new generics for LinearEmbeddingMatrix.

#' @export
setMethod("sampleFactors", "LinearEmbeddingMatrix", function(x, withDimnames=TRUE) {
    sf <- x@sampleFactors
    if (withDimnames) {
        dimnames(sf) <- dimnames(x)
    }
    return(sf)
})

#' @export
setMethod("featureLoadings", "LinearEmbeddingMatrix", function(x, withDimnames=TRUE){
    fl <- x@featureLoadings
    if(withDimnames){
        colnames(fl) <- colnames(x)
    }
    return(fl)
})

#' @export
setMethod("factorData", "LinearEmbeddingMatrix", function(x){
    x@factorData
})

#' @export
setReplaceMethod("sampleFactors", "LinearEmbeddingMatrix", function(x, value) {
    if (length(dim(value))!=2L) {
        stop("'value' should be a matrix-like object") 
    }
    if ((!is.null(colnames(value)) && !identical(colnames(value), colnames(x))) 
        || (!is.null(rownames(value)) && !identical(rownames(value), rownames(x))) ) {
        stop("'dimnames(value)' must match 'dimnames(x)' when setting sampleFactors")
    }

    x@sampleFactors <- value
    validObject(x)
    return(x)
})

#' @export
setReplaceMethod("featureLoadings", "LinearEmbeddingMatrix", function(x, value) {
    if (length(dim(value))!=2L) {
        stop("'value' should be a matrix-like object")
    }
    if (!is.null(colnames(value)) && !identical(colnames(value), colnames(x))){
        stop("'colnames(value)' must match 'colnames(x)' when setting featureLoadings")
    }
  
    x@featureLoadings <- value
    validObject(x)
    return(x)
})

#' @export
setReplaceMethod("factorData", "LinearEmbeddingMatrix", function(x, value) {
    if (!is(value, "DataFrame")) {
        stop("'value' should be a DataFrame")
    }
    if (!is.null(rownames(value)) && !identical(rownames(value), colnames(x))){
        stop("'rownames(value)' must match 'colnames(x)' when setting factorData")
    }
    
    x@factorData <- value
    validObject(x)
    return(x)
})

#' @export
setMethod("$", "LinearEmbeddingMatrix", function(x, name) {
    factorData(x)[[name]]
})

#' @export
setReplaceMethod("$", "LinearEmbeddingMatrix", function(x, name, value) {
    factorData(x)[[name]] <- value
    return(x)
})

#############################################
# Define matrix methods.

#' @export
setMethod("dim", "LinearEmbeddingMatrix", function(x) {
    dim(sampleFactors(x))
})

#' @export
setMethod("dimnames", "LinearEmbeddingMatrix", function(x) {
    list(x@NAMES, rownames(factorData(x)))
})

#' @export
setReplaceMethod("dimnames", "LinearEmbeddingMatrix", function(x, value) {
    fd <- factorData(x)
    rownames(fd) <- value[[2]]
    BiocGenerics:::replaceSlots(x, NAMES=value[[1]], factorData=fd, check=FALSE)
})

#' @export
#' @method as.matrix LinearEmbeddingMatrix
as.matrix.LinearEmbeddingMatrix <- function(x, ...) {
    y <- sampleFactors(x)
    while (!is.matrix(y)) { # in case of sparsity or other madness.
        y <- as.matrix(y)
    }
    return(y)
}

#' @export
setMethod("as.matrix", "LinearEmbeddingMatrix", as.matrix.LinearEmbeddingMatrix)

########################################
# Getters/setters for linearEmbedding.

#' @export
setGeneric("sampleFactors", function(x, ...) standardGeneric("sampleFactors"))

#' @export
setGeneric("sampleFactors<-", function(x, ..., value) standardGeneric("sampleFactors<-"))

#' @export
setGeneric("featureLoadings", function(x, ..., withDimnames=TRUE) standardGeneric("featureLoadings"))

#' @export
setGeneric("featureLoadings<-", function(x, ..., value) standardGeneric("featureLoadings<-"))

#' @export
setGeneric("factorData", function(x, ..., withDimnames=TRUE) standardGeneric("factorData"))

#' @export
setGeneric("factorData<-", function(x, ..., value) standardGeneric("factorData<-"))

########################################
# Getter/setters for reducedDim.

#' @export
setGeneric("reducedDim", function(x, type, ...) standardGeneric("reducedDim"))

#' @export
setGeneric("reducedDim<-", function(x, type, withDimnames=TRUE, ..., value) standardGeneric("reducedDim<-"))

#' @export
setGeneric("reducedDimNames", function(x) standardGeneric("reducedDimNames"))

#' @export
setGeneric("reducedDimNames<-", function(x, value) standardGeneric("reducedDimNames<-"))

#' @export
setGeneric("reducedDims", function(x, ...) standardGeneric("reducedDims"))

#' @export
setGeneric("reducedDims<-", function(x, withDimnames=TRUE, ..., value) standardGeneric("reducedDims<-"))

########################################
# Hidden getter/setters for internal slots.

#' @export
setGeneric("int_elementMetadata", function(x) standardGeneric("int_elementMetadata"))

#' @export
setGeneric("int_elementMetadata<-", function(x, value) standardGeneric("int_elementMetadata<-"))

#' @export
setGeneric("int_colData", function(x) standardGeneric("int_colData"))

#' @export
setGeneric("int_colData<-", function(x, value) standardGeneric("int_colData<-"))

#' @export
setGeneric("int_metadata", function(x) standardGeneric("int_metadata"))

#' @export
setGeneric("int_metadata<-", function(x, value) standardGeneric("int_metadata<-"))

########################################
# Miscellaneous methods.

#' @export
setGeneric("colLabels", function(x, ...) standardGeneric("colLabels"))

#' @export
setGeneric("colLabels<-", function(x, ..., value) standardGeneric("colLabels<-"))

#' @export
setGeneric("rowSubset", function(x, ...) standardGeneric("rowSubset"))

#' @export
setGeneric("rowSubset<-", function(x, ..., value) standardGeneric("rowSubset<-"))

#' @export
setGeneric("objectVersion", function(x) standardGeneric("objectVersion"))

########################################
# Alternative experiment getter/setters.

#' @export
setGeneric("altExp", function(x, e, ...) standardGeneric("altExp"))

#' @export
setGeneric("altExps", function(x, ...) standardGeneric("altExps"))

#' @export
setGeneric("altExpNames", function(x, ...) standardGeneric("altExpNames"))

#' @export
setGeneric("altExp<-", function(x, e, withDimnames=TRUE, withColData=FALSE, ..., value) standardGeneric("altExp<-"))

#' @export
setGeneric("altExps<-", function(x, withDimnames=TRUE, withColData=FALSE, ..., value) standardGeneric("altExps<-"))

#' @export
setGeneric("altExpNames<-", function(x, ..., value) standardGeneric("altExpNames<-"))

#' @export
setGeneric("mainExpName", function(x) standardGeneric("mainExpName"))

#' @export
setGeneric("mainExpName<-", function(x, value) standardGeneric("mainExpName<-"))

########################################
# Pairing getter/setters.

#' @export
setGeneric("colPair", function(x, type, ...) standardGeneric("colPair"))

#' @export
setGeneric("colPairs", function(x, ...) standardGeneric("colPairs"))

#' @export
setGeneric("colPairNames", function(x, ...) standardGeneric("colPairNames"))

#' @export
setGeneric("colPair<-", function(x, type, ..., value) standardGeneric("colPair<-"))

#' @export
setGeneric("colPairs<-", function(x, ..., value) standardGeneric("colPairs<-"))

#' @export
setGeneric("colPairNames<-", function(x, ..., value) standardGeneric("colPairNames<-"))

#' @export
setGeneric("rowPair", function(x, type, ...) standardGeneric("rowPair"))

#' @export
setGeneric("rowPairs", function(x, ...) standardGeneric("rowPairs"))

#' @export
setGeneric("rowPairNames", function(x, ...) standardGeneric("rowPairNames"))

#' @export
setGeneric("rowPair<-", function(x, type, ..., value) standardGeneric("rowPair<-"))

#' @export
setGeneric("rowPairs<-", function(x, ..., value) standardGeneric("rowPairs<-"))

#' @export
setGeneric("rowPairNames<-", function(x, ..., value) standardGeneric("rowPairNames<-"))

########################################
# Convenience assay getter/setters.

#' @export
setGeneric("normcounts", function(object, ...) standardGeneric("normcounts"))

#' @export
setGeneric("normcounts<-", function(object, ..., value) standardGeneric("normcounts<-"))

#' @export
setGeneric("logcounts", function(object, ...) standardGeneric("logcounts"))

#' @export
setGeneric("logcounts<-", function(object, ..., value) standardGeneric("logcounts<-"))

#' @export
setGeneric("cpm", function(object, ...) standardGeneric("cpm"))

#' @export
setGeneric("cpm<-", function(object, ..., value) standardGeneric("cpm<-"))

#' @export
setGeneric("tpm", function(object, ...) standardGeneric("tpm"))

#' @export
setGeneric("tpm<-", function(object, ..., value) standardGeneric("tpm<-"))

#' @export
setGeneric("weights<-", function(object, ..., value) standardGeneric("weights<-"))

# Setting up the options for a fully loaded SingleCellExperiment.

set.seed(1000)
ncells <- 100
u <- matrix(rpois(20000, 5), ncol=ncells)
v <- matrix(rnorm(20000), ncol=ncells)
empty <- SingleCellExperiment(list(counts=u, logcounts=v))
loaded <- empty

#########################################
# Mocking up some reduced dimensions.

d1 <- matrix(rnorm(ncells*4), ncol=4)
d2 <- matrix(rnorm(ncells*2), ncol=2)
reducedDim(loaded, "PCA") <- d1
reducedDim(loaded, "TSNE") <- d2

#########################################
# Mocking up some alternative Experiments.

se1 <- SummarizedExperiment(
    list(counts=matrix(rpois(1000, 5), ncol=ncells),
        logcounts=matrix(rnorm(1000, 5), ncol=ncells)
    )
)
rowData(se1)$stuff <- sample(LETTERS, nrow(se1), replace=TRUE)
rownames(se1) <- sprintf("SPIKE_%i", seq_len(nrow(se1)))

se2 <- SummarizedExperiment(
    list(counts=matrix(rpois(500, 5), ncol=ncells),
        logcounts=matrix(rnorm(500), ncol=ncells)
    )
)
rowData(se2)$blah <- sample(letters, nrow(se2), replace=TRUE)
rownames(se2) <- sprintf("TAG_%i", seq_len(nrow(se2)))

altExp(loaded, "Spike") <- se1
altExp(loaded, "Protein") <- se2

#########################################
# Adding some pairings.

rhits <- SelfHits(
    sample(nrow(loaded), 100),
    sample(nrow(loaded), 100),
    nnode=nrow(loaded)
)
mcols(rhits)$value <- runif(100)

chits <- SelfHits(
    sample(ncol(loaded), 20),
    sample(ncol(loaded), 20),
    nnode=ncol(loaded)
)
mcols(chits)$value <- runif(20)

rowPair(loaded) <- rhits
colPair(loaded) <- chits

#########################################
# Other load-ups. 

sizeFactors(loaded) <- 2^rnorm(ncells)

# Basic methods for the DualSubset class,
# an internal class that powers the *Pairs methods.

.get_hits <- function(x) x@hits

DualSubset <- function(hits) new("DualSubset", hits=sort(hits))

#' @importFrom S4Vectors nnode
setMethod("length", "DualSubset", function(x) nnode(.get_hits(x)))

#' @importFrom S4Vectors mcols mcols<- findMatches queryHits subjectHits 
#' SelfHits normalizeSingleBracketSubscript
setMethod("[", "DualSubset", function(x, i, j, ..., drop=FALSE) {
    p <- .get_hits(x)

    if (anyNA(i) && is.numeric(i)) {
        i <- as.integer(i)
    } else {
        i <- normalizeSingleBracketSubscript(i, x)
    }

    mq <- findMatches(i, queryHits(p))
    ms <- findMatches(i, subjectHits(p))
    mcom <- findMatches(subjectHits(mq), subjectHits(ms))

    left <- queryHits(mq)[queryHits(mcom)]
    right <- queryHits(ms)[subjectHits(mcom)]
    index <- subjectHits(mq)[queryHits(mcom)] # same as subjectHits(ms)[subjectHits(mcom)]

    o <- order(left, right)
    hits2 <- SelfHits(left[o], right[o], nnode=length(i))
    mcols(hits2) <- mcols(p)[index[o],,drop=FALSE]
    initialize(x, hits=hits2)
})

#' @importFrom S4Vectors mcols mcols<- queryHits subjectHits SelfHits
#' normalizeSingleBracketSubscript
setReplaceMethod("[", "DualSubset", function(x, i, j, ..., value) {
    p <- .get_hits(x)
    i <- normalizeSingleBracketSubscript(i, x)

    # Filtering out all elements to be replaced.
    p <- p[!(queryHits(p) %in% i & subjectHits(p) %in% i)]

    pv <- .get_hits(value)
    new.q <- i[queryHits(pv)]
    new.s <- i[subjectHits(pv)]

    total.p <- c(queryHits(p), new.q)
    total.s <- c(subjectHits(p), new.s)
    total.m <- rbind(mcols(p), mcols(pv))

    o <- order(total.p, total.s)
    hits2 <- SelfHits(total.p[o], total.s[o], nnode=length(x))
    mcols(hits2) <- total.m[o,,drop=FALSE]
    initialize(x, hits=hits2)
})

#' @importFrom utils tail 
#' @importFrom S4Vectors queryHits subjectHits SelfHits mcols mcols<- 
setMethod("c", "DualSubset", function(x, ...) {
    everything <- list(x, ...)
    shift <- 0L

    all.first <- all.second <- all.values <- vector("list", length(everything))
    for (i in seq_along(everything)) {
        current <- .get_hits(everything[[i]])
        contribution <- nnode(current)
        all.first[[i]] <- queryHits(current) + shift
        all.second[[i]] <- subjectHits(current) + shift
        all.values[[i]] <- mcols(current)
        shift <- shift + contribution
    }

    final <- SelfHits(unlist(all.first), unlist(all.second), nnode=shift)
    mcols(final) <- do.call(rbind, all.values)
    initialize(x, hits=final)
})

#' @importFrom S4Vectors queryHits subjectHits mcols
.hits2mat <- function(p) {
    m <- mcols(p)
    if (ncol(m)) {
        x <- m[,1]
        if (!is.logical(x) && !is.numeric(x) && !is.complex(x)) {
            stop("values of type '", typeof(x), "' are not supported in sparse matrices")
        }
    } else {
        x <- rep(TRUE, length(p))
    }

    Matrix::sparseMatrix(i=queryHits(p), j=subjectHits(p), x=x, 
        dims=rep(nnode(p), 2L), use.last.ij=TRUE)
}

#' @importFrom BiocGenerics which
#' @importFrom S4Vectors SelfHits 
.mat2hits <- function(mat) {
    i <- which(mat!=0, arr.ind=TRUE) 
    SelfHits(i[,1], i[,2], nnode=nrow(mat), x=mat[i])
}

# Checks the subsetting methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-subset.R")

sce <- loaded
rownames(sce) <- paste0("Gene", seq_len(nrow(v)))
colnames(sce) <- paste0("Cell", seq_len(ncells))

test_that("subsetting by row works correctly", {
    int_elementMetadata(sce)$indicator <- seq_len(nrow(sce))

    for (i in 1:3) {
        if (i==1L) {
            by.row <- sample(nrow(v), 20)
            sub.sce <- sce[by.row,]
            expect_identical(int_elementMetadata(sub.sce)$indicator, by.row)
        } else if (i==2L) {
            by.row <- rbinom(nrow(v), 1, 0.2)==1
            sub.sce <- sce[by.row,]
            expect_identical(int_elementMetadata(sub.sce)$indicator, which(by.row))
        } else if (i==3L) {
            by.row <- rownames(sce)[sample(nrow(v), 100)]
            sub.sce <- sce[by.row,]
            expect_identical(int_elementMetadata(sub.sce)$indicator, match(by.row, rownames(sce)))
        }
        ind <- int_elementMetadata(sub.sce)$indicator

        expect_identical(assay(sce)[ind,,drop=FALSE], assay(sub.sce)) # check SE elements are subsetted.
        expect_identical(rowData(sce)[ind,], rowData(sub.sce))
        expect_identical(rowPair(sub.sce), 
            SingleCellExperiment:::.get_hits(SingleCellExperiment:::DualSubset(rowPair(sce))[ind]))

        # Unchanged elements:
        expect_identical(sizeFactors(sub.sce), sizeFactors(sce))
        expect_identical(reducedDims(sub.sce), reducedDims(sce))
        expect_identical(int_colData(sub.sce), int_colData(sce))
        expect_identical(objectVersion(sub.sce), objectVersion(sce))
    }

    expect_error(sce[nrow(sce)+1,], "subscript contains out-of-bounds indices", fixed=TRUE)
    expect_error(sce["A",], "index out of bounds: A")
})

test_that("subsetting by column works correctly", {
    colData(sce)$indicator <- seq_len(ncells)

    for (j in 1:3) {
        if (j==1L) {
            by.col <- sample(ncells, 20)
            sub.sce <- sce[,by.col]
            expect_identical(colData(sub.sce)$indicator, by.col)
        } else if (j==2L) {
            by.col <- rbinom(ncells, 1, 0.2)==1
            sub.sce <- sce[,by.col]
            expect_identical(colData(sub.sce)$indicator, which(by.col))
        } else if (j==3L) {
            by.col <- colnames(sce)[sample(ncells, 50)]
            sub.sce <- sce[,by.col]
            expect_identical(colData(sub.sce)$indicator, match(by.col, colnames(sce)))
        }
        ind <- colData(sub.sce)$indicator

        expect_identical(assay(sce)[,ind,drop=FALSE], assay(sub.sce)) # check SE elements are subsetted.
        expect_identical(sizeFactors(sub.sce), sizeFactors(sce)[ind])

        expect_identical(reducedDim(sub.sce, "PCA", withDimnames=FALSE), d1[ind,,drop=FALSE])
        expect_identical(reducedDim(sub.sce, "TSNE", withDimnames=FALSE), d2[ind,,drop=FALSE])

        expect_identical(colPair(sub.sce),
            SingleCellExperiment:::.get_hits(SingleCellExperiment:::DualSubset(colPair(sce))[ind]))

        # Unchanged elements:
        expect_identical(int_elementMetadata(sub.sce), int_elementMetadata(sce))
        expect_identical(rowData(sub.sce), rowData(sce))
        expect_identical(objectVersion(sub.sce), objectVersion(sce))
    }

    expect_error(sce[,ncells+1], "subscript contains out-of-bounds indices", fixed=TRUE)
    expect_error(sce[,"A"], "index out of bounds: A")
})

test_that("subset replacement by row works correctly for basic cases", {
    sce.alt <- sce
    rownames(sce.alt) <- paste0(rownames(sce), "x")
    int_metadata(sce.alt)$whee <- 1

    scex <- sce.alt
    to <- 1:10
    from <- 21:30
    scex[to,] <- sce[from,]

    expect_identical(assay(scex)[to,,drop=FALSE], assay(sce)[from,,drop=FALSE])
    expect_equivalent(assay(scex)[-to,,drop=FALSE], assay(sce)[-to,,drop=FALSE])

    sub <- SingleCellExperiment:::DualSubset(rowPair(scex)) 
    full <- SingleCellExperiment:::DualSubset(rowPair(sce))
    expect_identical(sub[to], full[from])
    expect_identical(sub[-to], full[-to])

    # Unchanged elements, to name a few. 
    expect_identical(int_metadata(scex), int_metadata(sce))
    expect_identical(int_colData(scex), int_colData(sce))
    expect_identical(colData(scex), colData(sce))

    # Again for character
    scex2 <- sce.alt 
    to <- rownames(scex2)[1:10]
    from <- rownames(sce)[21:30]
    scex2[to,] <- sce[from,]
    expect_equal(scex, scex2)
})

test_that("subset replacement by row handles internal fields correctly", {
    to <- 1:10
    from <- 21:30

    # Handles mismatch.
    scex2 <- sce
    int_elementMetadata(scex2)$ERCC <- seq_len(nrow(scex2))
    expect_error(scex2[to,] <- sce[from,], "'int_elementMetadata'")
})

test_that("subset replacement by column works correctly for basic cases", {
    sce.alt <- sce
    colnames(sce.alt) <- paste0(colnames(sce), "x")

    scex <- sce.alt
    to <- 1:10
    from <- 21:30
    scex[,to] <- sce[,from]

    expect_identical(assay(scex)[,to,drop=FALSE], assay(sce)[,from,drop=FALSE])
    expect_equivalent(assay(scex)[,-to,drop=FALSE], assay(sce)[,-to,drop=FALSE])
    expect_identical(sizeFactors(scex)[to], sizeFactors(sce)[from])
    expect_equivalent(sizeFactors(scex)[-to], sizeFactors(sce)[-to])

    # Unchanged elements.
    expect_identical(int_elementMetadata(scex), int_elementMetadata(sce))
    expect_identical(rowData(scex), rowData(sce))
    expect_identical(int_metadata(scex), int_metadata(sce))
})

test_that("subset replacement by column handles internal fields", {
    to <- 1:10
    from <- 21:30

    # Throws an error upon mismatch.
    scex2 <- sce
    reducedDims(scex2) <- NULL
    expect_error(scex2[,to] <- sce[,from], "'int_colData'")
})

test_that("subset replacement by both rows and columns work correctly", {
    # Wholesale replacement!
    sce.alt <- sce
    rownames(sce.alt) <- paste0(rownames(sce), "x")
    colnames(sce.alt) <- paste0(colnames(sce), "x")
    int_metadata(sce.alt)$whee <- 1

    scex <- sce.alt
    scex[] <- sce
    expect_equal(scex, sce)

    # Partial replacement.
    to <- 1:10
    from <- 21:30

    scex <- sce.alt
    scex[to,to] <- sce[from,from]
    
    ref <- sce.alt
    ref[to,] <- sce[from,]
    expect_identical(int_elementMetadata(ref), int_elementMetadata(scex))

    ref <- sce.alt
    ref[,to] <- sce[,from]
    expect_identical(int_colData(ref), int_colData(scex))
})

test_that("S4Vectors subsetting works correctly", {
    out <- extractROWS(sce, 1:10)
    expect_identical(out, sce[1:10,])

    set.seed(100)
    f <- sample(10, nrow(sce), replace=TRUE)
    out <- split(sce, f)
    expect_identical(out[["1"]], sce[f==1,])
    expect_identical(out[["5"]], sce[f==5,])
    expect_identical(out[["8"]], sce[f==8,])
})

# Checks for proper functioning of the colPair methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-colPairs.R")

sce <- empty

chits <- sort(chits)
chits2 <- chits
mcols(chits2)$value <- mcols(chits2)$value * 2 
chits0 <- SelfHits(queryHits(chits), subjectHits(chits), nnode=nnode(chits) * 2L)

test_that("colPair getters/setters are functioning with character 'type'", {
    colPair(sce, "thing") <- chits
    expect_identical(colPair(sce, "thing"), chits)
    expect_identical(colPairNames(sce), "thing")

    colPair(sce, "stuff") <- chits2
    expect_identical(colPair(sce, "thing"), chits)
    expect_identical(colPair(sce, "stuff"), chits2)
    expect_identical(colPairNames(sce), c("thing", "stuff"))

    # Clearing values.
    colPair(sce, "thing") <- NULL
    expect_identical(colPair(sce, "stuff"), chits2)
    expect_identical(colPairNames(sce), "stuff")

    # In the absence of of redDim, create an unnamed one (like colPairs does)
    colPair(sce) <- NULL
    colPair(sce) <- chits
    expect_identical(colPairNames(sce), "unnamed1")

    # Checking for different errors.
    expect_error(colPair(sce, "thing"), "invalid subscript") 
    expect_error(colPair(sce, "DM") <- chits0, "number of nodes")
})

test_that("colPair getters/setters work with integer 'type'", {
    expect_error(colPair(sce), "no available entries") 
    expect_error(colPair(sce, 2), "invalid subscript 'type'") 

    expect_error(colPair(sce, 1) <- chits, "out of bounds")
    expect_error(colPair(sce, 2) <- chits, "out of bounds")

    # This gets a bit confusing as the order changes when earlier elements are wiped out.
    colPairs(sce) <- list(chits, chits2)
    expect_identical(colPair(sce), chits)
    expect_identical(colPair(sce, 2), chits2)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2"))

    mult <- chits
    mcols(mult)$value <- mcols(mult)$value * 5
    colPair(sce, "thing") <- mult # chits is the second element.
    expect_identical(colPair(sce, 1), chits)
    expect_identical(colPair(sce, 2), chits2)
    expect_identical(colPair(sce, 3), mult)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2", "thing"))

    colPair(sce, 1) <- NULL # chits2 becomes the first element now.
    expect_identical(colPair(sce), chits2)
    expect_identical(colPair(sce, 1), chits2)
    expect_identical(colPair(sce, 2), colPair(sce, "thing"))
    expect_identical(colPairNames(sce), c("unnamed2", "thing"))

    colPair(sce) <- NULL # 'mult' becomes the first element.
    expect_identical(colPair(sce), mult)
    expect_identical(colPairNames(sce), "thing")
    colPair(sce) <- chits2 # chits2 now overwrites the first element.
    expect_identical(colPair(sce, 1), chits2)
    expect_identical(colPairNames(sce), "thing")

    expect_error(colPair(sce, 5) <- chits, "out of bounds")
})

test_that("colPairs getters/setters are functioning", {
    colPairs(sce) <- list(thing=chits, TSNE=chits2)
    expect_identical(colPairs(sce), SimpleList(thing=chits, TSNE=chits2))

    expect_identical(colPairNames(sce), c("thing", "TSNE"))
    expect_identical(colPair(sce, "thing"), chits)
    expect_identical(colPair(sce, 1), chits)
    expect_identical(colPair(sce, "TSNE"), chits2)
    expect_identical(colPair(sce, 2), chits2)

    # Clearing via empty List.
    alt <- sce
    colPairs(alt) <- SimpleList()
    expect_identical(colPairs(alt), setNames(SimpleList(), character(0)))

    # Clearing via NULL.
    colPairs(sce) <- List(DM=chits)
    expect_identical(SimpleList(DM=chits), colPairs(sce))
    expect_identical(chits, colPair(sce))

    alt <- sce
    colPairs(alt) <- NULL
    expect_identical(colPairs(alt), setNames(SimpleList(), character(0)))

    # Setting with an unnamed list works.
    colPairs(sce) <- list(chits, chits2)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2"))

    # Checking for errors.
    expect_error(colPairs(sce) <- list(chits, chits0), "number of nodes")
    expect_error(colPairs(sce) <- list(chits0, chits0), "number of nodes")
})

test_that("colPair getters/setters work with matrices", {
    mat <- SingleCellExperiment:::.hits2mat(chits)
    colPair(sce, "thing") <- mat
    expect_identical(colPair(sce, "thing", asSparse=TRUE), mat)

    colPairs(sce) <- list(thing=chits, TSNE=mat)
    everything <- colPairs(sce, asSparse=TRUE)
    expect_identical(everything[[1]], mat)

    colnames(mcols(chits)) <- "x"
    expect_identical(colPair(sce, 2), chits)

    # What happens when there aren't any metadata fields?
    empty <- chits
    mcols(empty) <- NULL
    colPair(sce) <- empty
    expect_warning(emptymat <- colPair(sce, asSparse=TRUE), "filling matrix")
    expect_identical(emptymat, mat != 0)
})

test_that("colPairNames getters/setters work correctly", {
    colPairs(sce) <- list(chits, chits2)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2"))
    colPairs(sce) <- list(thing=chits, TSNE=chits2)
    expect_identical(colPairNames(sce), c("thing", "TSNE"))

    # Directly setting.
    colPairNames(sce) <- c("A", "B")
    expect_identical(colPairNames(sce), c("A", "B"))

    # When wiped.
    colPairs(sce) <- NULL
    expect_identical(colPairNames(sce), character(0))

    expect_error(colPairNames(sce) <- c("A", "B"), "more column names")
})

# Checks for proper functioning of the colPair methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-colPairs.R")

sce <- empty

chits <- sort(chits)
chits2 <- chits
mcols(chits2)$value <- mcols(chits2)$value * 2 
chits0 <- SelfHits(queryHits(chits), subjectHits(chits), nnode=nnode(chits) * 2L)

test_that("colPair getters/setters are functioning with character 'type'", {
    colPair(sce, "thing") <- chits
    expect_identical(colPair(sce, "thing"), chits)
    expect_identical(colPairNames(sce), "thing")

    colPair(sce, "stuff") <- chits2
    expect_identical(colPair(sce, "thing"), chits)
    expect_identical(colPair(sce, "stuff"), chits2)
    expect_identical(colPairNames(sce), c("thing", "stuff"))

    # Clearing values.
    colPair(sce, "thing") <- NULL
    expect_identical(colPair(sce, "stuff"), chits2)
    expect_identical(colPairNames(sce), "stuff")

    # In the absence of of redDim, create an unnamed one (like colPairs does)
    colPair(sce) <- NULL
    colPair(sce) <- chits
    expect_identical(colPairNames(sce), "unnamed1")

    # Checking for different errors.
    expect_error(colPair(sce, "thing"), "invalid subscript") 
    expect_error(colPair(sce, "DM") <- chits0, "number of nodes")
})

test_that("colPair getters/setters work with integer 'type'", {
    expect_error(colPair(sce), "no available entries") 
    expect_error(colPair(sce, 2), "invalid subscript 'type'") 

    expect_error(colPair(sce, 1) <- chits, "out of bounds")
    expect_error(colPair(sce, 2) <- chits, "out of bounds")

    # This gets a bit confusing as the order changes when earlier elements are wiped out.
    colPairs(sce) <- list(chits, chits2)
    expect_identical(colPair(sce), chits)
    expect_identical(colPair(sce, 2), chits2)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2"))

    mult <- chits
    mcols(mult)$value <- mcols(mult)$value * 5
    colPair(sce, "thing") <- mult # chits is the second element.
    expect_identical(colPair(sce, 1), chits)
    expect_identical(colPair(sce, 2), chits2)
    expect_identical(colPair(sce, 3), mult)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2", "thing"))

    colPair(sce, 1) <- NULL # chits2 becomes the first element now.
    expect_identical(colPair(sce), chits2)
    expect_identical(colPair(sce, 1), chits2)
    expect_identical(colPair(sce, 2), colPair(sce, "thing"))
    expect_identical(colPairNames(sce), c("unnamed2", "thing"))

    colPair(sce) <- NULL # 'mult' becomes the first element.
    expect_identical(colPair(sce), mult)
    expect_identical(colPairNames(sce), "thing")
    colPair(sce) <- chits2 # chits2 now overwrites the first element.
    expect_identical(colPair(sce, 1), chits2)
    expect_identical(colPairNames(sce), "thing")

    expect_error(colPair(sce, 5) <- chits, "out of bounds")
})

test_that("colPairs getters/setters are functioning", {
    colPairs(sce) <- list(thing=chits, TSNE=chits2)
    expect_identical(colPairs(sce), SimpleList(thing=chits, TSNE=chits2))

    expect_identical(colPairNames(sce), c("thing", "TSNE"))
    expect_identical(colPair(sce, "thing"), chits)
    expect_identical(colPair(sce, 1), chits)
    expect_identical(colPair(sce, "TSNE"), chits2)
    expect_identical(colPair(sce, 2), chits2)

    # Clearing via empty List.
    alt <- sce
    colPairs(alt) <- SimpleList()
    expect_identical(colPairs(alt), setNames(SimpleList(), character(0)))

    # Clearing via NULL.
    colPairs(sce) <- List(DM=chits)
    expect_identical(SimpleList(DM=chits), colPairs(sce))
    expect_identical(chits, colPair(sce))

    alt <- sce
    colPairs(alt) <- NULL
    expect_identical(colPairs(alt), setNames(SimpleList(), character(0)))

    # Setting with an unnamed list works.
    colPairs(sce) <- list(chits, chits2)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2"))

    # Checking for errors.
    expect_error(colPairs(sce) <- list(chits, chits0), "number of nodes")
    expect_error(colPairs(sce) <- list(chits0, chits0), "number of nodes")
})

test_that("colPair getters/setters work with matrices", {
    mat <- SingleCellExperiment:::.hits2mat(chits)
    colPair(sce, "thing") <- mat
    expect_identical(colPair(sce, "thing", asSparse=TRUE), mat)

    colPairs(sce) <- list(thing=chits, TSNE=mat)
    everything <- colPairs(sce, asSparse=TRUE)
    expect_identical(everything[[1]], mat)

    colnames(mcols(chits)) <- "x"
    expect_identical(colPair(sce, 2), chits)
})

test_that("colPairNames getters/setters work correctly", {
    colPairs(sce) <- list(chits, chits2)
    expect_identical(colPairNames(sce), c("unnamed1", "unnamed2"))
    colPairs(sce) <- list(thing=chits, TSNE=chits2)
    expect_identical(colPairNames(sce), c("thing", "TSNE"))

    # Directly setting.
    colPairNames(sce) <- c("A", "B")
    expect_identical(colPairNames(sce), c("A", "B"))

    # When wiped.
    colPairs(sce) <- NULL
    expect_identical(colPairNames(sce), character(0))

    expect_error(colPairNames(sce) <- c("A", "B"), "more column names")
})

# This tests the behavior of the DualSubset class.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-DualSubset.R")

set.seed(1000)
ds <- SingleCellExperiment:::DualSubset(rhits)
.hits <- SingleCellExperiment:::.get_hits

test_that("DualSubset subsetting works correctly", {
    REF_SUB <- function(x, i) {
        p <- alt <- SingleCellExperiment:::.get_hits(x)
        mcols(alt)[,1] <- seq_along(alt)
        mat <- SingleCellExperiment:::.hits2mat(alt)

        mat <- mat[i,i,drop=FALSE]
        p2 <- SingleCellExperiment:::.mat2hits(mat)
        mcols(p2) <- mcols(p)[mcols(p2)$x,,drop=FALSE]
        sort(p2)
    }

    keep <- 1:50
    sub <- ds[keep]
    expect_identical(length(sub), length(keep))
    expect_identical(.hits(sub), REF_SUB(ds, keep))
    expect_identical(
        length(.hits(sub)),
        sum(queryHits(rhits) %in% keep & subjectHits(rhits) %in% keep)
    )

    keep <- sample(length(ds), 50)
    sub <- ds[keep]
    expect_identical(length(sub), length(keep))
    expect_identical(.hits(sub), REF_SUB(ds, keep))
    expect_identical(
        length(.hits(sub)),
        sum(queryHits(rhits) %in% keep & subjectHits(rhits) %in% keep)
    )

    keep <- length(ds):1
    sub <- ds[keep]
    expect_identical(length(ds), length(sub))
    expect_identical(.hits(sub), REF_SUB(ds, keep))
    expect_identical(
        .hits(sub),
        sort(SelfHits(
            length(ds) - queryHits(rhits) + 1L,
            length(ds) - subjectHits(rhits) + 1L,
            nnode=length(ds),
            value=mcols(rhits)$value
        ))
    )
})

test_that("DualSubset subset replacement works correctly", {
    REF_SUB_REP <- function(x, i, value) {
        p <- alt <- SingleCellExperiment:::.get_hits(x)
        mcols(alt)[,1] <- seq_along(alt)
        mat <- SingleCellExperiment:::.hits2mat(alt)

        pv <- altv <- SingleCellExperiment:::.get_hits(value)
        mcols(altv)[,1] <- seq_along(altv)
        matv <- -SingleCellExperiment:::.hits2mat(altv)

        mat[i,i] <- matv
        p2 <- SingleCellExperiment:::.mat2hits(mat)
        index <- mcols(p2)$x
        use.left <- index > 0

        store <- mcols(p)[ifelse(use.left, index, 1),,drop=FALSE]
        store[!use.left,] <- mcols(pv)[-index[!use.left],,drop=FALSE]
        mcols(p2) <- store
        sort(p2)
    }

    swap1 <- 1:100
    swap2 <- 101:200

    ds2 <- ds
    ds2[swap1] <- ds[swap2]
    expect_identical(length(ds), length(ds2))
    expect_identical(.hits(ds2), REF_SUB_REP(ds, swap1, ds[swap2]))

    mod <- rhits
    mod <- mod[!(queryHits(mod) %in% swap1 & subjectHits(mod) %in% swap1)]
    sub <- .hits(ds[swap2])

    expect_identical(
        .hits(ds2),
        sort(SelfHits(
            c(queryHits(mod), queryHits(sub)),
            c(subjectHits(mod), subjectHits(sub)),
            nnode=length(ds),
            value=c(mcols(mod)$value, mcols(sub)$value)
        ))
    )

    # This should be a no-op.
    ds2 <- ds
    ds2[swap1] <- ds2[swap1]
    expect_identical(.hits(ds), .hits(ds2))
})

test_that("DualSubset concatenation works correctly", {
    combined <- c(ds, ds)
    expect_identical(length(combined), length(ds)*2L)
    expect_identical(
        .hits(combined),
        sort(SelfHits(
            c(queryHits(rhits), queryHits(rhits) + nnode(rhits)),
            c(subjectHits(rhits), subjectHits(rhits) + nnode(rhits)),
            nnode=nnode(rhits)*2L,
            value=c(mcols(rhits)$value, mcols(rhits)$value)
        ))
    )
})

test_that("SelfHits conversion to/from matrix works correctly", {
    p <- .hits(ds)

    mat <- SingleCellExperiment:::.hits2mat(p)
    expect_identical(nrow(mat), nnode(p))
    expect_identical(ncol(mat), nnode(p))
    expect_equal(sum(mat), sum(mcols(p)$value))

    roundtrip <- sort(SingleCellExperiment:::.mat2hits(mat))
    expect_identical(queryHits(roundtrip), queryHits(p))
    expect_identical(subjectHits(roundtrip), subjectHits(p))
    expect_identical(mcols(roundtrip)$x, mcols(p)$value)

    # Conversion still uses the first metadata field.
    mcols(p)$more <- "A"
    mat2 <- SingleCellExperiment:::.hits2mat(p)
    expect_identical(mat, mat2)

    mcols(p)$value <- NULL
    expect_error(SingleCellExperiment:::.hits2mat(p), "not supported")

    mcols(p)$more <- NULL
    mat2 <- SingleCellExperiment:::.hits2mat(p)
    expect_type(as.vector(mat2[0,0]), "logical")
    expect_equal(sum(mat2), length(p)) 
})

# Checks the combining methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-combine.R")

sce <- loaded

test_that("rbind works correctly in the basic case", {
    shuffled <- sample(nrow(v))
    sce.alt <- sce[shuffled,]

    sce2 <- rbind(sce, sce.alt)
    expect_equivalent(assay(sce2), rbind(assay(sce), assay(sce.alt)))
    expect_identical(sizeFactors(sce2), sizeFactors(sce))
    expect_identical(reducedDims(sce2), reducedDims(sce))

    dual1 <- SingleCellExperiment:::DualSubset(rowPair(sce))
    dual2 <- SingleCellExperiment:::DualSubset(rowPair(sce.alt))
    expect_identical(
        SingleCellExperiment:::DualSubset(rowPair(sce2)),
        c(dual1, dual2) 
    )
})

test_that("rbind respects the internal fields correctly", {
    # Respects the internal colData.
    sce2 <- sce
    int_colData(sce2)$X <- runif(ncol(sce2))
    sce3 <- rbind(sce, sce2)
    expect_identical(int_colData(sce3)$X, int_colData(sce2)$X)

    # Respects reordered internal elementMetadata
    int_elementMetadata(sce) <- cbind(int_elementMetadata(sce), DataFrame(A=runif(nrow(sce)), B=runif(nrow(sce))))
    alpha <- rbind(sce, sce)
    alt.sce <- sce
    int_elementMetadata(alt.sce) <- int_elementMetadata(alt.sce)[,ncol(int_elementMetadata(alt.sce)):1]
    bravo <- rbind(sce, alt.sce)
    expect_identical(alpha, bravo)
})

test_that("rbind handles errors in internal fields correctly", {
    sce2 <- sce
    int_colData(sce)$X <- runif(ncol(sce))
    int_colData(sce2)$X <- runif(ncol(sce2))
    expect_error(rbind(sce, sce2), "'int_colData'")

    # Throws errors upon mismatch in the internal elementMetadata.
    sce.err <- sce
    int_elementMetadata(sce.err)$X <- "YAY"
    expect_error(rbind(sce.err, sce), "'int_elementMetadata'")

    # Don't concatenate names when merging metadata().
    sce4 <- rbind(A=sce, B=sce)
    expect_identical(objectVersion(sce4), objectVersion(sce))
})

test_that("cbind works correctly in the basic case", {
    shuffled <- sample(ncells)
    sce.alt <- sce[,shuffled]

    sce2 <- cbind(sce, sce.alt)
    expect_equivalent(assay(sce2), cbind(assay(sce), assay(sce.alt)))
    expect_identical(sizeFactors(sce2), c(sizeFactors(sce), sizeFactors(sce.alt)))
    expect_identical(reducedDim(sce2, "PCA"), rbind(reducedDim(sce, "PCA"), reducedDim(sce.alt, "PCA")))
    expect_identical(altExp(sce2), cbind(altExp(sce), altExp(sce.alt)))

    dual1 <- SingleCellExperiment:::DualSubset(colPair(sce))
    dual2 <- SingleCellExperiment:::DualSubset(colPair(sce.alt))
    expect_identical(
        SingleCellExperiment:::DualSubset(colPair(sce2)),
        c(dual1, dual2) 
    )
})

test_that("cbind respects the internal fields correctly", {
    # Respects the internal elementMetadata.
    sce2 <- sce
    int_elementMetadata(sce2)$X <- runif(nrow(sce2))
    sce3 <- cbind(sce, sce2)
    expect_identical(int_elementMetadata(sce3)$X, int_elementMetadata(sce2)$X)

    # Respects reordered internal colData.
    alpha <- cbind(sce, sce)
    alt.sce <- sce
    int_colData(alt.sce) <- int_colData(alt.sce)[,ncol(int_colData(alt.sce)):1]
    bravo <- cbind(sce, alt.sce)
    expect_identical(alpha, bravo)

    alt.sce <- sce
    reducedDims(alt.sce) <- rev(reducedDims(alt.sce))
    altExps(alt.sce) <- rev(altExps(alt.sce))
    bravo <- cbind(sce, alt.sce)
    expect_identical(alpha, bravo)
})

test_that("cbind handles errors in the internal fields correctly", {
    # Chokes correctly when presented with errors.
    sce.err <- sce
    reducedDim(sce.err, "PCA") <- NULL
    expect_error(cbind(sce.err, sce), "'int_colData'")

    sce.err <- sce
    altExp(sce.err, 1) <- NULL
    expect_error(cbind(sce.err, sce), "'int_colData'")

    # Don't concatenate names when merging metadata().
    sce4 <- rbind(A=sce, B=sce) 
    expect_identical(objectVersion(sce4), objectVersion(sce))
})

# Checks the combining methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-combine.R")

sce <- loaded

test_that("rbind works correctly in the basic case", {
    shuffled <- sample(nrow(v))
    sce.alt <- sce[shuffled,]

    sce2 <- rbind(sce, sce.alt)
    expect_equivalent(assay(sce2), rbind(assay(sce), assay(sce.alt)))
    expect_identical(sizeFactors(sce2), sizeFactors(sce))
    expect_identical(reducedDims(sce2), reducedDims(sce))

    dual1 <- SingleCellExperiment:::DualSubset(rowPair(sce))
    dual2 <- SingleCellExperiment:::DualSubset(rowPair(sce.alt))
    expect_identical(
        SingleCellExperiment:::DualSubset(rowPair(sce2)),
        c(dual1, dual2) 
    )
})

test_that("rbind respects the internal fields correctly", {
    # Respects the internal colData.
    sce2 <- sce
    int_colData(sce2)$X <- runif(ncol(sce2))
    sce3 <- rbind(sce, sce2)
    expect_identical(int_colData(sce3)$X, int_colData(sce2)$X)

    # Respects reordered internal elementMetadata
    int_elementMetadata(sce) <- cbind(int_elementMetadata(sce), DataFrame(A=runif(nrow(sce)), B=runif(nrow(sce))))
    alpha <- rbind(sce, sce)
    alt.sce <- sce
    int_elementMetadata(alt.sce) <- int_elementMetadata(alt.sce)[,ncol(int_elementMetadata(alt.sce)):1]
    bravo <- rbind(sce, alt.sce)
    expect_identical(alpha, bravo)
})

test_that("rbind handles errors in internal fields correctly", {
    sce2 <- sce
    int_colData(sce)$X <- runif(ncol(sce))
    int_colData(sce2)$X <- runif(ncol(sce2))
    expect_error(rbind(sce, sce2), "'int_colData'")

    # Throws errors upon mismatch in the internal elementMetadata.
    sce.err <- sce
    int_elementMetadata(sce.err)$X <- "YAY"
    expect_error(rbind(sce.err, sce), "'int_elementMetadata'")

    # Don't concatenate names when merging metadata().
    sce4 <- rbind(A=sce, B=sce)
    expect_identical(objectVersion(sce4), objectVersion(sce))
})

test_that("cbind works correctly in the basic case", {
    shuffled <- sample(ncells)
    sce.alt <- sce[,shuffled]

    sce2 <- cbind(sce, sce.alt)
    expect_equivalent(assay(sce2), cbind(assay(sce), assay(sce.alt)))
    expect_identical(sizeFactors(sce2), c(sizeFactors(sce), sizeFactors(sce.alt)))
    expect_identical(reducedDim(sce2, "PCA"), rbind(reducedDim(sce, "PCA"), reducedDim(sce.alt, "PCA")))
    expect_identical(altExp(sce2), cbind(altExp(sce), altExp(sce.alt)))

    dual1 <- SingleCellExperiment:::DualSubset(colPair(sce))
    dual2 <- SingleCellExperiment:::DualSubset(colPair(sce.alt))
    expect_identical(
        SingleCellExperiment:::DualSubset(colPair(sce2)),
        c(dual1, dual2) 
    )
})

test_that("cbind respects the internal fields correctly", {
    # Respects the internal elementMetadata.
    sce2 <- sce
    int_elementMetadata(sce2)$X <- runif(nrow(sce2))
    sce3 <- cbind(sce, sce2)
    expect_identical(int_elementMetadata(sce3)$X, int_elementMetadata(sce2)$X)

    # Respects reordered internal colData.
    alpha <- cbind(sce, sce)
    alt.sce <- sce
    int_colData(alt.sce) <- int_colData(alt.sce)[,ncol(int_colData(alt.sce)):1]
    bravo <- cbind(sce, alt.sce)
    expect_identical(alpha, bravo)

    alt.sce <- sce
    reducedDims(alt.sce) <- rev(reducedDims(alt.sce))
    altExps(alt.sce) <- rev(altExps(alt.sce))
    bravo <- cbind(sce, alt.sce)
    expect_identical(alpha, bravo)
})

test_that("cbind handles errors in the internal fields correctly", {
    # Chokes correctly when presented with errors.
    sce.err <- sce
    reducedDim(sce.err, "PCA") <- NULL
    expect_error(cbind(sce.err, sce), "'int_colData'")

    sce.err <- sce
    altExp(sce.err, 1) <- NULL
    expect_error(cbind(sce.err, sce), "'int_colData'")

    # Don't concatenate names when merging metadata().
    sce4 <- rbind(A=sce, B=sce) 
    expect_identical(objectVersion(sce4), objectVersion(sce))
})

test_that("combineCols passes on delay when combining altExps", {
    sce.combined <- combineCols(sce, sce, use.names=FALSE, delayed=FALSE)
    expect_is(assay(altExp(sce.combined)), "matrix")

    sce.combined2 <- combineCols(sce, sce, use.names=FALSE, delayed=TRUE)
    expect_is(assay(altExp(sce.combined2)), "DelayedMatrix")
})

test_that("combineCols passes on fill when combining altExps", {
    sce1 <- sce[1:6, 1:10]
    rownames(sce1) <- LETTERS[seq_len(nrow(sce1))]
    colnames(sce1) <- letters[seq_len(ncol(sce1))]
    altExp(sce1) <- altExp(sce1)[1:6, ]

    sce2 <- sce[1:14, 11:20]
    rownames(sce2) <- LETTERS[1:14]
    colnames(sce2) <- letters[seq_len(ncol(sce2)) + ncol(sce1)]
    altExp(sce2) <- altExp(sce2)[4:7, ]

    sce.combined1 <- combineCols(sce1, sce2, use.names=TRUE)
    expect_true(anyNA(assay(sce.combined1)))

    sce.combined2 <- combineCols(sce1, sce2, use.names=TRUE, fill = -1)
    expect_true(any(assay(sce.combined2) == -1))

    sce.combined3 <- combineCols(sce1, sce2, use.names=TRUE)
    expect_true(anyNA(assay(altExp(sce.combined3))))

    sce.combined4 <- combineCols(sce1, sce2, use.names=TRUE, fill = -1)
    expect_true(any(assay(sce.combined4) == -1))
})

# Checks for proper functioning of the rowPair methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-rowPairs.R")

sce <- empty

rhits <- sort(rhits)
rhits2 <- rhits
mcols(rhits2)$value <- mcols(rhits2)$value * 2 
rhits0 <- SelfHits(queryHits(rhits), subjectHits(rhits), nnode=nnode(rhits) * 2L)

test_that("rowPair getters/setters are functioning with character 'type'", {
    rowPair(sce, "thing") <- rhits
    expect_identical(rowPair(sce, "thing"), rhits)
    expect_identical(rowPairNames(sce), "thing")

    rowPair(sce, "stuff") <- rhits2
    expect_identical(rowPair(sce, "thing"), rhits)
    expect_identical(rowPair(sce, "stuff"), rhits2)
    expect_identical(rowPairNames(sce), c("thing", "stuff"))

    # Clearing values.
    rowPair(sce, "thing") <- NULL
    expect_identical(rowPair(sce, "stuff"), rhits2)
    expect_identical(rowPairNames(sce), "stuff")

    # In the absence of of redDim, create an unnamed one (like rowPairs does)
    rowPair(sce) <- NULL
    rowPair(sce) <- rhits
    expect_identical(rowPairNames(sce), "unnamed1")

    # Checking for different errors.
    expect_error(rowPair(sce, "thing"), "invalid subscript") 
    expect_error(rowPair(sce, "DM") <- rhits0, "number of nodes")
})

test_that("rowPair getters/setters work with integer 'type'", {
    expect_error(rowPair(sce), "no available entries") 
    expect_error(rowPair(sce, 2), "invalid subscript 'type'") 

    expect_error(rowPair(sce, 1) <- rhits, "out of bounds")
    expect_error(rowPair(sce, 2) <- rhits, "out of bounds")

    # This gets a bit confusing as the order changes when earlier elements are wiped out.
    rowPairs(sce) <- list(rhits, rhits2)
    expect_identical(rowPair(sce), rhits)
    expect_identical(rowPair(sce, 2), rhits2)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2"))

    mult <- rhits
    mcols(mult)$value <- mcols(mult)$value * 5
    rowPair(sce, "thing") <- mult # rhits is the second element.
    expect_identical(rowPair(sce, 1), rhits)
    expect_identical(rowPair(sce, 2), rhits2)
    expect_identical(rowPair(sce, 3), mult)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2", "thing"))

    rowPair(sce, 1) <- NULL # rhits2 becomes the first element now.
    expect_identical(rowPair(sce), rhits2)
    expect_identical(rowPair(sce, 1), rhits2)
    expect_identical(rowPair(sce, 2), rowPair(sce, "thing"))
    expect_identical(rowPairNames(sce), c("unnamed2", "thing"))

    rowPair(sce) <- NULL # 'mult' becomes the first element.
    expect_identical(rowPair(sce), mult)
    expect_identical(rowPairNames(sce), "thing")
    rowPair(sce) <- rhits2 # rhits2 now overwrites the first element.
    expect_identical(rowPair(sce, 1), rhits2)
    expect_identical(rowPairNames(sce), "thing")

    expect_error(rowPair(sce, 5) <- rhits, "out of bounds")
})

test_that("rowPairs getters/setters are functioning", {
    rowPairs(sce) <- list(thing=rhits, TSNE=rhits2)
    expect_identical(rowPairNames(sce), c("thing", "TSNE"))
    expect_identical(rowPair(sce, "thing"), rhits)
    expect_identical(rowPair(sce, 1), rhits)
    expect_identical(rowPair(sce, "TSNE"), rhits2)
    expect_identical(rowPair(sce, 2), rhits2)

    # Clearing via empty List.
    alt <- sce
    rowPairs(alt) <- SimpleList()
    expect_identical(rowPairs(alt), setNames(SimpleList(), character(0)))

    # Clearing via NULL.
    rowPairs(sce) <- List(DM=rhits)
    expect_identical(SimpleList(DM=rhits), rowPairs(sce))
    expect_identical(rhits, rowPair(sce))

    alt <- sce
    rowPairs(alt) <- NULL
    expect_identical(rowPairs(alt), setNames(SimpleList(), character(0)))

    # Setting with an unnamed list works.
    rowPairs(sce) <- list(rhits, rhits2)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2"))

    # Checking for errors.
    expect_error(rowPairs(sce) <- list(rhits, rhits0), "number of nodes")
    expect_error(rowPairs(sce) <- list(rhits0, rhits0), "number of nodes")
})

test_that("rowPair getters/setters work with matrices", {
    mat <- SingleCellExperiment:::.hits2mat(rhits)
    rowPair(sce, "thing") <- mat
    expect_identical(rowPair(sce, "thing", asSparse=TRUE), mat)

    rowPairs(sce) <- list(thing=rhits, TSNE=mat)
    everything <- rowPairs(sce, asSparse=TRUE)
    expect_identical(everything[[1]], mat)

    colnames(mcols(rhits)) <- "x"
    expect_identical(rowPair(sce, 2), rhits)

    # What happens when there aren't any metadata fields?
    empty <- rhits
    mcols(empty) <- NULL
    rowPair(sce) <- empty
    expect_warning(emptymat <- rowPair(sce, asSparse=TRUE), "filling matrix")
    expect_identical(emptymat, mat != 0)
})

test_that("rowPairNames getters/setters work correctly", {
    rowPairs(sce) <- list(rhits, rhits2)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2"))
    rowPairs(sce) <- list(thing=rhits, TSNE=rhits2)
    expect_identical(rowPairNames(sce), c("thing", "TSNE"))

    # Directly setting.
    rowPairNames(sce) <- c("A", "B")
    expect_identical(rowPairNames(sce), c("A", "B"))

    # When wiped.
    rowPairs(sce) <- NULL
    expect_identical(rowPairNames(sce), character(0))

    expect_error(rowPairNames(sce) <- c("A", "B"), "more column names")
})

# Checks for proper functioning of the rowPair methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-rowPairs.R")

sce <- empty

rhits <- sort(rhits)
rhits2 <- rhits
mcols(rhits2)$value <- mcols(rhits2)$value * 2 
rhits0 <- SelfHits(queryHits(rhits), subjectHits(rhits), nnode=nnode(rhits) * 2L)

test_that("rowPair getters/setters are functioning with character 'type'", {
    rowPair(sce, "thing") <- rhits
    expect_identical(rowPair(sce, "thing"), rhits)
    expect_identical(rowPairNames(sce), "thing")

    rowPair(sce, "stuff") <- rhits2
    expect_identical(rowPair(sce, "thing"), rhits)
    expect_identical(rowPair(sce, "stuff"), rhits2)
    expect_identical(rowPairNames(sce), c("thing", "stuff"))

    # Clearing values.
    rowPair(sce, "thing") <- NULL
    expect_identical(rowPair(sce, "stuff"), rhits2)
    expect_identical(rowPairNames(sce), "stuff")

    # In the absence of of redDim, create an unnamed one (like rowPairs does)
    rowPair(sce) <- NULL
    rowPair(sce) <- rhits
    expect_identical(rowPairNames(sce), "unnamed1")

    # Checking for different errors.
    expect_error(rowPair(sce, "thing"), "invalid subscript") 
    expect_error(rowPair(sce, "DM") <- rhits0, "number of nodes")
})

test_that("rowPair getters/setters work with integer 'type'", {
    expect_error(rowPair(sce), "no available entries") 
    expect_error(rowPair(sce, 2), "invalid subscript 'type'") 

    expect_error(rowPair(sce, 1) <- rhits, "out of bounds")
    expect_error(rowPair(sce, 2) <- rhits, "out of bounds")

    # This gets a bit confusing as the order changes when earlier elements are wiped out.
    rowPairs(sce) <- list(rhits, rhits2)
    expect_identical(rowPair(sce), rhits)
    expect_identical(rowPair(sce, 2), rhits2)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2"))

    mult <- rhits
    mcols(mult)$value <- mcols(mult)$value * 5
    rowPair(sce, "thing") <- mult # rhits is the second element.
    expect_identical(rowPair(sce, 1), rhits)
    expect_identical(rowPair(sce, 2), rhits2)
    expect_identical(rowPair(sce, 3), mult)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2", "thing"))

    rowPair(sce, 1) <- NULL # rhits2 becomes the first element now.
    expect_identical(rowPair(sce), rhits2)
    expect_identical(rowPair(sce, 1), rhits2)
    expect_identical(rowPair(sce, 2), rowPair(sce, "thing"))
    expect_identical(rowPairNames(sce), c("unnamed2", "thing"))

    rowPair(sce) <- NULL # 'mult' becomes the first element.
    expect_identical(rowPair(sce), mult)
    expect_identical(rowPairNames(sce), "thing")
    rowPair(sce) <- rhits2 # rhits2 now overwrites the first element.
    expect_identical(rowPair(sce, 1), rhits2)
    expect_identical(rowPairNames(sce), "thing")

    expect_error(rowPair(sce, 5) <- rhits, "out of bounds")
})

test_that("rowPairs getters/setters are functioning", {
    rowPairs(sce) <- list(thing=rhits, TSNE=rhits2)
    expect_identical(rowPairNames(sce), c("thing", "TSNE"))
    expect_identical(rowPair(sce, "thing"), rhits)
    expect_identical(rowPair(sce, 1), rhits)
    expect_identical(rowPair(sce, "TSNE"), rhits2)
    expect_identical(rowPair(sce, 2), rhits2)

    # Clearing via empty List.
    alt <- sce
    rowPairs(alt) <- SimpleList()
    expect_identical(rowPairs(alt), setNames(SimpleList(), character(0)))

    # Clearing via NULL.
    rowPairs(sce) <- List(DM=rhits)
    expect_identical(SimpleList(DM=rhits), rowPairs(sce))
    expect_identical(rhits, rowPair(sce))

    alt <- sce
    rowPairs(alt) <- NULL
    expect_identical(rowPairs(alt), setNames(SimpleList(), character(0)))

    # Setting with an unnamed list works.
    rowPairs(sce) <- list(rhits, rhits2)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2"))

    # Checking for errors.
    expect_error(rowPairs(sce) <- list(rhits, rhits0), "number of nodes")
    expect_error(rowPairs(sce) <- list(rhits0, rhits0), "number of nodes")
})

test_that("rowPair getters/setters work with matrices", {
    mat <- SingleCellExperiment:::.hits2mat(rhits)
    rowPair(sce, "thing") <- mat
    expect_identical(rowPair(sce, "thing", asSparse=TRUE), mat)

    rowPairs(sce) <- list(thing=rhits, TSNE=mat)
    everything <- rowPairs(sce, asSparse=TRUE)
    expect_identical(everything[[1]], mat)

    colnames(mcols(rhits)) <- "x"
    expect_identical(rowPair(sce, 2), rhits)
})

test_that("rowPairNames getters/setters work correctly", {
    rowPairs(sce) <- list(rhits, rhits2)
    expect_identical(rowPairNames(sce), c("unnamed1", "unnamed2"))
    rowPairs(sce) <- list(thing=rhits, TSNE=rhits2)
    expect_identical(rowPairNames(sce), c("thing", "TSNE"))

    # Directly setting.
    rowPairNames(sce) <- c("A", "B")
    expect_identical(rowPairNames(sce), c("A", "B"))

    # When wiped.
    rowPairs(sce) <- NULL
    expect_identical(rowPairNames(sce), character(0))

    expect_error(rowPairNames(sce) <- c("A", "B"), "more column names")
})

# Basic methods for the DualSubset class,
# an internal class that powers the *Pairs methods.

.get_hits <- function(x) x@hits

DualSubset <- function(hits) new("DualSubset", hits=sort(hits))

#' @importFrom S4Vectors nnode
setMethod("length", "DualSubset", function(x) nnode(.get_hits(x)))

#' @importFrom S4Vectors mcols mcols<- findMatches queryHits subjectHits 
#' SelfHits normalizeSingleBracketSubscript
setMethod("[", "DualSubset", function(x, i, j, ..., drop=FALSE) {
    p <- .get_hits(x)

    if (anyNA(i) && is.numeric(i)) {
        i <- as.integer(i)
    } else {
        i <- normalizeSingleBracketSubscript(i, x)
    }

    mq <- findMatches(i, queryHits(p))
    ms <- findMatches(i, subjectHits(p))
    mcom <- findMatches(subjectHits(mq), subjectHits(ms))

    left <- queryHits(mq)[queryHits(mcom)]
    right <- queryHits(ms)[subjectHits(mcom)]
    index <- subjectHits(mq)[queryHits(mcom)] # same as subjectHits(ms)[subjectHits(mcom)]

    o <- order(left, right)
    hits2 <- SelfHits(left[o], right[o], nnode=length(i))
    mcols(hits2) <- mcols(p)[index[o],,drop=FALSE]
    initialize(x, hits=hits2)
})

#' @importFrom S4Vectors mcols mcols<- queryHits subjectHits SelfHits
#' normalizeSingleBracketSubscript
setReplaceMethod("[", "DualSubset", function(x, i, j, ..., value) {
    p <- .get_hits(x)
    i <- normalizeSingleBracketSubscript(i, x)

    # Filtering out all elements to be replaced.
    p <- p[!(queryHits(p) %in% i & subjectHits(p) %in% i)]

    pv <- .get_hits(value)
    new.q <- i[queryHits(pv)]
    new.s <- i[subjectHits(pv)]

    total.p <- c(queryHits(p), new.q)
    total.s <- c(subjectHits(p), new.s)
    total.m <- rbind(mcols(p), mcols(pv))

    o <- order(total.p, total.s)
    hits2 <- SelfHits(total.p[o], total.s[o], nnode=length(x))
    mcols(hits2) <- total.m[o,,drop=FALSE]
    initialize(x, hits=hits2)
})

#' @importFrom utils tail 
#' @importFrom S4Vectors queryHits subjectHits SelfHits mcols mcols<- 
setMethod("c", "DualSubset", function(x, ...) {
    everything <- list(x, ...)
    shift <- 0L

    all.first <- all.second <- all.values <- vector("list", length(everything))
    for (i in seq_along(everything)) {
        current <- .get_hits(everything[[i]])
        contribution <- nnode(current)
        all.first[[i]] <- queryHits(current) + shift
        all.second[[i]] <- subjectHits(current) + shift
        all.values[[i]] <- mcols(current)
        shift <- shift + contribution
    }

    final <- SelfHits(unlist(all.first), unlist(all.second), nnode=shift)
    mcols(final) <- do.call(rbind, all.values)
    initialize(x, hits=final)
})

#' @importFrom S4Vectors queryHits subjectHits mcols
.hits2mat <- function(p) {
    m <- mcols(p)
    if (!is.null(m) && ncol(m)) {
        x <- m[,1]
        if (!is.logical(x) && !is.numeric(x) && !is.complex(x)) {
            stop("values of type '", typeof(x), "' are not supported in sparse matrices")
        }
    } else {
        warning("no values found in 'mcols(<", class(p)[1], ">)', filling matrix with TRUE instead")
        x <- rep(TRUE, length(p))
    }

    Matrix::sparseMatrix(i=queryHits(p), j=subjectHits(p), x=x, 
        dims=rep(nnode(p), 2L), use.last.ij=TRUE)
}

#' @importFrom BiocGenerics which
#' @importFrom S4Vectors SelfHits 
.mat2hits <- function(mat) {
    i <- which(mat!=0, arr.ind=TRUE) 
    SelfHits(i[,1], i[,2], nnode=nrow(mat), x=mat[i])
}

#' Alternative Experiment methods
#'
#' @description
#' In some experiments, different features must be normalized differently or have different row-level metadata.
#' Typical examples would be for spike-in transcripts in plate-based experiments and antibody or CRISPR tags in CITE-seq experiments.
#' These data cannot be stored in the main \code{assays} of the \linkS4class{SingleCellExperiment} itself.
#' However, it is still desirable to store these features \emph{somewhere} in the SingleCellExperiment.
#' This simplifies book-keeping in long workflows and ensure that samples remain synchronised.
#'
#' To facilitate this, the \linkS4class{SingleCellExperiment} class allows for \dQuote{alternative Experiments}.
#' Nested \linkS4class{SummarizedExperiment}-class objects are stored inside the SingleCellExperiment object \code{x}, in a manner that guarantees that the nested objects have the same columns in the same order as those in \code{x}.
#' Methods are provided to enable convenient access to and manipulation of these alternative Experiments.
#' Each alternative Experiment should contain experimental data and row metadata for a distinct set of features.
#'
#' @section Getters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{altExp(x, e, withDimnames=TRUE, withColData=FALSE)}:}{
#' Retrieves a \linkS4class{SummarizedExperiment} containing alternative features (rows) for all cells (columns) in \code{x}.
#' \code{e} should either be a string specifying the name of the alternative Experiment in \code{x} to retrieve,
#' or a numeric scalar specifying the index of the desired Experiment, defaulting to the first Experiment is missing.
#'
#' If \code{withDimnames=TRUE}, the column names of the output object are set to \code{colnames(x)}.
#' In addition, if \code{withColData=TRUE}, \code{\link{colData}(x)} is \code{cbind}ed to the front of the column data of the output object.
#' }
#' \item{\code{altExpNames(x)}:}{
#' Returns a character vector containing the names of all alternative Experiments in \code{x}.
#' This is guaranteed to be of the same length as the number of results, though the names may not be unique.
#' }
#' \item{\code{altExps(x, withDimnames=TRUE, withColData=FALSE)}:}{
#' Returns a named \linkS4class{List} of matrices containing one or more \linkS4class{SummarizedExperiment} objects.
#' Each object is guaranteed to have the same number of columns, in a 1:1 correspondence to those in \code{x}.
#'
#' If \code{withDimnames=TRUE}, the column names of each output object are set to \code{colnames(x)}.
#' In addition, if \code{withColData=TRUE}, \code{\link{colData}(x)} is \code{cbind}ed to the front of the column data of each output object.
#' }
#' }
#'
#' @section Single-object setter:
#' \code{altExp(x, e, withDimnames=TRUE, withColData=FALSE) <- value} will add or replace an alternative Experiment
#' in a \linkS4class{SingleCellExperiment} object \code{x}.
#' The value of \code{e} determines how the result is added or replaced:
#' \itemize{
#' \item If \code{e} is missing, \code{value} is assigned to the first result.
#' If the result already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
#' \item If \code{e} is a numeric scalar, it must be within the range of existing results, and \code{value} will be assigned to the result at that index.
#' \item If \code{e} is a string and a result exists with this name, \code{value} is assigned to to that result.
#' Otherwise a new result with this name is append to the existing list of results.
#' }
#'
#' \code{value} is expected to be a SummarizedExperiment object with number of columns equal to \code{ncol(x)}.
#' Alternatively, if \code{value} is \code{NULL}, the alternative Experiment at \code{e} is removed from the object.
#'
#' If \code{withDimnames=TRUE}, the column names of \code{value} are checked against those of \code{x}.
#' A warning is raised if these are not identical, with the only exception being when \code{value=NULL}.
#' This is inspired by the argument of the same name in \code{\link{assay<-}}.
#'
#' If \code{withColData=TRUE}, we assume that the left-most columns of \code{colData(value)} are identical to \code{colData(x)}.
#' If so, these columns are removed, effectively reversing the \code{withColData=TRUE} setting for the \code{altExp} getter.
#' Otherwise, a warning is raised.
#'
#' @section Other setters:
#' In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{altExps(x, withDimnames=TRUE, withColData=FALSE) <- value}:}{
#' Replaces all alterrnative Experiments in \code{x} with those in \code{value}.
#' The latter should be a list-like object containing any number of SummarizedExperiment objects
#' with number of columns equal to \code{ncol(x)}.
#'
#' If \code{value} is named, those names will be used to name the alternative Experiments in \code{x}.
#' Otherwise, unnamed results are assigned default names prefixed with \code{"unnamed"}.
#'
#' If \code{value} is \code{NULL}, all alternative Experiments in \code{x} are removed.
#'
#' If \code{value} is a \linkS4class{Annotated} object, any \code{\link{metadata}} will be retained in \code{altExps(x)}.
#' If \code{value} is a \linkS4class{Vector} object, any \code{\link{mcols}} will also be retained.
#'
#' If \code{withDimnames=TRUE}, the column names of each entry of \code{value} are checked against those of \code{x}.
#' A warning is raised if these are not identical.
#'
#' If \code{withColData=TRUE}, we assume that the left-most columns of the \code{colData} for each entry of \code{value} are identical to \code{colData(x)}.
#' If so, these columns are removed, effectively reversing the \code{withColData=TRUE} setting for the \code{altExps} getter.
#' Otherwise, a warning is raised.
#' }
#' \item{\code{altExpNames(x) <- value}:}{
#' Replaces all names for alternative Experiments in \code{x} with a character vector \code{value}.
#' This should be of length equal to the number of results currently in \code{x}.
#' }
#' }
#'
#' \code{removeAltExps(x)} will remove all alternative Experiments from \code{x}.
#' This has the same effect as \code{altExps(x) <- NULL} but may be more convenient as it directly returns a SingleCellExperiment.
#'
#' @section Main Experiment naming:
#' The alternative Experiments are naturally associated with names (\code{e} during assignment).
#' However, we can also name the main Experiment in a \linkS4class{SingleCellExperiment} \code{x}:
#' \describe{
#' \item{\code{mainExpName(x) <- value}:}{
#' Set the name of the main Experiment to a non-\code{NA} string \code{value}.
#' This can also be used to unset the name if \code{value=NULL}.
#' }
#' \item{\code{mainExpName(x)}:}{
#' Returns a string containing the name of the main Experiment.
#' This may also be \code{NULL} if no name is specified.
#' }
#' }
#' The presence of a non-\code{NULL} main Experiment name is helpful for functions like \code{\link{swapAltExp}}.
#' An appropriate name is automatically added by functions like \code{\link{splitAltExps}}.
#' 
#' Note that, if a SingleCellExperiment is assigned as an alternative Experiment to another SingleCellExperiment via \code{altExp(x, e) <- value},
#' no attempt is made to synchronize \code{mainExpName(value)} with \code{e}.
#' In such cases, we suggest setting \code{mainExpName(value)} to \code{NULL} to avoid any confusion during interpretation.
#' 
#' @seealso
#' \code{\link{splitAltExps}}, for a convenient way of adding alternative Experiments from existing features.
#'
#' \code{\link{swapAltExp}}, to swap the main and alternative Experiments.
#'
#' @author Aaron Lun
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#' dim(counts(sce))
#'
#' # Mocking up some alternative Experiments.
#' se1 <- SummarizedExperiment(matrix(rpois(1000, 5), ncol=ncol(se)))
#' rowData(se1)$stuff <- sample(LETTERS, nrow(se1), replace=TRUE)
#' se2 <- SummarizedExperiment(matrix(rpois(500, 5), ncol=ncol(se)))
#' rowData(se2)$blah <- sample(letters, nrow(se2), replace=TRUE)
#'
#' # Setting the alternative Experiments.
#' altExp(sce, "spike-in") <- se1
#' altExp(sce, "CRISPR") <- se2
#'
#' # Getting alternative Experimental data.
#' altExpNames(sce)
#' altExp(sce, "spike-in")
#' altExp(sce, 2)
#'
#' # Setting alternative Experimental data.
#' altExpNames(sce) <- c("ERCC", "Ab")
#' altExp(sce, "ERCC") <- se1[1:2,]
#'
#' @name altExps
#' @docType methods
#' @aliases
#' altExp altExps altExpNames
#' altExp,SingleCellExperiment,missing-method
#' altExp,SingleCellExperiment,numeric-method
#' altExp,SingleCellExperiment,character-method
#' altExps,SingleCellExperiment-method
#' altExpNames,SingleCellExperiment-method
#' altExp<- altExps<- altExpNames<-
#' altExp<-,SingleCellExperiment,missing-method
#' altExp<-,SingleCellExperiment,numeric-method
#' altExp<-,SingleCellExperiment,character-method
#' altExps<-,SingleCellExperiment-method
#' altExpNames<-,SingleCellExperiment,character-method
#' [,SummarizedExperimentByColumn,ANY,ANY,ANY-method
#' [<-,SummarizedExperimentByColumn,ANY,ANY,ANY-method
#' c,SummarizedExperimentByColumn-method
#' length,SummarizedExperimentByColumn-method
#' names,SummarizedExperimentByColumn-method
#' names<-,SummarizedExperimentByColumn-method
#' removeAltExps
#' mainExpName
#' mainExpName,SingleCellExperiment-method
#' mainExpName<-
#' mainExpName<-,SingleCellExperiment,character_OR_NULL-method
#'
#' % Dumping the SEBC methods here, so that check doesn't complain.
NULL

.alt_key <- "altExps"

#' @export
setMethod("altExpNames", "SingleCellExperiment", function(x) {
    .get_internal_names(x, 
        getfun=int_colData, 
        key=.alt_key)
})

#' @export
#' @importFrom S4Vectors endoapply
setMethod("altExps", "SingleCellExperiment", function(x, withDimnames=TRUE, withColData=FALSE) {
    value <- .get_internal_all(x, 
        getfun=int_colData, 
        key=.alt_key)

    value <- endoapply(value, .get_se)

    if (withDimnames || withColData) {
        for (i in seq_along(value)) {
            value[[i]] <- .fill_altexps_info(x, value[[i]], 
                withDimnames=withDimnames, withColData=withColData)
        }
    }

    value
})

#' @importFrom BiocGenerics cbind
#' @importFrom SummarizedExperiment colData colData<-
.fill_altexps_info <- function(x, out, withDimnames, withColData) {
    if (withDimnames) {
        colnames(out) <- colnames(x)
    }

    if (withColData) {
        # We prepend to make it easier to reverse this operation in the setters.
        # Any new colData fields are added to the right side, so we just have
        # to check the harder-to-modify left side when reversing.
        prep <- cbind(colData(x), colData(out))
        rownames(prep) <- colnames(out)
        colData(out) <- prep
    }

    out
}

#' @export
setMethod("altExp", c("SingleCellExperiment", "missing"), function(x, e, withDimnames=TRUE, withColData=FALSE) {
    .get_internal_missing(x, 
        basefun=altExp, 
        namefun=altExpNames, 
        funstr="altExp",
        withDimnames=withDimnames,
        withColData=withColData)
})

#' @export
setMethod("altExp", c("SingleCellExperiment", "numeric"), function(x, e, withDimnames=TRUE, withColData=FALSE) {
    out <- .get_internal_integer(x, e,
        getfun=int_colData,
        key=.alt_key,
        funstr="altExp",
        substr="e")

    out <- .get_se(out)

    .fill_altexps_info(x, out, withDimnames=withDimnames, withColData=withColData)
})

#' @export
setMethod("altExp", c("SingleCellExperiment", "character"), function(x, e, withDimnames=TRUE, withColData=FALSE) {
    out <- .get_internal_character(x, e,
        getfun=int_colData,
        key=.alt_key,
        funstr="altExp",
        substr="e",
        namestr="altExpNames")

    out <- .get_se(out)

    .fill_altexps_info(x, out, withDimnames=withDimnames, withColData=withColData)
})

#' @export
setReplaceMethod("altExpNames", c("SingleCellExperiment", "character"), function(x, value) {
    .set_internal_names(x, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key)
})

#' @importFrom SummarizedExperiment colData colData<-
.check_altexp_columns <- function(main, alt, withDimnames, withColData, fun='altExp', vname="value") {
    if (!is.null(alt)) {
        if (withDimnames) {
            if (!identical(colnames(main), colnames(alt))) {
                msg <- paste0("'colnames(", vname, ")' are not the same as 'colnames(x)' for '", 
                    fun, "<-'. This will be an error in the next release of Bioconductor.")
                warning(paste(strwrap(msg), collapse="\n"))
            }
        }

        if (withColData) {
            main.cd <- colData(main)
            ncd <- ncol(main.cd)
            alt.cd <- colData(alt)
            acd <- ncol(alt.cd)
            keep <- seq_len(acd) <= ncd

            if (acd < ncd || !identical(alt.cd[,keep,drop=FALSE], main.cd)) {
                warning("left-most columns of 'colData(", vname, ")' should be the same as 'colData(x)' when 'withColData=TRUE'")
            } else {
                colData(alt) <- alt.cd[,!keep,drop=FALSE]
            }
        }
    }

    alt
}

#' @export
#' @importClassesFrom S4Vectors SimpleList
setReplaceMethod("altExps", "SingleCellExperiment", function(x, withDimnames=TRUE, withColData=FALSE, ..., value) {
    if (withDimnames || withColData) {
        for (v in seq_along(value)) {
            value[[v]] <- .check_altexp_columns(x, value[[v]], 
                withDimnames=withDimnames, withColData=withColData, 
                fun='altExps', vname=sprintf("value[[%s]]", v))
        }
    }

    .set_internal_all(x, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key,
        convertfun=SummarizedExperimentByColumn,
        xdimfun=ncol,
        vdimfun=length,
        funstr="altExps",
        xdimstr="ncol",
        vdimstr="columns")
})

#' @export
removeAltExps <- function(x) {
    altExps(x) <- NULL
    x
}

#' @export
setReplaceMethod("altExp", c("SingleCellExperiment", "missing"), function(x, e, withDimnames=TRUE, withColData=FALSE, ..., value) {
    .set_internal_missing(x, value,
        withDimnames=withDimnames,
        withColData=withColData,
        basefun=`altExp<-`,
        namefun=altExpNames)
})

#' @export
setReplaceMethod("altExp", c("SingleCellExperiment", "numeric"), function(x, e, withDimnames=TRUE, withColData=FALSE, ..., value) {
    value <- .check_altexp_columns(x, value, withDimnames=withDimnames, withColData=withColData)

    .set_internal_numeric(x, e, value,
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key,
        convertfun=SummarizedExperimentByColumn,
        xdimfun=ncol,
        vdimfun=length,
        funstr="altExp",
        xdimstr="ncol",
        vdimstr="columns",
        substr="e")
})

#' @export
setReplaceMethod("altExp", c("SingleCellExperiment", "character"), function(x, e, withDimnames=TRUE, withColData=FALSE, ..., value) {
    value <- .check_altexp_columns(x, value, withDimnames=withDimnames, withColData=withColData)

    .set_internal_character(x, e, value, 
        getfun=int_colData,
        setfun=`int_colData<-`,
        key=.alt_key,
        convertfun=SummarizedExperimentByColumn,
        xdimfun=ncol, 
        vdimfun=length,
        funstr="altExp", 
        xdimstr="ncol",
        vdimstr="columns", 
        substr="e") 
})

#' @export
setMethod("mainExpName", "SingleCellExperiment", function(x) {
    int_metadata(x)$mainExpName
})

#' @export
setReplaceMethod("mainExpName", c("SingleCellExperiment", "character_OR_NULL"), function(x, value) {
    int_metadata(x)$mainExpName <- value
    x
})

## ----options, include=FALSE, echo=FALSE---------------------------------------
library(BiocStyle)
knitr::opts_chunk$set(warning=FALSE, error=FALSE, message=FALSE)

## ----construct----------------------------------------------------------------
library(SingleCellExperiment)
counts <- matrix(rpois(100, lambda = 10), ncol=10, nrow=10)
sce <- SingleCellExperiment(assays = list(counts = counts))
sce

## -----------------------------------------------------------------------------
# Function in package A:
AsetX <- function(sce) {
    int_colData(sce)$X <- runif(ncol(sce))
    sce
}

# Function in package B:
BsetX <- function(sce) {
    int_colData(sce)$X <- sample(LETTERS, ncol(sce), replace=TRUE)
    sce
}

## -----------------------------------------------------------------------------
sce2 <- AsetX(sce)
int_colData(sce2)$X
sce2 <- BsetX(sce2)
int_colData(sce2)$X

## -----------------------------------------------------------------------------
AsetX_better <- function(sce) {
    int_colData(sce)$A <- DataFrame(X=runif(ncol(sce)))
    sce
}

BsetX_better <- function(sce) {
    choice <- sample(LETTERS, ncol(sce), replace=TRUE)
    int_colData(sce)$B <- DataFrame(X=choice)
    sce
}

sce2 <- AsetX_better(sce)
sce2 <- BsetX_better(sce2)
int_colData(sce2)$A$X 
int_colData(sce2)$B$X 

## -----------------------------------------------------------------------------
AsetY_better <- function(sce) {
    int_elementMetadata(sce)$A <- DataFrame(Y=runif(nrow(sce)))
    sce
}

BsetY_better <- function(sce) {
    choice <- sample(LETTERS, nrow(sce), replace=TRUE)
    int_elementMetadata(sce)$B <- DataFrame(Y=choice)
    sce
}

sce2 <- AsetY_better(sce)
sce2 <- BsetY_better(sce2)
int_elementMetadata(sce2)$A$Y 
int_elementMetadata(sce2)$B$Y

## -----------------------------------------------------------------------------
AsetZ_better <- function(sce) {
    int_metadata(sce)$A <- list(Z = "Aaron")
    sce
}

BsetZ_better <- function(sce) {
    int_metadata(sce)$B <- list(Z = "Davide")
    sce
}

sce2 <- AsetZ_better(sce)
sce2 <- BsetZ_better(sce2)
int_metadata(sce2)$A$Z
int_metadata(sce2)$B$Z

## -----------------------------------------------------------------------------
sessionInfo()

#' Swap main and alternative Experiments
#'
#' Swap the main Experiment for an alternative Experiment in a \linkS4class{SingleCellExperiment} object.
#'
#' @param x A \linkS4class{SingleCellExperiment} object.
#' @param name String or integer scalar specifying the alternative Experiment to use to replace the main Experiment.
#' @param saved String specifying the name to use to save the original \code{x} as an alternative experiment in the output.
#' If \code{NULL}, the original is not saved.
#' @param withColData Logical scalar specifying whether the column metadata of \code{x} should be preserved in the output.
#'
#' @return A SingleCellExperiment derived from \code{altExp(x, name)}.
#' This contains all alternative Experiments in \code{altExps(x)}, excluding the one that was promoted to the main Experiment.
#' An additional alternative Experiment containing \code{x} may be included if \code{saved} is specified.
#' 
#' @details
#' During the course of an analysis, we may need to perform operations on each of the alternative Experiments in turn.
#' This would require us to repeatedly call \code{altExp(x, name)} prior to running downstream functions on those Experiments.
#' In such cases, it may be more convenient to switch the main Experiment with the desired alternative Experiments,
#' allowing a particular section of the analysis to be performed on the latter by default.
#' 
#' For example, the initial phases of the analysis might use the entire set of features.
#' At some point, we might want to focus only on a subset of features of interest,
#' but we do not want to discard the rest of the features.
#' This can be achieved by storing the subset as an alternative Experiment and swapping it with the main Experiment,
#' as shown in the Examples below.
#'
#' If \code{withColData=TRUE}, the column metadata of the output object is set to \code{colData(x)}.
#' As a side-effect, any column data previously \code{altExp(x, name)} is stored in the \code{saved} alternative Experiment of the output.
#' This is necessary to preserve the column metadata while achieving reversibility (see below).
#' Setting \code{withColData=FALSE} will omit the \code{colData} exchange.
#'
#' \code{swapAltExp} is almost perfectly reversible, i.e., \code{swapAltExp(swapAltExp(x, name, saved), saved, name)} should return something very similar to \code{x}. 
#' The only exceptions are that the order of \code{\link{altExpNames}} is changed,
#' and that any non-\code{NULL} \code{\link{mainExpName}} in \code{altExp(x, name)} will be lost.
#'
#' @author Aaron Lun
#' @seealso 
#' \code{\link{altExps}}, for a description of the alternative Experiment concept.
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # using the class example
#'
#' # Let's say we defined a subset of genes of interest.
#' # We can save the feature set as its own altExp.
#' hvgs <- 1:10
#' altExp(sce, "subset") <- sce[hvgs,] 
#'
#' # At some point, we want to do our analysis on the HVGs only,
#' # but we want to hold onto the other features for later reference.
#' sce <- swapAltExp(sce, name="subset", saved="all")
#' sce
#' 
#' # Once we're done, it is straightforward to switch back.
#' swapAltExp(sce, "all") 
#' @export
swapAltExp <- function(x, name, saved=mainExpName(x), withColData=TRUE) {
    y <- altExp(x, name, withColData=withColData)
    y <- as(y, "SingleCellExperiment")

    all.ae <- altExps(x, withColData=FALSE)
    altExps(y) <- all.ae[setdiff(names(all.ae), name)]

    if (!is.null(saved)) {
        old <- removeAltExps(x)
        if (withColData) {
            colData(old) <- colData(altExp(x, name))
        }
        mainExpName(old) <- NULL
        altExp(y, saved) <- old
    }

    mainExpName(y) <- name
    y
}

#' @export
setMethod("[", c("SingleCellExperiment", "ANY", "ANY"), function(x, i, j, ..., drop=TRUE) {
    x <- updateObject(x)
    if (!missing(i)) {
        ii <- .convert_subset_index(i, rownames(x))
        int_elementMetadata(x) <- int_elementMetadata(x)[ii,,drop=FALSE]
    }

    if (!missing(j)) {
        jj <- .convert_subset_index(j, colnames(x))
        int_colData(x) <- int_colData(x)[jj,,drop=FALSE]
    }

    callNextMethod()
})

#' @export
#' @importClassesFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment rowData colData
setMethod("[<-", c("SingleCellExperiment", "ANY", "ANY", "SingleCellExperiment"), function(x, i, j, ..., value) {
    x <- updateObject(x)
    value <- updateObject(value)
    if (missing(i) && missing(j)) {
        return(value)
    }

    if (!missing(i)) {
        left <- int_elementMetadata(x)
        right <- int_elementMetadata(value)
        ii <- .convert_subset_index(i, rownames(x))

        tryCatch({
            left[ii,] <- right
        }, error=function(err) {
            stop(
                "failed to replace 'int_elementMetadata' in '<", class(x), ">[i,] <- value'\n",
                conditionMessage(err))
        })
        int_elementMetadata(x) <- left
    }

    if (!missing(j)) {
        left <- int_colData(x)
        right <- int_colData(value)
        jj <- .convert_subset_index(j, colnames(x))

        tryCatch({
            left[jj,] <- right
        }, error=function(err) {
            stop(
                "failed to replace 'int_colData' in '<", class(x), ">[,j] <- value'\n",
                conditionMessage(err))
        })
        int_colData(x) <- left
    }

    int_metadata(x) <- int_metadata(value)
    callNextMethod()
})

#' Get or set the row subset
#'
#' Get or set the row subset in an instance of a \linkS4class{SingleCellExperiment} class.
#' This is assumed to specify some interesting subset of genes to be favored in downstream analyses.
#'
#' @param x A \linkS4class{SingleCellExperiment} object.
#' @param field String containing the name of the field in the \code{\link{rowData}} to get or set subsetting data.
#' @param value Any character, logical or numeric vector specifying rows of \code{x} to include in the subset.
#' Alternatively \code{NULL}, in which case existing subsetting information is removed.
#' @param ... Additional arguments, currently ignored.
#' @param onAbsence String indicating an additional action to take when labels are absent:
#' nothing (\code{"none"}), a warning (\code{"warn"}) or an error (\code{"error"}).
#'
#' @details
#' A frequent task in single-cell data analyses is to focus on a subset of genes of interest,
#' e.g., highly variable genes, derived marker genes for clusters, known markers for cell types.
#' A related task is to filter out uninteresting genes such as ribosomal protein genes or mitochondrial transcripts,
#' in which case we want to subset to exclude those genes.
#' 
#' These functions store a set of genes of interest inside a \linkS4class{SingleCellExperiment}
#' for later retrieval and use in downstream functions.
#' Character and numeric \code{value} are converted to logical vectors that are parallel to the rows of \code{x},
#' allowing them to be added to the \code{\link{rowData}} for synchronized row-level operations.
#'
#' For developers, \code{onAbsence} is provided to make it easier to mandate that \code{x} actually has labels.
#' This avoids silent \code{NULL} values that flow to the rest of the function and make debugging difficult.
#'
#' @author Aaron Lun
#'
#' @return
#' For \code{rowSubset}, a logical vector is returned specifying the rows to retain in the subset of interest.
#' If no subset is available, a \code{NULL} is returned (and/or a warning or error, depending on \code{onAbsence}).
#' 
#' For \code{rowSubset<-}, a modified \code{x} is returned a subsetting vector in its \code{\link{rowData}}.
#' 
#' @seealso
#' \linkS4class{SingleCellExperiment}, for the underlying class definition. 
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # Using the class example
#'
#' rowSubset(sce, "hvgs") <- 1:10
#' rowSubset(sce, "hvgs")
#' 
#' rowSubset(sce) <- rbinom(nrow(sce), 1, 0.5)==1
#' rowSubset(sce)
#'
#' @docType methods
#' @name rowSubset
#' @aliases rowSubset rowSubset<-
NULL

.subset_field <- "subset"

#' @export
#' @rdname rowSubset
#' @importFrom SummarizedExperiment rowData
setMethod("rowSubset", "SingleCellExperiment", function(x, field="subset", onAbsence="none") {
    output <- rowData(x)[[field]]
    .absent_action(x, val=output, fun="rowSubset", onAbsence=onAbsence)
    output
})

#' @export
#' @rdname rowSubset
#' @importFrom SummarizedExperiment rowData<- rowData
setReplaceMethod("rowSubset", "SingleCellExperiment", function(x, field="subset", ..., value) {
    if (is.numeric(value)) {
        value <- seq_len(nrow(x)) %in% value
    } else if (is.character(value)) {
        value <- rownames(x) %in% value
    }

    rowData(x)[[field]] <- value
    x
})

#' @title Combining or subsetting SingleCellExperiment objects
#'
#' @description
#' An overview of methods to combine multiple \linkS4class{SingleCellExperiment} objects by row or column,
#' or to subset a SingleCellExperiment by row or column.
#' These methods are useful for ensuring that all data fields remain synchronized
#' when cells or genes are added or removed.
#'
#' @section Combining:
#' In the following code snippets, \code{...} contains one or more \linkS4class{SingleCellExperiment} objects.
#' \describe{
#' \item{\code{rbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where all objects in \code{...} are combined row-wise,
#' i.e., rows in successive objects are appended to the first object.
#'
#' Refer to \code{?"\link{rbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
#' Refer to \code{?\link[base]{rbind}} for the interpretation of \code{deparse.level}.
#'
#' Note that all objects in \code{...} must have the exact same values for \code{\link{reducedDims}} and \code{\link{altExps}}.
#' Any \code{\link{sizeFactors}} should either be \code{NULL} or contain the same values across objects.
#' }
#' \item{\code{cbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where
#' all objects in \code{...} are combined column-wise,
#' i.e., columns in successive objects are appended to the first object.
#'
#' Each object \code{x} in \code{...} must have the same values of \code{\link{reducedDimNames}(x)} (though they can be unordered).
#' Dimensionality reduction results with the same name across objects
#' will be combined row-wise to create the corresponding entry in the output object.
#'
#' Each object \code{x} in \code{...} must have the same values of \code{\link{altExpNames}(x)} (though they can be unordered).
#' Alternative Experiments with the same name across objects
#' will be combined column-wise to create the corresponding entry in the output object.
#'
#' \code{\link{sizeFactors}} should be either set to \code{NULL} in all objects, or set to a numeric vector in all objects.
#'
#' Refer to \code{?"\link{cbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
#' Refer to \code{?\link[base]{cbind}} for the interpretation of \code{deparse.level}.
#' }
#' }
#'
#' In the following code snippets, \code{x} is a SingleCellExperiment and \code{...} contains multiple SingleCellExperiment objects.
#' \describe{
#' \item{\code{combineCols(x, ..., delayed=TRUE, fill=NA, use.names=TRUE)}:}{
#' Returns a SingleCellExperiment where all objects are flexibly combined by column.
#' The assays and \code{\link{colData}} are combined as described in \code{?"\link{combineCols,SummarizedExperiment-method}"},
#' where assays or DataFrame columns missing in any given object are filled in with missing values before combining.
#'
#' Entries of the \code{\link{reducedDims}} with the same name across objects are combined by row.
#' If a dimensionality reduction result is not present for a particular SingleCellExperiment, it is represented by a matrix of \code{NA} values instead.
#' If corresponding \code{\link{reducedDim}} entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{reducedDims}} of the output object with a warning.
#'
#' Entries of the \code{\link{altExps}} with the same name across objects are combined by column using the relevant \code{\link{combineCols}} method.
#' If a named entry is not present for a particular SingleCellExperiment, it is represented by a SummarizedExperiment with a single assay full of \code{fill} values.
#' If entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{altExps}} of the output object with a warning.
#'
#' Entries of the \code{\link{colPairs}} with the same name across objects are concatenated together after adjusting the indices for each column's new position in the combined object.
#' If a named entry is not present for a particular SingleCellExperiments, it is assumed to contribute no column pairings and is ignored.
#' 
#' Entries of the \code{\link{rowPairs}} with the same name should be identical across objects if \code{use.names=FALSE}.
#' If \code{use.names=TRUE}, we attempt to merge together entries with the same name by taking the union of all column pairings.
#' However, if the same cell has a different set of pairings across objects, a warning is raised and we fall back to the \code{\link{rowPair}} entry from the first object.
#' }
#' }
#'
#' @section Subsetting:
#' In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{x[i, j, ..., drop=TRUE]}:}{Returns a SingleCellExperiment containing the
#' specified rows \code{i} and columns \code{j}.
#'
#' \code{i} and \code{j} can be a logical, integer or character vector of subscripts,
#' indicating the rows and columns respectively to retain.
#' Either can be missing, in which case subsetting is only performed in the specified dimension.
#' If both are missing, no subsetting is performed.
#'
#' Arguments in \code{...} and \code{drop} are passed to to \code{\link{[,SummarizedExperiment-method}}.}
#' \item{\code{x[i, j, ...] <- value}:}{Replaces all data for rows \code{i} and columns \code{j}
#' with the corresponding fields in a SingleCellExperiment \code{value}.
#'
#' \code{i} and \code{j} can be a logical, integer or character vector of subscripts,
#' indicating the rows and columns respectively to replace.
#' Either can be missing, in which case replacement is only performed in the specified dimension.
#' If both are missing, \code{x} is replaced entirely with \code{value}.
#'
#' If \code{j} is specified, \code{value} is expected to have the same name and order of \code{\link{reducedDimNames}}
#' and \code{\link{altExpNames}} as \code{x}.
#' If \code{sizeFactors} is set for \code{x}, it should also be set for \code{value}.
#'
#' Arguments in \code{...} are passed to the corresponding \linkS4class{SummarizedExperiment} method.}
#' }
#'
#' @author
#' Aaron Lun
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # using the class example
#'
#' # Combining:
#' rbind(sce, sce)
#' cbind(sce, sce)
#'
#' # Subsetting:
#' sce[1:10,]
#' sce[,1:5]
#'
#' sce2 <- sce
#' sce2[1:10,] <- sce[11:20,]
#'
#' # Can also use subset()
#' sce$WHEE <- sample(LETTERS, ncol(sce), replace=TRUE)
#' subset(sce, , WHEE=="A")
#'
#' # Can also use split()
#' split(sce, sample(LETTERS, nrow(sce), replace=TRUE))
#'
#' @docType methods
#' @aliases
#' cbind,SingleCellExperiment-method
#' rbind,SingleCellExperiment-method
#' combineCols,SingleCellExperiment-method
#' [,SingleCellExperiment,ANY-method
#' [,SingleCellExperiment,ANY,ANY-method
#' [,SingleCellExperiment,ANY,ANY,ANY-method
#' [<-,SingleCellExperiment,ANY,ANY,SingleCellExperiment-method
#'
#' @name SCE-combine
#' @rdname combine
NULL

#' @export
#' @importFrom BiocGenerics rbind cbind
setMethod("cbind", "SingleCellExperiment", function(..., deparse.level=1) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    out <- callNextMethod()

    args <- list(...)
    args <- lapply(args, updateObject)
    int_m <- do.call(c, unname(lapply(args, int_metadata)))

    tryCatch({
        int_cd <- do.call(rbind, lapply(args, int_colData))
    }, error=function(err) {
        stop(
            "failed to combine 'int_colData' in 'cbind(<", class(args[[1]]), ">)':\n  ",
            conditionMessage(err))
    })

    # Creating a shell to avoid having to pull out .cbind.DataFrame
    # to fuse metadata along the dimension not being combined.
    row_shells <- lapply(args, .create_shell_rowdata)
    tryCatch({
        combined <- do.call(cbind, row_shells)
    }, error=function(err) {
        stop(
            "failed to combine 'int_elementMetadata' in 'cbind(<", class(args[[1]]), ">)':\n  ",
            conditionMessage(err))
    })
    int_em <- rowData(combined)

    BiocGenerics:::replaceSlots(out, int_colData=int_cd, int_elementMetadata=int_em,
        int_metadata=int_m, check=FALSE)
})

#' @export
#' @importFrom BiocGenerics rbind cbind
setMethod("rbind", "SingleCellExperiment", function(..., deparse.level=1) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    out <- callNextMethod()

    args <- list(...)
    args <- lapply(args, updateObject)
    int_m <- do.call(c, unname(lapply(args, int_metadata)))

    tryCatch({
        int_em <- do.call(rbind, lapply(args, int_elementMetadata))
    }, error=function(err) {
        stop(
            "failed to combine 'int_elementMetadata' in 'rbind(<", class(args[[1]]), ">)':\n  ",
            conditionMessage(err))
    })

    # Creating a shell to avoid having to pull out .cbind.DataFrame
    # to fuse metadata along the dimension not being combined.
    col_shells <- lapply(args, .create_shell_coldata)
    tryCatch({
        combined <- do.call(rbind, col_shells)
    }, error=function(err) {
        stop(
            "failed to combine 'int_colData' in 'rbind(<", class(args[[1]]), ">)'\n",
            conditionMessage(err))
    })
    int_cd <- colData(combined)

    BiocGenerics:::replaceSlots(out, int_colData=int_cd, int_elementMetadata=int_em,
        int_metadata=int_m, check=FALSE)
})

#' @importFrom SummarizedExperiment SummarizedExperiment
.create_shell_coldata <- function(x) {
    SummarizedExperiment(colData=int_colData(x))
}

#' @importFrom SummarizedExperiment SummarizedExperiment
.create_shell_rowdata <- function(x) {
    SummarizedExperiment(rowData=int_elementMetadata(x))
}

#' @export
#' @importFrom DelayedArray ConstantArray
#' @importFrom S4Vectors combineCols combineRows combineUniqueCols
setMethod("combineCols", "SingleCellExperiment", function(x, ..., delayed=TRUE, fill=NA, use.names=TRUE) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    ans <- callNextMethod()

    args <- list(x, ...)
    args <- lapply(args, updateObject)
    new.int_m <- do.call(c, unname(lapply(args, int_metadata)))

    # Merging everything but the alternative experiments and reduced dimensions.
    all.int_cd <- all.int_ed <- all.altexp <- all.reddim <- all.colp <- all.rowp <- vector("list", length(args))
    for (i in seq_along(all.int_cd)) {
        current.int_cd <- int_colData(args[[i]])
        current.int_ed <- int_elementMetadata(args[[i]])

        all.altexp[i] <- list(current.int_cd[[.alt_key]])
        all.reddim[i] <- list(current.int_cd[[.red_key]])
        all.colp[i] <- list(current.int_cd[[.colp_key]])
        all.rowp[i] <- list(current.int_ed[[.rowp_key]])

        current.int_cd[[.alt_key]] <- NULL
        current.int_cd[[.red_key]] <- NULL
        current.int_cd[[.colp_key]] <- NULL
        current.int_ed[[.rowp_key]] <- NULL

        all.int_cd[[i]] <- current.int_cd
        all.int_ed[[i]] <- current.int_ed
    }

    new.int_cd <- do.call(combineRows, all.int_cd)

    # Reduced dimensions need a bit more care.
    all.reddim.names <- Reduce(union, lapply(all.reddim, colnames))
    new.reddim <- new.int_cd[,0]

    for (i in all.reddim.names) {
        collated <- vector("list", length(all.reddim))
        first <- NULL

        for (j in seq_along(collated)) {
            if (i %in% names(all.reddim[[j]])) {
                collated[[j]] <- all.reddim[[j]][[i]]
                if (is.null(first)) {
                    first <- collated[[j]]
                }
            }
        }

        for (j in seq_along(collated)) {
            if (is.null(collated[[j]])) {
                collated[[j]] <- matrix(NA_real_, ncol(args[[j]]), ncol(first))
            }
        }

        tryCatch({
            new.reddim[[i]] <- do.call(rbind, collated)
        }, error=function(e) {
            warning("failed to combine '", i, "' in 'reducedDims(<", class(ans), ">)':\n  ", conditionMessage(e))
        })
    }

    new.int_cd[[.red_key]] <- new.reddim

    # Alternative experiments need a bit more care.
    all.altexp.names <- Reduce(union, lapply(all.altexp, colnames))
    new.altexps <- new.int_cd[,0]

    for (i in all.altexp.names) {
        collated <- vector("list", length(all.altexp))
        first <- NULL

        for (j in seq_along(collated)) {
            if (i %in% names(all.altexp[[j]])) {
                collated[[j]] <- all.altexp[[j]][[i]]@se
                if (is.null(first)) {
                    first <- collated[[j]]
                }
            }
        }

        for (j in seq_along(collated)) {
            if (is.null(collated[[j]])) {
                dummy.assay <- assays(first)[1]
                dummy.assay[[1]] <- ConstantArray(c(nrow(first), ncol(args[[j]])), fill)
                dummy <- SummarizedExperiment(dummy.assay, rowData=rowData(first)[,0], colData=colData(args[[j]])[,0])
                collated[[j]] <- as(dummy, class(first)) # probably not the best placeholder, but whatever.
            }
        }

        tryCatch({
            new.altexps[[i]] <- SummarizedExperimentByColumn(do.call(combineCols, c(collated, list(use.names=use.names, delayed=delayed, fill=fill))))
        }, error=function(e) {
            warning("failed to combine '", i, "' in 'altExps(<", class(ans), ">)':\n  ", conditionMessage(e))
        })
    }

    new.int_cd[[.alt_key]] <- new.altexps

    # As do the colPairs.
    all.colp.names <- Reduce(union, lapply(all.colp, colnames))
    new.colp <- new.int_cd[,0]

    for (i in all.colp.names) {
        collated <- vector("list", length(all.colp))
        first <- NULL

        for (j in seq_along(collated)) {
            if (i %in% names(all.colp[[j]])) {
                collated[[j]] <- all.colp[[j]][[i]]
            }
        }

        for (j in seq_along(collated)) {
            if (is.null(collated[[j]])) {
                collated[[j]] <- DualSubset(SelfHits(integer(0), integer(0), nnode=ncol(args[[j]])))
            }
        }

        tryCatch({
            new.colp[[i]] <- do.call(c, collated)
        }, error=function(e) {
            warning("failed to combine '", i, "' in 'colPairs(<", class(ans), ">)':\n  ", conditionMessage(e))
        })
    }

    new.int_cd[[.colp_key]] <- new.colp

    # As do the rowPairs.
    for (i in seq_along(all.rowp)) {
        rn <- rownames(args[[i]])
        rownames(all.int_ed[[i]]) <- rn
        rownames(all.rowp[[i]]) <- rn
    }
    new.rowp <- do.call(combineUniqueCols, c(all.rowp, list(use.names=use.names)))
    new.int_ed <- do.call(combineUniqueCols, c(all.int_ed, list(use.names=use.names)))
    rownames(new.rowp) <- rownames(new.int_ed) <- NULL
    new.int_ed[[.rowp_key]] <- new.rowp

    ans <- as(ans, "SingleCellExperiment")
    BiocGenerics:::replaceSlots(ans, int_colData=new.int_cd, int_elementMetadata=new.int_ed,
        int_metadata=new.int_m, check=FALSE)
})

#' @title Combining or subsetting SingleCellExperiment objects
#'
#' @description
#' An overview of methods to combine multiple \linkS4class{SingleCellExperiment} objects by row or column,
#' or to subset a SingleCellExperiment by row or column.
#' These methods are useful for ensuring that all data fields remain synchronized
#' when cells or genes are added or removed.
#'
#' @section Combining:
#' In the following code snippets, \code{...} contains one or more \linkS4class{SingleCellExperiment} objects.
#' \describe{
#' \item{\code{rbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where all objects in \code{...} are combined row-wise,
#' i.e., rows in successive objects are appended to the first object.
#'
#' Refer to \code{?"\link{rbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
#' Refer to \code{?\link[base]{rbind}} for the interpretation of \code{deparse.level}.
#'
#' Note that all objects in \code{...} must have the exact same values for \code{\link{reducedDims}} and \code{\link{altExps}}.
#' Any \code{\link{sizeFactors}} should either be \code{NULL} or contain the same values across objects.
#' }
#' \item{\code{cbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where
#' all objects in \code{...} are combined column-wise,
#' i.e., columns in successive objects are appended to the first object.
#'
#' Each object \code{x} in \code{...} must have the same values of \code{\link{reducedDimNames}(x)} (though they can be unordered).
#' Dimensionality reduction results with the same name across objects
#' will be combined row-wise to create the corresponding entry in the output object.
#'
#' Each object \code{x} in \code{...} must have the same values of \code{\link{altExpNames}(x)} (though they can be unordered).
#' Alternative Experiments with the same name across objects
#' will be combined column-wise to create the corresponding entry in the output object.
#'
#' \code{\link{sizeFactors}} should be either set to \code{NULL} in all objects, or set to a numeric vector in all objects.
#'
#' Refer to \code{?"\link{cbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
#' Refer to \code{?\link[base]{cbind}} for the interpretation of \code{deparse.level}.
#' }
#' }
#'
#' In the following code snippets, \code{x} is a SingleCellExperiment and \code{...} contains multiple SingleCellExperiment objects.
#' \describe{
#' \item{\code{combineCols(x, ..., delayed=TRUE, fill=NA, use.names=TRUE)}:}{
#' Returns a SingleCellExperiment where all objects are flexibly combined by column.
#' The assays and \code{\link{colData}} are combined as described in \code{?"\link{combineCols,SummarizedExperiment-method}"},
#' where assays or DataFrame columns missing in any given object are filled in with missing values before combining.
#'
#' Entries of the \code{\link{reducedDims}} with the same name across objects are combined by row.
#' If a dimensionality reduction result is not present for a particular SingleCellExperiment, it is represented by a matrix of \code{NA} values instead.
#' If corresponding \code{\link{reducedDim}} entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{reducedDims}} of the output object with a warning.
#'
#' Entries of the \code{\link{altExps}} with the same name across objects are combined by column using the relevant \code{\link{combineCols}} method.
#' If a named entry is not present for a particular SingleCellExperiment, it is represented by a SummarizedExperiment with a single assay full of \code{fill} values.
#' If entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{altExps}} of the output object with a warning.
#'
#' Entries of the \code{\link{colPairs}} with the same name across objects are concatenated together after adjusting the indices for each column's new position in the combined object.
#' If a named entry is not present for a particular SingleCellExperiments, it is assumed to contribute no column pairings and is ignored.
#' 
#' Entries of the \code{\link{rowPairs}} with the same name should be identical across objects if \code{use.names=FALSE}.
#' If \code{use.names=TRUE}, we attempt to merge together entries with the same name by taking the union of all column pairings.
#' However, if the same cell has a different set of pairings across objects, a warning is raised and we fall back to the \code{\link{rowPair}} entry from the first object.
#' }
#' }
#'
#' @section Subsetting:
#' In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment} object.
#' \describe{
#' \item{\code{x[i, j, ..., drop=TRUE]}:}{Returns a SingleCellExperiment containing the
#' specified rows \code{i} and columns \code{j}.
#'
#' \code{i} and \code{j} can be a logical, integer or character vector of subscripts,
#' indicating the rows and columns respectively to retain.
#' Either can be missing, in which case subsetting is only performed in the specified dimension.
#' If both are missing, no subsetting is performed.
#'
#' Arguments in \code{...} and \code{drop} are passed to to \code{\link{[,SummarizedExperiment-method}}.}
#' \item{\code{x[i, j, ...] <- value}:}{Replaces all data for rows \code{i} and columns {j}
#' with the corresponding fields in a SingleCellExperiment \code{value}.
#'
#' \code{i} and \code{j} can be a logical, integer or character vector of subscripts,
#' indicating the rows and columns respectively to replace.
#' Either can be missing, in which case replacement is only performed in the specified dimension.
#' If both are missing, \code{x} is replaced entirely with \code{value}.
#'
#' If \code{j} is specified, \code{value} is expected to have the same name and order of \code{\link{reducedDimNames}}
#' and \code{\link{altExpNames}} as \code{x}.
#' If \code{sizeFactors} is set for \code{x}, it should also be set for \code{value}.
#'
#' Arguments in \code{...} are passed to the corresponding \linkS4class{SummarizedExperiment} method.}
#' }
#'
#' @author
#' Aaron Lun
#'
#' @examples
#' example(SingleCellExperiment, echo=FALSE) # using the class example
#'
#' # Combining:
#' rbind(sce, sce)
#' cbind(sce, sce)
#'
#' # Subsetting:
#' sce[1:10,]
#' sce[,1:5]
#'
#' sce2 <- sce
#' sce2[1:10,] <- sce[11:20,]
#'
#' # Can also use subset()
#' sce$WHEE <- sample(LETTERS, ncol(sce), replace=TRUE)
#' subset(sce, , WHEE=="A")
#'
#' # Can also use split()
#' split(sce, sample(LETTERS, nrow(sce), replace=TRUE))
#'
#' @docType methods
#' @aliases
#' cbind,SingleCellExperiment-method
#' rbind,SingleCellExperiment-method
#' combineCols,SingleCellExperiment-method
#' [,SingleCellExperiment,ANY-method
#' [,SingleCellExperiment,ANY,ANY-method
#' [,SingleCellExperiment,ANY,ANY,ANY-method
#' [<-,SingleCellExperiment,ANY,ANY,SingleCellExperiment-method
#'
#' @name SCE-combine
#' @rdname combine
NULL

#' @export
#' @importFrom BiocGenerics rbind cbind
setMethod("cbind", "SingleCellExperiment", function(..., deparse.level=1) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    out <- callNextMethod()

    args <- list(...)
    args <- lapply(args, updateObject)
    int_m <- do.call(c, unname(lapply(args, int_metadata)))

    tryCatch({
        int_cd <- do.call(rbind, lapply(args, int_colData))
    }, error=function(err) {
        stop(
            "failed to combine 'int_colData' in 'cbind(<", class(args[[1]]), ">)':\n  ",
            conditionMessage(err))
    })

    # Creating a shell to avoid having to pull out .cbind.DataFrame
    # to fuse metadata along the dimension not being combined.
    row_shells <- lapply(args, .create_shell_rowdata)
    tryCatch({
        combined <- do.call(cbind, row_shells)
    }, error=function(err) {
        stop(
            "failed to combine 'int_elementMetadata' in 'cbind(<", class(args[[1]]), ">)':\n  ",
            conditionMessage(err))
    })
    int_em <- rowData(combined)

    BiocGenerics:::replaceSlots(out, int_colData=int_cd, int_elementMetadata=int_em,
        int_metadata=int_m, check=FALSE)
})

#' @export
#' @importFrom BiocGenerics rbind cbind
setMethod("rbind", "SingleCellExperiment", function(..., deparse.level=1) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    out <- callNextMethod()

    args <- list(...)
    args <- lapply(args, updateObject)
    int_m <- do.call(c, unname(lapply(args, int_metadata)))

    tryCatch({
        int_em <- do.call(rbind, lapply(args, int_elementMetadata))
    }, error=function(err) {
        stop(
            "failed to combine 'int_elementMetadata' in 'rbind(<", class(args[[1]]), ">)':\n  ",
            conditionMessage(err))
    })

    # Creating a shell to avoid having to pull out .cbind.DataFrame
    # to fuse metadata along the dimension not being combined.
    col_shells <- lapply(args, .create_shell_coldata)
    tryCatch({
        combined <- do.call(rbind, col_shells)
    }, error=function(err) {
        stop(
            "failed to combine 'int_colData' in 'rbind(<", class(args[[1]]), ">)'\n",
            conditionMessage(err))
    })
    int_cd <- colData(combined)

    BiocGenerics:::replaceSlots(out, int_colData=int_cd, int_elementMetadata=int_em,
        int_metadata=int_m, check=FALSE)
})

#' @importFrom SummarizedExperiment SummarizedExperiment
.create_shell_coldata <- function(x) {
    SummarizedExperiment(colData=int_colData(x))
}

#' @importFrom SummarizedExperiment SummarizedExperiment
.create_shell_rowdata <- function(x) {
    SummarizedExperiment(rowData=int_elementMetadata(x))
}

#' @export
#' @importFrom DelayedArray ConstantArray
#' @importFrom S4Vectors combineCols combineRows combineUniqueCols
setMethod("combineCols", "SingleCellExperiment", function(x, ..., delayed=TRUE, fill=NA, use.names=TRUE) {
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    ans <- callNextMethod()

    args <- list(x, ...)
    args <- lapply(args, updateObject)
    new.int_m <- do.call(c, unname(lapply(args, int_metadata)))

    # Merging everything but the alternative experiments and reduced dimensions.
    all.int_cd <- all.int_ed <- all.altexp <- all.reddim <- all.colp <- all.rowp <- vector("list", length(args))
    for (i in seq_along(all.int_cd)) {
        current.int_cd <- int_colData(args[[i]])
        current.int_ed <- int_elementMetadata(args[[i]])

        all.altexp[i] <- list(current.int_cd[[.alt_key]])
        all.reddim[i] <- list(current.int_cd[[.red_key]])
        all.colp[i] <- list(current.int_cd[[.colp_key]])
        all.rowp[i] <- list(current.int_ed[[.rowp_key]])

        current.int_cd[[.alt_key]] <- NULL
        current.int_cd[[.red_key]] <- NULL
        current.int_cd[[.colp_key]] <- NULL
        current.int_ed[[.rowp_key]] <- NULL

        all.int_cd[[i]] <- current.int_cd
        all.int_ed[[i]] <- current.int_ed
    }

    new.int_cd <- do.call(combineRows, all.int_cd)

    # Reduced dimensions need a bit more care.
    all.reddim.names <- Reduce(union, lapply(all.reddim, colnames))
    new.reddim <- new.int_cd[,0]

    for (i in all.reddim.names) {
        collated <- vector("list", length(all.reddim))
        first <- NULL

        for (j in seq_along(collated)) {
            if (i %in% names(all.reddim[[j]])) {
                collated[[j]] <- all.reddim[[j]][[i]]
                if (is.null(first)) {
                    first <- collated[[j]]
                }
            }
        }

        for (j in seq_along(collated)) {
            if (is.null(collated[[j]])) {
                collated[[j]] <- matrix(NA_real_, ncol(args[[j]]), ncol(first))
            }
        }

        tryCatch({
            new.reddim[[i]] <- do.call(rbind, collated)
        }, error=function(e) {
            warning("failed to combine '", i, "' in 'reducedDims(<", class(ans), ">)':\n  ", conditionMessage(e))
        })
    }

    new.int_cd[[.red_key]] <- new.reddim

    # Alternative experiments need a bit more care.
    all.altexp.names <- Reduce(union, lapply(all.altexp, colnames))
    new.altexps <- new.int_cd[,0]

    for (i in all.altexp.names) {
        collated <- vector("list", length(all.altexp))
        first <- NULL

        for (j in seq_along(collated)) {
            if (i %in% names(all.altexp[[j]])) {
                collated[[j]] <- all.altexp[[j]][[i]]@se
                if (is.null(first)) {
                    first <- collated[[j]]
                }
            }
        }

        for (j in seq_along(collated)) {
            if (is.null(collated[[j]])) {
                dummy.assay <- assays(first)[1]
                dummy.assay[[1]] <- ConstantArray(c(nrow(first), ncol(args[[j]])), fill)
                dummy <- SummarizedExperiment(dummy.assay, rowData=rowData(first)[,0], colData=colData(args[[j]])[,0])
                collated[[j]] <- as(dummy, class(first)) # probably not the best placeholder, but whatever.
            }
        }

        tryCatch({
            new.altexps[[i]] <- SummarizedExperimentByColumn(do.call(combineCols, c(collated, list(use.names=use.names))))
        }, error=function(e) {
            warning("failed to combine '", i, "' in 'altExps(<", class(ans), ">)':\n  ", conditionMessage(e))
        })
    }

    new.int_cd[[.alt_key]] <- new.altexps

    # As do the colPairs.
    all.colp.names <- Reduce(union, lapply(all.colp, colnames))
    new.colp <- new.int_cd[,0]

    for (i in all.colp.names) {
        collated <- vector("list", length(all.colp))
        first <- NULL

        for (j in seq_along(collated)) {
            if (i %in% names(all.colp[[j]])) {
                collated[[j]] <- all.colp[[j]][[i]]
            }
        }

        for (j in seq_along(collated)) {
            if (is.null(collated[[j]])) {
                collated[[j]] <- DualSubset(SelfHits(integer(0), integer(0), nnode=ncol(args[[j]])))
            }
        }

        tryCatch({
            new.colp[[i]] <- do.call(c, collated)
        }, error=function(e) {
            warning("failed to combine '", i, "' in 'colPairs(<", class(ans), ">)':\n  ", conditionMessage(e))
        })
    }

    new.int_cd[[.colp_key]] <- new.colp

    # As do the rowPairs.
    for (i in seq_along(all.rowp)) {
        rn <- rownames(args[[i]])
        rownames(all.int_ed[[i]]) <- rn
        rownames(all.rowp[[i]]) <- rn
    }
    new.rowp <- do.call(combineUniqueCols, c(all.rowp, list(use.names=use.names)))
    new.int_ed <- do.call(combineUniqueCols, c(all.int_ed, list(use.names=use.names)))
    rownames(new.rowp) <- rownames(new.int_ed) <- NULL
    new.int_ed[[.rowp_key]] <- new.rowp

    ans <- as(ans, "SingleCellExperiment")
    BiocGenerics:::replaceSlots(ans, int_colData=new.int_cd, int_elementMetadata=new.int_ed,
        int_metadata=new.int_m, check=FALSE)
})

# Basic methods for the SummarizedExperimentByColumn class,
# an internal class that powers the alt* suite of methods.

.get_se <- function(x) x@se

SummarizedExperimentByColumn <- function(se) new("SummarizedExperimentByColumn", se=se)

setMethod("length", "SummarizedExperimentByColumn", function(x) ncol(.get_se(x)))

setMethod("[", "SummarizedExperimentByColumn", function(x, i, j, ..., drop=FALSE) {
    initialize(x, se=.get_se(x)[,i])
})

setReplaceMethod("[", "SummarizedExperimentByColumn", function(x, i, j, ..., value) {
    left <- .get_se(x)
    left[,i] <- .get_se(value)
    initialize(x, se=left)
})

setMethod("c", "SummarizedExperimentByColumn", function(x, ...) {
    gathered <- lapply(list(x, ...), .get_se)
    initialize(x, se=do.call(cbind, gathered))
})

setMethod("names", "SummarizedExperimentByColumn", function(x) colnames(.get_se(x)))

setReplaceMethod("names", "SummarizedExperimentByColumn", function(x, value) {
    colnames(x@se) <- value
    x
})

# Checks the combining methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-more-combine.R")

sce <- loaded
sce2 <- loaded[,1:50]

test_that("basic combineCols works correctly", {
    copy <- sce2
    logcounts(copy) <- NULL

    out <- combineCols(sce, copy, use.names=FALSE)
    expect_identical(ncol(out), ncol(sce) + ncol(copy))
    expect_identical(as.matrix(logcounts(out)[,1:ncol(sce)]), as.matrix(logcounts(sce)))
    expect_true(all(is.na(as.matrix(logcounts(out)[,ncol(sce) + 1:ncol(copy)]))))

    rownames(sce2) <- rownames(sce) <- sprintf("GENE_%i", seq_len(nrow(sce)))
    copy <- sce2[10:20,]
    out <- combineCols(sce, copy, use.names=TRUE)
    expect_identical(ncol(out), ncol(sce) + ncol(copy))
    expect_identical(as.matrix(counts(out)[,1:ncol(sce)]), as.matrix(counts(sce)))
    expect_identical(as.matrix(counts(out)[10:20,ncol(sce) + 1:ncol(copy)]), as.matrix(counts(copy)))
    expect_true(all(is.na(counts(out)[-(10:20),ncol(sce) + 1:ncol(copy)])))
})

test_that("combineCols works correctly with reducedDims", {
    # Handles absent entries.
    copy <- sce2
    reducedDim(copy, "PCA") <- NULL
    reducedDim(copy, "TSNE") <- reducedDim(copy, "TSNE") * 2
    out <- combineCols(sce, copy, use.names=FALSE)

    expect_identical(reducedDim(out, "TSNE"), rbind(reducedDim(sce, "TSNE"), reducedDim(copy, "TSNE")))
    expect_identical(reducedDim(out, "PCA")[1:ncol(sce),], reducedDim(sce, "PCA"))
    expect_true(all(is.na(reducedDim(out, "PCA")[ncol(sce) + 1:ncol(copy),])))

    # Robust to incompatible dimensions.
    copy <- sce2
    reducedDim(copy, "PCA") <- reducedDim(copy, "PCA")[,1:2]
    expect_warning(out <- combineCols(sce, copy, use.names=FALSE), "PCA")
    expect_false("PCA" %in% reducedDimNames(out))
    expect_identical(reducedDim(out, "TSNE"), rbind(reducedDim(sce, "TSNE"), reducedDim(copy, "TSNE")))
})

test_that("combineCols works correctly with altExps", {
    # Handles absent entries.
    copy1 <- sce
    altExp(copy1, "Protein") <- NULL
    copy2 <- sce2
    assay(altExp(copy2, "Spike"), "counts") <- NULL
    out <- combineCols(copy1, copy2, use.names=FALSE)

    prot <- altExp(out, "Protein")
    expect_true(all(is.na(as.matrix(assay(prot, "logcounts")[,1:ncol(copy1)]))))
    expect_identical(as.matrix(assay(prot, "logcounts")[,ncol(copy1) + 1:ncol(copy2)]), as.matrix(assay(altExp(copy2, "Protein"), "logcounts")))

    spike <- altExp(out, "Spike")
    expect_identical(as.matrix(assay(spike, "counts")[,1:ncol(copy1)]), as.matrix(assay(altExp(copy1, "Spike"), "counts")))
    expect_true(all(is.na(as.matrix(assay(spike, "counts")[,ncol(copy1) + 1:ncol(copy2)]))))

    # Robust to incompatible dimensions.
    copy1 <- sce
    altExp(copy1, "Protein") <- altExp(copy1, "Protein")[1:2,]
    expect_warning(out <- combineCols(copy1, copy2, use.names=FALSE), "Protein")
    expect_false("Protein" %in% altExpNames(out))

    # Use.names=TRUE propagates.
    rownames(copy1) <- rownames(copy2) <- sprintf("GENE_%i", seq_len(nrow(copy1)))
    out <- combineCols(copy1, copy2)
    prot <- altExp(out, "Protein")
    vals <- assay(prot, "counts")
    expect_identical(as.matrix(vals[1:2,1:ncol(copy1)]), as.matrix(assay(altExp(copy1, "Protein"), "counts")))
    expect_true(all(is.na(vals[-(1:2),1:ncol(copy1)])))
})

test_that("combineCols works correctly with colPairs", {
    # Handles absent entries.
    copy1 <- sce
    colPairs(copy1) <- NULL

    out <- combineCols(copy1, sce2, use.names=FALSE)
    expect_identical(as.matrix(colPair(out)) - ncol(copy1), as.matrix(colPair(sce2)))

    out <- combineCols(sce, copy1, use.names=FALSE)
    expect_identical(as.data.frame(colPair(out)), as.data.frame(colPair(sce)))
})

test_that("combineCols works correctly with rowPairs", {
    # Handles absent entries.
    copy1 <- sce
    rowPairs(copy1) <- NULL
    out <- combineCols(copy1, sce2, use.names=FALSE)
    expect_identical(rowPairs(out), rowPairs(sce2))

    # Handles mismatching entries.
    copy1 <- sce
    mcols(rowPair(copy1))$value <- runif(100)
    expect_warning(out <- combineCols(copy1, sce2, use.names=FALSE), "unnamed1")
    expect_identical(rowPairs(out), rowPairs(copy1))

    # Merges non-contradictory entries.
    copy1 <- sce
    copy2 <- sce2
    rownames(copy1) <- rownames(copy2) <- sprintf("GENE_%i", seq_len(nrow(copy1)))
    copy1 <- copy1[1:(nrow(sce)/2),]
    copy2 <- copy2[nrow(sce)/2+1:(nrow(sce)/2),]

    expect_warning(out <- combineCols(copy1, copy2), NA)
    expect_true(length(rowPair(out)) > 0)
    expect_true(length(rowPair(out)) < length(rowPair(sce))) # as links spanning the split are lost.
})

# Checks for proper functioning of the reducedDim methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-reducedDims.R")

sce <- empty

test_that("reducedDim getters/setters are functioning with character 'type'", {
    reducedDim(sce, "PCA") <- d1
    expect_identical(reducedDim(sce, "PCA"), d1)
    expect_identical(reducedDims(sce), SimpleList(PCA=d1))
    expect_identical(reducedDimNames(sce), "PCA")

    reducedDim(sce, "tSNE") <- d2
    expect_identical(reducedDim(sce, "tSNE"), d2)
    expect_identical(reducedDims(sce), SimpleList(PCA=d1, tSNE=d2))
    expect_identical(reducedDimNames(sce), c("PCA", "tSNE"))

    # Clearing values.
    reducedDim(sce, "PCA") <- NULL
    expect_identical(reducedDim(sce, "tSNE"), d2)
    expect_identical(reducedDim(sce), d2)
    expect_identical(reducedDims(sce), SimpleList(tSNE=d2))
    expect_identical(reducedDimNames(sce), "tSNE")

    # Checking for different errors.
    expect_error(reducedDim(sce, "PCA"), "invalid subscript") 
    expect_error(reducedDim(sce, 2), "invalid subscript") 
    expect_error(reducedDim(sce, "DM") <- d1[1:10,], "number of rows")
    expect_error(reducedDim(sce, 1) <- "huh", "number of rows")
})

test_that("reducedDims getters/setters are functioning", {
    reducedDims(sce) <- list(PCA=d1, TSNE=d2)
    expect_identical(reducedDimNames(sce), c("PCA", "TSNE"))
    expect_identical(reducedDim(sce, "PCA"), d1)
    expect_identical(reducedDim(sce, 1), d1)
    expect_identical(reducedDim(sce, "TSNE"), d2)
    expect_identical(reducedDim(sce, 2), d2)

    # Clearing via empty List.
    alt <- sce
    reducedDims(alt) <- SimpleList()
    expect_identical(reducedDims(alt), setNames(SimpleList(), character(0)))

    # Clearing via NULL.
    reducedDims(sce) <- SimpleList(DM=d1)
    expect_identical(SimpleList(DM=d1), reducedDims(sce))
    expect_identical(d1, reducedDim(sce))

    alt <- sce
    reducedDims(alt) <- NULL
    expect_identical(reducedDims(alt), setNames(SimpleList(), character(0)))

    # Setting with an unnamed list works.
    expect_warning(reducedDims(sce) <- list(d1, d2), "NULL")
    expect_identical(reducedDimNames(sce), c("unnamed1", "unnamed2"))

    expect_warning(reducedDims(sce) <- list(X=d1, d2), "empty")
    expect_identical(reducedDimNames(sce), c("X", "unnamed1"))

    # Checking for errors.
    expect_error(reducedDims(sce) <- list(d1, d2[1:10,]), "number of rows")
    expect_error(reducedDims(sce) <- list(d1[1:10,], d2[1:10,]), "number of rows")
})

test_that("getters/setters respond to dimnames", {
    named <- sce
    colnames(named) <- paste0("Cell", sample(ncol(named)))

    expect_warning(reducedDim(named, "PCA") <- d1, NA)
    expect_warning(reducedDim(named, "tSNE") <- d2, NA)
    expect_identical(rownames(reducedDim(named)), colnames(named))
    expect_identical(rownames(reducedDim(named, 2)), colnames(named))
    expect_identical(rownames(reducedDim(named, withDimnames=FALSE)), NULL)

    out <- reducedDims(named)
    expect_identical(rownames(out[[1]]), colnames(named))
    expect_identical(rownames(out[[2]]), colnames(named))
    out <- reducedDims(named, withDimnames=FALSE)
    expect_identical(rownames(out[[1]]), NULL)
    expect_identical(rownames(out[[2]]), NULL)

    # withDimnames works on the left hand side.
    rownames(reducedDim(named, "PCA", withDimnames=FALSE)) <- toupper(colnames(named))
    expect_identical(rownames(reducedDim(named)), colnames(named))
    expect_identical(rownames(reducedDim(named, withDimnames=FALSE)), toupper(colnames(named)))

    names(reducedDims(named, withDimnames=FALSE)) <- c("alpha", "bravo")
    expect_identical(rownames(reducedDim(named, withDimnames=FALSE)), toupper(colnames(named)))

    # No warning when names are the same.
    d1.2 <- d1
    rownames(d1.2) <- colnames(named)
    expect_warning(reducedDim(named) <- d1.2, NA)

    # withDimnames raises warnings on non-identity.
    d1.2 <- d1
    rownames(d1.2) <- toupper(colnames(named))
    expect_warning(reducedDim(named, "PCA") <- d1.2, "should be the same")
    expect_warning(reducedDims(named) <- list(PCA=d1.2), "should be the same")
    expect_warning(reducedDim(named, "PCA") <- d1, NA)
})

test_that("reducedDims getters/setters preserve mcols and metadata", {
    stuff <- List(PCA=d1, TSNE=d2)
    mcols(stuff)$A <- c("one", "two")
    metadata(stuff)$B <- "three"

    reducedDims(sce) <- stuff
    out <- reducedDims(sce)
    expect_identical(mcols(out), mcols(stuff))
    expect_identical(metadata(out), metadata(stuff))
})

test_that("reducedDim setter creates an unnamed redDim is none are present", {
    # In the absence of of redDim, create an unnamed one (like reducedDims does)
    reducedDim(sce) <- d1
    expect_identical(reducedDimNames(sce), "unnamed1")
})

test_that("reducedDim getters/setters work with numeric indices", {
    expect_error(reducedDim(sce), "no available entries") 
    expect_error(reducedDim(sce, 2), "invalid subscript 'type'") 
    expect_error(reducedDim(sce, "PCA"), "invalid subscript") 

    expect_error(reducedDim(sce, 1) <- d1, "out of bounds")
    expect_error(reducedDim(sce, 2) <- d1, "out of bounds")

    # This gets a bit confusing as the order changes when earlier elements are wiped out.
    expect_warning(reducedDims(sce) <- list(d1, d2), "NULL")
    expect_identical(reducedDim(sce), d1)
    expect_identical(reducedDim(sce, 2), d2)
    expect_identical(reducedDimNames(sce), c("unnamed1", "unnamed2"))

    mult <- d1 * 5
    reducedDim(sce, "PCA") <- mult # d1 is the second element.
    expect_identical(reducedDim(sce, 1), d1)
    expect_identical(reducedDim(sce, 2), d2)
    expect_identical(reducedDim(sce, 3), mult)
    expect_identical(reducedDimNames(sce), c("unnamed1", "unnamed2", "PCA"))

    reducedDim(sce, 1) <- NULL # d2 becomes the first element now.
    expect_identical(reducedDim(sce), d2)
    expect_identical(reducedDim(sce, 1), d2)
    expect_identical(reducedDim(sce, 2), reducedDim(sce, "PCA"))
    expect_identical(reducedDimNames(sce), c("unnamed2", "PCA"))

    reducedDim(sce) <- NULL # 'mult' becomes the first element.
    expect_identical(reducedDim(sce), mult)
    expect_identical(reducedDimNames(sce), "PCA")
    reducedDim(sce) <- d2 # d2 now overwrites the first element.
    expect_identical(reducedDim(sce, 1), d2)
    expect_identical(reducedDimNames(sce), "PCA")

    expect_error(reducedDim(sce, 5) <- d1, "out of bounds")
})

test_that("reducedDimNames getters/setters work correctly", {
    expect_warning(reducedDims(sce) <- list(d1, d2), "NULL")
    expect_identical(reducedDimNames(sce), c("unnamed1", "unnamed2"))
    reducedDims(sce) <- list(PCA=d1, TSNE=d2)
    expect_identical(reducedDimNames(sce), c("PCA", "TSNE"))

    # Directly setting.
    reducedDimNames(sce) <- c("A", "B")
    expect_identical(reducedDimNames(sce), c("A", "B"))

    # Responds to empty names.
    expect_warning(reducedDimNames(sce) <- c("X", ""), "empty")
    expect_identical(reducedDimNames(sce), c("X", "unnamed1"))

    # When wiped.
    reducedDims(sce) <- NULL
    expect_identical(reducedDimNames(sce), character(0))

    expect_error(reducedDimNames(sce) <- c("A", "B"), "more column names")
})

# Checks for proper functioning of the methods.
# library(SingleCellExperiment); library(testthat); source("setup.R"); source("test-sce-methods.R")

sce <- empty

test_that("size factor getters/setters are functioning", {
    sf1 <- 2^rnorm(ncells)
    sizeFactors(sce) <- sf1
    expect_identical(sizeFactors(sce), sf1)

    # Manual deletion.
    sizeFactors(sce) <- NULL
    expect_identical(sizeFactors(sce), NULL)

    # Additional actions work.
    expect_warning(sizeFactors(sce, onAbsence="warn"), "NULL")
    expect_error(sizeFactors(sce, onAbsence="error"), "NULL")
})

test_that("column label getters/setters are functioning", {
    labels <- sample(letters, ncol(sce), replace=TRUE) 
    colLabels(sce) <- labels
    expect_identical(colLabels(sce), labels)

    # Manual deletion.
    colLabels(sce) <- NULL
    expect_identical(colLabels(sce), NULL)

    # Additional actions work.
    expect_warning(colLabels(sce, onAbsence="warn"), "NULL")
    expect_error(colLabels(sce, onAbsence="error"), "NULL")
})

test_that("row subset getters/setters are functioning", {
    of.interest <- 1:10
    rowSubset(sce) <- of.interest
    expect_identical(which(rowSubset(sce)), of.interest)

    keep <- rbinom(nrow(sce), 1, 0.5)==1
    rowSubset(sce) <- keep
    expect_identical(rowSubset(sce), keep)

    rownames(sce) <- sprintf("GENE_%i", seq_len(nrow(sce)))
    labels <- sample(rownames(sce), ncol(sce), replace=TRUE) 
    rowSubset(sce) <- labels
    expect_identical(rowSubset(sce), rownames(sce) %in% labels)

    # Responds to non-default locations.
    of.interest <- 1:10
    rowSubset(sce, "hvgs") <- of.interest
    expect_identical(which(rowSubset(sce, "hvgs")), of.interest)

    # Manual deletion.
    rowSubset(sce) <- NULL
    expect_identical(rowSubset(sce), NULL)

    # Additional actions work.
    expect_warning(rowSubset(sce, onAbsence="warn"), "NULL")
    expect_error(rowSubset(sce, onAbsence="error"), "NULL")
})

test_that("object version extraction works", {
    expect_identical(objectVersion(sce), packageVersion("SingleCellExperiment"))
})

test_that("special colData/rowData getters/setters work", {
    int_elementMetadata(sce) <- DataFrame(STUFF=rbinom(nrow(v), 1, 0.2)==1)
    int_colData(sce) <- DataFrame(WHEE=2^rnorm(ncells))

    random_coldata <- DataFrame(a=rnorm(ncells), b=runif(ncells, 0, 1))
    colData(sce) <- random_coldata
    expect_identical(colData(sce, use.names=FALSE), random_coldata)
    expect_identical(colData(sce), colData(sce, internal=FALSE))
    expect_identical(colData(sce, internal=TRUE), cbind(colData(sce), int_colData(sce)))

    random_rowdata <- DataFrame(a=rnorm(NROW(sce)), b=runif(NROW(sce), 0, 1))
    rowData(sce) <- random_rowdata
    expect_identical(rowData(sce, use.names=FALSE), random_rowdata)
    expect_identical(rowData(sce), rowData(sce, internal=FALSE))
    expect_identical(rowData(sce, internal=TRUE), cbind(rowData(sce), int_elementMetadata(sce)))

    # Passes arguments correctly down the line.
    rout <- rowData(sce, use.names=FALSE)
    expect_identical(rownames(rout), NULL)
    cout <- colData(sce, use.names=FALSE)
    expect_identical(rownames(cout), NULL)

    sceN <- sce
    colnames(sceN) <- paste("Cell", seq_len(ncol(sceN)))
    rownames(sceN) <- paste("Cell", seq_len(nrow(sceN)))

    rout <- rowData(sceN, use.names=TRUE)
    expect_identical(rownames(rout), rownames(sceN))
    cout <- colData(sceN, use.names=TRUE)
    expect_identical(rownames(cout), colnames(sceN))

    # Warnings upon overlaps.
    rowData(sce)$STUFF <- rnorm(NROW(sce))
    expect_warning(rowData(sce, internal=TRUE), "overlapping names in internal and external rowData")

    colData(sce)$WHEE <- rnorm(ncells)
    expect_warning(colData(sce, internal=TRUE), "overlapping names in internal and external colData")
})

test_that("assay getters/setters work", {
    v2 <- matrix(runif(20000), ncol=ncells)
    counts(sce) <- v2
    expect_equivalent(counts(sce), v2)

    v3 <- log2(v2)
    logcounts(sce) <- v3
    expect_equivalent(counts(sce), v2)
    expect_equivalent(logcounts(sce), v3)

    cpm(sce) <- v3 + v2
    expect_equivalent(cpm(sce), v3+v2)
    tpm(sce) <- v3 - v2
    expect_equivalent(tpm(sce), v3-v2)

    v4 <- v2 * v3
    weights(sce) <- v4
    expect_equivalent(weights(sce), v4)

    counts(sce) <- NULL
    expect_equivalent(logcounts(sce), v3)
    expect_error(counts(sce), "invalid subscript")
})

test_that("assay getters/setters respect withDimnames", {
    sce_rownames <- paste0("G", seq_len(20000 / ncells))
    sce_colnames <- paste0("S", seq_len(ncells))
    v2 <- matrix(runif(20000), ncol=ncells)
    counts(sce) <- v2
    rownames(sce) <- sce_rownames
    colnames(sce) <- sce_colnames
    expect_identical(dimnames(counts(sce)), list(sce_rownames, sce_colnames))
    expect_identical(dimnames(counts(sce, withDimnames=FALSE)), NULL)

    v3 <- log2(v2)
    logcounts(sce, withDimnames=FALSE) <- v3
    expect_identical(dimnames(logcounts(sce)), list(sce_rownames, sce_colnames))
    expect_identical(dimnames(logcounts(sce, withDimnames=FALSE)), NULL)

    cpm(sce, withDimnames=FALSE) <- v3 + v2
    expect_identical(dimnames(cpm(sce)), list(sce_rownames, sce_colnames))
    expect_identical(dimnames(cpm(sce, withDimnames=FALSE)), NULL)

    tpm(sce, withDimnames=FALSE) <- v3 - v2
    expect_equivalent(tpm(sce), v3-v2)
    expect_identical(dimnames(tpm(sce)), list(sce_rownames, sce_colnames))
    expect_identical(dimnames(tpm(sce, withDimnames=FALSE)), NULL)
})

---
title: "Applying a function over a SingleCellExperiment's contents"
author: 
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: SingleCellExperiment
output:
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{2. Applying over a SingleCellExperiment object}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r options, include=FALSE, echo=FALSE}
library(BiocStyle)
knitr::opts_chunk$set(warning=FALSE, error=FALSE, message=FALSE)
```

# Motivation

The `SingleCellExperiment` is quite a complex class that can hold multiple aspects of the same dataset.
It is possible to have multiple assays, multiple dimensionality reduction results, and multiple alternative Experiments - 
each of which can further have multiple assays and `reducedDims`!
In some scenarios, it may be desirable to loop over these pieces and apply the same function to each of them.
This is made conveniently possible via the `applySCE()` framework.

# Quick start

Let's say we have a moderately complicated `SingleCellExperiment` object, 
containing multiple alternative Experiments for different data modalities.

```{r}
library(SingleCellExperiment)
counts <- matrix(rpois(100, lambda = 10), ncol=10, nrow=10)
sce <- SingleCellExperiment(counts)

altExp(sce, "Spike") <- SingleCellExperiment(matrix(rpois(20, lambda = 5), ncol=10, nrow=2))
altExp(sce, "Protein") <- SingleCellExperiment(matrix(rpois(50, lambda = 100), ncol=10, nrow=5))
altExp(sce, "CRISPR") <- SingleCellExperiment(matrix(rbinom(80, p=0.1, 1), ncol=10, nrow=8))

sce
```

Assume that we want to compute the total count for each modality, using the first assay.
We might define a function that looks like the below.
(We will come back to the purpose of `multiplier=` and `subset.row=` later.)

```{r}
totalCount <- function(x, i=1, multiplier=1, subset.row=NULL) {
    mat <- assay(x, i)
    if (!is.null(subset.row)) {
        mat <- mat[subset.row,,drop=FALSE]
    }
    colSums(mat) * multiplier
}
```

We can then easily apply this function across the main and alternative Experiments with:

```{r}
totals <- applySCE(sce, FUN=totalCount)
totals
```

# Design explanation 

The `applySCE()` call above is functionally equivalent to:

```{r}
totals.manual <- list( 
    totalCount(sce),
    Spike=totalCount(altExp(sce, "Spike")),
    Protein=totalCount(altExp(sce, "Protein")),
    CRISPR=totalCount(altExp(sce, "CRISPR"))
)
stopifnot(identical(totals, totals.manual))
```

Besides being more verbose than `applySCE()`, this approach does not deal well with common arguments.
Say we wanted to set `multiplier=10` for all calls.
With the manual approach above, this would involve specifying the argument multiple times:

```{r}
totals10.manual <- list( 
    totalCount(sce, multiplier=10),
    Spike=totalCount(altExp(sce, "Spike"), multiplier=10),
    Protein=totalCount(altExp(sce, "Protein"), multiplier=10),
    CRISPR=totalCount(altExp(sce, "CRISPR"), multiplier=10)
)
```

Whereas with the `applySCE()` approach, we can just set it once.
This makes it easier to change and reduces the possibility of errors when copy-pasting parameter lists across calls.

```{r}
totals10.apply <- applySCE(sce, FUN=totalCount, multiplier=10)
stopifnot(identical(totals10.apply, totals10.manual))
```

Now, one might consider just using `lapply()` in this case, which also avoids the need for repeated specification:

```{r}
totals10.lapply <- lapply(c(List(sce), altExps(sce)),
    FUN=totalCount, multiplier=10)
stopifnot(identical(totals10.apply, totals10.lapply))
```

However, this runs into the opposite problem - it is no longer possible to specify _custom_ arguments for each call.
For example, say we wanted to subset to a different set of features for each main and alternative Experiment.
With `applySCE()`, this is still possible:

```{r}
totals.custom <- applySCE(sce, FUN=totalCount, multiplier=10, 
    ALT.ARGS=list(Spike=list(subset.row=2), Protein=list(subset.row=3:5)))
totals.custom
```

In cases where we have a mix between custom and common arguments, `applySCE()` provides a more convenient and flexible interface than manual calls or `lapply()`ing.

# Simplifying to a `SingleCellExperiment`

The other convenient aspect of `applySCE()` is that, if the specified `FUN=` returns a `SingleCellExperiment`, `applySCE()` will try to format the output as a `SingleCellExperiment`.
To demonstrate, let's use the `head()` function to take the first few features for each main and alternative Experiment:

```{r}
head.sce <- applySCE(sce, FUN=head, n=5)
head.sce
```

Rather than returning a list of `SingleCellExperiment`s, we can see that the output is neatly organized as a `SingleCellExperiment` with the specified `n=5` features.
Moreover, each of the alternative Experiments is also truncated to its first 5 features (or fewer, if there weren't that many to begin with).
This output mirrors, as much as possible, the format of the input `sce`, and is much more convenient to work with than a list of objects.

```{r}
altExp(head.sce)
altExp(head.sce, "Protein")
altExp(head.sce, "CRISPR")
```

To look under the hood, we can turn off simplification and see what happens.
We see that the function indeed returns a list of `SingleCellExperiment` objects corresponding to the `head()` of each Experiment.
When `SIMPLIFY=TRUE`, this list is passed through `simplifyToSCE()` to attempt the reorganization into a single object.

```{r}
head.sce.list <- applySCE(sce, FUN=head, n=5, SIMPLIFY=FALSE) 
head.sce.list
```

For comparison, if we had to do this manually, it would be rather tedious and error-prone,
e.g., if we forgot to set `n=` or if we re-assigned the output of `head()` to the wrong alternative Experiment.

```{r}
manual.head <- head(sce, n=5)
altExp(manual.head, "Spike") <- head(altExp(sce, "Spike"), n=5)
altExp(manual.head, "Protein") <- head(altExp(sce, "Protein"), n=5)
altExp(manual.head, "CRISPR") <- head(altExp(sce, "CRISPR"), n=5)
manual.head
```

Of course, this simplification is only possible when circumstances permit.
It requires that `FUN=` returns a `SingleCellExperiment` at each call, and that no more than one result is generated for each alternative Experiment.
Failure to meet these conditions will result in a warning and a non-simplified output.

Developers may prefer to set `SIMPLIFY=FALSE` and manually call `simplifyToSCE()`, possibly with `warn.level=3` to trigger an explicit error when simplification fails.

# Session information {-}

```{r}
sessionInfo()
```

---
title: "Developing around the SingleCellExperiment class"
author: "Davide Risso and Aaron Lun"
package: SingleCellExperiment
output:
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{3. Developing around the SingleCellExperiment class}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r options, include=FALSE, echo=FALSE}
library(BiocStyle)
knitr::opts_chunk$set(warning=FALSE, error=FALSE, message=FALSE)
```

# Introduction

By design, the scope of this package is limited to defining the `SingleCellExperiment` class and some minimal getter and setter methods.
For this reason, we leave it to developers of specialized packages to provide more advanced methods for the `SingleCellExperiment` class.
If packages define their own data structure, it is their responsibility to provide coercion methods to/from their classes to `SingleCellExperiment`.

For developers, the use of `SingleCellExperiment` objects within package functions is mostly the same as the use of instances of the base `SummarizedExperiment` class.
The only exceptions involve direct access to the internal fields of the `SingleCellExperiment` definition.
Manipulation of these internal fields in other packages is possible but requires some caution, as we shall discuss below.

# Using the internal fields

## Rationale

We use an internal storage mechanism to protect certain fields from direct manipulation by the user.
This ensures that only a call to the provided setter methods can change the size factors.
The same effect could be achieved by reserving a subset of columns (or column names) as "private" in `colData()` and `rowData()`, though this is not easily implemented.

The internal storage avoids situations where users or functions can silently overwrite these important metadata fields during manipulations of `rowData` or `colData`.
This can result in bugs that are difficult to track down, particularly in long workflows involving many functions.
It also allows us to add new methods and metadata types to `SingleCellExperiment` without worrying about overwriting user-supplied metadata in existing objects.

Methods to get or set the internal fields are exported for use by developers of packages that depend on `r Biocpkg("SingleCellExperiment")`.
This allows dependent packages to store their own custom fields that are not meant to be directly accessible by the user.
However, this requires some care to avoid conflicts between packages.

## Conflicts between packages

The concern is that package **A** and **B** both define methods that get/set an internal field `X` in a `SingleCellExperiment` instance.
Consider the following example object:

```{r construct}
library(SingleCellExperiment)
counts <- matrix(rpois(100, lambda = 10), ncol=10, nrow=10)
sce <- SingleCellExperiment(assays = list(counts = counts))
sce
```

Assume that we have functions that set an internal field `X` in packages **A** and **B**.

```{r}
# Function in package A:
AsetX <- function(sce) {
    int_colData(sce)$X <- runif(ncol(sce))
    sce
}

# Function in package B:
BsetX <- function(sce) {
    int_colData(sce)$X <- sample(LETTERS, ncol(sce), replace=TRUE)
    sce
}
```

If both of these functions are called, one will clobber the output of the other.
This may lead to nonsensical results in downstream procedures.

```{r}
sce2 <- AsetX(sce)
int_colData(sce2)$X
sce2 <- BsetX(sce2)
int_colData(sce2)$X
```

## Using "Inception-style" nesting

We recommend using nested `DataFrame`s to store internal fields in the column-level metadata.
The name of the nested element should be set to the package name, thus avoiding clashes between fields with the same name from different packages.

```{r}
AsetX_better <- function(sce) {
    int_colData(sce)$A <- DataFrame(X=runif(ncol(sce)))
    sce
}

BsetX_better <- function(sce) {
    choice <- sample(LETTERS, ncol(sce), replace=TRUE)
    int_colData(sce)$B <- DataFrame(X=choice)
    sce
}

sce2 <- AsetX_better(sce)
sce2 <- BsetX_better(sce2)
int_colData(sce2)$A$X 
int_colData(sce2)$B$X 
```

The same approach can be applied to the row-level metadata, e.g., for some per-row field `Y`.

```{r}
AsetY_better <- function(sce) {
    int_elementMetadata(sce)$A <- DataFrame(Y=runif(nrow(sce)))
    sce
}

BsetY_better <- function(sce) {
    choice <- sample(LETTERS, nrow(sce), replace=TRUE)
    int_elementMetadata(sce)$B <- DataFrame(Y=choice)
    sce
}

sce2 <- AsetY_better(sce)
sce2 <- BsetY_better(sce2)
int_elementMetadata(sce2)$A$Y 
int_elementMetadata(sce2)$B$Y
```

For the object-wide metadata, a nested list is usually sufficient.

```{r}
AsetZ_better <- function(sce) {
    int_metadata(sce)$A <- list(Z = "Aaron")
    sce
}

BsetZ_better <- function(sce) {
    int_metadata(sce)$B <- list(Z = "Davide")
    sce
}

sce2 <- AsetZ_better(sce)
sce2 <- BsetZ_better(sce2)
int_metadata(sce2)$A$Z
int_metadata(sce2)$B$Z
```

In this manner, both **A** and **B** can set their internal `X`, `Y` and `Z` without interfering with each other.
Of course, this strategy assumes that packages do not have the same names as some of the in-built internal fields (which would be very unfortunate).

# Contacting us 

If your package accesses the internal fields of the `SingleCellExperiment` class, we suggest you get into contact with us on [GitHub](https://github.com/drisso/SingleCellExperiment).
This will help us in planning changes to the internal organization of the class.
It will also allow us to contact you with respect to changes or to get feedback.

We are particularly interested in scenarios where multiple packages are defining internal fields with the same scientific meaning.
In such cases, it may be valuable to provide getters and setters for this field in `r Biocpkg("SingleCellExperiment")` directly.
This reduces redundancy in the definitions across packages and promotes interoperability.
For example, methods from one package can set the field, which can then be used by methods of another package.

# Other design decisions

## What's up with `reducedDims`? 

We use a `SimpleList` as the `reducedDims` slot to allow for multiple dimensionality reduction results.
One can imagine that different dimensionality reduction techniques will be useful for different aspects of the analysis, e.g., t-SNE for visualization, PCA for pseudo-time inference.
We see `reducedDims` as a similar slot to `assays()` in that multiple matrices can be stored, though the dimensionality reduction results need not have the same number of dimensions.

## Why derive from a `RangedSummarizedExperiment`?

We decided to extend `RangedSummarizedExperiment` rather than `SummarizedExperiment` because for certain assays it will be essential to have `rowRanges()`. 
Even for RNA-seq, it is sometimes useful to have `rowRanges()` and other classes to define the genomic coordinates, e.g., `DESeqDataSet` in the `r Biocpkg("DESeq2")` package.
An alternative would have been to have two classes, `SingleCellExperiment` and `RangedSingleCellExperiment`.
However, this seems like an unnecessary duplication as having a class with default empty `rowRanges` seems good enough when one does not need `rowRanges`.

## Why not use a `MultiAssayExperiment`?

Another approach to storing alternative Experiments would be to use a `MultiAssayExperiment`.
We do not do so as the vast majority of scRNA-seq data analyses operate on the endogenous genes.
Switching to a `MultiAssayExperiment` introduces an additional layer of indirection with no benefit in most cases.
Indeed, the methods of this class are largely unnecessary when the alternative Experiments contain data for the same samples. 
By storing nested Experiments, we maintain the familiar `SummarizedExperiment` interface for better compatibility and ease of use.

# Session information {-}

```{r}
sessionInfo()
```

---
title: "An introduction to the SingleCellExperiment class"
author: 
- name: Davide Risso
  affiliation: Division of Biostatistics and Epidemiology, Weill Cornell Medicine 
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: SingleCellExperiment
output:
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{1. An introduction to the SingleCellExperiment class}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r options, include=FALSE, echo=FALSE}
library(BiocStyle)
knitr::opts_chunk$set(warning=FALSE, error=FALSE, message=FALSE)
```

# Motivation

The `SingleCellExperiment` class is a lightweight Bioconductor container for storing and manipulating single-cell genomics data.
It extends the `RangedSummarizedExperiment` class and follows similar conventions, 
i.e., rows should represent features (genes, transcripts, genomic regions) and columns should represent cells.
It provides methods for storing dimensionality reduction results and data for alternative feature sets (e.g., synthetic spike-in transcripts, antibody-derived tags).
It is the central data structure for Bioconductor single-cell packages like `r Biocpkg("scater")` and `r Biocpkg("scran")`.

# Creating SingleCellExperiment instances

`SingleCellExperiment` objects can be created via the constructor of the same name.
For example, if we have a count matrix in `counts`, we can simply call:

```{r construct}
library(SingleCellExperiment)
counts <- matrix(rpois(100, lambda = 10), ncol=10, nrow=10)
sce <- SingleCellExperiment(counts)
sce
```

In practice, it is often more useful to name the assay by passing in a named list:

```{r}
sce <- SingleCellExperiment(list(counts=counts))
sce
```

It is similarly easy to set the column and row metadata by passing values to the appropriate arguments.
We will not go into much detail here as most of this is covered by the `r Biocpkg("SummarizedExperiment")` documentation,
but to give an example:

```{r}
pretend.cell.labels <- sample(letters, ncol(counts), replace=TRUE)
pretend.gene.lengths <- sample(10000, nrow(counts))

sce <- SingleCellExperiment(list(counts=counts),
    colData=DataFrame(label=pretend.cell.labels),
    rowData=DataFrame(length=pretend.gene.lengths),
    metadata=list(study="GSE111111")
)
sce
```

Alternatively, we can construct a `SingleCellExperiment` by coercing an existing `(Ranged)SummarizedExperiment` object:

```{r coerce}
se <- SummarizedExperiment(list(counts=counts))
as(se, "SingleCellExperiment")
```

Any operation that can be applied to a `RangedSummarizedExperiment` is also applicable to any instance of a `SingleCellExperiment`.
This includes access to assay data via `assay()`, column metadata with `colData()`, and so on.
Again, without going into too much detail:

```{r}
dim(assay(sce))
colnames(colData(sce))
colnames(rowData(sce))
```

To demonstrate the use of the class in the rest of the vignette, we will use the Allen data set from the `r Biocpkg("scRNAseq")` package.

```{r fluidigm}
library(scRNAseq)
sce <- ReprocessedAllenData("tophat_counts")
sce
```

# Adding low-dimensional representations

We compute log-transformed normalized expression values from the count matrix. 
(We note that many of these steps can be performed as one-liners from the `r Biocpkg("scater")` package,
but we will show them here in full to demonstrate the capabilities of the `SingleCellExperiment` class.)

```{r subset}
counts <- assay(sce, "tophat_counts")
libsizes <- colSums(counts)
size.factors <- libsizes/mean(libsizes)
logcounts(sce) <- log2(t(t(counts)/size.factors) + 1)
assayNames(sce)
```

We obtain the PCA and t-SNE representations of the data and add them to the object with the `reducedDims()<-` method.
Alternatively, we can representations one at a time with the `reducedDim()<-` method (note the missing `s`).

```{r pca}
pca_data <- prcomp(t(logcounts(sce)), rank=50)

library(Rtsne)
set.seed(5252)
tsne_data <- Rtsne(pca_data$x[,1:50], pca = FALSE)

reducedDims(sce) <- list(PCA=pca_data$x, TSNE=tsne_data$Y)
sce
```

The coordinates for all representations can be retrieved from a `SingleCellExperiment` _en masse_ with `reducedDims()`
or one at a time by name/index with `reducedDim()`.
Each row of the coordinate matrix is assumed to correspond to a cell while each column represents a dimension.

```{r}
reducedDims(sce)
reducedDimNames(sce)
head(reducedDim(sce, "PCA")[,1:2])
head(reducedDim(sce, "TSNE")[,1:2])
```

Any subsetting by column of `sce_sub` will also lead to subsetting of the dimensionality reduction results by cell.
This is convenient as it ensures our low-dimensional results are always synchronized with the gene expression data.

```{r}
dim(reducedDim(sce, "PCA"))
dim(reducedDim(sce[,1:10], "PCA"))
```

# Convenient access to named assays

In the `SingleCellExperiment`, users can assign arbitrary names to entries of `assays`.
To assist interoperability between packages, we provide some suggestions for what the names should be for particular types of data:

- `counts`: Raw count data, e.g., number of reads or transcripts for a particular gene.
- `normcounts`: Normalized values on the same scale as the original counts.
For example, counts divided by cell-specific size factors that are centred at unity.
- `logcounts`: Log-transformed counts or count-like values.
In most cases, this will be defined as log-transformed `normcounts`, e.g., using log base 2 and a pseudo-count of 1.
- `cpm`: Counts-per-million.
This is the read count for each gene in each cell, divided by the library size of each cell in millions.
- `tpm`: Transcripts-per-million.
This is the number of transcripts for each gene in each cell, divided by the total number of transcripts in that cell (in millions).

Each of these suggested names has an appropriate getter/setter method for convenient manipulation of the `SingleCellExperiment`.
For example, we can take the (very specifically named) `tophat_counts` name and assign it to `counts` instead:

```{r}
counts(sce) <- assay(sce, "tophat_counts")
sce
dim(counts(sce))
```

This means that functions expecting count data can simply call `counts()` without worrying about package-specific naming conventions.

# Adding alternative feature sets

Many scRNA-seq experiments contain sequencing data for multiple feature types beyond the endogenous genes:

- Externally added spike-in transcripts for plate-based experiments.
- Antibody tags for CITE-seq experiments.
- CRISPR tags for CRISPR-seq experiments.
- Allele information for experiments involving multiple genotypes.

Such features can be stored inside the `SingleCellExperiment` via the concept of "alternative Experiments".
These are nested `SummarizedExperiment` instances that are guaranteed to have the same number and ordering of columns as the main `SingleCellExperiment` itself.
Data for endogenous genes and other features can thus be kept separate - which is often desirable as they need to be processed differently - while still retaining the synchronization of operations on a single object. 

To illustrate, consider the case of the spike-in transcripts in the Allen data. 
The `altExp()` method returns a self-contained `SingleCellExperiment` instance containing only the spike-in transcripts.

```{r}
altExp(sce)
```

Each alternative Experiment can have a different set of assays from the main `SingleCellExperiment`.
This is useful in cases where the other feature types must be normalized or transformed differently.
Similarly, the alternative Experiments can have different `rowData()` from the main object.

```{r}
rowData(altExp(sce))$concentration <- runif(nrow(altExp(sce)))
rowData(altExp(sce))
rowData(sce)
```

We provide the `splitAltExps()` utility to easily split a `SingleCellExperiment` into new alternative Experiments.
For example, if we wanted to split the RIKEN transcripts into a separate Experiment
- say, to ensure that they are not used in downstream analyses without explicitly throwing out the data -
we would do:

```{r}
is.riken <- grepl("^[0-9]", rownames(sce))
sce <- splitAltExps(sce, ifelse(is.riken, "RIKEN", "gene"))
altExpNames(sce)
```

Alternatively, if we want to swap the main and alternative Experiments -
perhaps because the RIKEN transcripts were more interesting than expected, and we want to perform our analyses on them -
we can simply use `swapAltExp()` to switch the RIKEN alternative Experiment with the gene expression data:

```{r}
swapAltExp(sce, "RIKEN", saved="original")
```

# Storing row or column pairings

A common procedure in single-cell analyses is to identify relationships between pairs of cells,
e.g., to construct a nearest-neighbor graph or to mark putative physical interactions between cells.
We can capture this information in the `SingleCellExperiment` class with the `colPairs()` functionality.
To demonstrate, say we have 100 relationships between the cells in `sce`, characterized by some distance measure:

```{r}
cell1 <- sample(ncol(sce), 100, replace=TRUE)
cell2 <- sample(ncol(sce), 100, replace=TRUE)
distance <- runif(100)
```

We store this in the `SingleCellExperiment` as a `SelfHits` object using the `value` metadata field to hold our data.
This is easily extracted as a `SelfHits` or, for logical or numeric data, as a sparse matrix from `r CRANpkg("Matrix")`.

```{r}
colPair(sce, "relationships") <- SelfHits(
    cell1, cell2, nnode=ncol(sce), value=distance)
colPair(sce, "relationships")
class(colPair(sce, asSparse=TRUE))
```

A particularly useful feature is that the indices of the interacting cells are automatically remapped when `sce` is subsetted.
This ensures that the pairings are always synchronized with the identities of the cells in `sce`.

```{r}
sub <- sce[,50:300]
colPair(sub) # grabs the first pairing, if no 'type' is supplied.
```

Similar functionality is available for pairings between rows via the `rowPairs()` family of functions, 
which is potentially useful for representing coexpression or regulatory networks.

# Additional metadata fields

The `SingleCellExperiment` class provides the `sizeFactors()` getter and setter methods,
to set and retrieve size factors from the `colData` of the object.
Each size factor represents the scaling factor applied to a cell to normalize expression values prior to downstream comparisons,
e.g., to remove the effects of differences in library size and other cell-specific biases.
These methods are primarily intended for programmatic use in functions implementing normalization methods,
but users can also directly call this to inspect or define the size factors for their analysis.

```{r}
# Making up some size factors and storing them:
sizeFactors(sce) <- 2^rnorm(ncol(sce))
summary(sizeFactors(sce))

# Deleting the size factors:
sizeFactors(sce) <- NULL
sizeFactors(sce)
```

The `colLabels()` getter and setters methods allow applications to set and retrieve cell labels from the `colData`.
These labels can be derived from cluster annotations, assigned by classification algorithms, etc.
and are often used in downstream visualization and analyses.
While labels can be stored in any `colData` field, the `colLabels()` methods aim to provide some informal standardization
to a default location that downstream functions can search first when attempting to retrieve annotations.

```{r}
# Making up some labels and storing them:
colLabels(sce) <- sample(letters, ncol(sce), replace=TRUE)
table(colLabels(sce))

# Deleting the labels:
colLabels(sce) <- NULL
colLabels(sce)
```

In a similar vein, we provide the `rowSubset()` function for users to set and get row subsets from the `rowData`.
This will store any vector of gene identities (e.g., row names, integer indices, logical vector) 
in the `SingleCellExperiment` object for retrieval and use by downstream functions.
Users can then easily pack multiple feature sets into the same object for synchronized manipulation.

```{r}
# Packs integer or character vectors into the rowData:
rowSubset(sce, "my gene set 1") <- 1:10
which(rowSubset(sce, "my gene set 1"))

# Easy to delete:
rowSubset(sce, "my gene set 1") <- NULL
rowSubset(sce, "my gene set 1")
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/colPairs.R
\docType{methods}
\name{colPairs}
\alias{colPairs}
\alias{colPair}
\alias{colPairNames}
\alias{colPair,SingleCellExperiment,missing-method}
\alias{colPair,SingleCellExperiment,numeric-method}
\alias{colPair,SingleCellExperiment,character-method}
\alias{colPairs,SingleCellExperiment-method}
\alias{colPairNames,SingleCellExperiment-method}
\alias{colPair<-}
\alias{colPairs<-}
\alias{colPairNames<-}
\alias{colPair<-,SingleCellExperiment,missing-method}
\alias{colPair<-,SingleCellExperiment,numeric-method}
\alias{colPair<-,SingleCellExperiment,character-method}
\alias{colPairs<-,SingleCellExperiment-method}
\alias{colPairNames<-,SingleCellExperiment,character-method}
\title{Column pair methods}
\description{
Methods to get or set column pairings in a \linkS4class{SingleCellExperiment} object.
These are typically used to store and retrieve relationships between cells, 
e.g., in nearest-neighbor graphs or for inferred cell-cell interactions.
}
\section{Getters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{colPair(x, type, asSparse=FALSE)}:}{
Retrieves a \linkS4class{SelfHits} object where each entry represents a pair of columns of \code{x}
and has number of nodes equal to \code{ncol(x)}.
\code{type} is either a string specifying the name of the column pairing in \code{x} to retrieve,
or a numeric scalar specifying the index of the desired result.

If \code{asSparse=TRUE}, a sparse matrix is returned instead, see below for details.
}
\item{\code{colPairNames(x)}:}{
Returns a character vector containing the names of all column pairings in \code{x}.
This is guaranteed to be of the same length as the number of results, though the names may not be unique.
}
\item{\code{colPairs(x, asSparse=FALSE)}:}{
Returns a named \linkS4class{List} of matrices containing one or more column pairings as \linkS4class{SelfHits} objects.
If \code{asSparse=FALSE}, each entry is instead a sparse matrix.
}
}

When \code{asSparse=TRUE}, the return value will be a triplet-form sparse matrix 
where each row/column corresponds to a column of \code{x}.
The values in the matrix will be taken from the first metadata field of the underlying \linkS4class{SelfHits} object,
with an error being raised if the first metadata field is not of an acceptable type.
If there are duplicate pairs, only the value from the last pair is used. 
If no metadata is available, the matrix values are set to \code{TRUE} for all pairs.
}

\section{Single setter}{

\code{colPair(x, type) <- value} will add or replace a column pairing
in a \linkS4class{SingleCellExperiment} object \code{x}.
The value of \code{type} determines how the pairing is added or replaced:
\itemize{
\item If \code{type} is missing, \code{value} is assigned to the first pairing.
If the pairing already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
\item If \code{type} is a numeric scalar, it must be within the range of existing pairings, 
and \code{value} will be assigned to the pairing at that index.
\item If \code{type} is a string and a pairing exists with this name, \code{value} is assigned to to that pairing.
Otherwise a new pairing with this name is append to the existing list of pairings.
}

\code{value} is expected to be a \linkS4class{SelfHits} with number of nodes equal to \code{ncol(x)}.
Any number of additional fields can be placed in \code{\link{mcols}(value)}.
Duplicate column pairs are supported and will not be collapsed into a single entry.

\code{value} may also be a sparse matrix with number of rows and columns equal to \code{ncol(x)}.
This is converted into a \linkS4class{SelfHits} object with values stored in the metadata as the \code{"x"} field.

Alternatively, if \code{value} is \code{NULL}, the pairings corresponding to \code{type} are removed from \code{x}.
}

\section{Other setters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{colPairs(x) <- value}:}{
Replaces all column pairings in \code{x} with those in \code{value}.
The latter should be a list-like object containing any number of \linkS4class{SelfHits} or sparse matrices,
each of which is subject to the constraints described for the single setter.

If \code{value} is named, those names will be used to name the column pairings in \code{x}.
Otherwise, unnamed pairings are assigned default names prefixed with \code{"unnamed"}.

If \code{value} is \code{NULL}, all column pairings in \code{x} are removed.
}
\item{\code{colPairNames(x) <- value}:}{
Replaces all names for column pairings in \code{x} with a character vector \code{value}.
This should be of length equal to the number of pairings currently in \code{x}.
}
}
}

\section{Interaction with SingleCellExperiment operations}{

When column-subset replacement is performed on a SingleCellExperiment object (i.e., \code{x[,i] <- y}),
a pair of columns in \code{colPair(x)} is only replaced if both columns are present in \code{i}.
This replacement not only affects the \code{value} of the pair but also whether it even exists in \code{y}.
For example, if a pair exists between two columns in \code{x[,i]} but not in the corresponding columns of \code{y},
it is removed upon subset replacement.

Importantly, pairs in \code{x} with only one column in \code{i} are preserved by replacement.
This ensures that \code{x[,i] <- x[,i]} is a no-op.
However, if the replacement is fundamentally altering the identity of the features in \code{x[,i]},
it is unlikely that the pairings involving the old identities are applicable to the replacement features in \code{y}.
In such cases, additional pruning may be required to remove all pairs involving \code{i} prior to replacement.

Another interesting note is that, for some \code{i <- 1:n} where \code{n} is in \code{[1, ncol(x))},
\code{cbind(x[,i], x[,-i])} will not return a SingleCellExperiment equal to \code{x} with respect to \code{\link{colPairs}}.
This operation will remove any pairs involving one column in \code{i} and another column outside of \code{i},
simply because each individual subset operation will remove pairs involving columns outside of the subset.
}

\examples{
example(SingleCellExperiment, echo=FALSE)

# Making up some regulatory pairings:
hits <- SelfHits(
    sample(ncol(sce), 10),
    sample(ncol(sce), 10),
    nnode=ncol(sce)
)
mcols(hits)$value <- runif(10)

colPair(sce, "regulators") <- hits
colPair(sce, "regulators")

as.mat <- colPair(sce, "regulators", asSparse=TRUE)
class(as.mat)

colPair(sce, "coexpression") <- hits
colPairs(sce)

colPair(sce, "regulators") <- NULL
colPairs(sce)

colPairs(sce) <- SimpleList()
colPairs(sce)

}
\seealso{
\code{\link{rowPairs}}, for the row equivalent.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defunct.R
\docType{methods}
\name{defunct}
\alias{defunct}
\alias{isSpike}
\alias{isSpike<-}
\alias{spikeNames}
\alias{clearSpikes}
\alias{sizeFactorNames}
\alias{clearSizeFactors}
\title{Defunct methods}
\description{
Defunct methods in the \pkg{SingleCellExperiment} package.
}
\section{Named size factors}{

The class now only supports one set of size factors, accessible via \code{\link{sizeFactors}}.
This represents a simplification of the class and removes a difficult part of the API 
(that had to deal with both \code{NULL} and strings to specify the size factor set of interest).
}

\section{Spike-ins}{

It is recommended to handle spike-ins and other \dQuote{alternative} features via \code{\link{altExps}}.
}

\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/colLabels.R
\docType{methods}
\name{colLabels}
\alias{colLabels}
\alias{colLabels<-}
\alias{colLabels,SingleCellExperiment-method}
\alias{colLabels<-,SingleCellExperiment-method}
\title{Get or set column labels}
\usage{
\S4method{colLabels}{SingleCellExperiment}(x, onAbsence = "none")

\S4method{colLabels}{SingleCellExperiment}(x, ...) <- value
}
\arguments{
\item{x}{A \linkS4class{SingleCellExperiment} object.}

\item{onAbsence}{String indicating an additional action to take when labels are absent:
nothing (\code{"none"}), a warning (\code{"warn"}) or an error (\code{"error"}).}

\item{...}{Additional arguments, currently ignored.}

\item{value}{Any vector-like object of length equal to \code{ncol(object)}, containing labels for all cells.
Alternatively \code{NULL}, in which case existing label information is removed.}
}
\value{
For \code{colLabels}, a vector or equivalent is returned containing label assignments for all cells.
If no labels are available, a \code{NULL} is returned (and/or a warning or error, depending on \code{onAbsence}).

For \code{colLabels<-}, a modified \code{x} is returned with labels in its \code{\link{colData}}.
}
\description{
Get or set column labels in an instance of a \linkS4class{SingleCellExperiment} class.
Labels are expected to represent information about the the biological state of each cell.
}
\details{
A frequent task in single-cell data analyses is to label cells with some annotation,
e.g., cluster identities, predicted cell type classifications and so on.
In a \linkS4class{SummarizedExperiment}, the \code{\link{colData}} represents the ideal place for such annotations,
which can be easily set and retrieved with standard methods, e.g., \code{x$label <- my.labels}.

That said, it is desirable to have some informal standardization of the name of the column used to store these annotations as this makes it easier to programmatically set sensible defaults for retrieval of the labels in downstream functions.
To this end, the \code{colLabels} function will get or set labels from the \code{"label"} field of the \code{\link{colData}}.
This considers the use case where there is a \dQuote{primary} set of labels that represents the default grouping of cells in downstream analyses.

To illustrate, let's say we have a downstream function that accepts a SingleCellExperiment object and requires labels.
When defining our function, we can set \code{colLabels(x)} as the default value for our label argument.
This pattern is useful as it accommodates on-the-fly changes to a secondary set of labels in \code{x} without requiring the user to run \code{colLabels(x) <- second.labels}, while facilitating convenient use of the primary labels by default.

For developers, \code{onAbsence} is provided to make it easier to mandate that \code{x} actually has labels.
This avoids silent \code{NULL} values that flow to the rest of the function and make debugging difficult.
}
\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example
colLabels(sce) <- sample(LETTERS, ncol(sce), replace=TRUE)
colLabels(sce)

}
\seealso{
\linkS4class{SingleCellExperiment}, for the underlying class definition.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reduced.dim.matrix.R
\name{reduced.dim.matrix}
\alias{reduced.dim.matrix}
\alias{reduced.dim.matrix-class}
\alias{[.reduced.dim.matrix}
\alias{cbind.reduced.dim.matrix}
\alias{rbind.reduced.dim.matrix}
\title{The reduced.dim.matrix class}
\description{
A matrix class that retains its attributes upon being subsetted or combined.
This is useful for storing metadata about a dimensionality reduction result alongside the matrix,
and for ensuring that the metadata persists when the matrix is stored inside \code{\link{reducedDims}}.
}
\section{Constructor}{

\code{reduced.dim.matrix(x, ...)} will return a reduced.dim.matrix object, given a matrix input \code{x}.
Arguments in \code{...} should be named and are stored as custom attributes in the output.
Any arguments named \code{dim} or \code{dimnames} are ignored.
}

\section{Subsetting}{

\code{x[i, j, ..., drop=FALSE]} will subset a reduced.dim.matrix \code{x} in the same manner as a base matrix.
The only difference is that a reduced.dim.matrix will be returned, retaining any custom attributes in \code{x}.
Note that no custom attributes are retained if the return value is a vector with \code{drop=TRUE}.
}

\section{Combining}{

\code{rbind(...)} will combine multiple reduced.dim.matrix inputs in \code{...} by row, 
while \code{cbind(...)} will combine those inputs by column.

If the custom attributes are the same across all objects \code{...},
a reduced.dim.matrix is returned containing all combined rows/columns as well as the custom attributes.

If the custom attributes are different, a warning is issued.
A matrix is returned containing all combined rows/columns; no custom attributes are retained.
}

\examples{
# Typical PC result, with metadata stored in the attributes:
pc <- matrix(runif(500), ncol=5)
attr(pc, "sdev") <- 1:100
attr(pc, "rotation") <- matrix(rnorm(20), ncol=5)

# Disappears upon subsetting and combining!
attributes(pc[1:10,])
attributes(rbind(pc, pc))

# Transformed into a reduced.dim.matrix:
rd.pc <- reduced.dim.matrix(pc)

attributes(rd.pc[1:10,])
attributes(rbind(rd.pc, rd.pc))

}
\seealso{
\code{\link{reducedDims}}, to store these objects in a \linkS4class{SingleCellExperiment}.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/updateObject.R
\name{updateObject}
\alias{updateObject}
\alias{updateObject,SingleCellExperiment-method}
\title{Update a SingleCellExperiment object}
\usage{
\S4method{updateObject}{SingleCellExperiment}(object, ..., verbose = FALSE)
}
\arguments{
\item{object}{A old \linkS4class{SingleCellExperiment} object.}

\item{...}{Additional arguments that are ignored.}

\item{verbose}{Logical scalar indicating whether a message should be emitted as the object is updated.}
}
\value{
An updated version of \code{object}.
}
\description{
Update \linkS4class{SingleCellExperiment} objects to the latest version of the class structure.
This is usually called by methods in the \pkg{SingleCellExperiment} package rather than by users or downstream packages.
}
\details{
This function updates the SingleCellExperiment to match changes in the internal class representation.
Changes are as follows:
\itemize{
\item Objects created before 1.7.1 are modified to include \code{\link{altExps}} and \code{\link{reducedDims}} fields in their internal column metadata.
Reduced dimension results previously in the \code{reducedDims} slot are transferred to the \code{reducedDims} field.
\item Objects created before 1.9.1 are modified so that the size factors are stored by \code{\link{sizeFactors<-}} in \code{\link{colData}} rather than \code{\link{int_colData}}.
}
}
\seealso{
\code{\link{objectVersion}}, which is used to determine if the object is up-to-date.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rowPairs.R
\docType{methods}
\name{rowPairs}
\alias{rowPairs}
\alias{rowPair}
\alias{rowPairNames}
\alias{rowPair,SingleCellExperiment,missing-method}
\alias{rowPair,SingleCellExperiment,numeric-method}
\alias{rowPair,SingleCellExperiment,character-method}
\alias{rowPairs,SingleCellExperiment-method}
\alias{rowPairNames,SingleCellExperiment-method}
\alias{rowPair<-}
\alias{rowPairs<-}
\alias{rowPairNames<-}
\alias{rowPair<-,SingleCellExperiment,missing-method}
\alias{rowPair<-,SingleCellExperiment,numeric-method}
\alias{rowPair<-,SingleCellExperiment,character-method}
\alias{rowPairs<-,SingleCellExperiment-method}
\alias{rowPairNames<-,SingleCellExperiment,character-method}
\alias{[,DualSubset,ANY,ANY,ANY-method}
\alias{[<-,DualSubset,ANY,ANY,ANY-method}
\alias{c,DualSubset-method}
\alias{length,DualSubset-method}
\title{Row pair methods}
\description{
Methods to get or set row pairings in a \linkS4class{SingleCellExperiment} object.
These are typically used to store and retrieve relationships between features, 
e.g., in gene regulatory or co-expression networks.
}
\section{Getters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{rowPair(x, type, asSparse=FALSE)}:}{
Retrieves a \linkS4class{SelfHits} object where each entry represents a pair of rows of \code{x}
and has number of nodes equal to \code{nrow(x)}.
\code{type} is either a string specifying the name of the row pairing in \code{x} to retrieve,
or a numeric scalar specifying the index of the desired pairing.

If \code{asSparse=TRUE}, a sparse matrix is returned instead, see below for details.
}
\item{\code{rowPairNames(x)}:}{
Returns a character vector containing the names of all row pairings in \code{x}.
This is guaranteed to be of the same length as the number of pairings, though the names may not be unique.
}
\item{\code{rowPairs(x, asSparse=FALSE)}:}{
Returns a named \linkS4class{List} of matrices containing one or more row pairings as \linkS4class{SelfHits} objects.
If \code{asSparse=FALSE}, each entry is instead a sparse matrix.
}
}

When \code{asSparse=TRUE}, the return value will be a triplet-form sparse matrix 
where each row/column corresponds to a row of \code{x}.
The values in the matrix will be taken from the first metadata field of the underlying \linkS4class{SelfHits} object,
with an error being raised if the first metadata field is not of an acceptable type.
If there are duplicate pairs, only the value from the last pair is used. 
If no metadata is available, the matrix values are set to \code{TRUE} for all pairs.
}

\section{Single setter}{

\code{rowPair(x, type) <- value} will add or replace a row pairing
in a \linkS4class{SingleCellExperiment} object \code{x}.
The value of \code{type} determines how the pairing is added or replaced:
\itemize{
\item If \code{type} is missing, \code{value} is assigned to the first pairing.
If the pairing already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
\item If \code{type} is a numeric scalar, it must be within the range of existing pairings, 
and \code{value} will be assigned to the pairing at that index.
\item If \code{type} is a string and a pairing exists with this name, \code{value} is assigned to to that pairing.
Otherwise a new pairing with this name is append to the existing list of pairings.
}

\code{value} is expected to be a \linkS4class{SelfHits} with number of nodes equal to \code{nrow(x)}.
Any number of additional fields can be placed in \code{\link{mcols}(value)}.
Duplicate row pairs are supported and will not be collapsed into a single entry.

\code{value} may also be a sparse matrix with number of rows and columns equal to \code{nrow(x)}.
This is converted into a \linkS4class{SelfHits} object with values stored in the metadata as the \code{"x"} field.

Alternatively, if \code{value} is \code{NULL}, the pairings corresponding to \code{type} are removed from \code{x}.
}

\section{Other setters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{rowPairs(x) <- value}:}{
Replaces all row pairings in \code{x} with those in \code{value}.
The latter should be a list-like object containing any number of \linkS4class{SelfHits} or sparse matrices,
each of which is subject to the constraints described for the single setter.

If \code{value} is named, those names will be used to name the row pairings in \code{x}.
Otherwise, unnamed pairings are assigned default names prefixed with \code{"unnamed"}.

If \code{value} is \code{NULL}, all row pairings in \code{x} are removed.
}
\item{\code{rowPairNames(x) <- value}:}{
Replaces all names for row pairings in \code{x} with a character vector \code{value}.
This should be of length equal to the number of pairings currently in \code{x}.
}
}
}

\section{Interaction with SingleCellExperiment operations}{

When row-subset replacement is performed on a SingleCellExperiment object (i.e., \code{x[i,] <- y}),
a pair of rows in \code{rowPair(x)} is only replaced if both rows are present in \code{i}.
This replacement not only affects the \code{value} of the pair but also whether it even exists in \code{y}.
For example, if a pair exists between two rows in \code{x[i,]} but not in the corresponding rows of \code{y},
it is removed upon subset replacement.

Importantly, pairs in \code{x} with only one row in \code{i} are preserved by replacement.
This ensures that \code{x[i,] <- x[i,]} is a no-op.
However, if the replacement is fundamentally altering the identity of the features in \code{x[i,]},
it is unlikely that the pairings involving the old identities are applicable to the replacement features in \code{y}.
In such cases, additional pruning may be required to remove all pairs involving \code{i} prior to replacement.

Another interesting note is that, for some \code{i <- 1:n} where \code{n} is in \code{[1, nrow(x))},
\code{rbind(x[i,], x[-i,])} will not return a SingleCellExperiment equal to \code{x} with respect to \code{\link{rowPairs}}.
This operation will remove any pairs involving one row in \code{i} and another row outside of \code{i},
simply because each individual subset operation will remove pairs involving rows outside of the subset.
}

\examples{
example(SingleCellExperiment, echo=FALSE)

# Making up some regulatory pairings:
hits <- SelfHits(
    sample(nrow(sce), 10),
    sample(nrow(sce), 10),
    nnode=nrow(sce)
)
mcols(hits)$value <- runif(10)

rowPair(sce, "regulators") <- hits
rowPair(sce, "regulators")

as.mat <- rowPair(sce, "regulators", asSparse=TRUE)
class(as.mat)

rowPair(sce, "coexpression") <- hits
rowPairs(sce)

rowPair(sce, "regulators") <- NULL
rowPairs(sce)

rowPairs(sce) <- SimpleList()
rowPairs(sce)

}
\seealso{
\code{\link{colPairs}}, for the column equivalent.
}
\author{
Aaron Lun
}

\name{Combining LEMs}

\alias{rbind,LinearEmbeddingMatrix-method}
\alias{cbind,LinearEmbeddingMatrix-method}

\title{LEM combining methods}

\description{
Methods to combine LinearEmbeddingMatrix objects.
}

\usage{
\S4method{rbind}{LinearEmbeddingMatrix}(..., deparse.level=1)

\S4method{cbind}{LinearEmbeddingMatrix}(..., deparse.level=1)
}

\arguments{
\item{...}{One or more LinearEmbeddingMatrix objects.}
\item{deparse.level}{An integer scalar; see \code{?base::\link[base]{cbind}} for a description of this argument.}
}

\details{
For \code{rbind}, LinearEmbeddingMatrix objects are combined row-wise, i.e., rows in successive objects are appended to the first object.
This corresponds to adding more samples to the first object.
Note that \code{featureLoadings} and \code{factorData} will only be taken from the first element in the list;
no checks are performed to determine whether they are consistent or not across objects.

For \code{cbind}, LinearEmbeddingMatrix objects are combined columns-wise, i.e., columns in successive objects are appended to the first object.
This corresponds to adding more factors to the first object.
\code{featureLoadings} will also be combined column-wise across objects, provided that the number of features is the same across objects.
Similarly, \code{factorData} will be combined row-wise across objects.

Combining objects with and without row names will result in the removal of all row names; similarly for column names.
Duplicate row names are currently supported by duplicate column names are not, and will be de-duplicated appropriately.
}

\value{
A LinearEmbeddingMatrix object containing all rows/columns of the supplied objects.
}

\author{
Aaron Lun
}

\examples{
example(LinearEmbeddingMatrix, echo=FALSE) # using the class example
rbind(lem, lem)
cbind(lem, lem)
}

\name{Getter/setter methods}
\alias{sampleFactors} 
\alias{featureLoadings} 
\alias{factorData} 

\alias{sampleFactors,LinearEmbeddingMatrix-method} 
\alias{featureLoadings,LinearEmbeddingMatrix-method} 
\alias{factorData,LinearEmbeddingMatrix-method} 

\alias{sampleFactors<-} 
\alias{featureLoadings<-} 
\alias{factorData<-} 

\alias{sampleFactors<-,LinearEmbeddingMatrix-method} 
\alias{featureLoadings<-,LinearEmbeddingMatrix-method} 
\alias{factorData<-,LinearEmbeddingMatrix-method} 

\alias{as.matrix,LinearEmbeddingMatrix-method} 
\alias{dim,LinearEmbeddingMatrix-method} 
\alias{dimnames,LinearEmbeddingMatrix-method} 
\alias{dimnames<-,LinearEmbeddingMatrix-method} 
\alias{dimnames<-,LinearEmbeddingMatrix,ANY-method} 

\alias{$,LinearEmbeddingMatrix-method}
\alias{$<-,LinearEmbeddingMatrix-method}

\title{LinearEmbeddingMatrix getters/setters}
\description{Getter/setter methods for the LinearEmbeddingMatrix class.}

\usage{
\S4method{sampleFactors}{LinearEmbeddingMatrix}(x, withDimnames=TRUE)

\S4method{sampleFactors}{LinearEmbeddingMatrix}(x) <- value

\S4method{featureLoadings}{LinearEmbeddingMatrix}(x, withDimnames=TRUE)

\S4method{featureLoadings}{LinearEmbeddingMatrix}(x) <- value

\S4method{factorData}{LinearEmbeddingMatrix}(x)

\S4method{factorData}{LinearEmbeddingMatrix}(x) <- value

\S4method{as.matrix}{LinearEmbeddingMatrix}(x, ...)

\S4method{dim}{LinearEmbeddingMatrix}(x)

\S4method{dimnames}{LinearEmbeddingMatrix}(x)

\S4method{dimnames}{LinearEmbeddingMatrix}(x) <- value

\S4method{$}{LinearEmbeddingMatrix}(x, name)

\S4method{$}{LinearEmbeddingMatrix}(x, name) <- value
}

\arguments{
\item{x}{A LinearEmbeddingMatrix object.}
\item{value}{An appropriate value to assign to the relevant slot.}
\item{withDimnames}{A logical scalar indicating whether dimension names should be attached to the returned object.}
\item{name}{A string specifying a field of the \code{factorData} slot.}
\item{...}{Further arguments, ignored.}
}

\details{
Any \code{value} to assign to \code{sampleFactors} and \code{featureLoadings} should be matrix-like objects,
while \code{factorData} should be a DataFrame - ee \linkS4class{LinearEmbeddingMatrix} for details.

The \code{as.matrix} method will return the matrix of sample factors, consistent with the fact that the LinearEmbeddingMatrix mimics a sample-factor matrix.
However, unlike the \code{sampleFactors} method, this is always guaranteed to return an ordinary R matrix, even if an alternative representation was stored in the slot.
This ensures consistency with \code{as.matrix} methods for other matrix-like S4 classes. 

For assignment to \code{dimnames}, a list of length 2 should be used containing vectors of row and column names.
}

\value{
For the getter methods \code{sampleFactors}, \code{featureLoadings} and \code{factorData}, the value of the slot with the same name is returned.
For the corresponding setter methods, a LinearEmbeddingMatrix is returned with modifications to the named slot.

For \code{dim}, the dimensions of the \code{sampleFactors} slot are returned in an integer vector of length 2.
For \code{dimnames}, a list of length 2 containing the row and column names is returned.
For \code{as.matrix}, an ordinary matrix derived from \code{sampleFactors} is returned.

For \code{$}, the value of the named field of the \code{factorData} slot is returned.
For \code{$<-}, a LinearEmbeddingMatrix is returned with the modified field in \code{factorData}.
}

\seealso{
\code{\link{LinearEmbeddingMatrix}}
}

\author{
Keegan Korthauer, Davide Risso and Aaron Lun
}

\examples{
example(LinearEmbeddingMatrix, echo=FALSE) # Using the class example

sampleFactors(lem)
sampleFactors(lem) <- sampleFactors(lem) * -1

featureLoadings(lem)
featureLoadings(lem) <- featureLoadings(lem) * -1

factorData(lem)
factorData(lem)$whee <- 1

nrow(lem)
ncol(lem)
colnames(lem) <- LETTERS[seq_len(ncol(lem))]
as.matrix(lem)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rowSubset.R
\docType{methods}
\name{rowSubset}
\alias{rowSubset}
\alias{rowSubset<-}
\alias{rowSubset,SingleCellExperiment-method}
\alias{rowSubset<-,SingleCellExperiment-method}
\title{Get or set the row subset}
\usage{
\S4method{rowSubset}{SingleCellExperiment}(x, field = "subset", onAbsence = "none")

\S4method{rowSubset}{SingleCellExperiment}(x, field = "subset", ...) <- value
}
\arguments{
\item{x}{A \linkS4class{SingleCellExperiment} object.}

\item{field}{String containing the name of the field in the \code{\link{rowData}} to get or set subsetting data.}

\item{onAbsence}{String indicating an additional action to take when labels are absent:
nothing (\code{"none"}), a warning (\code{"warn"}) or an error (\code{"error"}).}

\item{...}{Additional arguments, currently ignored.}

\item{value}{Any character, logical or numeric vector specifying rows of \code{x} to include in the subset.
Alternatively \code{NULL}, in which case existing subsetting information is removed.}
}
\value{
For \code{rowSubset}, a logical vector is returned specifying the rows to retain in the subset of interest.
If no subset is available, a \code{NULL} is returned (and/or a warning or error, depending on \code{onAbsence}).

For \code{rowSubset<-}, a modified \code{x} is returned a subsetting vector in its \code{\link{rowData}}.
}
\description{
Get or set the row subset in an instance of a \linkS4class{SingleCellExperiment} class.
This is assumed to specify some interesting subset of genes to be favored in downstream analyses.
}
\details{
A frequent task in single-cell data analyses is to focus on a subset of genes of interest,
e.g., highly variable genes, derived marker genes for clusters, known markers for cell types.
A related task is to filter out uninteresting genes such as ribosomal protein genes or mitochondrial transcripts,
in which case we want to subset to exclude those genes.

These functions store a set of genes of interest inside a \linkS4class{SingleCellExperiment}
for later retrieval and use in downstream functions.
Character and numeric \code{value} are converted to logical vectors that are parallel to the rows of \code{x},
allowing them to be added to the \code{\link{rowData}} for synchronized row-level operations.

For developers, \code{onAbsence} is provided to make it easier to mandate that \code{x} actually has labels.
This avoids silent \code{NULL} values that flow to the rest of the function and make debugging difficult.
}
\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example

rowSubset(sce, "hvgs") <- 1:10
rowSubset(sce, "hvgs")

rowSubset(sce) <- rbinom(nrow(sce), 1, 0.5)==1
rowSubset(sce)

}
\seealso{
\linkS4class{SingleCellExperiment}, for the underlying class definition.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assays.R
\docType{methods}
\name{SCE-assays}
\alias{SCE-assays}
\alias{counts}
\alias{counts<-}
\alias{counts,SingleCellExperiment-method}
\alias{counts<-,SingleCellExperiment-method}
\alias{normcounts}
\alias{normcounts<-}
\alias{normcounts,SingleCellExperiment-method}
\alias{normcounts<-,SingleCellExperiment-method}
\alias{logcounts}
\alias{logcounts<-}
\alias{logcounts,SingleCellExperiment-method}
\alias{logcounts<-,SingleCellExperiment-method}
\alias{cpm}
\alias{cpm<-}
\alias{cpm,SingleCellExperiment-method}
\alias{cpm<-,SingleCellExperiment-method}
\alias{tpm}
\alias{tpm<-}
\alias{tpm,SingleCellExperiment-method}
\alias{tpm<-,SingleCellExperiment-method}
\alias{weights}
\alias{weights<-}
\alias{weights,SingleCellExperiment-method}
\alias{weights<-,SingleCellExperiment-method}
\title{Named assay getters and setters}
\description{
These are methods for getting or setting \code{assay(sce, i=X, ...)} 
where \code{sce} is a \linkS4class{SingleCellExperiment} object and \code{X} is the name of the method.
For example, \code{counts} will get or set \code{X="counts"}.
This provides some convenience for users as well as encouraging standardization of assay names across packages.
}
\section{Available methods}{

In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment} object,
\code{value} is a matrix-like object with the same dimensions as \code{x},
and \code{...} are further arguments passed to \code{\link{assay}} (for the getter) or \code{\link{assay<-}} (for the setter).
\describe{
\item{\code{counts(x, ...)}, \code{counts(x, ...) <- value}:}{
Get or set a matrix of raw count data, e.g., number of reads or transcripts.
}
\item{\code{normcounts(x, ...)}, \code{normcounts(x, ...) <- value}:}{
Get or set a matrix of normalized values on the same scale as the original counts.
For example, counts divided by cell-specific size factors that are centred at unity.
}
\item{\code{logcounts(x, ...)}, \code{logcounts(x, ...) <- value}:}{
Get or set a matrix of log-transformed counts or count-like values.
In most cases, this will be defined as log-transformed \code{normcounts}, e.g., using log base 2 and a pseudo-count of 1.
}
\item{\code{cpm(x, ...)}, \code{cpm(x, ...) <- value}:}{
Get or set a matrix of counts-per-million values.
This is the read count for each gene in each cell, divided by the library size of each cell in millions.
}
\item{\code{tpm(x, ...)}, \code{tpm(x, ...) <- value}:}{
Get or set a matrix of transcripts-per-million values.
This is the number of transcripts for each gene in each cell, divided by the total number of transcripts in that cell (in millions).
}
\item{\code{weights(x, ...)}, \code{weights(x, ...) <- value}:}{
Get or set a matrix of weights, e.g., observational weights to be used in differential expression analysis.
}
}
}

\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example
counts(sce) <- matrix(rnorm(nrow(sce)*ncol(sce)), ncol=ncol(sce))
dim(counts(sce))

# One possible way of computing normalized "counts"
sf <- 2^rnorm(ncol(sce))
sf <- sf/mean(sf)
normcounts(sce) <- t(t(counts(sce))/sf)
dim(normcounts(sce))

# One possible way of computing log-counts
logcounts(sce) <- log2(normcounts(sce)+1)
dim(normcounts(sce))

}
\seealso{
\code{\link{assay}} and \code{\link{assay<-}}, for the wrapped methods.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine.R
\docType{methods}
\name{SCE-combine}
\alias{SCE-combine}
\alias{cbind,SingleCellExperiment-method}
\alias{rbind,SingleCellExperiment-method}
\alias{combineCols,SingleCellExperiment-method}
\alias{[,SingleCellExperiment,ANY-method}
\alias{[,SingleCellExperiment,ANY,ANY-method}
\alias{[,SingleCellExperiment,ANY,ANY,ANY-method}
\alias{[<-,SingleCellExperiment,ANY,ANY,SingleCellExperiment-method}
\title{Combining or subsetting SingleCellExperiment objects}
\description{
An overview of methods to combine multiple \linkS4class{SingleCellExperiment} objects by row or column,
or to subset a SingleCellExperiment by row or column.
These methods are useful for ensuring that all data fields remain synchronized
when cells or genes are added or removed.
}
\section{Combining}{

In the following code snippets, \code{...} contains one or more \linkS4class{SingleCellExperiment} objects.
\describe{
\item{\code{rbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where all objects in \code{...} are combined row-wise,
i.e., rows in successive objects are appended to the first object.

Refer to \code{?"\link{rbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
Refer to \code{?\link[base]{rbind}} for the interpretation of \code{deparse.level}.

Note that all objects in \code{...} must have the exact same values for \code{\link{reducedDims}} and \code{\link{altExps}}.
Any \code{\link{sizeFactors}} should either be \code{NULL} or contain the same values across objects.
}
\item{\code{cbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where
all objects in \code{...} are combined column-wise,
i.e., columns in successive objects are appended to the first object.

Each object \code{x} in \code{...} must have the same values of \code{\link{reducedDimNames}(x)} (though they can be unordered).
Dimensionality reduction results with the same name across objects
will be combined row-wise to create the corresponding entry in the output object.

Each object \code{x} in \code{...} must have the same values of \code{\link{altExpNames}(x)} (though they can be unordered).
Alternative Experiments with the same name across objects
will be combined column-wise to create the corresponding entry in the output object.

\code{\link{sizeFactors}} should be either set to \code{NULL} in all objects, or set to a numeric vector in all objects.

Refer to \code{?"\link{cbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
Refer to \code{?\link[base]{cbind}} for the interpretation of \code{deparse.level}.
}
}

In the following code snippets, \code{x} is a SingleCellExperiment and \code{...} contains multiple SingleCellExperiment objects.
\describe{
\item{\code{combineCols(x, ..., delayed=TRUE, fill=NA, use.names=TRUE)}:}{
Returns a SingleCellExperiment where all objects are flexibly combined by column.
The assays and \code{\link{colData}} are combined as described in \code{?"\link{combineCols,SummarizedExperiment-method}"},
where assays or DataFrame columns missing in any given object are filled in with missing values before combining.

Entries of the \code{\link{reducedDims}} with the same name across objects are combined by row.
If a dimensionality reduction result is not present for a particular SingleCellExperiment, it is represented by a matrix of \code{NA} values instead.
If corresponding \code{\link{reducedDim}} entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{reducedDims}} of the output object with a warning.

Entries of the \code{\link{altExps}} with the same name across objects are combined by column using the relevant \code{\link{combineCols}} method.
If a named entry is not present for a particular SingleCellExperiment, it is represented by a SummarizedExperiment with a single assay full of \code{fill} values.
If entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{altExps}} of the output object with a warning.

Entries of the \code{\link{colPairs}} with the same name across objects are concatenated together after adjusting the indices for each column's new position in the combined object.
If a named entry is not present for a particular SingleCellExperiments, it is assumed to contribute no column pairings and is ignored.

Entries of the \code{\link{rowPairs}} with the same name should be identical across objects if \code{use.names=FALSE}.
If \code{use.names=TRUE}, we attempt to merge together entries with the same name by taking the union of all column pairings.
However, if the same cell has a different set of pairings across objects, a warning is raised and we fall back to the \code{\link{rowPair}} entry from the first object.
}
}
}

\section{Subsetting}{

In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{x[i, j, ..., drop=TRUE]}:}{Returns a SingleCellExperiment containing the
specified rows \code{i} and columns \code{j}.

\code{i} and \code{j} can be a logical, integer or character vector of subscripts,
indicating the rows and columns respectively to retain.
Either can be missing, in which case subsetting is only performed in the specified dimension.
If both are missing, no subsetting is performed.

Arguments in \code{...} and \code{drop} are passed to to \code{\link{[,SummarizedExperiment-method}}.}
\item{\code{x[i, j, ...] <- value}:}{Replaces all data for rows \code{i} and columns \code{j}
with the corresponding fields in a SingleCellExperiment \code{value}.

\code{i} and \code{j} can be a logical, integer or character vector of subscripts,
indicating the rows and columns respectively to replace.
Either can be missing, in which case replacement is only performed in the specified dimension.
If both are missing, \code{x} is replaced entirely with \code{value}.

If \code{j} is specified, \code{value} is expected to have the same name and order of \code{\link{reducedDimNames}}
and \code{\link{altExpNames}} as \code{x}.
If \code{sizeFactors} is set for \code{x}, it should also be set for \code{value}.

Arguments in \code{...} are passed to the corresponding \linkS4class{SummarizedExperiment} method.}
}
}

\examples{
example(SingleCellExperiment, echo=FALSE) # using the class example

# Combining:
rbind(sce, sce)
cbind(sce, sce)

# Subsetting:
sce[1:10,]
sce[,1:5]

sce2 <- sce
sce2[1:10,] <- sce[11:20,]

# Can also use subset()
sce$WHEE <- sample(LETTERS, ncol(sce), replace=TRUE)
subset(sce, , WHEE=="A")

# Can also use split()
split(sce, sample(LETTERS, nrow(sce), replace=TRUE))

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine.R
\docType{methods}
\name{SCE-combine}
\alias{SCE-combine}
\alias{cbind,SingleCellExperiment-method}
\alias{rbind,SingleCellExperiment-method}
\alias{combineCols,SingleCellExperiment-method}
\alias{[,SingleCellExperiment,ANY-method}
\alias{[,SingleCellExperiment,ANY,ANY-method}
\alias{[,SingleCellExperiment,ANY,ANY,ANY-method}
\alias{[<-,SingleCellExperiment,ANY,ANY,SingleCellExperiment-method}
\title{Combining or subsetting SingleCellExperiment objects}
\description{
An overview of methods to combine multiple \linkS4class{SingleCellExperiment} objects by row or column,
or to subset a SingleCellExperiment by row or column.
These methods are useful for ensuring that all data fields remain synchronized
when cells or genes are added or removed.
}
\section{Combining}{

In the following code snippets, \code{...} contains one or more \linkS4class{SingleCellExperiment} objects.
\describe{
\item{\code{rbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where all objects in \code{...} are combined row-wise,
i.e., rows in successive objects are appended to the first object.

Refer to \code{?"\link{rbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
Refer to \code{?\link[base]{rbind}} for the interpretation of \code{deparse.level}.

Note that all objects in \code{...} must have the exact same values for \code{\link{reducedDims}} and \code{\link{altExps}}.
Any \code{\link{sizeFactors}} should either be \code{NULL} or contain the same values across objects.
}
\item{\code{cbind(..., deparse.level=1)}:}{Returns a SingleCellExperiment where
all objects in \code{...} are combined column-wise,
i.e., columns in successive objects are appended to the first object.

Each object \code{x} in \code{...} must have the same values of \code{\link{reducedDimNames}(x)} (though they can be unordered).
Dimensionality reduction results with the same name across objects
will be combined row-wise to create the corresponding entry in the output object.

Each object \code{x} in \code{...} must have the same values of \code{\link{altExpNames}(x)} (though they can be unordered).
Alternative Experiments with the same name across objects
will be combined column-wise to create the corresponding entry in the output object.

\code{\link{sizeFactors}} should be either set to \code{NULL} in all objects, or set to a numeric vector in all objects.

Refer to \code{?"\link{cbind,SummarizedExperiment-method}"} for details on how metadata is combined in the output object.
Refer to \code{?\link[base]{cbind}} for the interpretation of \code{deparse.level}.
}
}

In the following code snippets, \code{x} is a SingleCellExperiment and \code{...} contains multiple SingleCellExperiment objects.
\describe{
\item{\code{combineCols(x, ..., delayed=TRUE, fill=NA, use.names=TRUE)}:}{
Returns a SingleCellExperiment where all objects are flexibly combined by column.
The assays and \code{\link{colData}} are combined as described in \code{?"\link{combineCols,SummarizedExperiment-method}"},
where assays or DataFrame columns missing in any given object are filled in with missing values before combining.

Entries of the \code{\link{reducedDims}} with the same name across objects are combined by row.
If a dimensionality reduction result is not present for a particular SingleCellExperiment, it is represented by a matrix of \code{NA} values instead.
If corresponding \code{\link{reducedDim}} entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{reducedDims}} of the output object with a warning.

Entries of the \code{\link{altExps}} with the same name across objects are combined by column using the relevant \code{\link{combineCols}} method.
If a named entry is not present for a particular SingleCellExperiment, it is represented by a SummarizedExperiment with a single assay full of \code{fill} values.
If entries cannot be combined, e.g., due to inconsistent dimensions, they are omitted from the \code{\link{altExps}} of the output object with a warning.

Entries of the \code{\link{colPairs}} with the same name across objects are concatenated together after adjusting the indices for each column's new position in the combined object.
If a named entry is not present for a particular SingleCellExperiments, it is assumed to contribute no column pairings and is ignored.

Entries of the \code{\link{rowPairs}} with the same name should be identical across objects if \code{use.names=FALSE}.
If \code{use.names=TRUE}, we attempt to merge together entries with the same name by taking the union of all column pairings.
However, if the same cell has a different set of pairings across objects, a warning is raised and we fall back to the \code{\link{rowPair}} entry from the first object.
}
}
}

\section{Subsetting}{

In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{x[i, j, ..., drop=TRUE]}:}{Returns a SingleCellExperiment containing the
specified rows \code{i} and columns \code{j}.

\code{i} and \code{j} can be a logical, integer or character vector of subscripts,
indicating the rows and columns respectively to retain.
Either can be missing, in which case subsetting is only performed in the specified dimension.
If both are missing, no subsetting is performed.

Arguments in \code{...} and \code{drop} are passed to to \code{\link{[,SummarizedExperiment-method}}.}
\item{\code{x[i, j, ...] <- value}:}{Replaces all data for rows \code{i} and columns {j}
with the corresponding fields in a SingleCellExperiment \code{value}.

\code{i} and \code{j} can be a logical, integer or character vector of subscripts,
indicating the rows and columns respectively to replace.
Either can be missing, in which case replacement is only performed in the specified dimension.
If both are missing, \code{x} is replaced entirely with \code{value}.

If \code{j} is specified, \code{value} is expected to have the same name and order of \code{\link{reducedDimNames}}
and \code{\link{altExpNames}} as \code{x}.
If \code{sizeFactors} is set for \code{x}, it should also be set for \code{value}.

Arguments in \code{...} are passed to the corresponding \linkS4class{SummarizedExperiment} method.}
}
}

\examples{
example(SingleCellExperiment, echo=FALSE) # using the class example

# Combining:
rbind(sce, sce)
cbind(sce, sce)

# Subsetting:
sce[1:10,]
sce[,1:5]

sce2 <- sce
sce2[1:10,] <- sce[11:20,]

# Can also use subset()
sce$WHEE <- sample(LETTERS, ncol(sce), replace=TRUE)
subset(sce, , WHEE=="A")

# Can also use split()
split(sce, sample(LETTERS, nrow(sce), replace=TRUE))

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/swapAltExp.R
\name{swapAltExp}
\alias{swapAltExp}
\title{Swap main and alternative Experiments}
\usage{
swapAltExp(x, name, saved = mainExpName(x), withColData = TRUE)
}
\arguments{
\item{x}{A \linkS4class{SingleCellExperiment} object.}

\item{name}{String or integer scalar specifying the alternative Experiment to use to replace the main Experiment.}

\item{saved}{String specifying the name to use to save the original \code{x} as an alternative experiment in the output.
If \code{NULL}, the original is not saved.}

\item{withColData}{Logical scalar specifying whether the column metadata of \code{x} should be preserved in the output.}
}
\value{
A SingleCellExperiment derived from \code{altExp(x, name)}.
This contains all alternative Experiments in \code{altExps(x)}, excluding the one that was promoted to the main Experiment.
An additional alternative Experiment containing \code{x} may be included if \code{saved} is specified.
}
\description{
Swap the main Experiment for an alternative Experiment in a \linkS4class{SingleCellExperiment} object.
}
\details{
During the course of an analysis, we may need to perform operations on each of the alternative Experiments in turn.
This would require us to repeatedly call \code{altExp(x, name)} prior to running downstream functions on those Experiments.
In such cases, it may be more convenient to switch the main Experiment with the desired alternative Experiments,
allowing a particular section of the analysis to be performed on the latter by default.

For example, the initial phases of the analysis might use the entire set of features.
At some point, we might want to focus only on a subset of features of interest,
but we do not want to discard the rest of the features.
This can be achieved by storing the subset as an alternative Experiment and swapping it with the main Experiment,
as shown in the Examples below.

If \code{withColData=TRUE}, the column metadata of the output object is set to \code{colData(x)}.
As a side-effect, any column data previously \code{altExp(x, name)} is stored in the \code{saved} alternative Experiment of the output.
This is necessary to preserve the column metadata while achieving reversibility (see below).
Setting \code{withColData=FALSE} will omit the \code{colData} exchange.

\code{swapAltExp} is almost perfectly reversible, i.e., \code{swapAltExp(swapAltExp(x, name, saved), saved, name)} should return something very similar to \code{x}. 
The only exceptions are that the order of \code{\link{altExpNames}} is changed,
and that any non-\code{NULL} \code{\link{mainExpName}} in \code{altExp(x, name)} will be lost.
}
\examples{
example(SingleCellExperiment, echo=FALSE) # using the class example

# Let's say we defined a subset of genes of interest.
# We can save the feature set as its own altExp.
hvgs <- 1:10
altExp(sce, "subset") <- sce[hvgs,] 

# At some point, we want to do our analysis on the HVGs only,
# but we want to hold onto the other features for later reference.
sce <- swapAltExp(sce, name="subset", saved="all")
sce

# Once we're done, it is straightforward to switch back.
swapAltExp(sce, "all") 
}
\seealso{
\code{\link{altExps}}, for a description of the alternative Experiment concept.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sizeFactors.R
\name{sizeFactors}
\alias{sizeFactors}
\alias{sizeFactors,SingleCellExperiment-method}
\alias{sizeFactors<-,SingleCellExperiment-method}
\title{Size factor methods}
\usage{
\S4method{sizeFactors}{SingleCellExperiment}(object, onAbsence = "none")

\S4method{sizeFactors}{SingleCellExperiment}(object, ...) <- value
}
\arguments{
\item{object}{A \linkS4class{SingleCellExperiment} object.}

\item{onAbsence}{String indicating an additional action to take when size factors are absent:
nothing (\code{"none"}), a warning (\code{"warn"}) or an error (\code{"error"}).}

\item{...}{Additional arguments, currently ignored.}

\item{value}{A numeric vector of length equal to \code{ncol(object)}, containing size factors for all cells.}
}
\value{
For \code{sizeFactors}, a numeric vector is returned containing size factors for all cells.
If no size factors are available, a \code{NULL} is returned (and/or a warning or error, depending on \code{onAbsence}).

For \code{sizeFactors<-}, a modified \code{object} is returned with size factors in its \code{\link{colData}}.
}
\description{
Gets or sets the size factors for all cells in a \linkS4class{SingleCellExperiment} object.
}
\details{
A size factor is a scaling factor used to divide the raw counts of a particular cell to obtain normalized expression values,
thus allowing downstream comparisons between cells that are not affected by differences in library size or total RNA content.
The \code{sizeFactors} methods can be used to get or set size factors for all cells in a SingleCellExperiment object.

When setting size factors, the values are stored in the \code{\link{colData}} as the \code{\link{sizeFactors}} field.
This name is chosen for general consistency with other packages (e.g., \pkg{DESeq2})
and to allow the size factors to be easily extracted from the \code{\link{colData}} for use as covariates.

For developers, \code{onAbsence} is provided to make it easier to mandate that \code{object} has size factors.
This avoids silent \code{NULL} values that flow to the rest of the function and make debugging difficult.
}
\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example
sizeFactors(sce) <- runif(ncol(sce))
sizeFactors(sce)

}
\seealso{
\linkS4class{SingleCellExperiment}, for the underlying class definition. 

\code{librarySizeFactors} from the \pkg{scater} package
or \code{computeSumFactors} from the \pkg{scran} package,
as examples of functions that compute the size factors.
}
\author{
Aaron Lun
}

\name{Subsetting LEMs}

\alias{[,LinearEmbeddingMatrix,ANY-method}
\alias{[,LinearEmbeddingMatrix,ANY,ANY-method}
\alias{[,LinearEmbeddingMatrix,ANY,ANY,ANY-method}
\alias{[<-,LinearEmbeddingMatrix,ANY,ANY,LinearEmbeddingMatrix-method}

\title{LEM subsetting methods}

\description{
Methods to subset LinearEmbeddingMatrix objects.
}

\usage{
\S4method{[}{LinearEmbeddingMatrix,ANY,ANY}(x, i, j, ..., drop=TRUE)

\S4method{[}{LinearEmbeddingMatrix,ANY,ANY,LinearEmbeddingMatrix}(x, i, j) <- value
}

\arguments{
\item{x}{A LinearEmbeddingMatrix object.}
\item{i, j}{A vector of logical or integer subscripts, indicating the rows and columns to be subsetted for \code{i} and \code{j}, respectively.}
\item{...}{Extra arguments that are ignored.}
\item{drop}{A logical scalar indicating whether the result should be coerced to the lowest possible dimension.}
\item{value}{A LinearEmbeddingMatrix object with number of rows equal to length of \code{i} (or that of \code{x}, if \code{i} is not specified).
The number of columns must be equal to the length of \code{j} (or number of columns in \code{x}, if \code{j} is not specified).
}
}

\value{
For \code{[}, a subsetted LinearEmbeddingMatrix object is returned.

For \code{[<-}, a modified LinearEmbeddingMatrix object is returned.
}

\details{
Subsetting yields a LinearEmbeddingMatrix object containing the specified rows (samples) and columns (factors).
If column subsetting is performed, values of \code{featureLoadings} and \code{factorData} will be modified to retain only the selected factors.

If \code{drop=TRUE} and the subsetting would produce dimensions of length 1, those dimensions are dropped and a vector is returned directly from \code{sampleFactors}.
This mimics the expected behaviour from a matrix-like object.
Users should set \code{drop=FALSE} to ensure that a LinearEmbeddingMatrix is returned.

For subset replacement, if neither \code{i} or \code{j} are set, \code{x} will be effectively replaced by \code{value}.
However, row and column names will \emph{not} change, consistent with replacement in ordinary matrices.
}

\author{
Aaron Lun
}

\seealso{
\code{\link{LinearEmbeddingMatrix-class}}
}

\examples{
example(LinearEmbeddingMatrix, echo=FALSE) # using the class example

lem[1:10,]
lem[,1:5]

lem2 <- lem
lem2[1:10,] <- lem[11:20,]
}

\name{Miscellaneous LEM}
\alias{show,LinearEmbeddingMatrix-method} 

\title{Miscellaneous LEM methods}
\description{Various methods for the LinearEmbeddingMatrix class.}

\usage{
\S4method{show}{LinearEmbeddingMatrix}(object)
}

\arguments{
\item{object}{A LinearEmbeddingMatrix object.}
}

\details{
The \code{show} method will print out information about the data contained in \code{object}.
This includes the number of samples, the number of factors, the number of genes and the fields available in \code{factorData}.
}

\value{
A message is printed to screen describing the data stored in \code{object}.
}

\seealso{
\code{\link{LinearEmbeddingMatrix}}
}

\author{
Davide Risso
}

\examples{
example(LinearEmbeddingMatrix, echo=FALSE) # Using the class example
show(lem)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internals.R
\docType{methods}
\name{SCE-internals}
\alias{SCE-internals}
\alias{int_colData}
\alias{int_elementMetadata}
\alias{int_metadata}
\alias{int_colData,SingleCellExperiment-method}
\alias{int_elementMetadata,SingleCellExperiment-method}
\alias{int_metadata,SingleCellExperiment-method}
\alias{int_colData<-}
\alias{int_elementMetadata<-}
\alias{int_metadata<-}
\alias{int_colData<-,SingleCellExperiment-method}
\alias{int_elementMetadata<-,SingleCellExperiment-method}
\alias{int_metadata<-,SingleCellExperiment-method}
\alias{colData,SingleCellExperiment-method}
\alias{rowData,SingleCellExperiment-method}
\alias{parallel_slot_names,SingleCellExperiment-method}
\title{Internal SingleCellExperiment functions}
\description{
Methods to get or set internal fields from the SingleCellExperiment class.
Thse functions are intended for package developers who want to add protected fields to a SingleCellExperiment.
They should \emph{not} be used by ordinary users of the \pkg{SingleCellExperiment} package.
}
\section{Getters}{

In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment}.
\describe{
\item{\code{int_elementMetadata(x)}:}{Returns a \linkS4class{DataFrame} of internal row metadata,
with number of rows equal to \code{nrow(x)}.
This is analogous to the user-visible \code{\link{rowData}}.}
\item{\code{int_colData(x)}:}{Returns a \linkS4class{DataFrame} of internal column metadata,
with number of rows equal to \code{ncol(x)}.
This is analogous to the user-visible \code{\link{colData}}.}
\item{\code{int_metadata(x)}:}{Returns a list of internal metadata, analogous to the user-visible \code{\link{metadata}}.}
}

It may occasionally be useful to return both the visible and the internal \code{colData} in a single DataFrame.
This is facilitated by the following methods:
\describe{
\item{\code{rowData(x, ..., internal=FALSE)}:}{Returns a \linkS4class{DataFrame} of the user-visible row metadata.
If \code{internal=TRUE}, the internal row metadata is added column-wise to the user-visible metadata.
A warning is emitted if the user-visible metadata column names overlap with the internal fields.
Any arguments in \code{...} are passed to \code{\link{rowData,SummarizedExperiment-method}}.}
\item{\code{colData(x, ..., internal=FALSE)}:}{Returns a \linkS4class{DataFrame} of the user-visible column metadata.
If \code{internal=TRUE}, the internal column metadata is added column-wise to the user-visible metadata.
A warning is emitted if the user-visible metadata column names overlap with the internal fields.
Any arguments in \code{...} are passed to \code{\link{colData,SummarizedExperiment-method}}.}
}
}

\section{Setters}{

In the following code snippets, \code{x} is a \linkS4class{SingleCellExperiment}.
\describe{
\item{\code{int_elementMetadata(x) <- value}:}{Replaces the internal row metadata with \code{value},
a \linkS4class{DataFrame} with number of rows equal to \code{nrow(x)}.
This is analogous to the user-visible \code{\link{rowData<-}}.}
\item{\code{int_colData(x) <- value}:}{Replaces the internal column metadata with \code{value},
a \linkS4class{DataFrame} with number of rows equal to \code{ncol(x)}.
This is analogous to the user-visible \code{\link{colData<-}}.}
\item{\code{int_metadata(x) <- value}:}{Replaces the internal metadata with \code{value}, 
analogous to the user-visible \code{\link{metadata<-}}.}
}
}

\section{Comments}{

The internal metadata fields allow easy and extensible storage of additional elements
that are parallel to the rows or columns of a \linkS4class{SingleCellExperiment} class.
This avoids the need to specify new slots and adjust the subsetting/combining code for a new data element.
For example, \code{\link{altExps}} and \code{\link{reducedDims}} are implemented as fields in the internal column metadata.

That these elements are internal is important as this ensures that the implementation details are abstracted away.
Any user interaction with these internal fields should be done via the designated getter and setter methods,
e.g., \code{\link{reducedDim}} and friends for retrieving or modifying reduced dimensions.
This provides developers with more freedom to change the internal representation without breaking user code.

Package developers intending to use these methods to store their own content should read the development vignette for guidance.
}

\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example
int_metadata(sce)$whee <- 1
}
\seealso{
\code{\link{colData}}, \code{\link{rowData}} and \code{\link{metadata}} for the user-visible equivalents.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/altExps.R
\docType{methods}
\name{altExps}
\alias{altExps}
\alias{altExp}
\alias{altExpNames}
\alias{altExp,SingleCellExperiment,missing-method}
\alias{altExp,SingleCellExperiment,numeric-method}
\alias{altExp,SingleCellExperiment,character-method}
\alias{altExps,SingleCellExperiment-method}
\alias{altExpNames,SingleCellExperiment-method}
\alias{altExp<-}
\alias{altExps<-}
\alias{altExpNames<-}
\alias{altExp<-,SingleCellExperiment,missing-method}
\alias{altExp<-,SingleCellExperiment,numeric-method}
\alias{altExp<-,SingleCellExperiment,character-method}
\alias{altExps<-,SingleCellExperiment-method}
\alias{altExpNames<-,SingleCellExperiment,character-method}
\alias{[,SummarizedExperimentByColumn,ANY,ANY,ANY-method}
\alias{[<-,SummarizedExperimentByColumn,ANY,ANY,ANY-method}
\alias{c,SummarizedExperimentByColumn-method}
\alias{length,SummarizedExperimentByColumn-method}
\alias{names,SummarizedExperimentByColumn-method}
\alias{names<-,SummarizedExperimentByColumn-method}
\alias{removeAltExps}
\alias{mainExpName}
\alias{mainExpName,SingleCellExperiment-method}
\alias{mainExpName<-}
\alias{mainExpName<-,SingleCellExperiment,character_OR_NULL-method}
\alias{\%}
\alias{Dumping}
\alias{the}
\alias{SEBC}
\alias{methods}
\alias{here,}
\alias{so}
\alias{that}
\alias{check}
\alias{doesn't}
\alias{complain.}
\title{Alternative Experiment methods}
\description{
In some experiments, different features must be normalized differently or have different row-level metadata.
Typical examples would be for spike-in transcripts in plate-based experiments and antibody or CRISPR tags in CITE-seq experiments.
These data cannot be stored in the main \code{assays} of the \linkS4class{SingleCellExperiment} itself.
However, it is still desirable to store these features \emph{somewhere} in the SingleCellExperiment.
This simplifies book-keeping in long workflows and ensure that samples remain synchronised.

To facilitate this, the \linkS4class{SingleCellExperiment} class allows for \dQuote{alternative Experiments}.
Nested \linkS4class{SummarizedExperiment}-class objects are stored inside the SingleCellExperiment object \code{x}, in a manner that guarantees that the nested objects have the same columns in the same order as those in \code{x}.
Methods are provided to enable convenient access to and manipulation of these alternative Experiments.
Each alternative Experiment should contain experimental data and row metadata for a distinct set of features.
}
\section{Getters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{altExp(x, e, withDimnames=TRUE, withColData=FALSE)}:}{
Retrieves a \linkS4class{SummarizedExperiment} containing alternative features (rows) for all cells (columns) in \code{x}.
\code{e} should either be a string specifying the name of the alternative Experiment in \code{x} to retrieve,
or a numeric scalar specifying the index of the desired Experiment, defaulting to the first Experiment is missing.

If \code{withDimnames=TRUE}, the column names of the output object are set to \code{colnames(x)}.
In addition, if \code{withColData=TRUE}, \code{\link{colData}(x)} is \code{cbind}ed to the front of the column data of the output object.
}
\item{\code{altExpNames(x)}:}{
Returns a character vector containing the names of all alternative Experiments in \code{x}.
This is guaranteed to be of the same length as the number of results, though the names may not be unique.
}
\item{\code{altExps(x, withDimnames=TRUE, withColData=FALSE)}:}{
Returns a named \linkS4class{List} of matrices containing one or more \linkS4class{SummarizedExperiment} objects.
Each object is guaranteed to have the same number of columns, in a 1:1 correspondence to those in \code{x}.

If \code{withDimnames=TRUE}, the column names of each output object are set to \code{colnames(x)}.
In addition, if \code{withColData=TRUE}, \code{\link{colData}(x)} is \code{cbind}ed to the front of the column data of each output object.
}
}
}

\section{Single-object setter}{

\code{altExp(x, e, withDimnames=TRUE, withColData=FALSE) <- value} will add or replace an alternative Experiment
in a \linkS4class{SingleCellExperiment} object \code{x}.
The value of \code{e} determines how the result is added or replaced:
\itemize{
\item If \code{e} is missing, \code{value} is assigned to the first result.
If the result already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
\item If \code{e} is a numeric scalar, it must be within the range of existing results, and \code{value} will be assigned to the result at that index.
\item If \code{e} is a string and a result exists with this name, \code{value} is assigned to to that result.
Otherwise a new result with this name is append to the existing list of results.
}

\code{value} is expected to be a SummarizedExperiment object with number of columns equal to \code{ncol(x)}.
Alternatively, if \code{value} is \code{NULL}, the alternative Experiment at \code{e} is removed from the object.

If \code{withDimnames=TRUE}, the column names of \code{value} are checked against those of \code{x}.
A warning is raised if these are not identical, with the only exception being when \code{value=NULL}.
This is inspired by the argument of the same name in \code{\link{assay<-}}.

If \code{withColData=TRUE}, we assume that the left-most columns of \code{colData(value)} are identical to \code{colData(x)}.
If so, these columns are removed, effectively reversing the \code{withColData=TRUE} setting for the \code{altExp} getter.
Otherwise, a warning is raised.
}

\section{Other setters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{altExps(x, withDimnames=TRUE, withColData=FALSE) <- value}:}{
Replaces all alterrnative Experiments in \code{x} with those in \code{value}.
The latter should be a list-like object containing any number of SummarizedExperiment objects
with number of columns equal to \code{ncol(x)}.

If \code{value} is named, those names will be used to name the alternative Experiments in \code{x}.
Otherwise, unnamed results are assigned default names prefixed with \code{"unnamed"}.

If \code{value} is \code{NULL}, all alternative Experiments in \code{x} are removed.

If \code{value} is a \linkS4class{Annotated} object, any \code{\link{metadata}} will be retained in \code{altExps(x)}.
If \code{value} is a \linkS4class{Vector} object, any \code{\link{mcols}} will also be retained.

If \code{withDimnames=TRUE}, the column names of each entry of \code{value} are checked against those of \code{x}.
A warning is raised if these are not identical.

If \code{withColData=TRUE}, we assume that the left-most columns of the \code{colData} for each entry of \code{value} are identical to \code{colData(x)}.
If so, these columns are removed, effectively reversing the \code{withColData=TRUE} setting for the \code{altExps} getter.
Otherwise, a warning is raised.
}
\item{\code{altExpNames(x) <- value}:}{
Replaces all names for alternative Experiments in \code{x} with a character vector \code{value}.
This should be of length equal to the number of results currently in \code{x}.
}
}

\code{removeAltExps(x)} will remove all alternative Experiments from \code{x}.
This has the same effect as \code{altExps(x) <- NULL} but may be more convenient as it directly returns a SingleCellExperiment.
}

\section{Main Experiment naming}{

The alternative Experiments are naturally associated with names (\code{e} during assignment).
However, we can also name the main Experiment in a \linkS4class{SingleCellExperiment} \code{x}:
\describe{
\item{\code{mainExpName(x) <- value}:}{
Set the name of the main Experiment to a non-\code{NA} string \code{value}.
This can also be used to unset the name if \code{value=NULL}.
}
\item{\code{mainExpName(x)}:}{
Returns a string containing the name of the main Experiment.
This may also be \code{NULL} if no name is specified.
}
}
The presence of a non-\code{NULL} main Experiment name is helpful for functions like \code{\link{swapAltExp}}.
An appropriate name is automatically added by functions like \code{\link{splitAltExps}}.

Note that, if a SingleCellExperiment is assigned as an alternative Experiment to another SingleCellExperiment via \code{altExp(x, e) <- value},
no attempt is made to synchronize \code{mainExpName(value)} with \code{e}.
In such cases, we suggest setting \code{mainExpName(value)} to \code{NULL} to avoid any confusion during interpretation.
}

\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example
dim(counts(sce))

# Mocking up some alternative Experiments.
se1 <- SummarizedExperiment(matrix(rpois(1000, 5), ncol=ncol(se)))
rowData(se1)$stuff <- sample(LETTERS, nrow(se1), replace=TRUE)
se2 <- SummarizedExperiment(matrix(rpois(500, 5), ncol=ncol(se)))
rowData(se2)$blah <- sample(letters, nrow(se2), replace=TRUE)

# Setting the alternative Experiments.
altExp(sce, "spike-in") <- se1
altExp(sce, "CRISPR") <- se2

# Getting alternative Experimental data.
altExpNames(sce)
altExp(sce, "spike-in")
altExp(sce, 2)

# Setting alternative Experimental data.
altExpNames(sce) <- c("ERCC", "Ab")
altExp(sce, "ERCC") <- se1[1:2,]

}
\seealso{
\code{\link{splitAltExps}}, for a convenient way of adding alternative Experiments from existing features.

\code{\link{swapAltExp}}, to swap the main and alternative Experiments.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/applySCE.R
\name{applySCE}
\alias{applySCE}
\title{Applying over parts of a SingleCellExperiment}
\usage{
applySCE(
  X,
  FUN,
  WHICH = altExpNames(X),
  ...,
  MAIN.ARGS = list(),
  ALT.ARGS = list(),
  SIMPLIFY = TRUE
)
}
\arguments{
\item{X}{A \linkS4class{SingleCellExperiment} object.}

\item{FUN}{A function to apply to each Experiment.}

\item{WHICH}{A character or integer vector containing the names or positions of alternative Experiments to loop over.}

\item{...}{Further (named) arguments to pass to all calls to \code{FUN}.}

\item{MAIN.ARGS}{A named list of arguments to pass to \code{FUN} for the main Experiment only.
Alternatively \code{NULL}, in which case the function is \emph{not} applied to the main Experiment.}

\item{ALT.ARGS}{A named list where each entry is named after an alternative Experiment and contains named arguments to use in \code{FUN} for that Experiment.}

\item{SIMPLIFY}{Logical scalar indicating whether the output should be simplified to a single SingleCellExperiment.}
}
\value{
In most cases or when \code{SIMPLIFY=FALSE}, a list is returned containing the output of \code{FUN} applied to each Experiment.
If \code{MAIN.ARGS} is not \code{NULL}, the first entry corresponds to the result generated from the main Experiment;
all other results are generated according to the entries specified in \code{WHICH} and are named accordingly.

If \code{SIMPLIFY=TRUE} and certain conditions are fulfilled,
a SingleCellExperiment is returned where the results of \code{FUN} are mapped to the relevant main or alternative Experiments.
This mirrors the organization of Experiments in \code{X}.
}
\description{
Apply a function over the main and alternative Experiments of a \linkS4class{SingleCellExperiment}.
}
\details{
The behavior of this function is equivalent to creating a list containing \code{X} as the first entry and \code{\link{altExps}(X)} in the subsequent entries,
and then \code{\link{lapply}}ing over this list with \code{FUN} and the specified arguments.
In this manner, users can easily apply the same function to all the Experiments (main and alternative) in a \linkS4class{SingleCellExperiment} object.

Arguments in \code{...} are passed to all calls to \code{FUN}.
Arguments in \code{MAIN.ARGS} are only used in the call to \code{FUN} on the main Experiment.
Arguments in \code{ALT.ARGS} are passed to the call to \code{FUN} on the alternative Experiment of the same name.
For the last two, any arguments therein will override arguments of the same name in \code{...}.

By default, looping is performed over all alternative Experiments, but the order and identities can be changed by setting \code{WHICH}.
Values of \code{WHICH} should be unique if any simplification of the output is desired.
If \code{MAIN.ARGS=NULL}, the main Experiment is ignored and the function is only applied to the alternative Experiments.

The default of \code{SIMPLIFY=TRUE} is intended as a user-level convenience when all calls to \code{FUN} return a SingleCellExperiment with the same number of columns,
and \code{WHICH} itself contains no more than one reference to each alternative Experiment in \code{x}.
Under these conditions, the results are collated into a single SingleCellExperiment for easier downstream manipulation.
}
\section{Developer note}{

When using this function inside other functions, developers should set \code{SIMPLIFY=FALSE} to guarantee consistent output for arbitrary \code{WHICH}.
If simplification is necessary, the output of this function can be explicitly passed to \code{\link{simplifyToSCE}},
typically with \code{warn.level=3} to throw an appropriate error if simplification is not possible.
}

\examples{
ncells <- 10
u <- matrix(rpois(200, 5), ncol=ncells)
sce <- SingleCellExperiment(assays=list(counts=u))
altExp(sce, "BLAH") <- SingleCellExperiment(assays=list(counts=u*10))
altExp(sce, "WHEE") <- SingleCellExperiment(assays=list(counts=u/10))

# Here, using a very simple function that just 
# computes the mean of the input for each cell.
FUN <- function(y, multiplier=1) {
    colMeans(assay(y)) * multiplier
}

# Applying over all of the specified parts of 'sce'.
applySCE(sce, FUN=FUN)

# Adding general arguments.
applySCE(sce, FUN=FUN, multiplier=5)

# Adding custom arguments.
applySCE(sce, FUN=FUN, MAIN.ARGS=list(multiplier=5))
applySCE(sce, FUN=FUN, ALT.ARGS=list(BLAH=list(multiplier=5)))

# Skipping Experiments.
applySCE(sce, FUN=FUN, MAIN.ARGS=NULL) # skipping the main
applySCE(sce, FUN=FUN, WHICH=NULL) # skipping the alternatives

}
\seealso{
\code{\link{simplifyToSCE}}, which is used when \code{SIMPLIFY=TRUE}.

\code{\link{altExps}}, to manually extract the alternative Experiments for operations.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/SingleCellExperiment.R
\docType{class}
\name{SingleCellExperiment-class}
\alias{SingleCellExperiment-class}
\alias{SingleCellExperiment}
\alias{coerce,SummarizedExperiment,SingleCellExperiment-method}
\alias{coerce,RangedSummarizedExperiment,SingleCellExperiment-method}
\title{The SingleCellExperiment class}
\usage{
SingleCellExperiment(
  ...,
  reducedDims = list(),
  altExps = list(),
  rowPairs = list(),
  colPairs = list(),
  mainExpName = NULL
)
}
\arguments{
\item{...}{Arguments passed to the \code{\link{SummarizedExperiment}} constructor to fill the slots of the base class.}

\item{reducedDims}{A list of any number of matrix-like objects containing dimensionality reduction results,
each of which should have the same number of rows as the output SingleCellExperiment object.}

\item{altExps}{A list of any number of \linkS4class{SummarizedExperiment} objects containing alternative Experiments,
each of which should have the same number of columns as the output SingleCellExperiment object.}

\item{rowPairs}{A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of rows.
Each entry should have number of nodes equal to the number of rows of the output SingleCellExperiment object.
Alternatively, entries may be square sparse matrices of order equal to the number of rows of the output object.}

\item{colPairs}{A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of columns.
Each entry should have number of nodes equal to the number of columns of the output SingleCellExperiment object.
Alternatively, entries may be square sparse matrices of order equal to the number of columns of the output object.}

\item{mainExpName}{String containing the name of the main Experiment.
This is comparable to the names assigned to each of the \code{altExps}.}
}
\value{
A SingleCellExperiment object.
}
\description{
The SingleCellExperiment class is designed to represent single-cell sequencing data.
It inherits from the \linkS4class{RangedSummarizedExperiment} class and is used in the same manner.
In addition, the class supports storage of dimensionality reduction results (e.g., PCA, t-SNE) via \code{\link{reducedDims}},
and storage of alternative feature types (e.g., spike-ins) via \code{\link{altExps}}.
}
\details{
In this class, rows should represent genomic features (e.g., genes) while columns represent samples generated from single cells.
As with any \linkS4class{SummarizedExperiment} derivative,
different quantifications (e.g., counts, CPMs, log-expression) can be stored simultaneously in the \code{\link{assays}} slot,
and row and column metadata can be attached using \code{\link{rowData}} and \code{\link{colData}}, respectively.

The extra arguments in the constructor (e.g., \code{\link{reducedDims}} \code{\link{altExps}})
represent the main extensions implemented in the SingleCellExperiment class.
This enables a consistent, formalized representation of data structures 
that are commonly encountered during single-cell data analysis.
Readers are referred to the specific documentation pages for more details.

A SingleCellExperiment can also be created by coercing from a \linkS4class{SummarizedExperiment}
or \linkS4class{RangedSummarizedExperiment} instance.
}
\examples{
ncells <- 100
u <- matrix(rpois(20000, 5), ncol=ncells)
v <- log2(u + 1)

pca <- matrix(runif(ncells*5), ncells)
tsne <- matrix(rnorm(ncells*2), ncells)

sce <- SingleCellExperiment(assays=list(counts=u, logcounts=v),
    reducedDims=SimpleList(PCA=pca, tSNE=tsne))
sce

## coercion from SummarizedExperiment
se <- SummarizedExperiment(assays=list(counts=u, logcounts=v))
as(se, "SingleCellExperiment")

## coercion from RangedSummarizedExperiment
rse <- as(se, "RangedSummarizedExperiment")
as(rse, "SingleCellExperiment")

# coercion to a RangedSummarizedExperiment
as(sce, "RangedSummarizedExperiment")

# coercion to a SummarizedExperiment is slightly buggy right now
# and requires a little workaround:
as(as(sce, "RangedSummarizedExperiment"), "SummarizedExperiment")

}
\seealso{
\code{\link{reducedDims}}, for representation of dimensionality reduction results.

\code{\link{altExps}}, for representation of data for alternative feature sets.

\code{\link{colPairs}} and \code{\link{rowPairs}}, to hold pairing information for rows and columns.

\code{\link{sizeFactors}}, to store size factors for normalization.

\code{\link{colLabels}}, to store cell-level labels.

\code{\link{rowSubset}}, to store a subset of rows.

\code{?"\link{SCE-combine}"}, to combine or subset a SingleCellExperiment object.

\code{?"\link{SCE-internals}"}, for developer use.
}
\author{
Aaron Lun and Davide Risso
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/SingleCellExperiment.R
\docType{class}
\name{SingleCellExperiment-class}
\alias{SingleCellExperiment-class}
\alias{SingleCellExperiment}
\alias{coerce,SummarizedExperiment,SingleCellExperiment-method}
\alias{coerce,RangedSummarizedExperiment,SingleCellExperiment-method}
\title{The SingleCellExperiment class}
\usage{
SingleCellExperiment(
  ...,
  reducedDims = list(),
  altExps = list(),
  rowPairs = list(),
  colPairs = list(),
  mainExpName = NULL
)
}
\arguments{
\item{...}{Arguments passed to the \code{\link{SummarizedExperiment}} constructor to fill the slots of the base class.}

\item{reducedDims}{A list of any number of matrix-like objects containing dimensionality reduction results,
each of which should have the same number of rows as the output SingleCellExperiment object.}

\item{altExps}{A list of any number of \linkS4class{SummarizedExperiment} objects containing alternative Experiments,
each of which should have the same number of columns as the output SingleCellExperiment object.}

\item{rowPairs}{A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of rows.
Each entry should have number of nodes equal to the number of rows of the output SingleCellExperiment object.
Alternatively, entries may be square sparse matrices of order equal to the number of rows of the output object.}

\item{colPairs}{A list of any number of \linkS4class{SelfHits} objects describing relationships between pairs of columns.
Each entry should have number of nodes equal to the number of columns of the output SingleCellExperiment object.
Alternatively, entries may be square sparse matrices of order equal to the number of columns of the output object.}

\item{mainExpName}{String containing the name of the main Experiment.
This is comparable to the names assigned to each of the \code{altExps}.}
}
\value{
A SingleCellExperiment object.
}
\description{
The SingleCellExperiment class is designed to represent single-cell sequencing data.
It inherits from the \linkS4class{RangedSummarizedExperiment} class and is used in the same manner.
In addition, the class supports storage of dimensionality reduction results (e.g., PCA, t-SNE) via \code{\link{reducedDims}},
and storage of alternative feature types (e.g., spike-ins) via \code{\link{altExps}}.
}
\details{
In this class, rows should represent genomic features (e.g., genes) while columns represent samples generated from single cells.
As with any \linkS4class{SummarizedExperiment} derivative,
different quantifications (e.g., counts, CPMs, log-expression) can be stored simultaneously in the \code{\link{assays}} slot,
and row and column metadata can be attached using \code{\link{rowData}} and \code{\link{colData}}, respectively.

The extra arguments in the constructor (e.g., \code{\link{reducedDims}} \code{\link{altExps}})
represent the main extensions implemented in the SingleCellExperiment class.
This enables a consistent, formalized representation of data structures 
that are commonly encountered during single-cell data analysis.
Readers are referred to the specific documentation pages for more details.

A SingleCellExperiment can also be created by coercing from a \linkS4class{SummarizedExperiment}
or \linkS4class{RangedSummarizedExperiment} instance.
}
\examples{
ncells <- 100
u <- matrix(rpois(20000, 5), ncol=ncells)
v <- log2(u + 1)

pca <- matrix(runif(ncells*5), ncells)
tsne <- matrix(rnorm(ncells*2), ncells)

sce <- SingleCellExperiment(assays=list(counts=u, logcounts=v),
    reducedDims=SimpleList(PCA=pca, tSNE=tsne))
sce

## coercion from SummarizedExperiment
se <- SummarizedExperiment(assays=list(counts=u, logcounts=v))
as(se, "SingleCellExperiment")

}
\seealso{
\code{\link{reducedDims}}, for representation of dimensionality reduction results.

\code{\link{altExps}}, for representation of data for alternative feature sets.

\code{\link{colPairs}} and \code{\link{rowPairs}}, to hold pairing information for rows and columns.

\code{\link{sizeFactors}}, to store size factors for normalization.

\code{\link{colLabels}}, to store cell-level labels.

\code{\link{rowSubset}}, to store a subset of rows.

\code{?"\link{SCE-combine}"}, to combine or subset a SingleCellExperiment object.

\code{?"\link{SCE-internals}"}, for developer use.
}
\author{
Aaron Lun and Davide Risso
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unsplitAltExps.R
\name{unsplitAltExps}
\alias{unsplitAltExps}
\title{Unsplit the alternative experiments}
\usage{
unsplitAltExps(sce, prefix.rows = TRUE, prefix.cols = TRUE, delayed = TRUE)
}
\arguments{
\item{sce}{A \linkS4class{SingleCellExperiment} containing alternative experiments in the \code{\link{altExps}} slot.}

\item{prefix.rows}{Logical scalar indicating whether the (non-\code{NULL}) row names should be prefixed with the name of the alternative experiment.}

\item{prefix.cols}{Logical scalar indicating whether the names of column-related fields should be prefixed with the name of the alternative experiment.
If \code{NA}, any \code{\link{colData}} of the \code{\link{altExps}} are ignored.}

\item{delayed}{Logical scalar indicating whether the combining of the assays should be delayed.}
}
\value{
A SingleCellExperiment where all features in the alternative experiments of \code{sce} are now features in the main experiment.
The output object has no alternative experiments of its own.
}
\description{
Combine the main and alternative experiments back into one \linkS4class{SingleCellExperiment} object.
This is effectively the reverse operation to \code{\link{splitAltExps}}.
}
\details{
This function is intended for downstream applications that accept a SingleCellExperiment but are not aware of the \code{\link{altExps}} concept.
By consolidating all data together, applications like \pkg{iSEE} can use the same machinery to visualize any feature of interest across all modalities.
However, for quantitative analyses, it is usually preferable to keep different modalities separate.

Assays with the same name are \code{\link{rbind}}ed together in the output object.
If a particular name is not present for any experiment, its values are filled in with the appropriately typed \code{NA} instead.
By default, this is done efficiently via \linkS4class{ConstantMatrix} abstractions to avoid actually creating a dense matrix of \code{NA}s.
If \code{delayed=FALSE}, the combining of matrices is done without any \linkS4class{DelayedArray} wrappers,
yielding a simpler matrix representation at the cost of increasing memory usage.

Any \code{\link{colData}} or \code{\link{reducedDims}} in the alternative experiments are added to those of the main experiment.
The names of these migrated fields are prefixed by the name of the alternative experiment if \code{prefix.cols=TRUE}.

Setting \code{prefix.rows=FALSE}, \code{prefix.cols=NA} and \code{delayed=FALSE} will reverse the effects of \code{\link{splitAltExps}}.
}
\examples{
counts <- matrix(rpois(10000, 5), ncol=100)
sce <- SingleCellExperiment(assays=list(counts=counts))
feat.type <- sample(c("endog", "ERCC", "adt"), nrow(sce),
    replace=TRUE, p=c(0.8, 0.1, 0.1))
sce <- splitAltExps(sce, feat.type)

# Making life a little more complicated.
logcounts(sce) <- log2(counts(sce) + 1)
sce$cluster <- sample(5, ncol(sce), replace=TRUE)
reducedDim(sce, "PCA") <- matrix(rnorm(ncol(sce)*2), ncol=2)
 
# Now, putting Humpty Dumpty back together again. 
restored <- unsplitAltExps(sce)
restored

}
\seealso{
\code{\link{splitAltExps}}, which does the reverse operation of this function.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reducedDims.R
\docType{methods}
\name{reducedDims}
\alias{reducedDims}
\alias{reducedDim}
\alias{reducedDimNames}
\alias{reducedDim,SingleCellExperiment,missing-method}
\alias{reducedDim,SingleCellExperiment,numeric-method}
\alias{reducedDim,SingleCellExperiment,character-method}
\alias{reducedDims,SingleCellExperiment-method}
\alias{reducedDimNames,SingleCellExperiment-method}
\alias{reducedDim<-}
\alias{reducedDims<-}
\alias{reducedDimNames<-}
\alias{reducedDim<-,SingleCellExperiment,missing-method}
\alias{reducedDim<-,SingleCellExperiment,numeric-method}
\alias{reducedDim<-,SingleCellExperiment,character-method}
\alias{reducedDims<-,SingleCellExperiment-method}
\alias{reducedDimNames<-,SingleCellExperiment,character-method}
\title{Reduced dimensions methods}
\description{
Methods to get or set dimensionality reduction results in a \linkS4class{SingleCellExperiment} object.
These are typically used to store and retrieve low-dimensional representations of single-cell datasets.
Each row of a reduced dimension result is expected to correspond to a column of the SingleCellExperiment object.
}
\section{Getters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{reducedDim(x, type, withDimnames=TRUE)}:}{
Retrieves a matrix (or matrix-like object) containing reduced dimension coordinates for cells (rows) and dimensions (columns).
\code{type} is either a string specifying the name of the dimensionality reduction result in \code{x} to retrieve,
or a numeric scalar specifying the index of the desired result.
If \code{withDimnames=TRUE}, row names of the output matrix are replaced with the column names of \code{x}.
}
\item{\code{reducedDimNames(x)}:}{
Returns a character vector containing the names of all dimensionality reduction results in \code{x}.
This is guaranteed to be of the same length as the number of results, though the names may not be unique.
}
\item{\code{reducedDims(x, withDimnames=TRUE)}:}{
Returns a named \linkS4class{List} of matrices containing one or more dimensionality reduction results.
Each result is a matrix (or matrix-like object) with the same number of rows.
If \code{withDimnames=TRUE}, row names of each matrix are replaced with the column names of \code{x}.
}
}
}

\section{Single-result setter}{

\code{reducedDim(x, type) <- value} will add or replace a dimensionality reduction result
in a \linkS4class{SingleCellExperiment} object \code{x}.
The value of \code{type} determines how the result is added or replaced:
\itemize{
\item If \code{type} is missing, \code{value} is assigned to the first result.
If the result already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
\item If \code{type} is a numeric scalar, it must be within the range of existing results, and \code{value} will be assigned to the result at that index.
\item If \code{type} is a string and a result exists with this name, \code{value} is assigned to to that result.
Otherwise a new result with this name is append to the existing list of results.
}

\code{value} is expected to be a matrix or matrix-like object with number of rows equal to \code{ncol(x)}.
Alternatively, if \code{value} is \code{NULL}, the result corresponding to \code{type} is removed from the object.
}

\section{Other setters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{reducedDims(x) <- value}:}{
Replaces all dimensionality reduction results in \code{x} with those in \code{value}.
The latter should be a list-like object containing any number of matrices or matrix-like objects
with number of rows equal to \code{ncol(x)}.

If \code{value} is named, those names will be used to name the dimensionality reduction results in \code{x}.
Otherwise, unnamed results are assigned default names prefixed with \code{"unnamed"}.

If \code{value} is \code{NULL}, all dimensionality reduction results in \code{x} are removed.
}
\item{\code{reducedDimNames(x) <- value}:}{
Replaces all names for dimensionality reduction results in \code{x} with a character vector \code{value}.
This should be of length equal to the number of results currently in \code{x}.
}
}
}

\examples{
example(SingleCellExperiment, echo=FALSE)
reducedDim(sce, "PCA")
reducedDim(sce, "tSNE")
reducedDims(sce)

reducedDim(sce, "PCA") <- NULL
reducedDims(sce)

reducedDims(sce) <- SimpleList()
reducedDims(sce)

}
\author{
Aaron Lun and Kevin Rue-Albrecht
}

\name{LinearEmbeddingMatrix}
\alias{LinearEmbeddingMatrix}
\alias{LinearEmbeddingMatrix-class}

\docType{class}

\title{LinearEmbeddingMatrix class}
\description{A description of the LinearEmbeddingMatrix class for storing low-dimensional embeddings from linear dimensionality reduction methods.}

\usage{
LinearEmbeddingMatrix(sampleFactors = matrix(nrow = 0, ncol = 0),
    featureLoadings = matrix(nrow = 0, ncol = 0), factorData = NULL,
    metadata = list())
}

\arguments{
    \item{sampleFactors}{A matrix-like object of sample embeddings, where rows are samples and columns are factors.}
    \item{featureLoadings}{A matrix-like object of feature loadings, where rows are features and columns are factors.}
    \item{factorData}{A DataFrame containing factor-level information, with one row per factor.}
    \item{metadata}{An optional list of arbitrary content describing the overall experiment.}
}

\value{
A LinearEmbeddingMatrix object is returned from the constructor.
}

\details{
The LinearEmbeddingMatrix class is a matrix-like object that supports \code{dim}, \code{dimnames} and \code{as.matrix}.
It is designed for the storage of results from linear dimensionality reduction methods like principal components analysis (PCA),
factor analysis and non-negative matrix factorization.

The \code{sampleFactors} slot is intended to store The low-dimensional representation of the samples, such as the principal coordinates from PCA.
The feature loadings contributing to each factor are stored in \code{featureLoadings}, and should have the same number of columns as \code{sampleFactors}.
The \code{factorData} stores additional factor-level information, such as the percentage of variance explained by each factor,
and should have the same number of rows as \code{sampleFactors}.

The intended use of this class is to allow PCA and other results to be stored in the \code{\link{reducedDims}} slot of a SingleCellExperiment object.
This means that feature loadings remain attached to the embedding, allowing it to be used in downstream analyses.
}

\author{
Aaron Lun, Davide Risso and Keegan Korthauer
}

\examples{
lem <- LinearEmbeddingMatrix(matrix(rnorm(1000), ncol=5),
    matrix(runif(20000), ncol=5))
lem
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscellaneous.R
\docType{methods}
\name{SCE-miscellaneous}
\alias{SCE-miscellaneous}
\alias{show,SingleCellExperiment-method}
\alias{objectVersion}
\alias{objectVersion,SingleCellExperiment-method}
\title{Miscellaneous SingleCellExperiment methods}
\description{
Miscellaneous methods for the \linkS4class{SingleCellExperiment} class
that do not fit in any other documentation category.
}
\section{Available methods}{

In the following code snippets, \code{x} and \code{object} are \linkS4class{SingleCellExperiment} objects.
\describe{
\item{\code{show(object)}:}{Print a message to screen describing the contents of \code{object}.}
\item{\code{objectVersion(x)}:}{Return the version of the package with which \code{x} was constructed.}
\item{\code{sizeFactors(object)}:}{Return a numeric vector of size factors of length equal to \code{ncol(object)}.
If no size factors are available in \code{object}, return \code{NULL} instead.}
\item{\code{sizeFactors(object) <- value}:}{Replace the size factors with \code{value},
usually expected to be a numeric vector or vector-like object.
Alternatively, \code{value} can be \code{NULL} in which case any size factors in \code{object} are removed.}
}
}

\examples{
example(SingleCellExperiment, echo=FALSE) # Using the class example

show(sce)

objectVersion(sce)

# Setting/getting size factors.
sizeFactors(sce) <- runif(ncol(sce))
sizeFactors(sce)

sizeFactors(sce) <- NULL
sizeFactors(sce)

}
\seealso{
\code{\link{updateObject}}, where \code{objectVersion} is used.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitAltExps.R
\name{splitAltExps}
\alias{splitAltExps}
\title{Split off alternative features}
\usage{
splitAltExps(x, f, ref = NULL)
}
\arguments{
\item{x}{A \linkS4class{SingleCellExperiment} object.}

\item{f}{A character vector or factor of length equal to \code{nrow(x)}, specifying the feature type of each row.}

\item{ref}{String indicating which level of \code{f} should be treated as the main set.}
}
\value{
A SingleCellExperiment where each row corresponds to a feature in the main set.
Each other feature type is stored as an alternative Experiment, accessible by \code{\link{altExp}}.
\code{ref} is used as the \code{\link{mainExpName}}.
}
\description{
Split a \linkS4class{SingleCellExperiment} based on the feature type, creating alternative Experiments to hold features that are not in the majority set.
}
\details{
This function provides a convenient way to create a SingleCellExperiment with alternative Experiments.
For example, a SingleCellExperiment with rows corresponding to all features can be quickly split into endogenous genes (main)
and other alternative features like spike-in transcripts and antibody tags.

By default, the most frequent level of \code{f} is treated as the \code{ref} if the latter is not specified.
}
\examples{
example(SingleCellExperiment, echo=FALSE)
feat.type <- sample(c("endog", "ERCC", "CITE"), nrow(sce),
    replace=TRUE, p=c(0.8, 0.1, 0.1))

sce2 <- splitAltExps(sce, feat.type)
sce2
}
\seealso{
\code{\link{altExp}}, to access and manipulate the alternative Experiment fields.

\code{\link{unsplitAltExps}}, to reverse the splitting.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reducedDims.R
\docType{methods}
\name{reducedDims}
\alias{reducedDims}
\alias{reducedDim}
\alias{reducedDimNames}
\alias{reducedDim,SingleCellExperiment,missing-method}
\alias{reducedDim,SingleCellExperiment,numeric-method}
\alias{reducedDim,SingleCellExperiment,character-method}
\alias{reducedDims,SingleCellExperiment-method}
\alias{reducedDimNames,SingleCellExperiment-method}
\alias{reducedDim<-}
\alias{reducedDims<-}
\alias{reducedDimNames<-}
\alias{reducedDim<-,SingleCellExperiment,missing-method}
\alias{reducedDim<-,SingleCellExperiment,numeric-method}
\alias{reducedDim<-,SingleCellExperiment,character-method}
\alias{reducedDims<-,SingleCellExperiment-method}
\alias{reducedDimNames<-,SingleCellExperiment,character-method}
\title{Reduced dimensions methods}
\description{
Methods to get or set dimensionality reduction results in a \linkS4class{SingleCellExperiment} object.
These are typically used to store and retrieve low-dimensional representations of single-cell datasets.
Each row of a reduced dimension result is expected to correspond to a column of the SingleCellExperiment object.
}
\section{Getters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{reducedDim(x, type, withDimnames=TRUE)}:}{
Retrieves a matrix (or matrix-like object) containing reduced dimension coordinates for cells (rows) and dimensions (columns).
\code{type} is either a string specifying the name of the dimensionality reduction result in \code{x} to retrieve,
or a numeric scalar specifying the index of the desired result, defaulting to the first entry if missing.

If \code{withDimnames=TRUE}, row names of the output matrix are replaced with the column names of \code{x}.
}
\item{\code{reducedDimNames(x)}:}{
Returns a character vector containing the names of all dimensionality reduction results in \code{x}.
This is guaranteed to be of the same length as the number of results, though the names may not be unique.
}
\item{\code{reducedDims(x, withDimnames=TRUE)}:}{
Returns a named \linkS4class{List} of matrices containing one or more dimensionality reduction results.
Each result is a matrix (or matrix-like object) with the same number of rows as \code{ncol(x)}.

If \code{withDimnames=TRUE}, row names of each matrix are replaced with the column names of \code{x}.
}
}
}

\section{Single-result setter}{

\code{reducedDim(x, type, withDimnames=TRUE) <- value} will add or replace a dimensionality reduction result
in a \linkS4class{SingleCellExperiment} object \code{x}.
The value of \code{type} determines how the result is added or replaced:
\itemize{
\item If \code{type} is missing, \code{value} is assigned to the first result.
If the result already exists, its name is preserved; otherwise it is given a default name \code{"unnamed1"}.
\item If \code{type} is a numeric scalar, it must be within the range of existing results, and \code{value} will be assigned to the result at that index.
\item If \code{type} is a string and a result exists with this name, \code{value} is assigned to to that result.
Otherwise a new result with this name is append to the existing list of results.
}

\code{value} is expected to be a matrix or matrix-like object with number of rows equal to \code{ncol(x)}.
Alternatively, if \code{value} is \code{NULL}, the result corresponding to \code{type} is removed from the object.

If \code{withDimnames=TRUE}, any non-\code{NULL} \code{rownames(value)} is checked against \code{colnames(x)} and a warning is emitted if they are not the same.
Otherwise, any differences in the row names are ignored. 
This is inspired by the argument of the same name in \code{\link{assay<-}} but is more relaxed for practicality's sake - 
it raises a warning rather than an error and allows \code{NULL} rownames to pass through without complaints.
}

\section{Other setters}{

In the following examples, \code{x} is a \linkS4class{SingleCellExperiment} object.
\describe{
\item{\code{reducedDims(x, withDimnames=TRUE) <- value}:}{
Replaces all dimensionality reduction results in \code{x} with those in \code{value}.
The latter should be a list-like object containing any number of matrices or matrix-like objects
with number of rows equal to \code{ncol(x)}.

If \code{value} is named, those names will be used to name the dimensionality reduction results in \code{x}.
Otherwise, unnamed results are assigned default names prefixed with \code{"unnamed"}.

If \code{value} is \code{NULL}, all dimensionality reduction results in \code{x} are removed.

If \code{value} is a \linkS4class{Annotated} object, any \code{\link{metadata}} will be retained in \code{reducedDims(x)}.
If \code{value} is a \linkS4class{Vector} object, any \code{\link{mcols}} will also be retained.

If \code{withDimnames=TRUE}, any non-\code{NULL} row names in each entry of \code{value} is checked against \code{colnames(x)} and a warning is emitted if they are not the same.
Otherwise, any differences in the row names are ignored. 
}
\item{\code{reducedDimNames(x) <- value}:}{
Replaces all names for dimensionality reduction results in \code{x} with a character vector \code{value}.
This should be of length equal to the number of results currently in \code{x}.
}
}
}

\section{Storing dimensionality reduction metadata}{

When performing dimensionality reduction, we frequently generate metadata associated with a particular method.
The typical example is the percentage of variance explained and the rotation matrix from PCA;
model-based methods may also report some model information that can be used later to project points onto the embedding.
Ideally, we would want to store this information alongside the coordinates themselves.

Our recommended approach is to store this metadata as attributes of the coordinate matrix.
This is simple to do, easy to extract, and avoids problems with synchronization (when the coordinates are separated from the metadata).
The biggest problem with this approach is that attributes are not retained when the matrix is subsetted or combined.
To persist these attributes, we suggest wrapping the coordinates and metadata in a \link{reduced.dim.matrix}.
More complex matrix-like objects like the \code{\link{LinearEmbeddingMatrix}} can also be used 
but may not be immediately compatible with downstream functions that expect an ordinary matrix.

The path less taken is to store the metadata in the \code{\link{mcols}} of the \code{\link{reducedDims}} List.
This approach avoids the subsetting problem with the attributes but is less ideal as it separates the metadata from the coordinates.
Such separation makes the metadata harder to find and remember to keep in sync with the coordinates when the latter changes.
The structure of \code{\link{mcols}} is best suited to situations where there are some commonalities in the metadata across entries,
but this rarely occurs for different dimensionality reduction strategies.
}

\examples{
example(SingleCellExperiment, echo=FALSE)
reducedDim(sce, "PCA")
reducedDim(sce, "tSNE")
reducedDims(sce)

reducedDim(sce, "PCA") <- NULL
reducedDims(sce)

reducedDims(sce) <- SimpleList()
reducedDims(sce)

}
\author{
Aaron Lun and Kevin Rue-Albrecht
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simplifyToSCE.R
\name{simplifyToSCE}
\alias{simplifyToSCE}
\title{Simplify a list to a single SingleCellExperiment}
\usage{
simplifyToSCE(results, which.main, warn.level = 2)
}
\arguments{
\item{results}{A named list of SummarizedExperiment or SingleCellExperiment objects.}

\item{which.main}{Integer scalar specifying which entry of \code{results} contains the output generated from the main Experiment.
If \code{NULL} or a vector of length zero, this indicates that no entry was generated from the main Experiment.
Defaults to the unnamed entry of \code{results}.}

\item{warn.level}{Integer scalar specifying the type of warnings that can be emitted.}
}
\value{
A SingleCellExperiment corresponding to the entry of \code{results} generated from the main Experiment.
All results generated from the alternative Experiments of \code{x} are stored in the \code{\link{altExps}} of the output.

If no main Experiment was used to generate \code{results}, an empty SingleCellExperiment is used as a container for the various \code{\link{altExps}}.

If simplification could not be performed, \code{NULL} is returned with a warning (depending on \code{warn.level}.
}
\description{
Simplify a list of \linkS4class{SingleCellExperiment}, usually generated by \code{\link{applySCE}} on main and alternative Experiments,
into a single SingleCellExperiment containing some of the results in its \code{\link{altExps}}.
}
\details{
Each entry of \code{results} should be a \linkS4class{SummarizedExperiment} with the same number and names of the columns.
There should not be any duplicate entries in \code{names(results)}, as the names are used to represent the names of the alternative Experiments in the output.
If \code{which.main} is a scalar, the corresponding entry of \code{results} should be a \linkS4class{SingleCellExperiment}.
Failure to meet these conditions may result in a warning or error depending on \code{warn.level}.

The type of warnings that are emitted can be controlled with \code{warn.level}.
If \code{warn.level=0}, no warnings are emitted.
If \code{warn.level=1}, all warnings are emitted except for those related to \code{results} not being of the appropriate class.
If \code{warn.level=2}, all warnings are emitted, and if \code{warn.level=3}, warnings are promoted to errors.
}
\examples{
ncells <- 100
u <- matrix(rpois(20000, 5), ncol=ncells)
sce <- SingleCellExperiment(assays=list(counts=u))
altExp(sce, "BLAH") <- SingleCellExperiment(assays=list(counts=u*10))
altExp(sce, "WHEE") <- SingleCellExperiment(assays=list(counts=u*2))

# Setting FUN=identity just extracts each piece:
results <- applySCE(sce, FUN=identity, SIMPLIFY=FALSE)
results

# Simplifying to an output that mirrors the structure of 'sce'.
simplifyToSCE(results)

}
\seealso{
\code{\link{applySCE}}, where this function is used when \code{SIMPLIFY=TRUE}.
}
\author{
Aaron Lun
}
